/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/ 		var executeModules = data[2];
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(Object.prototype.hasOwnProperty.call(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 		// add entry modules from loaded chunk to deferred list
/******/ 		deferredModules.push.apply(deferredModules, executeModules || []);
/******/
/******/ 		// run deferred modules when all chunks ready
/******/ 		return checkDeferredModules();
/******/ 	};
/******/ 	function checkDeferredModules() {
/******/ 		var result;
/******/ 		for(var i = 0; i < deferredModules.length; i++) {
/******/ 			var deferredModule = deferredModules[i];
/******/ 			var fulfilled = true;
/******/ 			for(var j = 1; j < deferredModule.length; j++) {
/******/ 				var depId = deferredModule[j];
/******/ 				if(installedChunks[depId] !== 0) fulfilled = false;
/******/ 			}
/******/ 			if(fulfilled) {
/******/ 				deferredModules.splice(i--, 1);
/******/ 				result = __webpack_require__(__webpack_require__.s = deferredModule[0]);
/******/ 			}
/******/ 		}
/******/
/******/ 		return result;
/******/ 	}
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"main": 0
/******/ 	};
/******/
/******/ 	var deferredModules = [];
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "build/" + ({"compiler":"compiler"}[chunkId]||chunkId) + "." + {"compiler":"d7fb221e"}[chunkId] + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				// create error before stack unwound to get useful stacktrace later
/******/ 				var error = new Error();
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							error.message = 'Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')';
/******/ 							error.name = 'ChunkLoadError';
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				document.head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonp"] = window["webpackJsonp"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// add entry module to deferred list
/******/ 	deferredModules.push([0,"chunk-vendors"]);
/******/ 	// run deferred modules when ready
/******/ 	return checkDeferredModules();
/******/ })
/************************************************************************/
/******/ ({

/***/ "./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=script&lang=js&":
/*!*******************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js??ref--13-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-json-query-builder.vue?vue&type=script&lang=js& ***!
  \*******************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var core_js_modules_es_array_includes__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! core-js/modules/es.array.includes */ \"./node_modules/core-js/modules/es.array.includes.js\");\n/* harmony import */ var core_js_modules_es_array_includes__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_includes__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! core-js/modules/es.array.index-of */ \"./node_modules/core-js/modules/es.array.index-of.js\");\n/* harmony import */ var core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! core-js/modules/es.array.splice */ \"./node_modules/core-js/modules/es.array.splice.js\");\n/* harmony import */ var core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_2__);\n/* harmony import */ var core_js_modules_es_object_keys__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! core-js/modules/es.object.keys */ \"./node_modules/core-js/modules/es.object.keys.js\");\n/* harmony import */ var core_js_modules_es_object_keys__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_object_keys__WEBPACK_IMPORTED_MODULE_3__);\n/* harmony import */ var core_js_modules_es_object_to_string__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! core-js/modules/es.object.to-string */ \"./node_modules/core-js/modules/es.object.to-string.js\");\n/* harmony import */ var core_js_modules_es_object_to_string__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_object_to_string__WEBPACK_IMPORTED_MODULE_4__);\n/* harmony import */ var core_js_modules_es_regexp_to_string__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! core-js/modules/es.regexp.to-string */ \"./node_modules/core-js/modules/es.regexp.to-string.js\");\n/* harmony import */ var core_js_modules_es_regexp_to_string__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_regexp_to_string__WEBPACK_IMPORTED_MODULE_5__);\n/* harmony import */ var core_js_modules_es_string_includes__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! core-js/modules/es.string.includes */ \"./node_modules/core-js/modules/es.string.includes.js\");\n/* harmony import */ var core_js_modules_es_string_includes__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_string_includes__WEBPACK_IMPORTED_MODULE_6__);\n/* harmony import */ var C_Users_eedge_Documents_GitHub_vue_query_builder_node_modules_babel_runtime_helpers_esm_typeof__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./node_modules/@babel/runtime/helpers/esm/typeof */ \"./node_modules/@babel/runtime/helpers/esm/typeof.js\");\n/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.esm.js\");\n/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! uuid */ \"./node_modules/uuid/dist/esm-browser/index.js\");\n/* harmony import */ var _components_vue_query_group_vue__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! @/components/vue-query-group.vue */ \"./src/components/vue-query-group.vue\");\n\n\n\n\n\n\n\n\n\nfunction cov_d6iw7jf9e() {\n  var path = \"C:\\\\Users\\\\eedge\\\\Documents\\\\GitHub\\\\vue-query-builder\\\\src\\\\components\\\\vue-json-query-builder.vue\";\n  var hash = \"305d0d1aeb87c9b96c05676ba105a7dadd346823\";\n  var global = new Function(\"return this\")();\n  var gcv = \"__coverage__\";\n  var coverageData = {\n    path: \"C:\\\\Users\\\\eedge\\\\Documents\\\\GitHub\\\\vue-query-builder\\\\src\\\\components\\\\vue-json-query-builder.vue\",\n    statementMap: {\n      \"0\": {\n        start: {\n          line: 189,\n          column: 0\n        },\n        end: {\n          line: 189,\n          column: 31\n        }\n      },\n      \"1\": {\n        start: {\n          line: 227,\n          column: 8\n        },\n        end: {\n          line: 227,\n          column: 17\n        }\n      },\n      \"2\": {\n        start: {\n          line: 256,\n          column: 4\n        },\n        end: {\n          line: 271,\n          column: 5\n        }\n      },\n      \"3\": {\n        start: {\n          line: 275,\n          column: 19\n        },\n        end: {\n          line: 275,\n          column: 23\n        }\n      },\n      \"4\": {\n        start: {\n          line: 276,\n          column: 6\n        },\n        end: {\n          line: 276,\n          column: 57\n        }\n      },\n      \"5\": {\n        start: {\n          line: 279,\n          column: 19\n        },\n        end: {\n          line: 279,\n          column: 23\n        }\n      },\n      \"6\": {\n        start: {\n          line: 280,\n          column: 6\n        },\n        end: {\n          line: 280,\n          column: 58\n        }\n      },\n      \"7\": {\n        start: {\n          line: 283,\n          column: 19\n        },\n        end: {\n          line: 283,\n          column: 23\n        }\n      },\n      \"8\": {\n        start: {\n          line: 284,\n          column: 6\n        },\n        end: {\n          line: 284,\n          column: 56\n        }\n      },\n      \"9\": {\n        start: {\n          line: 287,\n          column: 19\n        },\n        end: {\n          line: 287,\n          column: 23\n        }\n      },\n      \"10\": {\n        start: {\n          line: 288,\n          column: 6\n        },\n        end: {\n          line: 288,\n          column: 54\n        }\n      },\n      \"11\": {\n        start: {\n          line: 291,\n          column: 19\n        },\n        end: {\n          line: 291,\n          column: 23\n        }\n      },\n      \"12\": {\n        start: {\n          line: 292,\n          column: 6\n        },\n        end: {\n          line: 292,\n          column: 43\n        }\n      },\n      \"13\": {\n        start: {\n          line: 295,\n          column: 19\n        },\n        end: {\n          line: 295,\n          column: 23\n        }\n      },\n      \"14\": {\n        start: {\n          line: 298,\n          column: 21\n        },\n        end: {\n          line: 298,\n          column: 40\n        }\n      },\n      \"15\": {\n        start: {\n          line: 299,\n          column: 23\n        },\n        end: {\n          line: 299,\n          column: 27\n        }\n      },\n      \"16\": {\n        start: {\n          line: 301,\n          column: 8\n        },\n        end: {\n          line: 312,\n          column: 9\n        }\n      },\n      \"17\": {\n        start: {\n          line: 302,\n          column: 10\n        },\n        end: {\n          line: 304,\n          column: 11\n        }\n      },\n      \"18\": {\n        start: {\n          line: 303,\n          column: 12\n        },\n        end: {\n          line: 303,\n          column: 29\n        }\n      },\n      \"19\": {\n        start: {\n          line: 305,\n          column: 15\n        },\n        end: {\n          line: 312,\n          column: 9\n        }\n      },\n      \"20\": {\n        start: {\n          line: 306,\n          column: 10\n        },\n        end: {\n          line: 311,\n          column: 11\n        }\n      },\n      \"21\": {\n        start: {\n          line: 306,\n          column: 23\n        },\n        end: {\n          line: 306,\n          column: 24\n        }\n      },\n      \"22\": {\n        start: {\n          line: 307,\n          column: 25\n        },\n        end: {\n          line: 307,\n          column: 40\n        }\n      },\n      \"23\": {\n        start: {\n          line: 308,\n          column: 12\n        },\n        end: {\n          line: 310,\n          column: 13\n        }\n      },\n      \"24\": {\n        start: {\n          line: 309,\n          column: 14\n        },\n        end: {\n          line: 309,\n          column: 31\n        }\n      },\n      \"25\": {\n        start: {\n          line: 314,\n          column: 8\n        },\n        end: {\n          line: 314,\n          column: 24\n        }\n      },\n      \"26\": {\n        start: {\n          line: 317,\n          column: 6\n        },\n        end: {\n          line: 317,\n          column: 65\n        }\n      },\n      \"27\": {\n        start: {\n          line: 321,\n          column: 17\n        },\n        end: {\n          line: 321,\n          column: 21\n        }\n      },\n      \"28\": {\n        start: {\n          line: 323,\n          column: 4\n        },\n        end: {\n          line: 323,\n          column: 35\n        }\n      },\n      \"29\": {\n        start: {\n          line: 325,\n          column: 26\n        },\n        end: {\n          line: 325,\n          column: 49\n        }\n      },\n      \"30\": {\n        start: {\n          line: 326,\n          column: 4\n        },\n        end: {\n          line: 330,\n          column: 5\n        }\n      },\n      \"31\": {\n        start: {\n          line: 327,\n          column: 6\n        },\n        end: {\n          line: 327,\n          column: 68\n        }\n      },\n      \"32\": {\n        start: {\n          line: 329,\n          column: 6\n        },\n        end: {\n          line: 329,\n          column: 33\n        }\n      },\n      \"33\": {\n        start: {\n          line: 334,\n          column: 19\n        },\n        end: {\n          line: 334,\n          column: 23\n        }\n      },\n      \"34\": {\n        start: {\n          line: 335,\n          column: 6\n        },\n        end: {\n          line: 340,\n          column: 7\n        }\n      },\n      \"35\": {\n        start: {\n          line: 336,\n          column: 8\n        },\n        end: {\n          line: 336,\n          column: 28\n        }\n      },\n      \"36\": {\n        start: {\n          line: 337,\n          column: 8\n        },\n        end: {\n          line: 339,\n          column: 10\n        }\n      },\n      \"37\": {\n        start: {\n          line: 338,\n          column: 10\n        },\n        end: {\n          line: 338,\n          column: 31\n        }\n      },\n      \"38\": {\n        start: {\n          line: 343,\n          column: 19\n        },\n        end: {\n          line: 343,\n          column: 23\n        }\n      },\n      \"39\": {\n        start: {\n          line: 346,\n          column: 21\n        },\n        end: {\n          line: 346,\n          column: 39\n        }\n      },\n      \"40\": {\n        start: {\n          line: 347,\n          column: 8\n        },\n        end: {\n          line: 350,\n          column: 10\n        }\n      },\n      \"41\": {\n        start: {\n          line: 352,\n          column: 8\n        },\n        end: {\n          line: 357,\n          column: 9\n        }\n      },\n      \"42\": {\n        start: {\n          line: 353,\n          column: 10\n        },\n        end: {\n          line: 356,\n          column: 11\n        }\n      },\n      \"43\": {\n        start: {\n          line: 353,\n          column: 23\n        },\n        end: {\n          line: 353,\n          column: 24\n        }\n      },\n      \"44\": {\n        start: {\n          line: 354,\n          column: 25\n        },\n        end: {\n          line: 354,\n          column: 39\n        }\n      },\n      \"45\": {\n        start: {\n          line: 355,\n          column: 12\n        },\n        end: {\n          line: 355,\n          column: 45\n        }\n      },\n      \"46\": {\n        start: {\n          line: 360,\n          column: 6\n        },\n        end: {\n          line: 360,\n          column: 52\n        }\n      },\n      \"47\": {\n        start: {\n          line: 363,\n          column: 19\n        },\n        end: {\n          line: 363,\n          column: 23\n        }\n      },\n      \"48\": {\n        start: {\n          line: 365,\n          column: 6\n        },\n        end: {\n          line: 365,\n          column: 65\n        }\n      },\n      \"49\": {\n        start: {\n          line: 366,\n          column: 6\n        },\n        end: {\n          line: 366,\n          column: 36\n        }\n      },\n      \"50\": {\n        start: {\n          line: 369,\n          column: 19\n        },\n        end: {\n          line: 369,\n          column: 23\n        }\n      },\n      \"51\": {\n        start: {\n          line: 370,\n          column: 27\n        },\n        end: {\n          line: 370,\n          column: 86\n        }\n      },\n      \"52\": {\n        start: {\n          line: 371,\n          column: 6\n        },\n        end: {\n          line: 375,\n          column: 7\n        }\n      },\n      \"53\": {\n        start: {\n          line: 372,\n          column: 8\n        },\n        end: {\n          line: 372,\n          column: 65\n        }\n      },\n      \"54\": {\n        start: {\n          line: 374,\n          column: 8\n        },\n        end: {\n          line: 374,\n          column: 55\n        }\n      },\n      \"55\": {\n        start: {\n          line: 376,\n          column: 6\n        },\n        end: {\n          line: 376,\n          column: 55\n        }\n      },\n      \"56\": {\n        start: {\n          line: 379,\n          column: 19\n        },\n        end: {\n          line: 379,\n          column: 23\n        }\n      },\n      \"57\": {\n        start: {\n          line: 380,\n          column: 28\n        },\n        end: {\n          line: 380,\n          column: 88\n        }\n      },\n      \"58\": {\n        start: {\n          line: 381,\n          column: 6\n        },\n        end: {\n          line: 385,\n          column: 7\n        }\n      },\n      \"59\": {\n        start: {\n          line: 382,\n          column: 8\n        },\n        end: {\n          line: 382,\n          column: 43\n        }\n      },\n      \"60\": {\n        start: {\n          line: 384,\n          column: 8\n        },\n        end: {\n          line: 384,\n          column: 32\n        }\n      },\n      \"61\": {\n        start: {\n          line: 386,\n          column: 6\n        },\n        end: {\n          line: 386,\n          column: 32\n        }\n      },\n      \"62\": {\n        start: {\n          line: 389,\n          column: 19\n        },\n        end: {\n          line: 389,\n          column: 23\n        }\n      },\n      \"63\": {\n        start: {\n          line: 390,\n          column: 27\n        },\n        end: {\n          line: 390,\n          column: 68\n        }\n      },\n      \"64\": {\n        start: {\n          line: 391,\n          column: 6\n        },\n        end: {\n          line: 395,\n          column: 9\n        }\n      },\n      \"65\": {\n        start: {\n          line: 396,\n          column: 6\n        },\n        end: {\n          line: 396,\n          column: 25\n        }\n      },\n      \"66\": {\n        start: {\n          line: 397,\n          column: 6\n        },\n        end: {\n          line: 397,\n          column: 44\n        }\n      },\n      \"67\": {\n        start: {\n          line: 398,\n          column: 6\n        },\n        end: {\n          line: 398,\n          column: 43\n        }\n      },\n      \"68\": {\n        start: {\n          line: 401,\n          column: 19\n        },\n        end: {\n          line: 401,\n          column: 23\n        }\n      },\n      \"69\": {\n        start: {\n          line: 402,\n          column: 6\n        },\n        end: {\n          line: 402,\n          column: 60\n        }\n      },\n      \"70\": {\n        start: {\n          line: 403,\n          column: 6\n        },\n        end: {\n          line: 403,\n          column: 36\n        }\n      },\n      \"71\": {\n        start: {\n          line: 404,\n          column: 6\n        },\n        end: {\n          line: 404,\n          column: 51\n        }\n      },\n      \"72\": {\n        start: {\n          line: 407,\n          column: 19\n        },\n        end: {\n          line: 407,\n          column: 23\n        }\n      },\n      \"73\": {\n        start: {\n          line: 408,\n          column: 6\n        },\n        end: {\n          line: 408,\n          column: 113\n        }\n      },\n      \"74\": {\n        start: {\n          line: 411,\n          column: 19\n        },\n        end: {\n          line: 411,\n          column: 23\n        }\n      },\n      \"75\": {\n        start: {\n          line: 412,\n          column: 6\n        },\n        end: {\n          line: 412,\n          column: 90\n        }\n      },\n      \"76\": {\n        start: {\n          line: 415,\n          column: 19\n        },\n        end: {\n          line: 415,\n          column: 23\n        }\n      },\n      \"77\": {\n        start: {\n          line: 416,\n          column: 34\n        },\n        end: {\n          line: 416,\n          column: 75\n        }\n      },\n      \"78\": {\n        start: {\n          line: 417,\n          column: 6\n        },\n        end: {\n          line: 434,\n          column: 9\n        }\n      },\n      \"79\": {\n        start: {\n          line: 428,\n          column: 8\n        },\n        end: {\n          line: 433,\n          column: 9\n        }\n      },\n      \"80\": {\n        start: {\n          line: 429,\n          column: 10\n        },\n        end: {\n          line: 429,\n          column: 76\n        }\n      },\n      \"81\": {\n        start: {\n          line: 430,\n          column: 10\n        },\n        end: {\n          line: 430,\n          column: 29\n        }\n      },\n      \"82\": {\n        start: {\n          line: 432,\n          column: 10\n        },\n        end: {\n          line: 432,\n          column: 23\n        }\n      },\n      \"83\": {\n        start: {\n          line: 441,\n          column: 21\n        },\n        end: {\n          line: 441,\n          column: 25\n        }\n      },\n      \"84\": {\n        start: {\n          line: 442,\n          column: 8\n        },\n        end: {\n          line: 442,\n          column: 47\n        }\n      },\n      \"85\": {\n        start: {\n          line: 443,\n          column: 8\n        },\n        end: {\n          line: 445,\n          column: 9\n        }\n      },\n      \"86\": {\n        start: {\n          line: 444,\n          column: 10\n        },\n        end: {\n          line: 444,\n          column: 30\n        }\n      }\n    },\n    fnMap: {\n      \"0\": {\n        name: \"(anonymous_0)\",\n        decl: {\n          start: {\n            line: 226,\n            column: 15\n          },\n          end: {\n            line: 226,\n            column: 16\n          }\n        },\n        loc: {\n          start: {\n            line: 226,\n            column: 25\n          },\n          end: {\n            line: 228,\n            column: 7\n          }\n        },\n        line: 226\n      },\n      \"1\": {\n        name: \"(anonymous_1)\",\n        decl: {\n          start: {\n            line: 255,\n            column: 8\n          },\n          end: {\n            line: 255,\n            column: 9\n          }\n        },\n        loc: {\n          start: {\n            line: 255,\n            column: 19\n          },\n          end: {\n            line: 272,\n            column: 3\n          }\n        },\n        line: 255\n      },\n      \"2\": {\n        name: \"(anonymous_2)\",\n        decl: {\n          start: {\n            line: 274,\n            column: 26\n          },\n          end: {\n            line: 274,\n            column: 27\n          }\n        },\n        loc: {\n          start: {\n            line: 274,\n            column: 36\n          },\n          end: {\n            line: 277,\n            column: 5\n          }\n        },\n        line: 274\n      },\n      \"3\": {\n        name: \"(anonymous_3)\",\n        decl: {\n          start: {\n            line: 278,\n            column: 27\n          },\n          end: {\n            line: 278,\n            column: 28\n          }\n        },\n        loc: {\n          start: {\n            line: 278,\n            column: 37\n          },\n          end: {\n            line: 281,\n            column: 5\n          }\n        },\n        line: 278\n      },\n      \"4\": {\n        name: \"(anonymous_4)\",\n        decl: {\n          start: {\n            line: 282,\n            column: 23\n          },\n          end: {\n            line: 282,\n            column: 24\n          }\n        },\n        loc: {\n          start: {\n            line: 282,\n            column: 34\n          },\n          end: {\n            line: 285,\n            column: 5\n          }\n        },\n        line: 282\n      },\n      \"5\": {\n        name: \"(anonymous_5)\",\n        decl: {\n          start: {\n            line: 286,\n            column: 22\n          },\n          end: {\n            line: 286,\n            column: 23\n          }\n        },\n        loc: {\n          start: {\n            line: 286,\n            column: 33\n          },\n          end: {\n            line: 289,\n            column: 5\n          }\n        },\n        line: 286\n      },\n      \"6\": {\n        name: \"(anonymous_6)\",\n        decl: {\n          start: {\n            line: 290,\n            column: 19\n          },\n          end: {\n            line: 290,\n            column: 20\n          }\n        },\n        loc: {\n          start: {\n            line: 290,\n            column: 30\n          },\n          end: {\n            line: 293,\n            column: 5\n          }\n        },\n        line: 290\n      },\n      \"7\": {\n        name: \"(anonymous_7)\",\n        decl: {\n          start: {\n            line: 294,\n            column: 24\n          },\n          end: {\n            line: 294,\n            column: 25\n          }\n        },\n        loc: {\n          start: {\n            line: 294,\n            column: 35\n          },\n          end: {\n            line: 318,\n            column: 5\n          }\n        },\n        line: 294\n      },\n      \"8\": {\n        name: \"checkIfEntityAndChildrenAreValid\",\n        decl: {\n          start: {\n            line: 297,\n            column: 15\n          },\n          end: {\n            line: 297,\n            column: 47\n          }\n        },\n        loc: {\n          start: {\n            line: 297,\n            column: 56\n          },\n          end: {\n            line: 315,\n            column: 7\n          }\n        },\n        line: 297\n      },\n      \"9\": {\n        name: \"(anonymous_9)\",\n        decl: {\n          start: {\n            line: 320,\n            column: 11\n          },\n          end: {\n            line: 320,\n            column: 12\n          }\n        },\n        loc: {\n          start: {\n            line: 320,\n            column: 22\n          },\n          end: {\n            line: 331,\n            column: 3\n          }\n        },\n        line: 320\n      },\n      \"10\": {\n        name: \"(anonymous_10)\",\n        decl: {\n          start: {\n            line: 333,\n            column: 21\n          },\n          end: {\n            line: 333,\n            column: 22\n          }\n        },\n        loc: {\n          start: {\n            line: 333,\n            column: 31\n          },\n          end: {\n            line: 341,\n            column: 5\n          }\n        },\n        line: 333\n      },\n      \"11\": {\n        name: \"(anonymous_11)\",\n        decl: {\n          start: {\n            line: 337,\n            column: 63\n          },\n          end: {\n            line: 337,\n            column: 64\n          }\n        },\n        loc: {\n          start: {\n            line: 337,\n            column: 73\n          },\n          end: {\n            line: 339,\n            column: 9\n          }\n        },\n        line: 337\n      },\n      \"12\": {\n        name: \"(anonymous_12)\",\n        decl: {\n          start: {\n            line: 342,\n            column: 28\n          },\n          end: {\n            line: 342,\n            column: 29\n          }\n        },\n        loc: {\n          start: {\n            line: 342,\n            column: 39\n          },\n          end: {\n            line: 361,\n            column: 5\n          }\n        },\n        line: 342\n      },\n      \"13\": {\n        name: \"addUUIDsToQueryAndChildren\",\n        decl: {\n          start: {\n            line: 345,\n            column: 15\n          },\n          end: {\n            line: 345,\n            column: 41\n          }\n        },\n        loc: {\n          start: {\n            line: 345,\n            column: 48\n          },\n          end: {\n            line: 358,\n            column: 7\n          }\n        },\n        line: 345\n      },\n      \"14\": {\n        name: \"(anonymous_14)\",\n        decl: {\n          start: {\n            line: 362,\n            column: 25\n          },\n          end: {\n            line: 362,\n            column: 26\n          }\n        },\n        loc: {\n          start: {\n            line: 362,\n            column: 36\n          },\n          end: {\n            line: 367,\n            column: 5\n          }\n        },\n        line: 362\n      },\n      \"15\": {\n        name: \"(anonymous_15)\",\n        decl: {\n          start: {\n            line: 368,\n            column: 29\n          },\n          end: {\n            line: 368,\n            column: 30\n          }\n        },\n        loc: {\n          start: {\n            line: 368,\n            column: 40\n          },\n          end: {\n            line: 377,\n            column: 5\n          }\n        },\n        line: 368\n      },\n      \"16\": {\n        name: \"(anonymous_16)\",\n        decl: {\n          start: {\n            line: 378,\n            column: 22\n          },\n          end: {\n            line: 378,\n            column: 23\n          }\n        },\n        loc: {\n          start: {\n            line: 378,\n            column: 33\n          },\n          end: {\n            line: 387,\n            column: 5\n          }\n        },\n        line: 378\n      },\n      \"17\": {\n        name: \"(anonymous_17)\",\n        decl: {\n          start: {\n            line: 388,\n            column: 15\n          },\n          end: {\n            line: 388,\n            column: 16\n          }\n        },\n        loc: {\n          start: {\n            line: 388,\n            column: 26\n          },\n          end: {\n            line: 399,\n            column: 5\n          }\n        },\n        line: 388\n      },\n      \"18\": {\n        name: \"(anonymous_18)\",\n        decl: {\n          start: {\n            line: 400,\n            column: 20\n          },\n          end: {\n            line: 400,\n            column: 21\n          }\n        },\n        loc: {\n          start: {\n            line: 400,\n            column: 36\n          },\n          end: {\n            line: 405,\n            column: 5\n          }\n        },\n        line: 400\n      },\n      \"19\": {\n        name: \"(anonymous_19)\",\n        decl: {\n          start: {\n            line: 406,\n            column: 17\n          },\n          end: {\n            line: 406,\n            column: 18\n          }\n        },\n        loc: {\n          start: {\n            line: 406,\n            column: 28\n          },\n          end: {\n            line: 409,\n            column: 5\n          }\n        },\n        line: 406\n      },\n      \"20\": {\n        name: \"(anonymous_20)\",\n        decl: {\n          start: {\n            line: 410,\n            column: 18\n          },\n          end: {\n            line: 410,\n            column: 19\n          }\n        },\n        loc: {\n          start: {\n            line: 410,\n            column: 29\n          },\n          end: {\n            line: 413,\n            column: 5\n          }\n        },\n        line: 410\n      },\n      \"21\": {\n        name: \"(anonymous_21)\",\n        decl: {\n          start: {\n            line: 414,\n            column: 22\n          },\n          end: {\n            line: 414,\n            column: 23\n          }\n        },\n        loc: {\n          start: {\n            line: 414,\n            column: 38\n          },\n          end: {\n            line: 435,\n            column: 5\n          }\n        },\n        line: 414\n      },\n      \"22\": {\n        name: \"(anonymous_22)\",\n        decl: {\n          start: {\n            line: 427,\n            column: 14\n          },\n          end: {\n            line: 427,\n            column: 15\n          }\n        },\n        loc: {\n          start: {\n            line: 427,\n            column: 33\n          },\n          end: {\n            line: 434,\n            column: 7\n          }\n        },\n        line: 427\n      },\n      \"23\": {\n        name: \"(anonymous_23)\",\n        decl: {\n          start: {\n            line: 440,\n            column: 15\n          },\n          end: {\n            line: 440,\n            column: 16\n          }\n        },\n        loc: {\n          start: {\n            line: 440,\n            column: 26\n          },\n          end: {\n            line: 446,\n            column: 7\n          }\n        },\n        line: 440\n      }\n    },\n    branchMap: {\n      \"0\": {\n        loc: {\n          start: {\n            line: 288,\n            column: 13\n          },\n          end: {\n            line: 288,\n            column: 53\n          }\n        },\n        type: \"binary-expr\",\n        locations: [{\n          start: {\n            line: 288,\n            column: 13\n          },\n          end: {\n            line: 288,\n            column: 25\n          }\n        }, {\n          start: {\n            line: 288,\n            column: 29\n          },\n          end: {\n            line: 288,\n            column: 53\n          }\n        }],\n        line: 288\n      },\n      \"1\": {\n        loc: {\n          start: {\n            line: 292,\n            column: 13\n          },\n          end: {\n            line: 292,\n            column: 42\n          }\n        },\n        type: \"cond-expr\",\n        locations: [{\n          start: {\n            line: 292,\n            column: 28\n          },\n          end: {\n            line: 292,\n            column: 34\n          }\n        }, {\n          start: {\n            line: 292,\n            column: 37\n          },\n          end: {\n            line: 292,\n            column: 42\n          }\n        }],\n        line: 292\n      },\n      \"2\": {\n        loc: {\n          start: {\n            line: 301,\n            column: 8\n          },\n          end: {\n            line: 312,\n            column: 9\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 301,\n            column: 8\n          },\n          end: {\n            line: 312,\n            column: 9\n          }\n        }, {\n          start: {\n            line: 301,\n            column: 8\n          },\n          end: {\n            line: 312,\n            column: 9\n          }\n        }],\n        line: 301\n      },\n      \"3\": {\n        loc: {\n          start: {\n            line: 302,\n            column: 10\n          },\n          end: {\n            line: 304,\n            column: 11\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 302,\n            column: 10\n          },\n          end: {\n            line: 304,\n            column: 11\n          }\n        }, {\n          start: {\n            line: 302,\n            column: 10\n          },\n          end: {\n            line: 304,\n            column: 11\n          }\n        }],\n        line: 302\n      },\n      \"4\": {\n        loc: {\n          start: {\n            line: 302,\n            column: 14\n          },\n          end: {\n            line: 302,\n            column: 75\n          }\n        },\n        type: \"binary-expr\",\n        locations: [{\n          start: {\n            line: 302,\n            column: 14\n          },\n          end: {\n            line: 302,\n            column: 35\n          }\n        }, {\n          start: {\n            line: 302,\n            column: 39\n          },\n          end: {\n            line: 302,\n            column: 75\n          }\n        }],\n        line: 302\n      },\n      \"5\": {\n        loc: {\n          start: {\n            line: 305,\n            column: 15\n          },\n          end: {\n            line: 312,\n            column: 9\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 305,\n            column: 15\n          },\n          end: {\n            line: 312,\n            column: 9\n          }\n        }, {\n          start: {\n            line: 305,\n            column: 15\n          },\n          end: {\n            line: 312,\n            column: 9\n          }\n        }],\n        line: 305\n      },\n      \"6\": {\n        loc: {\n          start: {\n            line: 308,\n            column: 12\n          },\n          end: {\n            line: 310,\n            column: 13\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 308,\n            column: 12\n          },\n          end: {\n            line: 310,\n            column: 13\n          }\n        }, {\n          start: {\n            line: 308,\n            column: 12\n          },\n          end: {\n            line: 310,\n            column: 13\n          }\n        }],\n        line: 308\n      },\n      \"7\": {\n        loc: {\n          start: {\n            line: 326,\n            column: 4\n          },\n          end: {\n            line: 330,\n            column: 5\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 326,\n            column: 4\n          },\n          end: {\n            line: 330,\n            column: 5\n          }\n        }, {\n          start: {\n            line: 326,\n            column: 4\n          },\n          end: {\n            line: 330,\n            column: 5\n          }\n        }],\n        line: 326\n      },\n      \"8\": {\n        loc: {\n          start: {\n            line: 335,\n            column: 6\n          },\n          end: {\n            line: 340,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 335,\n            column: 6\n          },\n          end: {\n            line: 340,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 335,\n            column: 6\n          },\n          end: {\n            line: 340,\n            column: 7\n          }\n        }],\n        line: 335\n      },\n      \"9\": {\n        loc: {\n          start: {\n            line: 352,\n            column: 8\n          },\n          end: {\n            line: 357,\n            column: 9\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 352,\n            column: 8\n          },\n          end: {\n            line: 357,\n            column: 9\n          }\n        }, {\n          start: {\n            line: 352,\n            column: 8\n          },\n          end: {\n            line: 357,\n            column: 9\n          }\n        }],\n        line: 352\n      },\n      \"10\": {\n        loc: {\n          start: {\n            line: 371,\n            column: 6\n          },\n          end: {\n            line: 375,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 371,\n            column: 6\n          },\n          end: {\n            line: 375,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 371,\n            column: 6\n          },\n          end: {\n            line: 375,\n            column: 7\n          }\n        }],\n        line: 371\n      },\n      \"11\": {\n        loc: {\n          start: {\n            line: 381,\n            column: 6\n          },\n          end: {\n            line: 385,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 381,\n            column: 6\n          },\n          end: {\n            line: 385,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 381,\n            column: 6\n          },\n          end: {\n            line: 385,\n            column: 7\n          }\n        }],\n        line: 381\n      },\n      \"12\": {\n        loc: {\n          start: {\n            line: 428,\n            column: 8\n          },\n          end: {\n            line: 433,\n            column: 9\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 428,\n            column: 8\n          },\n          end: {\n            line: 433,\n            column: 9\n          }\n        }, {\n          start: {\n            line: 428,\n            column: 8\n          },\n          end: {\n            line: 433,\n            column: 9\n          }\n        }],\n        line: 428\n      },\n      \"13\": {\n        loc: {\n          start: {\n            line: 443,\n            column: 8\n          },\n          end: {\n            line: 445,\n            column: 9\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 443,\n            column: 8\n          },\n          end: {\n            line: 445,\n            column: 9\n          }\n        }, {\n          start: {\n            line: 443,\n            column: 8\n          },\n          end: {\n            line: 445,\n            column: 9\n          }\n        }],\n        line: 443\n      }\n    },\n    s: {\n      \"0\": 0,\n      \"1\": 0,\n      \"2\": 0,\n      \"3\": 0,\n      \"4\": 0,\n      \"5\": 0,\n      \"6\": 0,\n      \"7\": 0,\n      \"8\": 0,\n      \"9\": 0,\n      \"10\": 0,\n      \"11\": 0,\n      \"12\": 0,\n      \"13\": 0,\n      \"14\": 0,\n      \"15\": 0,\n      \"16\": 0,\n      \"17\": 0,\n      \"18\": 0,\n      \"19\": 0,\n      \"20\": 0,\n      \"21\": 0,\n      \"22\": 0,\n      \"23\": 0,\n      \"24\": 0,\n      \"25\": 0,\n      \"26\": 0,\n      \"27\": 0,\n      \"28\": 0,\n      \"29\": 0,\n      \"30\": 0,\n      \"31\": 0,\n      \"32\": 0,\n      \"33\": 0,\n      \"34\": 0,\n      \"35\": 0,\n      \"36\": 0,\n      \"37\": 0,\n      \"38\": 0,\n      \"39\": 0,\n      \"40\": 0,\n      \"41\": 0,\n      \"42\": 0,\n      \"43\": 0,\n      \"44\": 0,\n      \"45\": 0,\n      \"46\": 0,\n      \"47\": 0,\n      \"48\": 0,\n      \"49\": 0,\n      \"50\": 0,\n      \"51\": 0,\n      \"52\": 0,\n      \"53\": 0,\n      \"54\": 0,\n      \"55\": 0,\n      \"56\": 0,\n      \"57\": 0,\n      \"58\": 0,\n      \"59\": 0,\n      \"60\": 0,\n      \"61\": 0,\n      \"62\": 0,\n      \"63\": 0,\n      \"64\": 0,\n      \"65\": 0,\n      \"66\": 0,\n      \"67\": 0,\n      \"68\": 0,\n      \"69\": 0,\n      \"70\": 0,\n      \"71\": 0,\n      \"72\": 0,\n      \"73\": 0,\n      \"74\": 0,\n      \"75\": 0,\n      \"76\": 0,\n      \"77\": 0,\n      \"78\": 0,\n      \"79\": 0,\n      \"80\": 0,\n      \"81\": 0,\n      \"82\": 0,\n      \"83\": 0,\n      \"84\": 0,\n      \"85\": 0,\n      \"86\": 0\n    },\n    f: {\n      \"0\": 0,\n      \"1\": 0,\n      \"2\": 0,\n      \"3\": 0,\n      \"4\": 0,\n      \"5\": 0,\n      \"6\": 0,\n      \"7\": 0,\n      \"8\": 0,\n      \"9\": 0,\n      \"10\": 0,\n      \"11\": 0,\n      \"12\": 0,\n      \"13\": 0,\n      \"14\": 0,\n      \"15\": 0,\n      \"16\": 0,\n      \"17\": 0,\n      \"18\": 0,\n      \"19\": 0,\n      \"20\": 0,\n      \"21\": 0,\n      \"22\": 0,\n      \"23\": 0\n    },\n    b: {\n      \"0\": [0, 0],\n      \"1\": [0, 0],\n      \"2\": [0, 0],\n      \"3\": [0, 0],\n      \"4\": [0, 0],\n      \"5\": [0, 0],\n      \"6\": [0, 0],\n      \"7\": [0, 0],\n      \"8\": [0, 0],\n      \"9\": [0, 0],\n      \"10\": [0, 0],\n      \"11\": [0, 0],\n      \"12\": [0, 0],\n      \"13\": [0, 0]\n    },\n    _coverageSchema: \"1a1c01bbd47fc00a2c39e90264f33305004495a9\",\n    hash: \"305d0d1aeb87c9b96c05676ba105a7dadd346823\"\n  };\n  var coverage = global[gcv] || (global[gcv] = {});\n\n  if (!coverage[path] || coverage[path].hash !== hash) {\n    coverage[path] = coverageData;\n  }\n\n  var actualCoverage = coverage[path];\n  {\n    // @ts-ignore\n    cov_d6iw7jf9e = function () {\n      return actualCoverage;\n    };\n  }\n  return actualCoverage;\n}\n\ncov_d6iw7jf9e();\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n\ncov_d6iw7jf9e().s[0]++;\nvue__WEBPACK_IMPORTED_MODULE_8__[\"default\"].use(__webpack_require__(/*! vue-moment */ \"./node_modules/vue-moment/dist/vue-moment.js\"));\n\n\n/**\r\n  * VueJSONQueryBuilder is a Vue-based UI component that allows the user to generate queries in JSON format.\r\n  * @displayName Vue JSON Query Builder\r\n*/\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  name: 'VueJSONQueryBuilder',\n  components: {\n    VueQueryGroup: _components_vue_query_group_vue__WEBPACK_IMPORTED_MODULE_10__[\"default\"]\n  },\n  props: {\n    /**\r\n      * The initial query to load into VueJSONQueryBuilder on load.\r\n    */\n    query: {\n      type: Object,\n      required: true\n    },\n\n    /**\r\n      * The options to define the parameters of each rule.\r\n    */\n    options: {\n      type: Array\n    },\n\n    /**\r\n      * @model\r\n      * Returns current query to parent component.\r\n    */\n    value: {\n      type: Object,\n      required: false,\n      default: function _default() {\n        cov_d6iw7jf9e().f[0]++;\n        cov_d6iw7jf9e().s[1]++;\n        return {};\n      }\n    },\n\n    /**\r\n      * The location in localStorage in which to store current query.\r\n    */\n    storage: {\n      type: String,\n      required: false,\n      default: ''\n    },\n\n    /**\r\n      * The function to run upon click of \"Run Query\" button, returning current query.\r\n    */\n    runQuery: {\n      type: [Function, Object],\n      required: false,\n      default: null\n    },\n\n    /**\r\n      * Determines whether VueJSONQueryBuilder instance is collapsed or expanded upon load.\r\n    */\n    visible: {\n      type: Boolean,\n      required: false,\n      default: true\n    }\n  },\n  data: function data() {\n    cov_d6iw7jf9e().f[1]++;\n    cov_d6iw7jf9e().s[2]++;\n    return {\n      currentQuery: {},\n      isVisible: this.visible,\n      storedQueries: '',\n      loading: false,\n      modals: {\n        saveQuery: {\n          visible: false,\n          queryName: ''\n        },\n        viewSavedQueries: {\n          visible: false,\n          savedQueries: []\n        }\n      }\n    };\n  },\n  computed: {\n    savedQueriesLocation: function savedQueriesLocation() {\n      cov_d6iw7jf9e().f[2]++;\n      var self = (cov_d6iw7jf9e().s[3]++, this);\n      cov_d6iw7jf9e().s[4]++;\n      return 'VueJSONQueryBuilder_saved_' + self.storage;\n    },\n    storedQueriesLocation: function storedQueriesLocation() {\n      cov_d6iw7jf9e().f[3]++;\n      var self = (cov_d6iw7jf9e().s[5]++, this);\n      cov_d6iw7jf9e().s[6]++;\n      return 'VueJSONQueryBuilder_stored_' + self.storage;\n    },\n    saveQueryDisabled: function saveQueryDisabled() {\n      cov_d6iw7jf9e().f[4]++;\n      var self = (cov_d6iw7jf9e().s[7]++, this);\n      cov_d6iw7jf9e().s[8]++;\n      return self.modals.saveQuery.queryName.length < 2;\n    },\n    runQueryDisabled: function runQueryDisabled() {\n      cov_d6iw7jf9e().f[5]++;\n      var self = (cov_d6iw7jf9e().s[9]++, this);\n      cov_d6iw7jf9e().s[10]++;\n      return (cov_d6iw7jf9e().b[0][0]++, self.loading) || (cov_d6iw7jf9e().b[0][1]++, !self.areAllQueriesValid);\n    },\n    pointerEvents: function pointerEvents() {\n      cov_d6iw7jf9e().f[6]++;\n      var self = (cov_d6iw7jf9e().s[11]++, this);\n      cov_d6iw7jf9e().s[12]++;\n      return self.loading ? (cov_d6iw7jf9e().b[1][0]++, 'none') : (cov_d6iw7jf9e().b[1][1]++, 'all');\n    },\n    areAllQueriesValid: function areAllQueriesValid() {\n      cov_d6iw7jf9e().f[7]++;\n      var self = (cov_d6iw7jf9e().s[13]++, this);\n\n      function checkIfEntityAndChildrenAreValid(entity) {\n        cov_d6iw7jf9e().f[8]++;\n        var keys = (cov_d6iw7jf9e().s[14]++, Object.keys(entity));\n        var response = (cov_d6iw7jf9e().s[15]++, true);\n        cov_d6iw7jf9e().s[16]++;\n\n        if (keys.includes('value')) {\n          cov_d6iw7jf9e().b[2][0]++;\n          cov_d6iw7jf9e().s[17]++;\n\n          if ((cov_d6iw7jf9e().b[4][0]++, entity.value === null) || (cov_d6iw7jf9e().b[4][1]++, entity.value.toString().length === 0)) {\n            cov_d6iw7jf9e().b[3][0]++;\n            cov_d6iw7jf9e().s[18]++;\n            response = false;\n          } else {\n            cov_d6iw7jf9e().b[3][1]++;\n          }\n        } else {\n          cov_d6iw7jf9e().b[2][1]++;\n          cov_d6iw7jf9e().s[19]++;\n\n          if (keys.includes('rules')) {\n            cov_d6iw7jf9e().b[5][0]++;\n            cov_d6iw7jf9e().s[20]++;\n\n            for (var i = (cov_d6iw7jf9e().s[21]++, 0); i < entity.rules.length; i++) {\n              var rule = (cov_d6iw7jf9e().s[22]++, entity.rules[i]);\n              cov_d6iw7jf9e().s[23]++;\n\n              if (!checkIfEntityAndChildrenAreValid(rule)) {\n                cov_d6iw7jf9e().b[6][0]++;\n                cov_d6iw7jf9e().s[24]++;\n                response = false;\n              } else {\n                cov_d6iw7jf9e().b[6][1]++;\n              }\n            }\n          } else {\n            cov_d6iw7jf9e().b[5][1]++;\n          }\n        }\n\n        cov_d6iw7jf9e().s[25]++;\n        return response;\n      }\n\n      cov_d6iw7jf9e().s[26]++;\n      return checkIfEntityAndChildrenAreValid(self.currentQuery);\n    }\n  },\n  created: function created() {\n    cov_d6iw7jf9e().f[9]++;\n    var self = (cov_d6iw7jf9e().s[27]++, this);\n    cov_d6iw7jf9e().s[28]++;\n    self.getAndStoreSavedQueries();\n    var storedQueries = (cov_d6iw7jf9e().s[29]++, self.getStoredQueries());\n    cov_d6iw7jf9e().s[30]++;\n\n    if (storedQueries) {\n      cov_d6iw7jf9e().b[7][0]++;\n      cov_d6iw7jf9e().s[31]++;\n      self.currentQuery = JSON.parse(JSON.stringify(storedQueries));\n    } else {\n      cov_d6iw7jf9e().b[7][1]++;\n      cov_d6iw7jf9e().s[32]++;\n      self.resetToDefaultQuery();\n    }\n  },\n  methods: {\n    runCurrentQuery: function runCurrentQuery() {\n      cov_d6iw7jf9e().f[10]++;\n      var self = (cov_d6iw7jf9e().s[33]++, this);\n      cov_d6iw7jf9e().s[34]++;\n\n      if (self.runQuery) {\n        cov_d6iw7jf9e().b[8][0]++;\n        cov_d6iw7jf9e().s[35]++;\n        self.loading = true;\n        cov_d6iw7jf9e().s[36]++;\n        Promise.resolve(self.runQuery(self.currentQuery)).then(function () {\n          cov_d6iw7jf9e().f[11]++;\n          cov_d6iw7jf9e().s[37]++;\n          self.loading = false;\n        });\n      } else {\n        cov_d6iw7jf9e().b[8][1]++;\n      }\n    },\n    addUUIDsToCurrentQuery: function addUUIDsToCurrentQuery() {\n      cov_d6iw7jf9e().f[12]++;\n      var self = (cov_d6iw7jf9e().s[38]++, this);\n\n      function addUUIDsToQueryAndChildren(query) {\n        cov_d6iw7jf9e().f[13]++;\n        var keys = (cov_d6iw7jf9e().s[39]++, Object.keys(query));\n        cov_d6iw7jf9e().s[40]++;\n        Object.defineProperty(query, '_uuid', {\n          enumerable: false,\n          value: Object(uuid__WEBPACK_IMPORTED_MODULE_9__[\"v4\"])()\n        });\n        cov_d6iw7jf9e().s[41]++;\n\n        if (keys.includes('rules')) {\n          cov_d6iw7jf9e().b[9][0]++;\n          cov_d6iw7jf9e().s[42]++;\n\n          for (var i = (cov_d6iw7jf9e().s[43]++, 0); i < query.rules.length; i++) {\n            var rule = (cov_d6iw7jf9e().s[44]++, query.rules[i]);\n            cov_d6iw7jf9e().s[45]++;\n            addUUIDsToQueryAndChildren(rule);\n          }\n        } else {\n          cov_d6iw7jf9e().b[9][1]++;\n        }\n      }\n\n      cov_d6iw7jf9e().s[46]++;\n      addUUIDsToQueryAndChildren(self.currentQuery);\n    },\n    resetToDefaultQuery: function resetToDefaultQuery() {\n      cov_d6iw7jf9e().f[14]++;\n      var self = (cov_d6iw7jf9e().s[47]++, this);\n      cov_d6iw7jf9e().s[48]++;\n      self.currentQuery = JSON.parse(JSON.stringify(self.query));\n      cov_d6iw7jf9e().s[49]++;\n      self.addUUIDsToCurrentQuery();\n    },\n    getAndStoreSavedQueries: function getAndStoreSavedQueries() {\n      cov_d6iw7jf9e().f[15]++;\n      var self = (cov_d6iw7jf9e().s[50]++, this);\n      var savedQueries = (cov_d6iw7jf9e().s[51]++, JSON.parse(localStorage.getItem(self.savedQueriesLocation)));\n      cov_d6iw7jf9e().s[52]++;\n\n      if (Array.isArray(savedQueries)) {\n        cov_d6iw7jf9e().b[10][0]++;\n        cov_d6iw7jf9e().s[53]++;\n        self.modals.viewSavedQueries.savedQueries = savedQueries;\n      } else {\n        cov_d6iw7jf9e().b[10][1]++;\n        cov_d6iw7jf9e().s[54]++;\n        self.modals.viewSavedQueries.savedQueries = [];\n      }\n\n      cov_d6iw7jf9e().s[55]++;\n      return self.modals.viewSavedQueries.savedQueries;\n    },\n    getStoredQueries: function getStoredQueries() {\n      cov_d6iw7jf9e().f[16]++;\n      var self = (cov_d6iw7jf9e().s[56]++, this);\n      var storedQueries = (cov_d6iw7jf9e().s[57]++, JSON.parse(localStorage.getItem(self.storedQueriesLocation)));\n      cov_d6iw7jf9e().s[58]++;\n\n      if (Object(C_Users_eedge_Documents_GitHub_vue_query_builder_node_modules_babel_runtime_helpers_esm_typeof__WEBPACK_IMPORTED_MODULE_7__[\"default\"])(storedQueries) === 'object') {\n        cov_d6iw7jf9e().b[11][0]++;\n        cov_d6iw7jf9e().s[59]++;\n        self.storedQueries = storedQueries;\n      } else {\n        cov_d6iw7jf9e().b[11][1]++;\n        cov_d6iw7jf9e().s[60]++;\n        self.storedQueries = [];\n      }\n\n      cov_d6iw7jf9e().s[61]++;\n      return self.storedQueries;\n    },\n    saveQuery: function saveQuery() {\n      cov_d6iw7jf9e().f[17]++;\n      var self = (cov_d6iw7jf9e().s[62]++, this);\n      var savedQueries = (cov_d6iw7jf9e().s[63]++, self.modals.viewSavedQueries.savedQueries);\n      cov_d6iw7jf9e().s[64]++;\n      savedQueries.push({\n        name: self.modals.saveQuery.queryName,\n        createdDate: new Date(),\n        query: self.currentQuery\n      });\n      cov_d6iw7jf9e().s[65]++;\n      self.saveQueries();\n      cov_d6iw7jf9e().s[66]++;\n      self.modals.saveQuery.visible = false;\n      cov_d6iw7jf9e().s[67]++;\n      self.modals.saveQuery.queryName = '';\n    },\n    loadSavedQuery: function loadSavedQuery(query) {\n      cov_d6iw7jf9e().f[18]++;\n      var self = (cov_d6iw7jf9e().s[68]++, this);\n      cov_d6iw7jf9e().s[69]++;\n      self.currentQuery = JSON.parse(JSON.stringify(query));\n      cov_d6iw7jf9e().s[70]++;\n      self.addUUIDsToCurrentQuery();\n      cov_d6iw7jf9e().s[71]++;\n      self.modals.viewSavedQueries.visible = false;\n    },\n    saveQueries: function saveQueries() {\n      cov_d6iw7jf9e().f[19]++;\n      var self = (cov_d6iw7jf9e().s[72]++, this);\n      cov_d6iw7jf9e().s[73]++;\n      localStorage.setItem(self.savedQueriesLocation, JSON.stringify(self.modals.viewSavedQueries.savedQueries));\n    },\n    storeQueries: function storeQueries() {\n      cov_d6iw7jf9e().f[20]++;\n      var self = (cov_d6iw7jf9e().s[74]++, this);\n      cov_d6iw7jf9e().s[75]++;\n      localStorage.setItem(self.storedQueriesLocation, JSON.stringify(self.currentQuery));\n    },\n    deleteSavedQuery: function deleteSavedQuery(query) {\n      cov_d6iw7jf9e().f[21]++;\n      var self = (cov_d6iw7jf9e().s[76]++, this);\n      var currentSavedQueries = (cov_d6iw7jf9e().s[77]++, self.modals.viewSavedQueries.savedQueries);\n      cov_d6iw7jf9e().s[78]++;\n      self.$bvModal.msgBoxConfirm('Please confirm that you wish to delete this query.', {\n        title: 'Confirm Query Deletion',\n        size: 'sm',\n        buttonSize: 'sm',\n        okVariant: 'danger',\n        okTitle: 'Yes',\n        cancelTitle: 'No',\n        footerClass: 'p-2',\n        hideHeaderClose: true,\n        centered: true\n      }).then(function (response) {\n        cov_d6iw7jf9e().f[22]++;\n        cov_d6iw7jf9e().s[79]++;\n\n        if (response === true) {\n          cov_d6iw7jf9e().b[12][0]++;\n          cov_d6iw7jf9e().s[80]++;\n          currentSavedQueries.splice(currentSavedQueries.indexOf(query), 1);\n          cov_d6iw7jf9e().s[81]++;\n          self.saveQueries();\n        } else {\n          cov_d6iw7jf9e().b[12][1]++;\n          cov_d6iw7jf9e().s[82]++;\n          return false;\n        }\n      });\n    }\n  },\n  watch: {\n    currentQuery: {\n      deep: true,\n      handler: function handler() {\n        cov_d6iw7jf9e().f[23]++;\n        var self = (cov_d6iw7jf9e().s[83]++, this);\n        cov_d6iw7jf9e().s[84]++;\n        self.$emit('input', self.currentQuery);\n        cov_d6iw7jf9e().s[85]++;\n\n        if (self.storage) {\n          cov_d6iw7jf9e().b[13][0]++;\n          cov_d6iw7jf9e().s[86]++;\n          self.storeQueries();\n        } else {\n          cov_d6iw7jf9e().b[13][1]++;\n        }\n      }\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?./node_modules/cache-loader/dist/cjs.js??ref--13-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-group.vue?vue&type=script&lang=js&":
/*!************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js??ref--13-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-query-group.vue?vue&type=script&lang=js& ***!
  \************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! core-js/modules/es.array.index-of */ \"./node_modules/core-js/modules/es.array.index-of.js\");\n/* harmony import */ var core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! core-js/modules/es.array.splice */ \"./node_modules/core-js/modules/es.array.splice.js\");\n/* harmony import */ var core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var core_js_modules_es_number_constructor__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! core-js/modules/es.number.constructor */ \"./node_modules/core-js/modules/es.number.constructor.js\");\n/* harmony import */ var core_js_modules_es_number_constructor__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_number_constructor__WEBPACK_IMPORTED_MODULE_2__);\n/* harmony import */ var uuid__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! uuid */ \"./node_modules/uuid/dist/esm-browser/index.js\");\n/* harmony import */ var _components_vue_query_rule_vue__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @/components/vue-query-rule.vue */ \"./src/components/vue-query-rule.vue\");\n\n\n\n\nfunction cov_1chrm2kor3() {\n  var path = \"C:\\\\Users\\\\eedge\\\\Documents\\\\GitHub\\\\vue-query-builder\\\\src\\\\components\\\\vue-query-group.vue\";\n  var hash = \"1466fd83034a340d2827ff7309dc43c441ff69f7\";\n  var global = new Function(\"return this\")();\n  var gcv = \"__coverage__\";\n  var coverageData = {\n    path: \"C:\\\\Users\\\\eedge\\\\Documents\\\\GitHub\\\\vue-query-builder\\\\src\\\\components\\\\vue-query-group.vue\",\n    statementMap: {\n      \"0\": {\n        start: {\n          line: 162,\n          column: 4\n        },\n        end: {\n          line: 164,\n          column: 5\n        }\n      },\n      \"1\": {\n        start: {\n          line: 167,\n          column: 19\n        },\n        end: {\n          line: 167,\n          column: 23\n        }\n      },\n      \"2\": {\n        start: {\n          line: 168,\n          column: 6\n        },\n        end: {\n          line: 170,\n          column: 7\n        }\n      },\n      \"3\": {\n        start: {\n          line: 169,\n          column: 8\n        },\n        end: {\n          line: 169,\n          column: 23\n        }\n      },\n      \"4\": {\n        start: {\n          line: 174,\n          column: 19\n        },\n        end: {\n          line: 174,\n          column: 23\n        }\n      },\n      \"5\": {\n        start: {\n          line: 175,\n          column: 6\n        },\n        end: {\n          line: 177,\n          column: 7\n        }\n      },\n      \"6\": {\n        start: {\n          line: 176,\n          column: 8\n        },\n        end: {\n          line: 176,\n          column: 24\n        }\n      },\n      \"7\": {\n        start: {\n          line: 178,\n          column: 6\n        },\n        end: {\n          line: 178,\n          column: 31\n        }\n      },\n      \"8\": {\n        start: {\n          line: 181,\n          column: 19\n        },\n        end: {\n          line: 181,\n          column: 23\n        }\n      },\n      \"9\": {\n        start: {\n          line: 182,\n          column: 6\n        },\n        end: {\n          line: 184,\n          column: 7\n        }\n      },\n      \"10\": {\n        start: {\n          line: 183,\n          column: 8\n        },\n        end: {\n          line: 183,\n          column: 24\n        }\n      },\n      \"11\": {\n        start: {\n          line: 185,\n          column: 6\n        },\n        end: {\n          line: 185,\n          column: 31\n        }\n      },\n      \"12\": {\n        start: {\n          line: 190,\n          column: 19\n        },\n        end: {\n          line: 190,\n          column: 23\n        }\n      },\n      \"13\": {\n        start: {\n          line: 191,\n          column: 23\n        },\n        end: {\n          line: 195,\n          column: 7\n        }\n      },\n      \"14\": {\n        start: {\n          line: 197,\n          column: 6\n        },\n        end: {\n          line: 200,\n          column: 8\n        }\n      },\n      \"15\": {\n        start: {\n          line: 202,\n          column: 6\n        },\n        end: {\n          line: 202,\n          column: 45\n        }\n      },\n      \"16\": {\n        start: {\n          line: 205,\n          column: 19\n        },\n        end: {\n          line: 205,\n          column: 23\n        }\n      },\n      \"17\": {\n        start: {\n          line: 206,\n          column: 22\n        },\n        end: {\n          line: 209,\n          column: 7\n        }\n      },\n      \"18\": {\n        start: {\n          line: 211,\n          column: 6\n        },\n        end: {\n          line: 214,\n          column: 8\n        }\n      },\n      \"19\": {\n        start: {\n          line: 216,\n          column: 6\n        },\n        end: {\n          line: 216,\n          column: 44\n        }\n      },\n      \"20\": {\n        start: {\n          line: 219,\n          column: 19\n        },\n        end: {\n          line: 219,\n          column: 23\n        }\n      },\n      \"21\": {\n        start: {\n          line: 220,\n          column: 26\n        },\n        end: {\n          line: 220,\n          column: 57\n        }\n      },\n      \"22\": {\n        start: {\n          line: 221,\n          column: 6\n        },\n        end: {\n          line: 221,\n          column: 68\n        }\n      }\n    },\n    fnMap: {\n      \"0\": {\n        name: \"(anonymous_0)\",\n        decl: {\n          start: {\n            line: 161,\n            column: 8\n          },\n          end: {\n            line: 161,\n            column: 9\n          }\n        },\n        loc: {\n          start: {\n            line: 161,\n            column: 19\n          },\n          end: {\n            line: 165,\n            column: 3\n          }\n        },\n        line: 161\n      },\n      \"1\": {\n        name: \"(anonymous_1)\",\n        decl: {\n          start: {\n            line: 166,\n            column: 11\n          },\n          end: {\n            line: 166,\n            column: 12\n          }\n        },\n        loc: {\n          start: {\n            line: 166,\n            column: 22\n          },\n          end: {\n            line: 171,\n            column: 3\n          }\n        },\n        line: 166\n      },\n      \"2\": {\n        name: \"(anonymous_2)\",\n        decl: {\n          start: {\n            line: 173,\n            column: 31\n          },\n          end: {\n            line: 173,\n            column: 32\n          }\n        },\n        loc: {\n          start: {\n            line: 173,\n            column: 42\n          },\n          end: {\n            line: 179,\n            column: 5\n          }\n        },\n        line: 173\n      },\n      \"3\": {\n        name: \"(anonymous_3)\",\n        decl: {\n          start: {\n            line: 180,\n            column: 30\n          },\n          end: {\n            line: 180,\n            column: 31\n          }\n        },\n        loc: {\n          start: {\n            line: 180,\n            column: 41\n          },\n          end: {\n            line: 186,\n            column: 5\n          }\n        },\n        line: 180\n      },\n      \"4\": {\n        name: \"(anonymous_4)\",\n        decl: {\n          start: {\n            line: 189,\n            column: 13\n          },\n          end: {\n            line: 189,\n            column: 14\n          }\n        },\n        loc: {\n          start: {\n            line: 189,\n            column: 24\n          },\n          end: {\n            line: 203,\n            column: 5\n          }\n        },\n        line: 189\n      },\n      \"5\": {\n        name: \"(anonymous_5)\",\n        decl: {\n          start: {\n            line: 204,\n            column: 14\n          },\n          end: {\n            line: 204,\n            column: 15\n          }\n        },\n        loc: {\n          start: {\n            line: 204,\n            column: 25\n          },\n          end: {\n            line: 217,\n            column: 5\n          }\n        },\n        line: 204\n      },\n      \"6\": {\n        name: \"(anonymous_6)\",\n        decl: {\n          start: {\n            line: 218,\n            column: 17\n          },\n          end: {\n            line: 218,\n            column: 18\n          }\n        },\n        loc: {\n          start: {\n            line: 218,\n            column: 28\n          },\n          end: {\n            line: 222,\n            column: 5\n          }\n        },\n        line: 218\n      }\n    },\n    branchMap: {\n      \"0\": {\n        loc: {\n          start: {\n            line: 168,\n            column: 6\n          },\n          end: {\n            line: 170,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 168,\n            column: 6\n          },\n          end: {\n            line: 170,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 168,\n            column: 6\n          },\n          end: {\n            line: 170,\n            column: 7\n          }\n        }],\n        line: 168\n      },\n      \"1\": {\n        loc: {\n          start: {\n            line: 175,\n            column: 6\n          },\n          end: {\n            line: 177,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 175,\n            column: 6\n          },\n          end: {\n            line: 177,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 175,\n            column: 6\n          },\n          end: {\n            line: 177,\n            column: 7\n          }\n        }],\n        line: 175\n      },\n      \"2\": {\n        loc: {\n          start: {\n            line: 182,\n            column: 6\n          },\n          end: {\n            line: 184,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 182,\n            column: 6\n          },\n          end: {\n            line: 184,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 182,\n            column: 6\n          },\n          end: {\n            line: 184,\n            column: 7\n          }\n        }],\n        line: 182\n      }\n    },\n    s: {\n      \"0\": 0,\n      \"1\": 0,\n      \"2\": 0,\n      \"3\": 0,\n      \"4\": 0,\n      \"5\": 0,\n      \"6\": 0,\n      \"7\": 0,\n      \"8\": 0,\n      \"9\": 0,\n      \"10\": 0,\n      \"11\": 0,\n      \"12\": 0,\n      \"13\": 0,\n      \"14\": 0,\n      \"15\": 0,\n      \"16\": 0,\n      \"17\": 0,\n      \"18\": 0,\n      \"19\": 0,\n      \"20\": 0,\n      \"21\": 0,\n      \"22\": 0\n    },\n    f: {\n      \"0\": 0,\n      \"1\": 0,\n      \"2\": 0,\n      \"3\": 0,\n      \"4\": 0,\n      \"5\": 0,\n      \"6\": 0\n    },\n    b: {\n      \"0\": [0, 0],\n      \"1\": [0, 0],\n      \"2\": [0, 0]\n    },\n    _coverageSchema: \"1a1c01bbd47fc00a2c39e90264f33305004495a9\",\n    hash: \"1466fd83034a340d2827ff7309dc43c441ff69f7\"\n  };\n  var coverage = global[gcv] || (global[gcv] = {});\n\n  if (!coverage[path] || coverage[path].hash !== hash) {\n    coverage[path] = coverageData;\n  }\n\n  var actualCoverage = coverage[path];\n  {\n    // @ts-ignore\n    cov_1chrm2kor3 = function () {\n      return actualCoverage;\n    };\n  }\n  return actualCoverage;\n}\n\ncov_1chrm2kor3();\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n\n\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  name: 'VueQueryGroup',\n  components: {\n    VueQueryRule: _components_vue_query_rule_vue__WEBPACK_IMPORTED_MODULE_4__[\"default\"]\n  },\n  props: {\n    currentQuery: {\n      type: Object,\n      required: true\n    },\n    options: {\n      type: Array\n    },\n    level: {\n      type: Number,\n      required: false,\n      default: 0\n    }\n  },\n  data: function data() {\n    cov_1chrm2kor3().f[0]++;\n    cov_1chrm2kor3().s[0]++;\n    return {\n      condition: 'and'\n    };\n  },\n  mounted: function mounted() {\n    cov_1chrm2kor3().f[1]++;\n    var self = (cov_1chrm2kor3().s[1]++, this);\n    cov_1chrm2kor3().s[2]++;\n\n    if (self.currentQuery.rules.length === 0) {\n      cov_1chrm2kor3().b[0][0]++;\n      cov_1chrm2kor3().s[3]++;\n      self.addRule();\n    } else {\n      cov_1chrm2kor3().b[0][1]++;\n    }\n  },\n  computed: {\n    andConditionButtonVariant: function andConditionButtonVariant() {\n      cov_1chrm2kor3().f[2]++;\n      var self = (cov_1chrm2kor3().s[4]++, this);\n      cov_1chrm2kor3().s[5]++;\n\n      if (self.currentQuery.condition === 'and') {\n        cov_1chrm2kor3().b[1][0]++;\n        cov_1chrm2kor3().s[6]++;\n        return 'primary';\n      } else {\n        cov_1chrm2kor3().b[1][1]++;\n      }\n\n      cov_1chrm2kor3().s[7]++;\n      return 'outline-primary';\n    },\n    orConditionButtonVariant: function orConditionButtonVariant() {\n      cov_1chrm2kor3().f[3]++;\n      var self = (cov_1chrm2kor3().s[8]++, this);\n      cov_1chrm2kor3().s[9]++;\n\n      if (self.currentQuery.condition === 'or') {\n        cov_1chrm2kor3().b[2][0]++;\n        cov_1chrm2kor3().s[10]++;\n        return 'primary';\n      } else {\n        cov_1chrm2kor3().b[2][1]++;\n      }\n\n      cov_1chrm2kor3().s[11]++;\n      return 'outline-primary';\n    }\n  },\n  methods: {\n    addRule: function addRule() {\n      cov_1chrm2kor3().f[4]++;\n      var self = (cov_1chrm2kor3().s[12]++, this);\n      var newGroup = (cov_1chrm2kor3().s[13]++, {\n        id: self.options[0].id,\n        operator: '=',\n        value: ''\n      });\n      cov_1chrm2kor3().s[14]++;\n      Object.defineProperty(newGroup, '_uuid', {\n        enumerable: false,\n        value: Object(uuid__WEBPACK_IMPORTED_MODULE_3__[\"v4\"])()\n      });\n      cov_1chrm2kor3().s[15]++;\n      self.currentQuery.rules.push(newGroup);\n    },\n    addGroup: function addGroup() {\n      cov_1chrm2kor3().f[5]++;\n      var self = (cov_1chrm2kor3().s[16]++, this);\n      var newRule = (cov_1chrm2kor3().s[17]++, {\n        condition: 'and',\n        rules: []\n      });\n      cov_1chrm2kor3().s[18]++;\n      Object.defineProperty(newRule, '_uuid', {\n        enumerable: false,\n        value: Object(uuid__WEBPACK_IMPORTED_MODULE_3__[\"v4\"])()\n      });\n      cov_1chrm2kor3().s[19]++;\n      self.currentQuery.rules.push(newRule);\n    },\n    deleteGroup: function deleteGroup() {\n      cov_1chrm2kor3().f[6]++;\n      var self = (cov_1chrm2kor3().s[20]++, this);\n      var parentRules = (cov_1chrm2kor3().s[21]++, self.$parent.currentQuery.rules);\n      cov_1chrm2kor3().s[22]++;\n      parentRules.splice(parentRules.indexOf(self.currentQuery), 1);\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/components/vue-query-group.vue?./node_modules/cache-loader/dist/cjs.js??ref--13-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=script&lang=js&":
/*!***********************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js??ref--13-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-query-rule.vue?vue&type=script&lang=js& ***!
  \***********************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var core_js_modules_es_array_find__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! core-js/modules/es.array.find */ \"./node_modules/core-js/modules/es.array.find.js\");\n/* harmony import */ var core_js_modules_es_array_find__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_find__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var core_js_modules_es_array_includes__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! core-js/modules/es.array.includes */ \"./node_modules/core-js/modules/es.array.includes.js\");\n/* harmony import */ var core_js_modules_es_array_includes__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_includes__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! core-js/modules/es.array.index-of */ \"./node_modules/core-js/modules/es.array.index-of.js\");\n/* harmony import */ var core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_index_of__WEBPACK_IMPORTED_MODULE_2__);\n/* harmony import */ var core_js_modules_es_array_map__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! core-js/modules/es.array.map */ \"./node_modules/core-js/modules/es.array.map.js\");\n/* harmony import */ var core_js_modules_es_array_map__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_map__WEBPACK_IMPORTED_MODULE_3__);\n/* harmony import */ var core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! core-js/modules/es.array.splice */ \"./node_modules/core-js/modules/es.array.splice.js\");\n/* harmony import */ var core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_array_splice__WEBPACK_IMPORTED_MODULE_4__);\n/* harmony import */ var core_js_modules_es_function_name__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! core-js/modules/es.function.name */ \"./node_modules/core-js/modules/es.function.name.js\");\n/* harmony import */ var core_js_modules_es_function_name__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_function_name__WEBPACK_IMPORTED_MODULE_5__);\n/* harmony import */ var core_js_modules_es_string_includes__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! core-js/modules/es.string.includes */ \"./node_modules/core-js/modules/es.string.includes.js\");\n/* harmony import */ var core_js_modules_es_string_includes__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es_string_includes__WEBPACK_IMPORTED_MODULE_6__);\n\n\n\n\n\n\n\n\nfunction cov_248y8d982h() {\n  var path = \"C:\\\\Users\\\\eedge\\\\Documents\\\\GitHub\\\\vue-query-builder\\\\src\\\\components\\\\vue-query-rule.vue\";\n  var hash = \"fb837893da57b21d61b367a4586c9b0053e6b844\";\n  var global = new Function(\"return this\")();\n  var gcv = \"__coverage__\";\n  var coverageData = {\n    path: \"C:\\\\Users\\\\eedge\\\\Documents\\\\GitHub\\\\vue-query-builder\\\\src\\\\components\\\\vue-query-rule.vue\",\n    statementMap: {\n      \"0\": {\n        start: {\n          line: 108,\n          column: 4\n        },\n        end: {\n          line: 108,\n          column: 13\n        }\n      },\n      \"1\": {\n        start: {\n          line: 112,\n          column: 19\n        },\n        end: {\n          line: 112,\n          column: 23\n        }\n      },\n      \"2\": {\n        start: {\n          line: 113,\n          column: 6\n        },\n        end: {\n          line: 115,\n          column: 9\n        }\n      },\n      \"3\": {\n        start: {\n          line: 114,\n          column: 8\n        },\n        end: {\n          line: 114,\n          column: 41\n        }\n      },\n      \"4\": {\n        start: {\n          line: 118,\n          column: 19\n        },\n        end: {\n          line: 118,\n          column: 23\n        }\n      },\n      \"5\": {\n        start: {\n          line: 119,\n          column: 22\n        },\n        end: {\n          line: 119,\n          column: 34\n        }\n      },\n      \"6\": {\n        start: {\n          line: 120,\n          column: 6\n        },\n        end: {\n          line: 125,\n          column: 8\n        }\n      },\n      \"7\": {\n        start: {\n          line: 121,\n          column: 8\n        },\n        end: {\n          line: 124,\n          column: 9\n        }\n      },\n      \"8\": {\n        start: {\n          line: 128,\n          column: 19\n        },\n        end: {\n          line: 128,\n          column: 23\n        }\n      },\n      \"9\": {\n        start: {\n          line: 129,\n          column: 6\n        },\n        end: {\n          line: 129,\n          column: 26\n        }\n      },\n      \"10\": {\n        start: {\n          line: 132,\n          column: 19\n        },\n        end: {\n          line: 132,\n          column: 23\n        }\n      },\n      \"11\": {\n        start: {\n          line: 133,\n          column: 6\n        },\n        end: {\n          line: 133,\n          column: 32\n        }\n      },\n      \"12\": {\n        start: {\n          line: 136,\n          column: 19\n        },\n        end: {\n          line: 136,\n          column: 23\n        }\n      },\n      \"13\": {\n        start: {\n          line: 137,\n          column: 6\n        },\n        end: {\n          line: 137,\n          column: 47\n        }\n      },\n      \"14\": {\n        start: {\n          line: 140,\n          column: 19\n        },\n        end: {\n          line: 140,\n          column: 23\n        }\n      },\n      \"15\": {\n        start: {\n          line: 141,\n          column: 6\n        },\n        end: {\n          line: 192,\n          column: 7\n        }\n      },\n      \"16\": {\n        start: {\n          line: 143,\n          column: 10\n        },\n        end: {\n          line: 148,\n          column: 12\n        }\n      },\n      \"17\": {\n        start: {\n          line: 153,\n          column: 10\n        },\n        end: {\n          line: 160,\n          column: 12\n        }\n      },\n      \"18\": {\n        start: {\n          line: 162,\n          column: 10\n        },\n        end: {\n          line: 167,\n          column: 12\n        }\n      },\n      \"19\": {\n        start: {\n          line: 169,\n          column: 10\n        },\n        end: {\n          line: 178,\n          column: 12\n        }\n      },\n      \"20\": {\n        start: {\n          line: 180,\n          column: 10\n        },\n        end: {\n          line: 191,\n          column: 12\n        }\n      },\n      \"21\": {\n        start: {\n          line: 197,\n          column: 19\n        },\n        end: {\n          line: 197,\n          column: 23\n        }\n      },\n      \"22\": {\n        start: {\n          line: 198,\n          column: 6\n        },\n        end: {\n          line: 202,\n          column: 7\n        }\n      },\n      \"23\": {\n        start: {\n          line: 199,\n          column: 8\n        },\n        end: {\n          line: 199,\n          column: 29\n        }\n      },\n      \"24\": {\n        start: {\n          line: 201,\n          column: 8\n        },\n        end: {\n          line: 201,\n          column: 29\n        }\n      },\n      \"25\": {\n        start: {\n          line: 205,\n          column: 19\n        },\n        end: {\n          line: 205,\n          column: 23\n        }\n      },\n      \"26\": {\n        start: {\n          line: 206,\n          column: 26\n        },\n        end: {\n          line: 206,\n          column: 57\n        }\n      },\n      \"27\": {\n        start: {\n          line: 207,\n          column: 6\n        },\n        end: {\n          line: 207,\n          column: 60\n        }\n      },\n      \"28\": {\n        start: {\n          line: 212,\n          column: 19\n        },\n        end: {\n          line: 212,\n          column: 23\n        }\n      },\n      \"29\": {\n        start: {\n          line: 213,\n          column: 6\n        },\n        end: {\n          line: 213,\n          column: 31\n        }\n      },\n      \"30\": {\n        start: {\n          line: 214,\n          column: 6\n        },\n        end: {\n          line: 214,\n          column: 28\n        }\n      },\n      \"31\": {\n        start: {\n          line: 217,\n          column: 19\n        },\n        end: {\n          line: 217,\n          column: 23\n        }\n      },\n      \"32\": {\n        start: {\n          line: 218,\n          column: 6\n        },\n        end: {\n          line: 222,\n          column: 7\n        }\n      },\n      \"33\": {\n        start: {\n          line: 219,\n          column: 8\n        },\n        end: {\n          line: 219,\n          column: 30\n        }\n      },\n      \"34\": {\n        start: {\n          line: 220,\n          column: 13\n        },\n        end: {\n          line: 222,\n          column: 7\n        }\n      },\n      \"35\": {\n        start: {\n          line: 221,\n          column: 8\n        },\n        end: {\n          line: 221,\n          column: 30\n        }\n      },\n      \"36\": {\n        start: {\n          line: 223,\n          column: 6\n        },\n        end: {\n          line: 223,\n          column: 19\n        }\n      }\n    },\n    fnMap: {\n      \"0\": {\n        name: \"(anonymous_0)\",\n        decl: {\n          start: {\n            line: 107,\n            column: 8\n          },\n          end: {\n            line: 107,\n            column: 9\n          }\n        },\n        loc: {\n          start: {\n            line: 107,\n            column: 19\n          },\n          end: {\n            line: 109,\n            column: 3\n          }\n        },\n        line: 107\n      },\n      \"1\": {\n        name: \"(anonymous_1)\",\n        decl: {\n          start: {\n            line: 111,\n            column: 16\n          },\n          end: {\n            line: 111,\n            column: 17\n          }\n        },\n        loc: {\n          start: {\n            line: 111,\n            column: 27\n          },\n          end: {\n            line: 116,\n            column: 5\n          }\n        },\n        line: 111\n      },\n      \"2\": {\n        name: \"(anonymous_2)\",\n        decl: {\n          start: {\n            line: 113,\n            column: 31\n          },\n          end: {\n            line: 113,\n            column: 32\n          }\n        },\n        loc: {\n          start: {\n            line: 113,\n            column: 47\n          },\n          end: {\n            line: 115,\n            column: 7\n          }\n        },\n        line: 113\n      },\n      \"3\": {\n        name: \"(anonymous_3)\",\n        decl: {\n          start: {\n            line: 117,\n            column: 19\n          },\n          end: {\n            line: 117,\n            column: 20\n          }\n        },\n        loc: {\n          start: {\n            line: 117,\n            column: 30\n          },\n          end: {\n            line: 126,\n            column: 5\n          }\n        },\n        line: 117\n      },\n      \"4\": {\n        name: \"(anonymous_4)\",\n        decl: {\n          start: {\n            line: 120,\n            column: 25\n          },\n          end: {\n            line: 120,\n            column: 26\n          }\n        },\n        loc: {\n          start: {\n            line: 120,\n            column: 41\n          },\n          end: {\n            line: 125,\n            column: 7\n          }\n        },\n        line: 120\n      },\n      \"5\": {\n        name: \"(anonymous_5)\",\n        decl: {\n          start: {\n            line: 127,\n            column: 19\n          },\n          end: {\n            line: 127,\n            column: 20\n          }\n        },\n        loc: {\n          start: {\n            line: 127,\n            column: 29\n          },\n          end: {\n            line: 130,\n            column: 5\n          }\n        },\n        line: 127\n      },\n      \"6\": {\n        name: \"(anonymous_6)\",\n        decl: {\n          start: {\n            line: 131,\n            column: 25\n          },\n          end: {\n            line: 131,\n            column: 26\n          }\n        },\n        loc: {\n          start: {\n            line: 131,\n            column: 35\n          },\n          end: {\n            line: 134,\n            column: 5\n          }\n        },\n        line: 131\n      },\n      \"7\": {\n        name: \"(anonymous_7)\",\n        decl: {\n          start: {\n            line: 135,\n            column: 14\n          },\n          end: {\n            line: 135,\n            column: 15\n          }\n        },\n        loc: {\n          start: {\n            line: 135,\n            column: 24\n          },\n          end: {\n            line: 138,\n            column: 5\n          }\n        },\n        line: 135\n      },\n      \"8\": {\n        name: \"(anonymous_8)\",\n        decl: {\n          start: {\n            line: 139,\n            column: 25\n          },\n          end: {\n            line: 139,\n            column: 26\n          }\n        },\n        loc: {\n          start: {\n            line: 139,\n            column: 36\n          },\n          end: {\n            line: 193,\n            column: 5\n          }\n        },\n        line: 139\n      },\n      \"9\": {\n        name: \"(anonymous_9)\",\n        decl: {\n          start: {\n            line: 196,\n            column: 20\n          },\n          end: {\n            line: 196,\n            column: 21\n          }\n        },\n        loc: {\n          start: {\n            line: 196,\n            column: 30\n          },\n          end: {\n            line: 203,\n            column: 5\n          }\n        },\n        line: 196\n      },\n      \"10\": {\n        name: \"(anonymous_10)\",\n        decl: {\n          start: {\n            line: 204,\n            column: 16\n          },\n          end: {\n            line: 204,\n            column: 17\n          }\n        },\n        loc: {\n          start: {\n            line: 204,\n            column: 26\n          },\n          end: {\n            line: 208,\n            column: 5\n          }\n        },\n        line: 204\n      },\n      \"11\": {\n        name: \"(anonymous_11)\",\n        decl: {\n          start: {\n            line: 211,\n            column: 19\n          },\n          end: {\n            line: 211,\n            column: 20\n          }\n        },\n        loc: {\n          start: {\n            line: 211,\n            column: 30\n          },\n          end: {\n            line: 215,\n            column: 5\n          }\n        },\n        line: 211\n      },\n      \"12\": {\n        name: \"(anonymous_12)\",\n        decl: {\n          start: {\n            line: 216,\n            column: 25\n          },\n          end: {\n            line: 216,\n            column: 26\n          }\n        },\n        loc: {\n          start: {\n            line: 216,\n            column: 44\n          },\n          end: {\n            line: 224,\n            column: 5\n          }\n        },\n        line: 216\n      }\n    },\n    branchMap: {\n      \"0\": {\n        loc: {\n          start: {\n            line: 141,\n            column: 6\n          },\n          end: {\n            line: 192,\n            column: 7\n          }\n        },\n        type: \"switch\",\n        locations: [{\n          start: {\n            line: 142,\n            column: 8\n          },\n          end: {\n            line: 148,\n            column: 12\n          }\n        }, {\n          start: {\n            line: 149,\n            column: 8\n          },\n          end: {\n            line: 149,\n            column: 22\n          }\n        }, {\n          start: {\n            line: 150,\n            column: 8\n          },\n          end: {\n            line: 150,\n            column: 20\n          }\n        }, {\n          start: {\n            line: 151,\n            column: 8\n          },\n          end: {\n            line: 151,\n            column: 21\n          }\n        }, {\n          start: {\n            line: 152,\n            column: 8\n          },\n          end: {\n            line: 160,\n            column: 12\n          }\n        }, {\n          start: {\n            line: 161,\n            column: 8\n          },\n          end: {\n            line: 167,\n            column: 12\n          }\n        }, {\n          start: {\n            line: 168,\n            column: 8\n          },\n          end: {\n            line: 178,\n            column: 12\n          }\n        }, {\n          start: {\n            line: 179,\n            column: 8\n          },\n          end: {\n            line: 191,\n            column: 12\n          }\n        }],\n        line: 141\n      },\n      \"1\": {\n        loc: {\n          start: {\n            line: 198,\n            column: 6\n          },\n          end: {\n            line: 202,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 198,\n            column: 6\n          },\n          end: {\n            line: 202,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 198,\n            column: 6\n          },\n          end: {\n            line: 202,\n            column: 7\n          }\n        }],\n        line: 198\n      },\n      \"2\": {\n        loc: {\n          start: {\n            line: 218,\n            column: 6\n          },\n          end: {\n            line: 222,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 218,\n            column: 6\n          },\n          end: {\n            line: 222,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 218,\n            column: 6\n          },\n          end: {\n            line: 222,\n            column: 7\n          }\n        }],\n        line: 218\n      },\n      \"3\": {\n        loc: {\n          start: {\n            line: 218,\n            column: 10\n          },\n          end: {\n            line: 218,\n            column: 51\n          }\n        },\n        type: \"binary-expr\",\n        locations: [{\n          start: {\n            line: 218,\n            column: 10\n          },\n          end: {\n            line: 218,\n            column: 27\n          }\n        }, {\n          start: {\n            line: 218,\n            column: 31\n          },\n          end: {\n            line: 218,\n            column: 51\n          }\n        }],\n        line: 218\n      },\n      \"4\": {\n        loc: {\n          start: {\n            line: 220,\n            column: 13\n          },\n          end: {\n            line: 222,\n            column: 7\n          }\n        },\n        type: \"if\",\n        locations: [{\n          start: {\n            line: 220,\n            column: 13\n          },\n          end: {\n            line: 222,\n            column: 7\n          }\n        }, {\n          start: {\n            line: 220,\n            column: 13\n          },\n          end: {\n            line: 222,\n            column: 7\n          }\n        }],\n        line: 220\n      },\n      \"5\": {\n        loc: {\n          start: {\n            line: 220,\n            column: 17\n          },\n          end: {\n            line: 220,\n            column: 58\n          }\n        },\n        type: \"binary-expr\",\n        locations: [{\n          start: {\n            line: 220,\n            column: 17\n          },\n          end: {\n            line: 220,\n            column: 35\n          }\n        }, {\n          start: {\n            line: 220,\n            column: 39\n          },\n          end: {\n            line: 220,\n            column: 58\n          }\n        }],\n        line: 220\n      }\n    },\n    s: {\n      \"0\": 0,\n      \"1\": 0,\n      \"2\": 0,\n      \"3\": 0,\n      \"4\": 0,\n      \"5\": 0,\n      \"6\": 0,\n      \"7\": 0,\n      \"8\": 0,\n      \"9\": 0,\n      \"10\": 0,\n      \"11\": 0,\n      \"12\": 0,\n      \"13\": 0,\n      \"14\": 0,\n      \"15\": 0,\n      \"16\": 0,\n      \"17\": 0,\n      \"18\": 0,\n      \"19\": 0,\n      \"20\": 0,\n      \"21\": 0,\n      \"22\": 0,\n      \"23\": 0,\n      \"24\": 0,\n      \"25\": 0,\n      \"26\": 0,\n      \"27\": 0,\n      \"28\": 0,\n      \"29\": 0,\n      \"30\": 0,\n      \"31\": 0,\n      \"32\": 0,\n      \"33\": 0,\n      \"34\": 0,\n      \"35\": 0,\n      \"36\": 0\n    },\n    f: {\n      \"0\": 0,\n      \"1\": 0,\n      \"2\": 0,\n      \"3\": 0,\n      \"4\": 0,\n      \"5\": 0,\n      \"6\": 0,\n      \"7\": 0,\n      \"8\": 0,\n      \"9\": 0,\n      \"10\": 0,\n      \"11\": 0,\n      \"12\": 0\n    },\n    b: {\n      \"0\": [0, 0, 0, 0, 0, 0, 0, 0],\n      \"1\": [0, 0],\n      \"2\": [0, 0],\n      \"3\": [0, 0],\n      \"4\": [0, 0],\n      \"5\": [0, 0]\n    },\n    _coverageSchema: \"1a1c01bbd47fc00a2c39e90264f33305004495a9\",\n    hash: \"fb837893da57b21d61b367a4586c9b0053e6b844\"\n  };\n  var coverage = global[gcv] || (global[gcv] = {});\n\n  if (!coverage[path] || coverage[path].hash !== hash) {\n    coverage[path] = coverageData;\n  }\n\n  var actualCoverage = coverage[path];\n  {\n    // @ts-ignore\n    cov_248y8d982h = function () {\n      return actualCoverage;\n    };\n  }\n  return actualCoverage;\n}\n\ncov_248y8d982h();\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n//\n/* harmony default export */ __webpack_exports__[\"default\"] = ({\n  name: 'VueQueryRule',\n  components: {},\n  props: {\n    rule: {\n      type: Object,\n      required: true\n    },\n    options: {\n      type: Array\n    }\n  },\n  data: function data() {\n    cov_248y8d982h().f[0]++;\n    cov_248y8d982h().s[0]++;\n    return {};\n  },\n  computed: {\n    ruleParams: function ruleParams() {\n      cov_248y8d982h().f[1]++;\n      var self = (cov_248y8d982h().s[1]++, this);\n      cov_248y8d982h().s[2]++;\n      return self.options.find(function (option) {\n        cov_248y8d982h().f[2]++;\n        cov_248y8d982h().s[3]++;\n        return option.id === self.rule.id;\n      });\n    },\n    ruleIDOptions: function ruleIDOptions() {\n      cov_248y8d982h().f[3]++;\n      var self = (cov_248y8d982h().s[4]++, this);\n      var options = (cov_248y8d982h().s[5]++, self.options);\n      cov_248y8d982h().s[6]++;\n      return options.map(function (option) {\n        cov_248y8d982h().f[4]++;\n        cov_248y8d982h().s[7]++;\n        return {\n          id: option.id,\n          name: option.name\n        };\n      });\n    },\n    currentRuleID: function currentRuleID() {\n      cov_248y8d982h().f[5]++;\n      var self = (cov_248y8d982h().s[8]++, this);\n      cov_248y8d982h().s[9]++;\n      return self.rule.id;\n    },\n    currentRuleOperator: function currentRuleOperator() {\n      cov_248y8d982h().f[6]++;\n      var self = (cov_248y8d982h().s[10]++, this);\n      cov_248y8d982h().s[11]++;\n      return self.rule.operator;\n    },\n    multiple: function multiple() {\n      cov_248y8d982h().f[7]++;\n      var self = (cov_248y8d982h().s[12]++, this);\n      cov_248y8d982h().s[13]++;\n      return self.rule.operator.includes('in');\n    },\n    ruleOperatorOptions: function ruleOperatorOptions() {\n      cov_248y8d982h().f[8]++;\n      var self = (cov_248y8d982h().s[14]++, this);\n      cov_248y8d982h().s[15]++;\n\n      switch (self.ruleParams.type) {\n        case 'select':\n          cov_248y8d982h().b[0][0]++;\n          cov_248y8d982h().s[16]++;\n          return [{\n            id: '=',\n            name: 'is'\n          }, {\n            id: '!=',\n            name: 'is not'\n          }, {\n            id: 'in',\n            name: 'is (multiple)'\n          }, {\n            id: '!in',\n            name: 'is not (multiple)'\n          }];\n\n        case 'number':\n          cov_248y8d982h().b[0][1]++;\n\n        case 'date':\n          cov_248y8d982h().b[0][2]++;\n\n        case 'month':\n          cov_248y8d982h().b[0][3]++;\n\n        case 'time':\n          cov_248y8d982h().b[0][4]++;\n          cov_248y8d982h().s[17]++;\n          return [{\n            id: '=',\n            name: 'is'\n          }, {\n            id: '!=',\n            name: 'is not'\n          }, {\n            id: '>',\n            name: 'is greater than'\n          }, {\n            id: '<',\n            name: 'is less than'\n          }, {\n            id: '>=',\n            name: '>='\n          }, {\n            id: '<=',\n            name: '<='\n          }];\n\n        case 'phone':\n          cov_248y8d982h().b[0][5]++;\n          cov_248y8d982h().s[18]++;\n          return [{\n            id: '=',\n            name: 'is'\n          }, {\n            id: '!=',\n            name: 'is not'\n          }, {\n            id: '()',\n            name: 'includes'\n          }, {\n            id: '!()',\n            name: 'does not include'\n          }];\n\n        case 'email':\n          cov_248y8d982h().b[0][6]++;\n          cov_248y8d982h().s[19]++;\n          return [{\n            id: '=',\n            name: 'is'\n          }, {\n            id: '!=',\n            name: 'is not'\n          }, {\n            id: '()',\n            name: 'includes'\n          }, {\n            id: '!()',\n            name: 'does not include'\n          }, {\n            id: '(',\n            name: 'starts with'\n          }, {\n            id: ')',\n            name: 'ends with'\n          }, {\n            id: '!(',\n            name: 'does not start with'\n          }, {\n            id: '!)',\n            name: 'does not end with'\n          }];\n\n        default:\n          cov_248y8d982h().b[0][7]++;\n          cov_248y8d982h().s[20]++;\n          return [{\n            id: '=',\n            name: 'is'\n          }, {\n            id: '!=',\n            name: 'is not'\n          }, {\n            id: 'in',\n            name: 'is (multiple)'\n          }, {\n            id: '!in',\n            name: 'is not (multiple)'\n          }, {\n            id: '()',\n            name: 'includes'\n          }, {\n            id: '!()',\n            name: 'does not include'\n          }, {\n            id: '(',\n            name: 'starts with'\n          }, {\n            id: ')',\n            name: 'ends with'\n          }, {\n            id: '!(',\n            name: 'does not start with'\n          }, {\n            id: '!)',\n            name: 'does not end with'\n          }];\n      }\n    }\n  },\n  methods: {\n    resetRuleValue: function resetRuleValue() {\n      cov_248y8d982h().f[9]++;\n      var self = (cov_248y8d982h().s[21]++, this);\n      cov_248y8d982h().s[22]++;\n\n      if (self.multiple) {\n        cov_248y8d982h().b[1][0]++;\n        cov_248y8d982h().s[23]++;\n        self.rule.value = [];\n      } else {\n        cov_248y8d982h().b[1][1]++;\n        cov_248y8d982h().s[24]++;\n        self.rule.value = '';\n      }\n    },\n    deleteRule: function deleteRule() {\n      cov_248y8d982h().f[10]++;\n      var self = (cov_248y8d982h().s[25]++, this);\n      var parentRules = (cov_248y8d982h().s[26]++, self.$parent.currentQuery.rules);\n      cov_248y8d982h().s[27]++;\n      parentRules.splice(parentRules.indexOf(self.rule), 1);\n    }\n  },\n  watch: {\n    currentRuleID: function currentRuleID() {\n      cov_248y8d982h().f[11]++;\n      var self = (cov_248y8d982h().s[28]++, this);\n      cov_248y8d982h().s[29]++;\n      self.rule.operator = '=';\n      cov_248y8d982h().s[30]++;\n      self.resetRuleValue();\n    },\n    currentRuleOperator: function currentRuleOperator(to, from) {\n      cov_248y8d982h().f[12]++;\n      var self = (cov_248y8d982h().s[31]++, this);\n      cov_248y8d982h().s[32]++;\n\n      if ((cov_248y8d982h().b[3][0]++, to.includes('in')) && (cov_248y8d982h().b[3][1]++, !from.includes('in'))) {\n        cov_248y8d982h().b[2][0]++;\n        cov_248y8d982h().s[33]++;\n        self.resetRuleValue();\n      } else {\n        cov_248y8d982h().b[2][1]++;\n        cov_248y8d982h().s[34]++;\n\n        if ((cov_248y8d982h().b[5][0]++, !to.includes('in')) && (cov_248y8d982h().b[5][1]++, from.includes('in'))) {\n          cov_248y8d982h().b[4][0]++;\n          cov_248y8d982h().s[35]++;\n          self.resetRuleValue();\n        } else {\n          cov_248y8d982h().b[4][1]++;\n        }\n      }\n\n      cov_248y8d982h().s[36]++;\n      return false;\n    }\n  }\n});\n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?./node_modules/cache-loader/dist/cjs.js??ref--13-0!./node_modules/babel-loader/lib!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"4798365a-vue-loader-template\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=template&id=1e8f3424&":
/*!***************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"4798365a-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-json-query-builder.vue?vue&type=template&id=1e8f3424& ***!
  \***************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return render; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return staticRenderFns; });\nvar render = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('b-card',{staticClass:\"vue-json-query-builder\",style:({'pointer-events': _vm.pointerEvents}),attrs:{\"no-body\":\"\",\"border-variant\":\"primary\"}},[_c('b-card-header',{attrs:{\"header-bg-variant\":\"primary\",\"header-border-variant\":\"primary\",\"header-text-variant\":\"white\",\"header-class\":\"vue-json-query-builder-header p-2 d-flex align-items-center\"},on:{\"click\":function($event){_vm.isVisible = !_vm.isVisible}}},[_c('small',{staticClass:\"mr-auto\"},[_vm._v(\"Query Builder\")]),(!_vm.isVisible)?_c('b-icon-caret-up-fill'):_c('b-icon-caret-down-fill')],1),(_vm.isVisible)?_c('b-card-body',{staticClass:\"p-2\"},[_c('VueQueryGroup',{attrs:{\"current-query\":_vm.currentQuery,\"options\":_vm.options},scopedSlots:_vm._u([{key:\"ruleID\",fn:function(ref){\nvar rule = ref.rule;\nvar options = ref.options;\nreturn [_vm._t(\"ruleID\",null,{\"rule\":rule,\"options\":options})]}},{key:\"ruleOperator\",fn:function(ref){\nvar rule = ref.rule;\nvar options = ref.options;\nreturn [_vm._t(\"ruleOperator\",null,{\"rule\":rule,\"options\":options})]}},{key:\"number\",fn:function(ref){\nvar rule = ref.rule;\nreturn [_vm._t(\"number\",null,{\"rule\":rule})]}},{key:\"date\",fn:function(ref){\nvar rule = ref.rule;\nreturn [_vm._t(\"date\",null,{\"rule\":rule})]}},{key:\"time\",fn:function(ref){\nvar rule = ref.rule;\nreturn [_vm._t(\"time\",null,{\"rule\":rule})]}},{key:\"select\",fn:function(ref){\nvar rule = ref.rule;\nvar options = ref.options;\nvar multiple = ref.multiple;\nreturn [_vm._t(\"select\",null,{\"rule\":rule,\"options\":options,\"multiple\":multiple})]}},{key:\"phone\",fn:function(ref){\nvar rule = ref.rule;\nreturn [_vm._t(\"phone\",null,{\"rule\":rule})]}},{key:\"email\",fn:function(ref){\nvar rule = ref.rule;\nreturn [_vm._t(\"email\",null,{\"rule\":rule})]}}],null,true)})],1):_vm._e(),(_vm.isVisible)?_c('b-card-footer',{attrs:{\"footer-border-variant\":\"primary\",\"footer-class\":\"vue-json-query-builder-footer d-flex p-2\"}},[(_vm.storage.length > 0)?_c('b-button-group',{staticClass:\"mr-1\",attrs:{\"size\":\"sm\"}},[_c('b-button',{staticClass:\"vue-json-query-builder-save-query d-flex align-items-center\",attrs:{\"variant\":\"outline-primary\"},on:{\"click\":function($event){_vm.modals.saveQuery.visible = true}}},[_c('b-icon-bookmark-plus',{staticClass:\"mr-1\"}),_vm._v(\" Save Query \")],1),(_vm.modals.viewSavedQueries.savedQueries.length > 0)?_c('b-button',{staticClass:\"vue-json-query-builder-view-saved-queries d-flex align-items-center\",attrs:{\"variant\":\"outline-primary\"},on:{\"click\":function($event){_vm.modals.viewSavedQueries.visible = true}}},[_c('b-icon-bookmarks',{staticClass:\"mr-1\"}),_vm._v(\" View Saved Queries \")],1):_vm._e()],1):_vm._e(),_c('b-button',{staticClass:\"vue-json-query-builder-reset-to-default-query d-flex align-items-center ml-auto mr-1\",attrs:{\"size\":\"sm\",\"variant\":\"secondary\"},on:{\"click\":_vm.resetToDefaultQuery}},[_c('b-icon-arrow-counterclockwise',{staticClass:\"mr-1\"}),_vm._v(\" Reset to Default Query \")],1),(_vm.runQuery)?_c('b-button',{staticClass:\"vue-json-query-builder-run-query d-flex align-items-center\",attrs:{\"size\":\"sm\",\"variant\":\"success\",\"disabled\":_vm.runQueryDisabled},on:{\"click\":function($event){return _vm.runCurrentQuery(_vm.currentQuery)}}},[_vm._v(\" Run Query \"),(_vm.loading)?_c('b-icon',{staticClass:\"ml-1\",attrs:{\"icon\":\"circle-fill\",\"animation\":\"throb\"}}):_c('b-icon-arrow-right-circle-fill',{staticClass:\"ml-1\"})],1):_vm._e()],1):_vm._e(),_c('b-modal',{attrs:{\"header-bg-variant\":\"primary\",\"header-text-variant\":\"white\",\"title\":\"Save Query\"},scopedSlots:_vm._u([{key:\"modal-footer\",fn:function(){return [_c('b-button',{on:{\"click\":function($event){_vm.modals.saveQuery.visible = false}}},[_vm._v(\" Cancel \")]),_c('b-button',{attrs:{\"variant\":\"success\",\"disabled\":_vm.saveQueryDisabled},on:{\"click\":_vm.saveQuery}},[_c('b-icon-cloud-upload'),_vm._v(\" Save Query \")],1)]},proxy:true}]),model:{value:(_vm.modals.saveQuery.visible),callback:function ($$v) {_vm.$set(_vm.modals.saveQuery, \"visible\", $$v)},expression:\"modals.saveQuery.visible\"}},[_c('p',[_vm._v(\" Please enter the name for your new query below. \")]),_c('b-form-input',{attrs:{\"size\":\"sm\"},model:{value:(_vm.modals.saveQuery.queryName),callback:function ($$v) {_vm.$set(_vm.modals.saveQuery, \"queryName\", $$v)},expression:\"modals.saveQuery.queryName\"}})],1),_c('b-modal',{attrs:{\"header-bg-variant\":\"primary\",\"header-text-variant\":\"white\",\"title\":\"Saved Queries\",\"hide-footer\":\"\"},model:{value:(_vm.modals.viewSavedQueries.visible),callback:function ($$v) {_vm.$set(_vm.modals.viewSavedQueries, \"visible\", $$v)},expression:\"modals.viewSavedQueries.visible\"}},[_c('b-table',{attrs:{\"items\":_vm.modals.viewSavedQueries.savedQueries,\"fields\":['name', 'createdDate', 'actions']},scopedSlots:_vm._u([{key:\"cell(createdDate)\",fn:function(row){return [_vm._v(\" \"+_vm._s(_vm._f(\"moment\")(row,\"dddd, MMMM Do, YYYY\"))+\" \")]}},{key:\"cell(actions)\",fn:function(row){return [_c('b-button-group',{attrs:{\"size\":\"sm\"}},[_c('b-button',{on:{\"click\":function($event){return _vm.loadSavedQuery(row.item.query)}}},[_vm._v(\" Load \")]),_c('b-button',{attrs:{\"variant\":\"danger\"},on:{\"click\":function($event){return _vm.deleteSavedQuery(row.item.query)}}},[_vm._v(\" Delete \")])],1)]}}])})],1)],1)}\nvar staticRenderFns = []\n\n\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?./node_modules/cache-loader/dist/cjs.js?%7B%22cacheDirectory%22:%22node_modules/.cache/vue-loader%22,%22cacheIdentifier%22:%224798365a-vue-loader-template%22%7D!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"4798365a-vue-loader-template\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-group.vue?vue&type=template&id=2c86c013&":
/*!********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"4798365a-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-query-group.vue?vue&type=template&id=2c86c013& ***!
  \********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return render; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return staticRenderFns; });\nvar render = function() {\n  var _vm = this\n  var _h = _vm.$createElement\n  var _c = _vm._self._c || _h\n  return _c(\n    \"div\",\n    [\n      _c(\n        \"div\",\n        { staticClass: \"d-flex\" },\n        [\n          _c(\n            \"b-button-group\",\n            { staticClass: \"mr-1\", attrs: { size: \"sm\" } },\n            [\n              _c(\n                \"b-button\",\n                {\n                  staticClass: \"vue-json-query-builder-and\",\n                  attrs: { variant: _vm.andConditionButtonVariant },\n                  on: {\n                    click: function($event) {\n                      _vm.currentQuery.condition = \"and\"\n                    }\n                  }\n                },\n                [_vm._v(\" AND \")]\n              ),\n              _c(\n                \"b-button\",\n                {\n                  staticClass: \"vue-json-query-builder-or\",\n                  attrs: { variant: _vm.orConditionButtonVariant },\n                  on: {\n                    click: function($event) {\n                      _vm.currentQuery.condition = \"or\"\n                    }\n                  }\n                },\n                [_vm._v(\" OR \")]\n              )\n            ],\n            1\n          ),\n          _c(\n            \"b-button-group\",\n            { staticClass: \"ml-auto\", attrs: { size: \"sm\" } },\n            [\n              _vm.level > 0\n                ? _c(\n                    \"b-button\",\n                    {\n                      staticClass: \"vue-json-query-builder-delete-group\",\n                      attrs: { variant: \"danger\" },\n                      on: { click: _vm.deleteGroup }\n                    },\n                    [_c(\"b-icon-trash-fill\"), _vm._v(\" Delete Group \")],\n                    1\n                  )\n                : _vm._e(),\n              _c(\n                \"b-button\",\n                {\n                  staticClass: \"vue-json-query-builder-add-rule\",\n                  attrs: { variant: \"outline-primary\" },\n                  on: { click: _vm.addRule }\n                },\n                [_c(\"b-icon-file-plus\"), _vm._v(\" Add Rule \")],\n                1\n              ),\n              _c(\n                \"b-button\",\n                {\n                  staticClass: \"vue-json-query-builder-add-group border-left-0\",\n                  attrs: { variant: \"outline-primary\" },\n                  on: { click: _vm.addGroup }\n                },\n                [_c(\"b-icon-folder-plus\"), _vm._v(\" Add Group \")],\n                1\n              )\n            ],\n            1\n          )\n        ],\n        1\n      ),\n      _vm._l(_vm.currentQuery.rules, function(item) {\n        return [\n          typeof item.condition === \"string\"\n            ? _c(\n                \"b-card\",\n                {\n                  key: item._uuid,\n                  staticClass: \"mt-2\",\n                  attrs: { \"no-body\": \"\", \"border-variant\": \"primary\" }\n                },\n                [\n                  _c(\n                    \"b-card-body\",\n                    { staticClass: \"p-2\" },\n                    [\n                      _c(\"VueQueryGroup\", {\n                        attrs: {\n                          \"current-query\": item,\n                          options: _vm.options,\n                          level: _vm.level + 1\n                        },\n                        scopedSlots: _vm._u(\n                          [\n                            {\n                              key: \"ruleID\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                var options = ref.options\n                                return [\n                                  _vm._t(\"ruleID\", null, {\n                                    rule: rule,\n                                    options: options\n                                  })\n                                ]\n                              }\n                            },\n                            {\n                              key: \"ruleOperator\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                var options = ref.options\n                                return [\n                                  _vm._t(\"ruleOperator\", null, {\n                                    rule: rule,\n                                    options: options\n                                  })\n                                ]\n                              }\n                            },\n                            {\n                              key: \"number\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                return [_vm._t(\"number\", null, { rule: rule })]\n                              }\n                            },\n                            {\n                              key: \"date\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                return [_vm._t(\"date\", null, { rule: rule })]\n                              }\n                            },\n                            {\n                              key: \"time\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                return [_vm._t(\"time\", null, { rule: rule })]\n                              }\n                            },\n                            {\n                              key: \"select\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                var options = ref.options\n                                var multiple = ref.multiple\n                                return [\n                                  _vm._t(\"select\", null, {\n                                    rule: rule,\n                                    options: options,\n                                    multiple: multiple\n                                  })\n                                ]\n                              }\n                            },\n                            {\n                              key: \"phone\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                return [_vm._t(\"phone\", null, { rule: rule })]\n                              }\n                            },\n                            {\n                              key: \"email\",\n                              fn: function(ref) {\n                                var rule = ref.rule\n                                return [_vm._t(\"email\", null, { rule: rule })]\n                              }\n                            }\n                          ],\n                          null,\n                          true\n                        )\n                      })\n                    ],\n                    1\n                  )\n                ],\n                1\n              )\n            : _c(\"VueQueryRule\", {\n                key: item._uuid,\n                staticClass: \"mt-2\",\n                attrs: { rule: item, options: _vm.options },\n                scopedSlots: _vm._u(\n                  [\n                    {\n                      key: \"ruleID\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        var options = ref.options\n                        return [\n                          _vm._t(\"ruleID\", null, {\n                            rule: rule,\n                            options: options\n                          })\n                        ]\n                      }\n                    },\n                    {\n                      key: \"ruleOperator\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        var options = ref.options\n                        return [\n                          _vm._t(\"ruleOperator\", null, {\n                            rule: rule,\n                            options: options\n                          })\n                        ]\n                      }\n                    },\n                    {\n                      key: \"number\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        return [_vm._t(\"number\", null, { rule: rule })]\n                      }\n                    },\n                    {\n                      key: \"date\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        return [_vm._t(\"date\", null, { rule: rule })]\n                      }\n                    },\n                    {\n                      key: \"time\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        return [_vm._t(\"time\", null, { rule: rule })]\n                      }\n                    },\n                    {\n                      key: \"select\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        var options = ref.options\n                        var multiple = ref.multiple\n                        return [\n                          _vm._t(\"select\", null, {\n                            rule: rule,\n                            options: options,\n                            multiple: multiple\n                          })\n                        ]\n                      }\n                    },\n                    {\n                      key: \"phone\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        return [_vm._t(\"phone\", null, { rule: rule })]\n                      }\n                    },\n                    {\n                      key: \"email\",\n                      fn: function(ref) {\n                        var rule = ref.rule\n                        return [_vm._t(\"email\", null, { rule: rule })]\n                      }\n                    }\n                  ],\n                  null,\n                  true\n                )\n              })\n        ]\n      })\n    ],\n    2\n  )\n}\nvar staticRenderFns = []\nrender._withStripped = true\n\n\n\n//# sourceURL=webpack:///./src/components/vue-query-group.vue?./node_modules/cache-loader/dist/cjs.js?%7B%22cacheDirectory%22:%22node_modules/.cache/vue-loader%22,%22cacheIdentifier%22:%224798365a-vue-loader-template%22%7D!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"4798365a-vue-loader-template\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=template&id=002e3d98&":
/*!*******************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"4798365a-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-query-rule.vue?vue&type=template&id=002e3d98& ***!
  \*******************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return render; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return staticRenderFns; });\nvar render = function() {\n  var _vm = this\n  var _h = _vm.$createElement\n  var _c = _vm._self._c || _h\n  return _c(\n    \"div\",\n    { staticClass: \"vue-query-rule d-flex\" },\n    [\n      _c(\n        \"b-container\",\n        { staticClass: \"p-0\", attrs: { fluid: \"\" } },\n        [\n          _c(\n            \"b-row\",\n            { attrs: { \"no-gutters\": \"\" } },\n            [\n              _c(\n                \"b-col\",\n                { staticClass: \"vue-query-rule-id pr-1\", attrs: { cols: \"4\" } },\n                [\n                  _vm._t(\n                    \"ruleID\",\n                    [\n                      _c(\"b-form-select\", {\n                        attrs: {\n                          size: \"sm\",\n                          options: _vm.ruleIDOptions,\n                          \"value-field\": \"id\",\n                          \"text-field\": \"name\"\n                        },\n                        model: {\n                          value: _vm.rule.id,\n                          callback: function($$v) {\n                            _vm.$set(_vm.rule, \"id\", $$v)\n                          },\n                          expression: \"rule.id\"\n                        }\n                      })\n                    ],\n                    { rule: _vm.rule, options: _vm.ruleIDOptions }\n                  )\n                ],\n                2\n              ),\n              _c(\n                \"b-col\",\n                {\n                  staticClass: \"vue-query-rule-operator pr-1\",\n                  attrs: { cols: \"3\" }\n                },\n                [\n                  _vm._t(\n                    \"ruleOperator\",\n                    [\n                      _c(\"b-form-select\", {\n                        attrs: {\n                          size: \"sm\",\n                          options: _vm.ruleOperatorOptions,\n                          \"value-field\": \"id\",\n                          \"text-field\": \"name\"\n                        },\n                        model: {\n                          value: _vm.rule.operator,\n                          callback: function($$v) {\n                            _vm.$set(_vm.rule, \"operator\", $$v)\n                          },\n                          expression: \"rule.operator\"\n                        }\n                      })\n                    ],\n                    { rule: _vm.rule, options: _vm.ruleOperatorOptions }\n                  )\n                ],\n                2\n              ),\n              _c(\n                \"b-col\",\n                {\n                  staticClass: \"vue-query-rule-value pr-1\",\n                  attrs: { cols: \"5\" }\n                },\n                [\n                  _vm.ruleParams.type === \"number\"\n                    ? _vm._t(\n                        \"number\",\n                        [\n                          _c(\"b-form-input\", {\n                            attrs: { size: \"sm\", type: \"number\" },\n                            model: {\n                              value: _vm.rule.value,\n                              callback: function($$v) {\n                                _vm.$set(_vm.rule, \"value\", $$v)\n                              },\n                              expression: \"rule.value\"\n                            }\n                          })\n                        ],\n                        { rule: _vm.rule }\n                      )\n                    : _vm.ruleParams.type === \"date\"\n                    ? _vm._t(\n                        \"date\",\n                        [\n                          _c(\"b-form-datepicker\", {\n                            attrs: {\n                              size: \"sm\",\n                              \"date-format-options\": {\n                                year: \"numeric\",\n                                month: \"numeric\",\n                                day: \"numeric\"\n                              }\n                            },\n                            model: {\n                              value: _vm.rule.value,\n                              callback: function($$v) {\n                                _vm.$set(_vm.rule, \"value\", $$v)\n                              },\n                              expression: \"rule.value\"\n                            }\n                          })\n                        ],\n                        { rule: _vm.rule }\n                      )\n                    : _vm.ruleParams.type === \"time\"\n                    ? _vm._t(\n                        \"time\",\n                        [\n                          _c(\"b-form-input\", {\n                            attrs: { size: \"sm\", type: \"time\" },\n                            model: {\n                              value: _vm.rule.value,\n                              callback: function($$v) {\n                                _vm.$set(_vm.rule, \"value\", $$v)\n                              },\n                              expression: \"rule.value\"\n                            }\n                          })\n                        ],\n                        { rule: _vm.rule }\n                      )\n                    : _vm.ruleParams.type === \"select\"\n                    ? _vm._t(\n                        \"select\",\n                        [\n                          _c(\"b-form-select\", {\n                            attrs: {\n                              size: \"sm\",\n                              options: _vm.ruleParams.options,\n                              \"value-field\": \"id\",\n                              \"text-field\": \"name\",\n                              multiple: _vm.multiple\n                            },\n                            model: {\n                              value: _vm.rule.value,\n                              callback: function($$v) {\n                                _vm.$set(_vm.rule, \"value\", $$v)\n                              },\n                              expression: \"rule.value\"\n                            }\n                          })\n                        ],\n                        {\n                          rule: _vm.rule,\n                          options: _vm.ruleParams.options,\n                          multiple: _vm.multiple\n                        }\n                      )\n                    : _vm.ruleParams.type === \"phone\"\n                    ? _vm._t(\n                        \"phone\",\n                        [\n                          _c(\"b-form-input\", {\n                            attrs: { size: \"sm\", type: \"tel\" },\n                            model: {\n                              value: _vm.rule.value,\n                              callback: function($$v) {\n                                _vm.$set(_vm.rule, \"value\", $$v)\n                              },\n                              expression: \"rule.value\"\n                            }\n                          })\n                        ],\n                        { rule: _vm.rule }\n                      )\n                    : _vm.ruleParams.type === \"email\"\n                    ? _vm._t(\n                        \"email\",\n                        [\n                          _c(\"b-form-input\", {\n                            attrs: { size: \"sm\", type: \"email\" },\n                            model: {\n                              value: _vm.rule.value,\n                              callback: function($$v) {\n                                _vm.$set(_vm.rule, \"value\", $$v)\n                              },\n                              expression: \"rule.value\"\n                            }\n                          })\n                        ],\n                        { rule: _vm.rule }\n                      )\n                    : _c(\"b-form-input\", {\n                        attrs: { size: \"sm\" },\n                        model: {\n                          value: _vm.rule.value,\n                          callback: function($$v) {\n                            _vm.$set(_vm.rule, \"value\", $$v)\n                          },\n                          expression: \"rule.value\"\n                        }\n                      })\n                ],\n                2\n              )\n            ],\n            1\n          )\n        ],\n        1\n      ),\n      _c(\n        \"b-button\",\n        {\n          staticClass: \"vue-json-query-builder-delete-rule\",\n          attrs: { size: \"sm\", variant: \"danger\" },\n          on: { click: _vm.deleteRule }\n        },\n        [_c(\"b-icon-trash-fill\")],\n        1\n      )\n    ],\n    1\n  )\n}\nvar staticRenderFns = []\nrender._withStripped = true\n\n\n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?./node_modules/cache-loader/dist/cjs.js?%7B%22cacheDirectory%22:%22node_modules/.cache/vue-loader%22,%22cacheIdentifier%22:%224798365a-vue-loader-template%22%7D!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/scss/custom.scss":
/*!***************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-3-1!./node_modules/postcss-loader/src??ref--9-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-3-3!./src/scss/custom.scss ***!
  \***************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \"/*!\\n * Bootstrap v4.5.0 (https://getbootstrap.com/)\\n * Copyright 2011-2020 The Bootstrap Authors\\n * Copyright 2011-2020 Twitter, Inc.\\n * Licensed under MIT (https://github.com/twbs/bootstrap/blob/master/LICENSE)\\n */\\n:root {\\n  --blue: #007bff;\\n  --indigo: #6610f2;\\n  --purple: #6f42c1;\\n  --pink: #e83e8c;\\n  --red: #dc3545;\\n  --orange: #fd7e14;\\n  --yellow: #ffc107;\\n  --green: #28a745;\\n  --teal: #20c997;\\n  --cyan: #17a2b8;\\n  --white: #fff;\\n  --gray: #6c757d;\\n  --gray-dark: #343a40;\\n  --primary: #a23422;\\n  --secondary: #6c757d;\\n  --success: #28a745;\\n  --info: #17a2b8;\\n  --warning: #ffc107;\\n  --danger: #dc3545;\\n  --light: #f8f9fa;\\n  --dark: #343a40;\\n  --primary-light-dark: #b33926;\\n  --primary-dark: #912f1e;\\n  --breakpoint-xs: 0;\\n  --breakpoint-sm: 576px;\\n  --breakpoint-md: 768px;\\n  --breakpoint-lg: 992px;\\n  --breakpoint-xl: 1200px;\\n  --font-family-sans-serif: -apple-system, BlinkMacSystemFont, \\\"Segoe UI\\\", Roboto, \\\"Helvetica Neue\\\", Arial, \\\"Noto Sans\\\", sans-serif, \\\"Apple Color Emoji\\\", \\\"Segoe UI Emoji\\\", \\\"Segoe UI Symbol\\\", \\\"Noto Color Emoji\\\";\\n  --font-family-monospace: SFMono-Regular, Menlo, Monaco, Consolas, \\\"Liberation Mono\\\", \\\"Courier New\\\", monospace; }\\n\\n*,\\n*::before,\\n*::after {\\n  box-sizing: border-box; }\\n\\nhtml {\\n  font-family: sans-serif;\\n  line-height: 1.15;\\n  -webkit-text-size-adjust: 100%;\\n  -webkit-tap-highlight-color: rgba(0, 0, 0, 0); }\\n\\narticle, aside, figcaption, figure, footer, header, hgroup, main, nav, section {\\n  display: block; }\\n\\nbody {\\n  margin: 0;\\n  font-family: -apple-system, BlinkMacSystemFont, \\\"Segoe UI\\\", Roboto, \\\"Helvetica Neue\\\", Arial, \\\"Noto Sans\\\", sans-serif, \\\"Apple Color Emoji\\\", \\\"Segoe UI Emoji\\\", \\\"Segoe UI Symbol\\\", \\\"Noto Color Emoji\\\";\\n  font-size: 1rem;\\n  font-weight: 400;\\n  line-height: 1.5;\\n  color: #212529;\\n  text-align: left;\\n  background-color: #fff; }\\n\\n[tabindex=\\\"-1\\\"]:focus:not(:focus-visible) {\\n  outline: 0 !important; }\\n\\nhr {\\n  box-sizing: content-box;\\n  height: 0;\\n  overflow: visible; }\\n\\nh1, h2, h3, h4, h5, h6 {\\n  margin-top: 0;\\n  margin-bottom: 0.5rem; }\\n\\np {\\n  margin-top: 0;\\n  margin-bottom: 1rem; }\\n\\nabbr[title],\\nabbr[data-original-title] {\\n  text-decoration: underline;\\n  -webkit-text-decoration: underline dotted;\\n          text-decoration: underline dotted;\\n  cursor: help;\\n  border-bottom: 0;\\n  -webkit-text-decoration-skip-ink: none;\\n          text-decoration-skip-ink: none; }\\n\\naddress {\\n  margin-bottom: 1rem;\\n  font-style: normal;\\n  line-height: inherit; }\\n\\nol,\\nul,\\ndl {\\n  margin-top: 0;\\n  margin-bottom: 1rem; }\\n\\nol ol,\\nul ul,\\nol ul,\\nul ol {\\n  margin-bottom: 0; }\\n\\ndt {\\n  font-weight: 700; }\\n\\ndd {\\n  margin-bottom: .5rem;\\n  margin-left: 0; }\\n\\nblockquote {\\n  margin: 0 0 1rem; }\\n\\nb,\\nstrong {\\n  font-weight: bolder; }\\n\\nsmall {\\n  font-size: 80%; }\\n\\nsub,\\nsup {\\n  position: relative;\\n  font-size: 75%;\\n  line-height: 0;\\n  vertical-align: baseline; }\\n\\nsub {\\n  bottom: -.25em; }\\n\\nsup {\\n  top: -.5em; }\\n\\na {\\n  color: #a23422;\\n  text-decoration: none;\\n  background-color: transparent; }\\n  a:hover {\\n    color: #632015;\\n    text-decoration: underline; }\\n\\na:not([href]) {\\n  color: inherit;\\n  text-decoration: none; }\\n  a:not([href]):hover {\\n    color: inherit;\\n    text-decoration: none; }\\n\\npre,\\ncode,\\nkbd,\\nsamp {\\n  font-family: SFMono-Regular, Menlo, Monaco, Consolas, \\\"Liberation Mono\\\", \\\"Courier New\\\", monospace;\\n  font-size: 1em; }\\n\\npre {\\n  margin-top: 0;\\n  margin-bottom: 1rem;\\n  overflow: auto;\\n  -ms-overflow-style: scrollbar; }\\n\\nfigure {\\n  margin: 0 0 1rem; }\\n\\nimg {\\n  vertical-align: middle;\\n  border-style: none; }\\n\\nsvg {\\n  overflow: hidden;\\n  vertical-align: middle; }\\n\\ntable {\\n  border-collapse: collapse; }\\n\\ncaption {\\n  padding-top: 0.75rem;\\n  padding-bottom: 0.75rem;\\n  color: #6c757d;\\n  text-align: left;\\n  caption-side: bottom; }\\n\\nth {\\n  text-align: inherit; }\\n\\nlabel {\\n  display: inline-block;\\n  margin-bottom: 0.5rem; }\\n\\nbutton {\\n  border-radius: 0; }\\n\\nbutton:focus {\\n  outline: 1px dotted;\\n  outline: 5px auto -webkit-focus-ring-color; }\\n\\ninput,\\nbutton,\\nselect,\\noptgroup,\\ntextarea {\\n  margin: 0;\\n  font-family: inherit;\\n  font-size: inherit;\\n  line-height: inherit; }\\n\\nbutton,\\ninput {\\n  overflow: visible; }\\n\\nbutton,\\nselect {\\n  text-transform: none; }\\n\\n[role=\\\"button\\\"] {\\n  cursor: pointer; }\\n\\nselect {\\n  word-wrap: normal; }\\n\\nbutton,\\n[type=\\\"button\\\"],\\n[type=\\\"reset\\\"],\\n[type=\\\"submit\\\"] {\\n  -webkit-appearance: button; }\\n\\nbutton:not(:disabled),\\n[type=\\\"button\\\"]:not(:disabled),\\n[type=\\\"reset\\\"]:not(:disabled),\\n[type=\\\"submit\\\"]:not(:disabled) {\\n  cursor: pointer; }\\n\\nbutton::-moz-focus-inner,\\n[type=\\\"button\\\"]::-moz-focus-inner,\\n[type=\\\"reset\\\"]::-moz-focus-inner,\\n[type=\\\"submit\\\"]::-moz-focus-inner {\\n  padding: 0;\\n  border-style: none; }\\n\\ninput[type=\\\"radio\\\"],\\ninput[type=\\\"checkbox\\\"] {\\n  box-sizing: border-box;\\n  padding: 0; }\\n\\ntextarea {\\n  overflow: auto;\\n  resize: vertical; }\\n\\nfieldset {\\n  min-width: 0;\\n  padding: 0;\\n  margin: 0;\\n  border: 0; }\\n\\nlegend {\\n  display: block;\\n  width: 100%;\\n  max-width: 100%;\\n  padding: 0;\\n  margin-bottom: .5rem;\\n  font-size: 1.5rem;\\n  line-height: inherit;\\n  color: inherit;\\n  white-space: normal; }\\n\\nprogress {\\n  vertical-align: baseline; }\\n\\n[type=\\\"number\\\"]::-webkit-inner-spin-button,\\n[type=\\\"number\\\"]::-webkit-outer-spin-button {\\n  height: auto; }\\n\\n[type=\\\"search\\\"] {\\n  outline-offset: -2px;\\n  -webkit-appearance: none; }\\n\\n[type=\\\"search\\\"]::-webkit-search-decoration {\\n  -webkit-appearance: none; }\\n\\n::-webkit-file-upload-button {\\n  font: inherit;\\n  -webkit-appearance: button; }\\n\\noutput {\\n  display: inline-block; }\\n\\nsummary {\\n  display: list-item;\\n  cursor: pointer; }\\n\\ntemplate {\\n  display: none; }\\n\\n[hidden] {\\n  display: none !important; }\\n\\nh1, h2, h3, h4, h5, h6,\\n.h1, .h2, .h3, .h4, .h5, .h6 {\\n  margin-bottom: 0.5rem;\\n  font-weight: 500;\\n  line-height: 1.2; }\\n\\nh1, .h1 {\\n  font-size: 2.5rem; }\\n\\nh2, .h2 {\\n  font-size: 2rem; }\\n\\nh3, .h3 {\\n  font-size: 1.75rem; }\\n\\nh4, .h4 {\\n  font-size: 1.5rem; }\\n\\nh5, .h5 {\\n  font-size: 1.25rem; }\\n\\nh6, .h6 {\\n  font-size: 1rem; }\\n\\n.lead {\\n  font-size: 1.25rem;\\n  font-weight: 300; }\\n\\n.display-1 {\\n  font-size: 6rem;\\n  font-weight: 300;\\n  line-height: 1.2; }\\n\\n.display-2 {\\n  font-size: 5.5rem;\\n  font-weight: 300;\\n  line-height: 1.2; }\\n\\n.display-3 {\\n  font-size: 4.5rem;\\n  font-weight: 300;\\n  line-height: 1.2; }\\n\\n.display-4 {\\n  font-size: 3.5rem;\\n  font-weight: 300;\\n  line-height: 1.2; }\\n\\nhr {\\n  margin-top: 1rem;\\n  margin-bottom: 1rem;\\n  border: 0;\\n  border-top: 1px solid rgba(0, 0, 0, 0.1); }\\n\\nsmall,\\n.small {\\n  font-size: 80%;\\n  font-weight: 400; }\\n\\nmark,\\n.mark {\\n  padding: 0.2em;\\n  background-color: #fcf8e3; }\\n\\n.list-unstyled {\\n  padding-left: 0;\\n  list-style: none; }\\n\\n.list-inline {\\n  padding-left: 0;\\n  list-style: none; }\\n\\n.list-inline-item {\\n  display: inline-block; }\\n  .list-inline-item:not(:last-child) {\\n    margin-right: 0.5rem; }\\n\\n.initialism {\\n  font-size: 90%;\\n  text-transform: uppercase; }\\n\\n.blockquote {\\n  margin-bottom: 1rem;\\n  font-size: 1.25rem; }\\n\\n.blockquote-footer {\\n  display: block;\\n  font-size: 80%;\\n  color: #6c757d; }\\n  .blockquote-footer::before {\\n    content: \\\"\\\\2014\\\\00A0\\\"; }\\n\\n.img-fluid {\\n  max-width: 100%;\\n  height: auto; }\\n\\n.img-thumbnail {\\n  padding: 0.25rem;\\n  background-color: #fff;\\n  border: 1px solid #dee2e6;\\n  border-radius: 0.25rem;\\n  max-width: 100%;\\n  height: auto; }\\n\\n.figure {\\n  display: inline-block; }\\n\\n.figure-img {\\n  margin-bottom: 0.5rem;\\n  line-height: 1; }\\n\\n.figure-caption {\\n  font-size: 90%;\\n  color: #6c757d; }\\n\\ncode {\\n  font-size: 87.5%;\\n  color: #e83e8c;\\n  word-wrap: break-word; }\\n  a > code {\\n    color: inherit; }\\n\\nkbd {\\n  padding: 0.2rem 0.4rem;\\n  font-size: 87.5%;\\n  color: #fff;\\n  background-color: #212529;\\n  border-radius: 0.2rem; }\\n  kbd kbd {\\n    padding: 0;\\n    font-size: 100%;\\n    font-weight: 700; }\\n\\npre {\\n  display: block;\\n  font-size: 87.5%;\\n  color: #212529; }\\n  pre code {\\n    font-size: inherit;\\n    color: inherit;\\n    word-break: normal; }\\n\\n.pre-scrollable {\\n  max-height: 340px;\\n  overflow-y: scroll; }\\n\\n.container {\\n  width: 100%;\\n  padding-right: 15px;\\n  padding-left: 15px;\\n  margin-right: auto;\\n  margin-left: auto; }\\n  @media (min-width: 576px) {\\n    .container {\\n      max-width: 540px; } }\\n  @media (min-width: 768px) {\\n    .container {\\n      max-width: 720px; } }\\n  @media (min-width: 992px) {\\n    .container {\\n      max-width: 960px; } }\\n  @media (min-width: 1200px) {\\n    .container {\\n      max-width: 1140px; } }\\n\\n.container-fluid, .container-sm, .container-md, .container-lg, .container-xl {\\n  width: 100%;\\n  padding-right: 15px;\\n  padding-left: 15px;\\n  margin-right: auto;\\n  margin-left: auto; }\\n\\n@media (min-width: 576px) {\\n  .container, .container-sm {\\n    max-width: 540px; } }\\n\\n@media (min-width: 768px) {\\n  .container, .container-sm, .container-md {\\n    max-width: 720px; } }\\n\\n@media (min-width: 992px) {\\n  .container, .container-sm, .container-md, .container-lg {\\n    max-width: 960px; } }\\n\\n@media (min-width: 1200px) {\\n  .container, .container-sm, .container-md, .container-lg, .container-xl {\\n    max-width: 1140px; } }\\n\\n.row {\\n  display: flex;\\n  flex-wrap: wrap;\\n  margin-right: -15px;\\n  margin-left: -15px; }\\n\\n.no-gutters {\\n  margin-right: 0;\\n  margin-left: 0; }\\n  .no-gutters > .col,\\n  .no-gutters > [class*=\\\"col-\\\"] {\\n    padding-right: 0;\\n    padding-left: 0; }\\n\\n.col-1, .col-2, .col-3, .col-4, .col-5, .col-6, .col-7, .col-8, .col-9, .col-10, .col-11, .col-12, .col,\\n.col-auto, .col-sm-1, .col-sm-2, .col-sm-3, .col-sm-4, .col-sm-5, .col-sm-6, .col-sm-7, .col-sm-8, .col-sm-9, .col-sm-10, .col-sm-11, .col-sm-12, .col-sm,\\n.col-sm-auto, .col-md-1, .col-md-2, .col-md-3, .col-md-4, .col-md-5, .col-md-6, .col-md-7, .col-md-8, .col-md-9, .col-md-10, .col-md-11, .col-md-12, .col-md,\\n.col-md-auto, .col-lg-1, .col-lg-2, .col-lg-3, .col-lg-4, .col-lg-5, .col-lg-6, .col-lg-7, .col-lg-8, .col-lg-9, .col-lg-10, .col-lg-11, .col-lg-12, .col-lg,\\n.col-lg-auto, .col-xl-1, .col-xl-2, .col-xl-3, .col-xl-4, .col-xl-5, .col-xl-6, .col-xl-7, .col-xl-8, .col-xl-9, .col-xl-10, .col-xl-11, .col-xl-12, .col-xl,\\n.col-xl-auto {\\n  position: relative;\\n  width: 100%;\\n  padding-right: 15px;\\n  padding-left: 15px; }\\n\\n.col {\\n  flex-basis: 0;\\n  flex-grow: 1;\\n  min-width: 0;\\n  max-width: 100%; }\\n\\n.row-cols-1 > * {\\n  flex: 0 0 100%;\\n  max-width: 100%; }\\n\\n.row-cols-2 > * {\\n  flex: 0 0 50%;\\n  max-width: 50%; }\\n\\n.row-cols-3 > * {\\n  flex: 0 0 33.33333%;\\n  max-width: 33.33333%; }\\n\\n.row-cols-4 > * {\\n  flex: 0 0 25%;\\n  max-width: 25%; }\\n\\n.row-cols-5 > * {\\n  flex: 0 0 20%;\\n  max-width: 20%; }\\n\\n.row-cols-6 > * {\\n  flex: 0 0 16.66667%;\\n  max-width: 16.66667%; }\\n\\n.col-auto {\\n  flex: 0 0 auto;\\n  width: auto;\\n  max-width: 100%; }\\n\\n.col-1 {\\n  flex: 0 0 8.33333%;\\n  max-width: 8.33333%; }\\n\\n.col-2 {\\n  flex: 0 0 16.66667%;\\n  max-width: 16.66667%; }\\n\\n.col-3 {\\n  flex: 0 0 25%;\\n  max-width: 25%; }\\n\\n.col-4 {\\n  flex: 0 0 33.33333%;\\n  max-width: 33.33333%; }\\n\\n.col-5 {\\n  flex: 0 0 41.66667%;\\n  max-width: 41.66667%; }\\n\\n.col-6 {\\n  flex: 0 0 50%;\\n  max-width: 50%; }\\n\\n.col-7 {\\n  flex: 0 0 58.33333%;\\n  max-width: 58.33333%; }\\n\\n.col-8 {\\n  flex: 0 0 66.66667%;\\n  max-width: 66.66667%; }\\n\\n.col-9 {\\n  flex: 0 0 75%;\\n  max-width: 75%; }\\n\\n.col-10 {\\n  flex: 0 0 83.33333%;\\n  max-width: 83.33333%; }\\n\\n.col-11 {\\n  flex: 0 0 91.66667%;\\n  max-width: 91.66667%; }\\n\\n.col-12 {\\n  flex: 0 0 100%;\\n  max-width: 100%; }\\n\\n.order-first {\\n  order: -1; }\\n\\n.order-last {\\n  order: 13; }\\n\\n.order-0 {\\n  order: 0; }\\n\\n.order-1 {\\n  order: 1; }\\n\\n.order-2 {\\n  order: 2; }\\n\\n.order-3 {\\n  order: 3; }\\n\\n.order-4 {\\n  order: 4; }\\n\\n.order-5 {\\n  order: 5; }\\n\\n.order-6 {\\n  order: 6; }\\n\\n.order-7 {\\n  order: 7; }\\n\\n.order-8 {\\n  order: 8; }\\n\\n.order-9 {\\n  order: 9; }\\n\\n.order-10 {\\n  order: 10; }\\n\\n.order-11 {\\n  order: 11; }\\n\\n.order-12 {\\n  order: 12; }\\n\\n.offset-1 {\\n  margin-left: 8.33333%; }\\n\\n.offset-2 {\\n  margin-left: 16.66667%; }\\n\\n.offset-3 {\\n  margin-left: 25%; }\\n\\n.offset-4 {\\n  margin-left: 33.33333%; }\\n\\n.offset-5 {\\n  margin-left: 41.66667%; }\\n\\n.offset-6 {\\n  margin-left: 50%; }\\n\\n.offset-7 {\\n  margin-left: 58.33333%; }\\n\\n.offset-8 {\\n  margin-left: 66.66667%; }\\n\\n.offset-9 {\\n  margin-left: 75%; }\\n\\n.offset-10 {\\n  margin-left: 83.33333%; }\\n\\n.offset-11 {\\n  margin-left: 91.66667%; }\\n\\n@media (min-width: 576px) {\\n  .col-sm {\\n    flex-basis: 0;\\n    flex-grow: 1;\\n    min-width: 0;\\n    max-width: 100%; }\\n  .row-cols-sm-1 > * {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .row-cols-sm-2 > * {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .row-cols-sm-3 > * {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .row-cols-sm-4 > * {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .row-cols-sm-5 > * {\\n    flex: 0 0 20%;\\n    max-width: 20%; }\\n  .row-cols-sm-6 > * {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-sm-auto {\\n    flex: 0 0 auto;\\n    width: auto;\\n    max-width: 100%; }\\n  .col-sm-1 {\\n    flex: 0 0 8.33333%;\\n    max-width: 8.33333%; }\\n  .col-sm-2 {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-sm-3 {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .col-sm-4 {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .col-sm-5 {\\n    flex: 0 0 41.66667%;\\n    max-width: 41.66667%; }\\n  .col-sm-6 {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .col-sm-7 {\\n    flex: 0 0 58.33333%;\\n    max-width: 58.33333%; }\\n  .col-sm-8 {\\n    flex: 0 0 66.66667%;\\n    max-width: 66.66667%; }\\n  .col-sm-9 {\\n    flex: 0 0 75%;\\n    max-width: 75%; }\\n  .col-sm-10 {\\n    flex: 0 0 83.33333%;\\n    max-width: 83.33333%; }\\n  .col-sm-11 {\\n    flex: 0 0 91.66667%;\\n    max-width: 91.66667%; }\\n  .col-sm-12 {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .order-sm-first {\\n    order: -1; }\\n  .order-sm-last {\\n    order: 13; }\\n  .order-sm-0 {\\n    order: 0; }\\n  .order-sm-1 {\\n    order: 1; }\\n  .order-sm-2 {\\n    order: 2; }\\n  .order-sm-3 {\\n    order: 3; }\\n  .order-sm-4 {\\n    order: 4; }\\n  .order-sm-5 {\\n    order: 5; }\\n  .order-sm-6 {\\n    order: 6; }\\n  .order-sm-7 {\\n    order: 7; }\\n  .order-sm-8 {\\n    order: 8; }\\n  .order-sm-9 {\\n    order: 9; }\\n  .order-sm-10 {\\n    order: 10; }\\n  .order-sm-11 {\\n    order: 11; }\\n  .order-sm-12 {\\n    order: 12; }\\n  .offset-sm-0 {\\n    margin-left: 0; }\\n  .offset-sm-1 {\\n    margin-left: 8.33333%; }\\n  .offset-sm-2 {\\n    margin-left: 16.66667%; }\\n  .offset-sm-3 {\\n    margin-left: 25%; }\\n  .offset-sm-4 {\\n    margin-left: 33.33333%; }\\n  .offset-sm-5 {\\n    margin-left: 41.66667%; }\\n  .offset-sm-6 {\\n    margin-left: 50%; }\\n  .offset-sm-7 {\\n    margin-left: 58.33333%; }\\n  .offset-sm-8 {\\n    margin-left: 66.66667%; }\\n  .offset-sm-9 {\\n    margin-left: 75%; }\\n  .offset-sm-10 {\\n    margin-left: 83.33333%; }\\n  .offset-sm-11 {\\n    margin-left: 91.66667%; } }\\n\\n@media (min-width: 768px) {\\n  .col-md {\\n    flex-basis: 0;\\n    flex-grow: 1;\\n    min-width: 0;\\n    max-width: 100%; }\\n  .row-cols-md-1 > * {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .row-cols-md-2 > * {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .row-cols-md-3 > * {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .row-cols-md-4 > * {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .row-cols-md-5 > * {\\n    flex: 0 0 20%;\\n    max-width: 20%; }\\n  .row-cols-md-6 > * {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-md-auto {\\n    flex: 0 0 auto;\\n    width: auto;\\n    max-width: 100%; }\\n  .col-md-1 {\\n    flex: 0 0 8.33333%;\\n    max-width: 8.33333%; }\\n  .col-md-2 {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-md-3 {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .col-md-4 {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .col-md-5 {\\n    flex: 0 0 41.66667%;\\n    max-width: 41.66667%; }\\n  .col-md-6 {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .col-md-7 {\\n    flex: 0 0 58.33333%;\\n    max-width: 58.33333%; }\\n  .col-md-8 {\\n    flex: 0 0 66.66667%;\\n    max-width: 66.66667%; }\\n  .col-md-9 {\\n    flex: 0 0 75%;\\n    max-width: 75%; }\\n  .col-md-10 {\\n    flex: 0 0 83.33333%;\\n    max-width: 83.33333%; }\\n  .col-md-11 {\\n    flex: 0 0 91.66667%;\\n    max-width: 91.66667%; }\\n  .col-md-12 {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .order-md-first {\\n    order: -1; }\\n  .order-md-last {\\n    order: 13; }\\n  .order-md-0 {\\n    order: 0; }\\n  .order-md-1 {\\n    order: 1; }\\n  .order-md-2 {\\n    order: 2; }\\n  .order-md-3 {\\n    order: 3; }\\n  .order-md-4 {\\n    order: 4; }\\n  .order-md-5 {\\n    order: 5; }\\n  .order-md-6 {\\n    order: 6; }\\n  .order-md-7 {\\n    order: 7; }\\n  .order-md-8 {\\n    order: 8; }\\n  .order-md-9 {\\n    order: 9; }\\n  .order-md-10 {\\n    order: 10; }\\n  .order-md-11 {\\n    order: 11; }\\n  .order-md-12 {\\n    order: 12; }\\n  .offset-md-0 {\\n    margin-left: 0; }\\n  .offset-md-1 {\\n    margin-left: 8.33333%; }\\n  .offset-md-2 {\\n    margin-left: 16.66667%; }\\n  .offset-md-3 {\\n    margin-left: 25%; }\\n  .offset-md-4 {\\n    margin-left: 33.33333%; }\\n  .offset-md-5 {\\n    margin-left: 41.66667%; }\\n  .offset-md-6 {\\n    margin-left: 50%; }\\n  .offset-md-7 {\\n    margin-left: 58.33333%; }\\n  .offset-md-8 {\\n    margin-left: 66.66667%; }\\n  .offset-md-9 {\\n    margin-left: 75%; }\\n  .offset-md-10 {\\n    margin-left: 83.33333%; }\\n  .offset-md-11 {\\n    margin-left: 91.66667%; } }\\n\\n@media (min-width: 992px) {\\n  .col-lg {\\n    flex-basis: 0;\\n    flex-grow: 1;\\n    min-width: 0;\\n    max-width: 100%; }\\n  .row-cols-lg-1 > * {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .row-cols-lg-2 > * {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .row-cols-lg-3 > * {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .row-cols-lg-4 > * {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .row-cols-lg-5 > * {\\n    flex: 0 0 20%;\\n    max-width: 20%; }\\n  .row-cols-lg-6 > * {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-lg-auto {\\n    flex: 0 0 auto;\\n    width: auto;\\n    max-width: 100%; }\\n  .col-lg-1 {\\n    flex: 0 0 8.33333%;\\n    max-width: 8.33333%; }\\n  .col-lg-2 {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-lg-3 {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .col-lg-4 {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .col-lg-5 {\\n    flex: 0 0 41.66667%;\\n    max-width: 41.66667%; }\\n  .col-lg-6 {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .col-lg-7 {\\n    flex: 0 0 58.33333%;\\n    max-width: 58.33333%; }\\n  .col-lg-8 {\\n    flex: 0 0 66.66667%;\\n    max-width: 66.66667%; }\\n  .col-lg-9 {\\n    flex: 0 0 75%;\\n    max-width: 75%; }\\n  .col-lg-10 {\\n    flex: 0 0 83.33333%;\\n    max-width: 83.33333%; }\\n  .col-lg-11 {\\n    flex: 0 0 91.66667%;\\n    max-width: 91.66667%; }\\n  .col-lg-12 {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .order-lg-first {\\n    order: -1; }\\n  .order-lg-last {\\n    order: 13; }\\n  .order-lg-0 {\\n    order: 0; }\\n  .order-lg-1 {\\n    order: 1; }\\n  .order-lg-2 {\\n    order: 2; }\\n  .order-lg-3 {\\n    order: 3; }\\n  .order-lg-4 {\\n    order: 4; }\\n  .order-lg-5 {\\n    order: 5; }\\n  .order-lg-6 {\\n    order: 6; }\\n  .order-lg-7 {\\n    order: 7; }\\n  .order-lg-8 {\\n    order: 8; }\\n  .order-lg-9 {\\n    order: 9; }\\n  .order-lg-10 {\\n    order: 10; }\\n  .order-lg-11 {\\n    order: 11; }\\n  .order-lg-12 {\\n    order: 12; }\\n  .offset-lg-0 {\\n    margin-left: 0; }\\n  .offset-lg-1 {\\n    margin-left: 8.33333%; }\\n  .offset-lg-2 {\\n    margin-left: 16.66667%; }\\n  .offset-lg-3 {\\n    margin-left: 25%; }\\n  .offset-lg-4 {\\n    margin-left: 33.33333%; }\\n  .offset-lg-5 {\\n    margin-left: 41.66667%; }\\n  .offset-lg-6 {\\n    margin-left: 50%; }\\n  .offset-lg-7 {\\n    margin-left: 58.33333%; }\\n  .offset-lg-8 {\\n    margin-left: 66.66667%; }\\n  .offset-lg-9 {\\n    margin-left: 75%; }\\n  .offset-lg-10 {\\n    margin-left: 83.33333%; }\\n  .offset-lg-11 {\\n    margin-left: 91.66667%; } }\\n\\n@media (min-width: 1200px) {\\n  .col-xl {\\n    flex-basis: 0;\\n    flex-grow: 1;\\n    min-width: 0;\\n    max-width: 100%; }\\n  .row-cols-xl-1 > * {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .row-cols-xl-2 > * {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .row-cols-xl-3 > * {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .row-cols-xl-4 > * {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .row-cols-xl-5 > * {\\n    flex: 0 0 20%;\\n    max-width: 20%; }\\n  .row-cols-xl-6 > * {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-xl-auto {\\n    flex: 0 0 auto;\\n    width: auto;\\n    max-width: 100%; }\\n  .col-xl-1 {\\n    flex: 0 0 8.33333%;\\n    max-width: 8.33333%; }\\n  .col-xl-2 {\\n    flex: 0 0 16.66667%;\\n    max-width: 16.66667%; }\\n  .col-xl-3 {\\n    flex: 0 0 25%;\\n    max-width: 25%; }\\n  .col-xl-4 {\\n    flex: 0 0 33.33333%;\\n    max-width: 33.33333%; }\\n  .col-xl-5 {\\n    flex: 0 0 41.66667%;\\n    max-width: 41.66667%; }\\n  .col-xl-6 {\\n    flex: 0 0 50%;\\n    max-width: 50%; }\\n  .col-xl-7 {\\n    flex: 0 0 58.33333%;\\n    max-width: 58.33333%; }\\n  .col-xl-8 {\\n    flex: 0 0 66.66667%;\\n    max-width: 66.66667%; }\\n  .col-xl-9 {\\n    flex: 0 0 75%;\\n    max-width: 75%; }\\n  .col-xl-10 {\\n    flex: 0 0 83.33333%;\\n    max-width: 83.33333%; }\\n  .col-xl-11 {\\n    flex: 0 0 91.66667%;\\n    max-width: 91.66667%; }\\n  .col-xl-12 {\\n    flex: 0 0 100%;\\n    max-width: 100%; }\\n  .order-xl-first {\\n    order: -1; }\\n  .order-xl-last {\\n    order: 13; }\\n  .order-xl-0 {\\n    order: 0; }\\n  .order-xl-1 {\\n    order: 1; }\\n  .order-xl-2 {\\n    order: 2; }\\n  .order-xl-3 {\\n    order: 3; }\\n  .order-xl-4 {\\n    order: 4; }\\n  .order-xl-5 {\\n    order: 5; }\\n  .order-xl-6 {\\n    order: 6; }\\n  .order-xl-7 {\\n    order: 7; }\\n  .order-xl-8 {\\n    order: 8; }\\n  .order-xl-9 {\\n    order: 9; }\\n  .order-xl-10 {\\n    order: 10; }\\n  .order-xl-11 {\\n    order: 11; }\\n  .order-xl-12 {\\n    order: 12; }\\n  .offset-xl-0 {\\n    margin-left: 0; }\\n  .offset-xl-1 {\\n    margin-left: 8.33333%; }\\n  .offset-xl-2 {\\n    margin-left: 16.66667%; }\\n  .offset-xl-3 {\\n    margin-left: 25%; }\\n  .offset-xl-4 {\\n    margin-left: 33.33333%; }\\n  .offset-xl-5 {\\n    margin-left: 41.66667%; }\\n  .offset-xl-6 {\\n    margin-left: 50%; }\\n  .offset-xl-7 {\\n    margin-left: 58.33333%; }\\n  .offset-xl-8 {\\n    margin-left: 66.66667%; }\\n  .offset-xl-9 {\\n    margin-left: 75%; }\\n  .offset-xl-10 {\\n    margin-left: 83.33333%; }\\n  .offset-xl-11 {\\n    margin-left: 91.66667%; } }\\n\\n.table {\\n  width: 100%;\\n  margin-bottom: 1rem;\\n  color: #212529; }\\n  .table th,\\n  .table td {\\n    padding: 0.75rem;\\n    vertical-align: top;\\n    border-top: 1px solid #dee2e6; }\\n  .table thead th {\\n    vertical-align: bottom;\\n    border-bottom: 2px solid #dee2e6; }\\n  .table tbody + tbody {\\n    border-top: 2px solid #dee2e6; }\\n\\n.table-sm th,\\n.table-sm td {\\n  padding: 0.3rem; }\\n\\n.table-bordered {\\n  border: 1px solid #dee2e6; }\\n  .table-bordered th,\\n  .table-bordered td {\\n    border: 1px solid #dee2e6; }\\n  .table-bordered thead th,\\n  .table-bordered thead td {\\n    border-bottom-width: 2px; }\\n\\n.table-borderless th,\\n.table-borderless td,\\n.table-borderless thead th,\\n.table-borderless tbody + tbody {\\n  border: 0; }\\n\\n.table-striped tbody tr:nth-of-type(odd) {\\n  background-color: rgba(0, 0, 0, 0.05); }\\n\\n.table-hover tbody tr:hover {\\n  color: #212529;\\n  background-color: rgba(0, 0, 0, 0.075); }\\n\\n.table-primary,\\n.table-primary > th,\\n.table-primary > td {\\n  background-color: #e5c6c1; }\\n\\n.table-primary th,\\n.table-primary td,\\n.table-primary thead th,\\n.table-primary tbody + tbody {\\n  border-color: #cf958c; }\\n\\n.table-hover .table-primary:hover {\\n  background-color: #ddb5af; }\\n  .table-hover .table-primary:hover > td,\\n  .table-hover .table-primary:hover > th {\\n    background-color: #ddb5af; }\\n\\n.table-secondary,\\n.table-secondary > th,\\n.table-secondary > td {\\n  background-color: #d6d8db; }\\n\\n.table-secondary th,\\n.table-secondary td,\\n.table-secondary thead th,\\n.table-secondary tbody + tbody {\\n  border-color: #b3b7bb; }\\n\\n.table-hover .table-secondary:hover {\\n  background-color: #c8cbcf; }\\n  .table-hover .table-secondary:hover > td,\\n  .table-hover .table-secondary:hover > th {\\n    background-color: #c8cbcf; }\\n\\n.table-success,\\n.table-success > th,\\n.table-success > td {\\n  background-color: #c3e6cb; }\\n\\n.table-success th,\\n.table-success td,\\n.table-success thead th,\\n.table-success tbody + tbody {\\n  border-color: #8fd19e; }\\n\\n.table-hover .table-success:hover {\\n  background-color: #b1dfbb; }\\n  .table-hover .table-success:hover > td,\\n  .table-hover .table-success:hover > th {\\n    background-color: #b1dfbb; }\\n\\n.table-info,\\n.table-info > th,\\n.table-info > td {\\n  background-color: #bee5eb; }\\n\\n.table-info th,\\n.table-info td,\\n.table-info thead th,\\n.table-info tbody + tbody {\\n  border-color: #86cfda; }\\n\\n.table-hover .table-info:hover {\\n  background-color: #abdde5; }\\n  .table-hover .table-info:hover > td,\\n  .table-hover .table-info:hover > th {\\n    background-color: #abdde5; }\\n\\n.table-warning,\\n.table-warning > th,\\n.table-warning > td {\\n  background-color: #ffeeba; }\\n\\n.table-warning th,\\n.table-warning td,\\n.table-warning thead th,\\n.table-warning tbody + tbody {\\n  border-color: #ffdf7e; }\\n\\n.table-hover .table-warning:hover {\\n  background-color: #ffe8a1; }\\n  .table-hover .table-warning:hover > td,\\n  .table-hover .table-warning:hover > th {\\n    background-color: #ffe8a1; }\\n\\n.table-danger,\\n.table-danger > th,\\n.table-danger > td {\\n  background-color: #f5c6cb; }\\n\\n.table-danger th,\\n.table-danger td,\\n.table-danger thead th,\\n.table-danger tbody + tbody {\\n  border-color: #ed969e; }\\n\\n.table-hover .table-danger:hover {\\n  background-color: #f1b0b7; }\\n  .table-hover .table-danger:hover > td,\\n  .table-hover .table-danger:hover > th {\\n    background-color: #f1b0b7; }\\n\\n.table-light,\\n.table-light > th,\\n.table-light > td {\\n  background-color: #fdfdfe; }\\n\\n.table-light th,\\n.table-light td,\\n.table-light thead th,\\n.table-light tbody + tbody {\\n  border-color: #fbfcfc; }\\n\\n.table-hover .table-light:hover {\\n  background-color: #ececf6; }\\n  .table-hover .table-light:hover > td,\\n  .table-hover .table-light:hover > th {\\n    background-color: #ececf6; }\\n\\n.table-dark,\\n.table-dark > th,\\n.table-dark > td {\\n  background-color: #c6c8ca; }\\n\\n.table-dark th,\\n.table-dark td,\\n.table-dark thead th,\\n.table-dark tbody + tbody {\\n  border-color: #95999c; }\\n\\n.table-hover .table-dark:hover {\\n  background-color: #b9bbbe; }\\n  .table-hover .table-dark:hover > td,\\n  .table-hover .table-dark:hover > th {\\n    background-color: #b9bbbe; }\\n\\n.table-primary-light-dark,\\n.table-primary-light-dark > th,\\n.table-primary-light-dark > td {\\n  background-color: #eac8c2; }\\n\\n.table-primary-light-dark th,\\n.table-primary-light-dark td,\\n.table-primary-light-dark thead th,\\n.table-primary-light-dark tbody + tbody {\\n  border-color: #d7988e; }\\n\\n.table-hover .table-primary-light-dark:hover {\\n  background-color: #e3b7af; }\\n  .table-hover .table-primary-light-dark:hover > td,\\n  .table-hover .table-primary-light-dark:hover > th {\\n    background-color: #e3b7af; }\\n\\n.table-primary-dark,\\n.table-primary-dark > th,\\n.table-primary-dark > td {\\n  background-color: #e0c5c0; }\\n\\n.table-primary-dark th,\\n.table-primary-dark td,\\n.table-primary-dark thead th,\\n.table-primary-dark tbody + tbody {\\n  border-color: #c6938a; }\\n\\n.table-hover .table-primary-dark:hover {\\n  background-color: #d8b5af; }\\n  .table-hover .table-primary-dark:hover > td,\\n  .table-hover .table-primary-dark:hover > th {\\n    background-color: #d8b5af; }\\n\\n.table-active,\\n.table-active > th,\\n.table-active > td {\\n  background-color: rgba(0, 0, 0, 0.075); }\\n\\n.table-hover .table-active:hover {\\n  background-color: rgba(0, 0, 0, 0.075); }\\n  .table-hover .table-active:hover > td,\\n  .table-hover .table-active:hover > th {\\n    background-color: rgba(0, 0, 0, 0.075); }\\n\\n.table .thead-dark th {\\n  color: #fff;\\n  background-color: #343a40;\\n  border-color: #454d55; }\\n\\n.table .thead-light th {\\n  color: #495057;\\n  background-color: #e9ecef;\\n  border-color: #dee2e6; }\\n\\n.table-dark {\\n  color: #fff;\\n  background-color: #343a40; }\\n  .table-dark th,\\n  .table-dark td,\\n  .table-dark thead th {\\n    border-color: #454d55; }\\n  .table-dark.table-bordered {\\n    border: 0; }\\n  .table-dark.table-striped tbody tr:nth-of-type(odd) {\\n    background-color: rgba(255, 255, 255, 0.05); }\\n  .table-dark.table-hover tbody tr:hover {\\n    color: #fff;\\n    background-color: rgba(255, 255, 255, 0.075); }\\n\\n@media (max-width: 575.98px) {\\n  .table-responsive-sm {\\n    display: block;\\n    width: 100%;\\n    overflow-x: auto;\\n    -webkit-overflow-scrolling: touch; }\\n    .table-responsive-sm > .table-bordered {\\n      border: 0; } }\\n\\n@media (max-width: 767.98px) {\\n  .table-responsive-md {\\n    display: block;\\n    width: 100%;\\n    overflow-x: auto;\\n    -webkit-overflow-scrolling: touch; }\\n    .table-responsive-md > .table-bordered {\\n      border: 0; } }\\n\\n@media (max-width: 991.98px) {\\n  .table-responsive-lg {\\n    display: block;\\n    width: 100%;\\n    overflow-x: auto;\\n    -webkit-overflow-scrolling: touch; }\\n    .table-responsive-lg > .table-bordered {\\n      border: 0; } }\\n\\n@media (max-width: 1199.98px) {\\n  .table-responsive-xl {\\n    display: block;\\n    width: 100%;\\n    overflow-x: auto;\\n    -webkit-overflow-scrolling: touch; }\\n    .table-responsive-xl > .table-bordered {\\n      border: 0; } }\\n\\n.table-responsive {\\n  display: block;\\n  width: 100%;\\n  overflow-x: auto;\\n  -webkit-overflow-scrolling: touch; }\\n  .table-responsive > .table-bordered {\\n    border: 0; }\\n\\n.form-control {\\n  display: block;\\n  width: 100%;\\n  height: calc(1.5em + 0.75rem + 2px);\\n  padding: 0.375rem 0.75rem;\\n  font-size: 1rem;\\n  font-weight: 400;\\n  line-height: 1.5;\\n  color: #495057;\\n  background-color: #fff;\\n  background-clip: padding-box;\\n  border: 1px solid #ced4da;\\n  border-radius: 0.25rem;\\n  transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .form-control {\\n      transition: none; } }\\n  .form-control::-ms-expand {\\n    background-color: transparent;\\n    border: 0; }\\n  .form-control:-moz-focusring {\\n    color: transparent;\\n    text-shadow: 0 0 0 #495057; }\\n  .form-control:focus {\\n    color: #495057;\\n    background-color: #fff;\\n    border-color: #df7665;\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .form-control::-moz-placeholder {\\n    color: #6c757d;\\n    opacity: 1; }\\n  .form-control:-ms-input-placeholder {\\n    color: #6c757d;\\n    opacity: 1; }\\n  .form-control::-ms-input-placeholder {\\n    color: #6c757d;\\n    opacity: 1; }\\n  .form-control::placeholder {\\n    color: #6c757d;\\n    opacity: 1; }\\n  .form-control:disabled, .form-control[readonly] {\\n    background-color: #e9ecef;\\n    opacity: 1; }\\n\\ninput[type=\\\"date\\\"].form-control,\\ninput[type=\\\"time\\\"].form-control,\\ninput[type=\\\"datetime-local\\\"].form-control,\\ninput[type=\\\"month\\\"].form-control {\\n  -webkit-appearance: none;\\n     -moz-appearance: none;\\n          appearance: none; }\\n\\nselect.form-control:focus::-ms-value {\\n  color: #495057;\\n  background-color: #fff; }\\n\\n.form-control-file,\\n.form-control-range {\\n  display: block;\\n  width: 100%; }\\n\\n.col-form-label {\\n  padding-top: calc(0.375rem + 1px);\\n  padding-bottom: calc(0.375rem + 1px);\\n  margin-bottom: 0;\\n  font-size: inherit;\\n  line-height: 1.5; }\\n\\n.col-form-label-lg {\\n  padding-top: calc(0.5rem + 1px);\\n  padding-bottom: calc(0.5rem + 1px);\\n  font-size: 1.25rem;\\n  line-height: 1.5; }\\n\\n.col-form-label-sm {\\n  padding-top: calc(0.25rem + 1px);\\n  padding-bottom: calc(0.25rem + 1px);\\n  font-size: 0.875rem;\\n  line-height: 1.5; }\\n\\n.form-control-plaintext {\\n  display: block;\\n  width: 100%;\\n  padding: 0.375rem 0;\\n  margin-bottom: 0;\\n  font-size: 1rem;\\n  line-height: 1.5;\\n  color: #212529;\\n  background-color: transparent;\\n  border: solid transparent;\\n  border-width: 1px 0; }\\n  .form-control-plaintext.form-control-sm, .form-control-plaintext.form-control-lg {\\n    padding-right: 0;\\n    padding-left: 0; }\\n\\n.form-control-sm {\\n  height: calc(1.5em + 0.5rem + 2px);\\n  padding: 0.25rem 0.5rem;\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  border-radius: 0.2rem; }\\n\\n.form-control-lg {\\n  height: calc(1.5em + 1rem + 2px);\\n  padding: 0.5rem 1rem;\\n  font-size: 1.25rem;\\n  line-height: 1.5;\\n  border-radius: 0.3rem; }\\n\\nselect.form-control[size], select.form-control[multiple] {\\n  height: auto; }\\n\\ntextarea.form-control {\\n  height: auto; }\\n\\n.form-group {\\n  margin-bottom: 1rem; }\\n\\n.form-text {\\n  display: block;\\n  margin-top: 0.25rem; }\\n\\n.form-row {\\n  display: flex;\\n  flex-wrap: wrap;\\n  margin-right: -5px;\\n  margin-left: -5px; }\\n  .form-row > .col,\\n  .form-row > [class*=\\\"col-\\\"] {\\n    padding-right: 5px;\\n    padding-left: 5px; }\\n\\n.form-check {\\n  position: relative;\\n  display: block;\\n  padding-left: 1.25rem; }\\n\\n.form-check-input {\\n  position: absolute;\\n  margin-top: 0.3rem;\\n  margin-left: -1.25rem; }\\n  .form-check-input[disabled] ~ .form-check-label,\\n  .form-check-input:disabled ~ .form-check-label {\\n    color: #6c757d; }\\n\\n.form-check-label {\\n  margin-bottom: 0; }\\n\\n.form-check-inline {\\n  display: inline-flex;\\n  align-items: center;\\n  padding-left: 0;\\n  margin-right: 0.75rem; }\\n  .form-check-inline .form-check-input {\\n    position: static;\\n    margin-top: 0;\\n    margin-right: 0.3125rem;\\n    margin-left: 0; }\\n\\n.valid-feedback {\\n  display: none;\\n  width: 100%;\\n  margin-top: 0.25rem;\\n  font-size: 80%;\\n  color: #28a745; }\\n\\n.valid-tooltip {\\n  position: absolute;\\n  top: 100%;\\n  z-index: 5;\\n  display: none;\\n  max-width: 100%;\\n  padding: 0.25rem 0.5rem;\\n  margin-top: .1rem;\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  color: #fff;\\n  background-color: rgba(40, 167, 69, 0.9);\\n  border-radius: 0.25rem; }\\n\\n.was-validated :valid ~ .valid-feedback,\\n.was-validated :valid ~ .valid-tooltip,\\n.is-valid ~ .valid-feedback,\\n.is-valid ~ .valid-tooltip {\\n  display: block; }\\n\\n.was-validated .form-control:valid, .form-control.is-valid {\\n  border-color: #28a745;\\n  padding-right: calc(1.5em + 0.75rem);\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='8' height='8' viewBox='0 0 8 8'%3e%3cpath fill='%2328a745' d='M2.3 6.73L.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z'/%3e%3c/svg%3e\\\");\\n  background-repeat: no-repeat;\\n  background-position: right calc(0.375em + 0.1875rem) center;\\n  background-size: calc(0.75em + 0.375rem) calc(0.75em + 0.375rem); }\\n  .was-validated .form-control:valid:focus, .form-control.is-valid:focus {\\n    border-color: #28a745;\\n    box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.25); }\\n\\n.was-validated textarea.form-control:valid, textarea.form-control.is-valid {\\n  padding-right: calc(1.5em + 0.75rem);\\n  background-position: top calc(0.375em + 0.1875rem) right calc(0.375em + 0.1875rem); }\\n\\n.was-validated .custom-select:valid, .custom-select.is-valid {\\n  border-color: #28a745;\\n  padding-right: calc(0.75em + 2.3125rem);\\n  background: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e\\\") no-repeat right 0.75rem center/8px 10px, url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='8' height='8' viewBox='0 0 8 8'%3e%3cpath fill='%2328a745' d='M2.3 6.73L.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z'/%3e%3c/svg%3e\\\") #fff no-repeat center right 1.75rem/calc(0.75em + 0.375rem) calc(0.75em + 0.375rem); }\\n  .was-validated .custom-select:valid:focus, .custom-select.is-valid:focus {\\n    border-color: #28a745;\\n    box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.25); }\\n\\n.was-validated .form-check-input:valid ~ .form-check-label, .form-check-input.is-valid ~ .form-check-label {\\n  color: #28a745; }\\n\\n.was-validated .form-check-input:valid ~ .valid-feedback,\\n.was-validated .form-check-input:valid ~ .valid-tooltip, .form-check-input.is-valid ~ .valid-feedback,\\n.form-check-input.is-valid ~ .valid-tooltip {\\n  display: block; }\\n\\n.was-validated .custom-control-input:valid ~ .custom-control-label, .custom-control-input.is-valid ~ .custom-control-label {\\n  color: #28a745; }\\n  .was-validated .custom-control-input:valid ~ .custom-control-label::before, .custom-control-input.is-valid ~ .custom-control-label::before {\\n    border-color: #28a745; }\\n\\n.was-validated .custom-control-input:valid:checked ~ .custom-control-label::before, .custom-control-input.is-valid:checked ~ .custom-control-label::before {\\n  border-color: #34ce57;\\n  background-color: #34ce57; }\\n\\n.was-validated .custom-control-input:valid:focus ~ .custom-control-label::before, .custom-control-input.is-valid:focus ~ .custom-control-label::before {\\n  box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.25); }\\n\\n.was-validated .custom-control-input:valid:focus:not(:checked) ~ .custom-control-label::before, .custom-control-input.is-valid:focus:not(:checked) ~ .custom-control-label::before {\\n  border-color: #28a745; }\\n\\n.was-validated .custom-file-input:valid ~ .custom-file-label, .custom-file-input.is-valid ~ .custom-file-label {\\n  border-color: #28a745; }\\n\\n.was-validated .custom-file-input:valid:focus ~ .custom-file-label, .custom-file-input.is-valid:focus ~ .custom-file-label {\\n  border-color: #28a745;\\n  box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.25); }\\n\\n.invalid-feedback {\\n  display: none;\\n  width: 100%;\\n  margin-top: 0.25rem;\\n  font-size: 80%;\\n  color: #dc3545; }\\n\\n.invalid-tooltip {\\n  position: absolute;\\n  top: 100%;\\n  z-index: 5;\\n  display: none;\\n  max-width: 100%;\\n  padding: 0.25rem 0.5rem;\\n  margin-top: .1rem;\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  color: #fff;\\n  background-color: rgba(220, 53, 69, 0.9);\\n  border-radius: 0.25rem; }\\n\\n.was-validated :invalid ~ .invalid-feedback,\\n.was-validated :invalid ~ .invalid-tooltip,\\n.is-invalid ~ .invalid-feedback,\\n.is-invalid ~ .invalid-tooltip {\\n  display: block; }\\n\\n.was-validated .form-control:invalid, .form-control.is-invalid {\\n  border-color: #dc3545;\\n  padding-right: calc(1.5em + 0.75rem);\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='%23dc3545' viewBox='0 0 12 12'%3e%3ccircle cx='6' cy='6' r='4.5'/%3e%3cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3e%3ccircle cx='6' cy='8.2' r='.6' fill='%23dc3545' stroke='none'/%3e%3c/svg%3e\\\");\\n  background-repeat: no-repeat;\\n  background-position: right calc(0.375em + 0.1875rem) center;\\n  background-size: calc(0.75em + 0.375rem) calc(0.75em + 0.375rem); }\\n  .was-validated .form-control:invalid:focus, .form-control.is-invalid:focus {\\n    border-color: #dc3545;\\n    box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.25); }\\n\\n.was-validated textarea.form-control:invalid, textarea.form-control.is-invalid {\\n  padding-right: calc(1.5em + 0.75rem);\\n  background-position: top calc(0.375em + 0.1875rem) right calc(0.375em + 0.1875rem); }\\n\\n.was-validated .custom-select:invalid, .custom-select.is-invalid {\\n  border-color: #dc3545;\\n  padding-right: calc(0.75em + 2.3125rem);\\n  background: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e\\\") no-repeat right 0.75rem center/8px 10px, url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='%23dc3545' viewBox='0 0 12 12'%3e%3ccircle cx='6' cy='6' r='4.5'/%3e%3cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3e%3ccircle cx='6' cy='8.2' r='.6' fill='%23dc3545' stroke='none'/%3e%3c/svg%3e\\\") #fff no-repeat center right 1.75rem/calc(0.75em + 0.375rem) calc(0.75em + 0.375rem); }\\n  .was-validated .custom-select:invalid:focus, .custom-select.is-invalid:focus {\\n    border-color: #dc3545;\\n    box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.25); }\\n\\n.was-validated .form-check-input:invalid ~ .form-check-label, .form-check-input.is-invalid ~ .form-check-label {\\n  color: #dc3545; }\\n\\n.was-validated .form-check-input:invalid ~ .invalid-feedback,\\n.was-validated .form-check-input:invalid ~ .invalid-tooltip, .form-check-input.is-invalid ~ .invalid-feedback,\\n.form-check-input.is-invalid ~ .invalid-tooltip {\\n  display: block; }\\n\\n.was-validated .custom-control-input:invalid ~ .custom-control-label, .custom-control-input.is-invalid ~ .custom-control-label {\\n  color: #dc3545; }\\n  .was-validated .custom-control-input:invalid ~ .custom-control-label::before, .custom-control-input.is-invalid ~ .custom-control-label::before {\\n    border-color: #dc3545; }\\n\\n.was-validated .custom-control-input:invalid:checked ~ .custom-control-label::before, .custom-control-input.is-invalid:checked ~ .custom-control-label::before {\\n  border-color: #e4606d;\\n  background-color: #e4606d; }\\n\\n.was-validated .custom-control-input:invalid:focus ~ .custom-control-label::before, .custom-control-input.is-invalid:focus ~ .custom-control-label::before {\\n  box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.25); }\\n\\n.was-validated .custom-control-input:invalid:focus:not(:checked) ~ .custom-control-label::before, .custom-control-input.is-invalid:focus:not(:checked) ~ .custom-control-label::before {\\n  border-color: #dc3545; }\\n\\n.was-validated .custom-file-input:invalid ~ .custom-file-label, .custom-file-input.is-invalid ~ .custom-file-label {\\n  border-color: #dc3545; }\\n\\n.was-validated .custom-file-input:invalid:focus ~ .custom-file-label, .custom-file-input.is-invalid:focus ~ .custom-file-label {\\n  border-color: #dc3545;\\n  box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.25); }\\n\\n.form-inline {\\n  display: flex;\\n  flex-flow: row wrap;\\n  align-items: center; }\\n  .form-inline .form-check {\\n    width: 100%; }\\n  @media (min-width: 576px) {\\n    .form-inline label {\\n      display: flex;\\n      align-items: center;\\n      justify-content: center;\\n      margin-bottom: 0; }\\n    .form-inline .form-group {\\n      display: flex;\\n      flex: 0 0 auto;\\n      flex-flow: row wrap;\\n      align-items: center;\\n      margin-bottom: 0; }\\n    .form-inline .form-control {\\n      display: inline-block;\\n      width: auto;\\n      vertical-align: middle; }\\n    .form-inline .form-control-plaintext {\\n      display: inline-block; }\\n    .form-inline .input-group,\\n    .form-inline .custom-select {\\n      width: auto; }\\n    .form-inline .form-check {\\n      display: flex;\\n      align-items: center;\\n      justify-content: center;\\n      width: auto;\\n      padding-left: 0; }\\n    .form-inline .form-check-input {\\n      position: relative;\\n      flex-shrink: 0;\\n      margin-top: 0;\\n      margin-right: 0.25rem;\\n      margin-left: 0; }\\n    .form-inline .custom-control {\\n      align-items: center;\\n      justify-content: center; }\\n    .form-inline .custom-control-label {\\n      margin-bottom: 0; } }\\n\\n.btn {\\n  display: inline-block;\\n  font-weight: 400;\\n  color: #212529;\\n  text-align: center;\\n  vertical-align: middle;\\n  -webkit-user-select: none;\\n     -moz-user-select: none;\\n      -ms-user-select: none;\\n          user-select: none;\\n  background-color: transparent;\\n  border: 1px solid transparent;\\n  padding: 0.375rem 0.75rem;\\n  font-size: 1rem;\\n  line-height: 1.5;\\n  border-radius: 0.25rem;\\n  transition: color 0.15s ease-in-out, background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .btn {\\n      transition: none; } }\\n  .btn:hover {\\n    color: #212529;\\n    text-decoration: none; }\\n  .btn:focus, .btn.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .btn.disabled, .btn:disabled {\\n    opacity: 0.65; }\\n  .btn:not(:disabled):not(.disabled) {\\n    cursor: pointer; }\\n\\na.btn.disabled,\\nfieldset:disabled a.btn {\\n  pointer-events: none; }\\n\\n.btn-primary {\\n  color: #fff;\\n  background-color: #a23422;\\n  border-color: #a23422; }\\n  .btn-primary:hover {\\n    color: #fff;\\n    background-color: #822a1b;\\n    border-color: #782619; }\\n  .btn-primary:focus, .btn-primary.focus {\\n    color: #fff;\\n    background-color: #822a1b;\\n    border-color: #782619;\\n    box-shadow: 0 0 0 0.2rem rgba(176, 82, 67, 0.5); }\\n  .btn-primary.disabled, .btn-primary:disabled {\\n    color: #fff;\\n    background-color: #a23422;\\n    border-color: #a23422; }\\n  .btn-primary:not(:disabled):not(.disabled):active, .btn-primary:not(:disabled):not(.disabled).active,\\n  .show > .btn-primary.dropdown-toggle {\\n    color: #fff;\\n    background-color: #782619;\\n    border-color: #6d2317; }\\n    .btn-primary:not(:disabled):not(.disabled):active:focus, .btn-primary:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-primary.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(176, 82, 67, 0.5); }\\n\\n.btn-secondary {\\n  color: #fff;\\n  background-color: #6c757d;\\n  border-color: #6c757d; }\\n  .btn-secondary:hover {\\n    color: #fff;\\n    background-color: #5a6268;\\n    border-color: #545b62; }\\n  .btn-secondary:focus, .btn-secondary.focus {\\n    color: #fff;\\n    background-color: #5a6268;\\n    border-color: #545b62;\\n    box-shadow: 0 0 0 0.2rem rgba(130, 138, 145, 0.5); }\\n  .btn-secondary.disabled, .btn-secondary:disabled {\\n    color: #fff;\\n    background-color: #6c757d;\\n    border-color: #6c757d; }\\n  .btn-secondary:not(:disabled):not(.disabled):active, .btn-secondary:not(:disabled):not(.disabled).active,\\n  .show > .btn-secondary.dropdown-toggle {\\n    color: #fff;\\n    background-color: #545b62;\\n    border-color: #4e555b; }\\n    .btn-secondary:not(:disabled):not(.disabled):active:focus, .btn-secondary:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-secondary.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(130, 138, 145, 0.5); }\\n\\n.btn-success {\\n  color: #fff;\\n  background-color: #28a745;\\n  border-color: #28a745; }\\n  .btn-success:hover {\\n    color: #fff;\\n    background-color: #218838;\\n    border-color: #1e7e34; }\\n  .btn-success:focus, .btn-success.focus {\\n    color: #fff;\\n    background-color: #218838;\\n    border-color: #1e7e34;\\n    box-shadow: 0 0 0 0.2rem rgba(72, 180, 97, 0.5); }\\n  .btn-success.disabled, .btn-success:disabled {\\n    color: #fff;\\n    background-color: #28a745;\\n    border-color: #28a745; }\\n  .btn-success:not(:disabled):not(.disabled):active, .btn-success:not(:disabled):not(.disabled).active,\\n  .show > .btn-success.dropdown-toggle {\\n    color: #fff;\\n    background-color: #1e7e34;\\n    border-color: #1c7430; }\\n    .btn-success:not(:disabled):not(.disabled):active:focus, .btn-success:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-success.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(72, 180, 97, 0.5); }\\n\\n.btn-info {\\n  color: #fff;\\n  background-color: #17a2b8;\\n  border-color: #17a2b8; }\\n  .btn-info:hover {\\n    color: #fff;\\n    background-color: #138496;\\n    border-color: #117a8b; }\\n  .btn-info:focus, .btn-info.focus {\\n    color: #fff;\\n    background-color: #138496;\\n    border-color: #117a8b;\\n    box-shadow: 0 0 0 0.2rem rgba(58, 176, 195, 0.5); }\\n  .btn-info.disabled, .btn-info:disabled {\\n    color: #fff;\\n    background-color: #17a2b8;\\n    border-color: #17a2b8; }\\n  .btn-info:not(:disabled):not(.disabled):active, .btn-info:not(:disabled):not(.disabled).active,\\n  .show > .btn-info.dropdown-toggle {\\n    color: #fff;\\n    background-color: #117a8b;\\n    border-color: #10707f; }\\n    .btn-info:not(:disabled):not(.disabled):active:focus, .btn-info:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-info.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(58, 176, 195, 0.5); }\\n\\n.btn-warning {\\n  color: #212529;\\n  background-color: #ffc107;\\n  border-color: #ffc107; }\\n  .btn-warning:hover {\\n    color: #212529;\\n    background-color: #e0a800;\\n    border-color: #d39e00; }\\n  .btn-warning:focus, .btn-warning.focus {\\n    color: #212529;\\n    background-color: #e0a800;\\n    border-color: #d39e00;\\n    box-shadow: 0 0 0 0.2rem rgba(222, 170, 12, 0.5); }\\n  .btn-warning.disabled, .btn-warning:disabled {\\n    color: #212529;\\n    background-color: #ffc107;\\n    border-color: #ffc107; }\\n  .btn-warning:not(:disabled):not(.disabled):active, .btn-warning:not(:disabled):not(.disabled).active,\\n  .show > .btn-warning.dropdown-toggle {\\n    color: #212529;\\n    background-color: #d39e00;\\n    border-color: #c69500; }\\n    .btn-warning:not(:disabled):not(.disabled):active:focus, .btn-warning:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-warning.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(222, 170, 12, 0.5); }\\n\\n.btn-danger {\\n  color: #fff;\\n  background-color: #dc3545;\\n  border-color: #dc3545; }\\n  .btn-danger:hover {\\n    color: #fff;\\n    background-color: #c82333;\\n    border-color: #bd2130; }\\n  .btn-danger:focus, .btn-danger.focus {\\n    color: #fff;\\n    background-color: #c82333;\\n    border-color: #bd2130;\\n    box-shadow: 0 0 0 0.2rem rgba(225, 83, 97, 0.5); }\\n  .btn-danger.disabled, .btn-danger:disabled {\\n    color: #fff;\\n    background-color: #dc3545;\\n    border-color: #dc3545; }\\n  .btn-danger:not(:disabled):not(.disabled):active, .btn-danger:not(:disabled):not(.disabled).active,\\n  .show > .btn-danger.dropdown-toggle {\\n    color: #fff;\\n    background-color: #bd2130;\\n    border-color: #b21f2d; }\\n    .btn-danger:not(:disabled):not(.disabled):active:focus, .btn-danger:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-danger.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(225, 83, 97, 0.5); }\\n\\n.btn-light {\\n  color: #212529;\\n  background-color: #f8f9fa;\\n  border-color: #f8f9fa; }\\n  .btn-light:hover {\\n    color: #212529;\\n    background-color: #e2e6ea;\\n    border-color: #dae0e5; }\\n  .btn-light:focus, .btn-light.focus {\\n    color: #212529;\\n    background-color: #e2e6ea;\\n    border-color: #dae0e5;\\n    box-shadow: 0 0 0 0.2rem rgba(216, 217, 219, 0.5); }\\n  .btn-light.disabled, .btn-light:disabled {\\n    color: #212529;\\n    background-color: #f8f9fa;\\n    border-color: #f8f9fa; }\\n  .btn-light:not(:disabled):not(.disabled):active, .btn-light:not(:disabled):not(.disabled).active,\\n  .show > .btn-light.dropdown-toggle {\\n    color: #212529;\\n    background-color: #dae0e5;\\n    border-color: #d3d9df; }\\n    .btn-light:not(:disabled):not(.disabled):active:focus, .btn-light:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-light.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(216, 217, 219, 0.5); }\\n\\n.btn-dark {\\n  color: #fff;\\n  background-color: #343a40;\\n  border-color: #343a40; }\\n  .btn-dark:hover {\\n    color: #fff;\\n    background-color: #23272b;\\n    border-color: #1d2124; }\\n  .btn-dark:focus, .btn-dark.focus {\\n    color: #fff;\\n    background-color: #23272b;\\n    border-color: #1d2124;\\n    box-shadow: 0 0 0 0.2rem rgba(82, 88, 93, 0.5); }\\n  .btn-dark.disabled, .btn-dark:disabled {\\n    color: #fff;\\n    background-color: #343a40;\\n    border-color: #343a40; }\\n  .btn-dark:not(:disabled):not(.disabled):active, .btn-dark:not(:disabled):not(.disabled).active,\\n  .show > .btn-dark.dropdown-toggle {\\n    color: #fff;\\n    background-color: #1d2124;\\n    border-color: #171a1d; }\\n    .btn-dark:not(:disabled):not(.disabled):active:focus, .btn-dark:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-dark.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(82, 88, 93, 0.5); }\\n\\n.btn-primary-light-dark {\\n  color: #fff;\\n  background-color: #b33926;\\n  border-color: #b33926; }\\n  .btn-primary-light-dark:hover {\\n    color: #fff;\\n    background-color: #932f1f;\\n    border-color: #892c1d; }\\n  .btn-primary-light-dark:focus, .btn-primary-light-dark.focus {\\n    color: #fff;\\n    background-color: #932f1f;\\n    border-color: #892c1d;\\n    box-shadow: 0 0 0 0.2rem rgba(190, 87, 70, 0.5); }\\n  .btn-primary-light-dark.disabled, .btn-primary-light-dark:disabled {\\n    color: #fff;\\n    background-color: #b33926;\\n    border-color: #b33926; }\\n  .btn-primary-light-dark:not(:disabled):not(.disabled):active, .btn-primary-light-dark:not(:disabled):not(.disabled).active,\\n  .show > .btn-primary-light-dark.dropdown-toggle {\\n    color: #fff;\\n    background-color: #892c1d;\\n    border-color: #7e281a; }\\n    .btn-primary-light-dark:not(:disabled):not(.disabled):active:focus, .btn-primary-light-dark:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-primary-light-dark.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(190, 87, 70, 0.5); }\\n\\n.btn-primary-dark {\\n  color: #fff;\\n  background-color: #912f1e;\\n  border-color: #912f1e; }\\n  .btn-primary-dark:hover {\\n    color: #fff;\\n    background-color: #722418;\\n    border-color: #672116; }\\n  .btn-primary-dark:focus, .btn-primary-dark.focus {\\n    color: #fff;\\n    background-color: #722418;\\n    border-color: #672116;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 78, 64, 0.5); }\\n  .btn-primary-dark.disabled, .btn-primary-dark:disabled {\\n    color: #fff;\\n    background-color: #912f1e;\\n    border-color: #912f1e; }\\n  .btn-primary-dark:not(:disabled):not(.disabled):active, .btn-primary-dark:not(:disabled):not(.disabled).active,\\n  .show > .btn-primary-dark.dropdown-toggle {\\n    color: #fff;\\n    background-color: #672116;\\n    border-color: #5c1e13; }\\n    .btn-primary-dark:not(:disabled):not(.disabled):active:focus, .btn-primary-dark:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-primary-dark.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(162, 78, 64, 0.5); }\\n\\n.btn-outline-primary {\\n  color: #a23422;\\n  border-color: #a23422; }\\n  .btn-outline-primary:hover {\\n    color: #fff;\\n    background-color: #a23422;\\n    border-color: #a23422; }\\n  .btn-outline-primary:focus, .btn-outline-primary.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.5); }\\n  .btn-outline-primary.disabled, .btn-outline-primary:disabled {\\n    color: #a23422;\\n    background-color: transparent; }\\n  .btn-outline-primary:not(:disabled):not(.disabled):active, .btn-outline-primary:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-primary.dropdown-toggle {\\n    color: #fff;\\n    background-color: #a23422;\\n    border-color: #a23422; }\\n    .btn-outline-primary:not(:disabled):not(.disabled):active:focus, .btn-outline-primary:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-primary.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.5); }\\n\\n.btn-outline-secondary {\\n  color: #6c757d;\\n  border-color: #6c757d; }\\n  .btn-outline-secondary:hover {\\n    color: #fff;\\n    background-color: #6c757d;\\n    border-color: #6c757d; }\\n  .btn-outline-secondary:focus, .btn-outline-secondary.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(108, 117, 125, 0.5); }\\n  .btn-outline-secondary.disabled, .btn-outline-secondary:disabled {\\n    color: #6c757d;\\n    background-color: transparent; }\\n  .btn-outline-secondary:not(:disabled):not(.disabled):active, .btn-outline-secondary:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-secondary.dropdown-toggle {\\n    color: #fff;\\n    background-color: #6c757d;\\n    border-color: #6c757d; }\\n    .btn-outline-secondary:not(:disabled):not(.disabled):active:focus, .btn-outline-secondary:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-secondary.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(108, 117, 125, 0.5); }\\n\\n.btn-outline-success {\\n  color: #28a745;\\n  border-color: #28a745; }\\n  .btn-outline-success:hover {\\n    color: #fff;\\n    background-color: #28a745;\\n    border-color: #28a745; }\\n  .btn-outline-success:focus, .btn-outline-success.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.5); }\\n  .btn-outline-success.disabled, .btn-outline-success:disabled {\\n    color: #28a745;\\n    background-color: transparent; }\\n  .btn-outline-success:not(:disabled):not(.disabled):active, .btn-outline-success:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-success.dropdown-toggle {\\n    color: #fff;\\n    background-color: #28a745;\\n    border-color: #28a745; }\\n    .btn-outline-success:not(:disabled):not(.disabled):active:focus, .btn-outline-success:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-success.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.5); }\\n\\n.btn-outline-info {\\n  color: #17a2b8;\\n  border-color: #17a2b8; }\\n  .btn-outline-info:hover {\\n    color: #fff;\\n    background-color: #17a2b8;\\n    border-color: #17a2b8; }\\n  .btn-outline-info:focus, .btn-outline-info.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(23, 162, 184, 0.5); }\\n  .btn-outline-info.disabled, .btn-outline-info:disabled {\\n    color: #17a2b8;\\n    background-color: transparent; }\\n  .btn-outline-info:not(:disabled):not(.disabled):active, .btn-outline-info:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-info.dropdown-toggle {\\n    color: #fff;\\n    background-color: #17a2b8;\\n    border-color: #17a2b8; }\\n    .btn-outline-info:not(:disabled):not(.disabled):active:focus, .btn-outline-info:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-info.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(23, 162, 184, 0.5); }\\n\\n.btn-outline-warning {\\n  color: #ffc107;\\n  border-color: #ffc107; }\\n  .btn-outline-warning:hover {\\n    color: #212529;\\n    background-color: #ffc107;\\n    border-color: #ffc107; }\\n  .btn-outline-warning:focus, .btn-outline-warning.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(255, 193, 7, 0.5); }\\n  .btn-outline-warning.disabled, .btn-outline-warning:disabled {\\n    color: #ffc107;\\n    background-color: transparent; }\\n  .btn-outline-warning:not(:disabled):not(.disabled):active, .btn-outline-warning:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-warning.dropdown-toggle {\\n    color: #212529;\\n    background-color: #ffc107;\\n    border-color: #ffc107; }\\n    .btn-outline-warning:not(:disabled):not(.disabled):active:focus, .btn-outline-warning:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-warning.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(255, 193, 7, 0.5); }\\n\\n.btn-outline-danger {\\n  color: #dc3545;\\n  border-color: #dc3545; }\\n  .btn-outline-danger:hover {\\n    color: #fff;\\n    background-color: #dc3545;\\n    border-color: #dc3545; }\\n  .btn-outline-danger:focus, .btn-outline-danger.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.5); }\\n  .btn-outline-danger.disabled, .btn-outline-danger:disabled {\\n    color: #dc3545;\\n    background-color: transparent; }\\n  .btn-outline-danger:not(:disabled):not(.disabled):active, .btn-outline-danger:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-danger.dropdown-toggle {\\n    color: #fff;\\n    background-color: #dc3545;\\n    border-color: #dc3545; }\\n    .btn-outline-danger:not(:disabled):not(.disabled):active:focus, .btn-outline-danger:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-danger.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.5); }\\n\\n.btn-outline-light {\\n  color: #f8f9fa;\\n  border-color: #f8f9fa; }\\n  .btn-outline-light:hover {\\n    color: #212529;\\n    background-color: #f8f9fa;\\n    border-color: #f8f9fa; }\\n  .btn-outline-light:focus, .btn-outline-light.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(248, 249, 250, 0.5); }\\n  .btn-outline-light.disabled, .btn-outline-light:disabled {\\n    color: #f8f9fa;\\n    background-color: transparent; }\\n  .btn-outline-light:not(:disabled):not(.disabled):active, .btn-outline-light:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-light.dropdown-toggle {\\n    color: #212529;\\n    background-color: #f8f9fa;\\n    border-color: #f8f9fa; }\\n    .btn-outline-light:not(:disabled):not(.disabled):active:focus, .btn-outline-light:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-light.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(248, 249, 250, 0.5); }\\n\\n.btn-outline-dark {\\n  color: #343a40;\\n  border-color: #343a40; }\\n  .btn-outline-dark:hover {\\n    color: #fff;\\n    background-color: #343a40;\\n    border-color: #343a40; }\\n  .btn-outline-dark:focus, .btn-outline-dark.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(52, 58, 64, 0.5); }\\n  .btn-outline-dark.disabled, .btn-outline-dark:disabled {\\n    color: #343a40;\\n    background-color: transparent; }\\n  .btn-outline-dark:not(:disabled):not(.disabled):active, .btn-outline-dark:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-dark.dropdown-toggle {\\n    color: #fff;\\n    background-color: #343a40;\\n    border-color: #343a40; }\\n    .btn-outline-dark:not(:disabled):not(.disabled):active:focus, .btn-outline-dark:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-dark.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(52, 58, 64, 0.5); }\\n\\n.btn-outline-primary-light-dark {\\n  color: #b33926;\\n  border-color: #b33926; }\\n  .btn-outline-primary-light-dark:hover {\\n    color: #fff;\\n    background-color: #b33926;\\n    border-color: #b33926; }\\n  .btn-outline-primary-light-dark:focus, .btn-outline-primary-light-dark.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(179, 57, 38, 0.5); }\\n  .btn-outline-primary-light-dark.disabled, .btn-outline-primary-light-dark:disabled {\\n    color: #b33926;\\n    background-color: transparent; }\\n  .btn-outline-primary-light-dark:not(:disabled):not(.disabled):active, .btn-outline-primary-light-dark:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-primary-light-dark.dropdown-toggle {\\n    color: #fff;\\n    background-color: #b33926;\\n    border-color: #b33926; }\\n    .btn-outline-primary-light-dark:not(:disabled):not(.disabled):active:focus, .btn-outline-primary-light-dark:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-primary-light-dark.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(179, 57, 38, 0.5); }\\n\\n.btn-outline-primary-dark {\\n  color: #912f1e;\\n  border-color: #912f1e; }\\n  .btn-outline-primary-dark:hover {\\n    color: #fff;\\n    background-color: #912f1e;\\n    border-color: #912f1e; }\\n  .btn-outline-primary-dark:focus, .btn-outline-primary-dark.focus {\\n    box-shadow: 0 0 0 0.2rem rgba(145, 47, 30, 0.5); }\\n  .btn-outline-primary-dark.disabled, .btn-outline-primary-dark:disabled {\\n    color: #912f1e;\\n    background-color: transparent; }\\n  .btn-outline-primary-dark:not(:disabled):not(.disabled):active, .btn-outline-primary-dark:not(:disabled):not(.disabled).active,\\n  .show > .btn-outline-primary-dark.dropdown-toggle {\\n    color: #fff;\\n    background-color: #912f1e;\\n    border-color: #912f1e; }\\n    .btn-outline-primary-dark:not(:disabled):not(.disabled):active:focus, .btn-outline-primary-dark:not(:disabled):not(.disabled).active:focus,\\n    .show > .btn-outline-primary-dark.dropdown-toggle:focus {\\n      box-shadow: 0 0 0 0.2rem rgba(145, 47, 30, 0.5); }\\n\\n.btn-link {\\n  font-weight: 400;\\n  color: #a23422;\\n  text-decoration: none; }\\n  .btn-link:hover {\\n    color: #632015;\\n    text-decoration: underline; }\\n  .btn-link:focus, .btn-link.focus {\\n    text-decoration: underline; }\\n  .btn-link:disabled, .btn-link.disabled {\\n    color: #6c757d;\\n    pointer-events: none; }\\n\\n.btn-lg, .btn-group-lg > .btn {\\n  padding: 0.5rem 1rem;\\n  font-size: 1.25rem;\\n  line-height: 1.5;\\n  border-radius: 0.3rem; }\\n\\n.btn-sm, .btn-group-sm > .btn {\\n  padding: 0.25rem 0.5rem;\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  border-radius: 0.2rem; }\\n\\n.btn-block {\\n  display: block;\\n  width: 100%; }\\n  .btn-block + .btn-block {\\n    margin-top: 0.5rem; }\\n\\ninput[type=\\\"submit\\\"].btn-block,\\ninput[type=\\\"reset\\\"].btn-block,\\ninput[type=\\\"button\\\"].btn-block {\\n  width: 100%; }\\n\\n.fade {\\n  transition: opacity 0.15s linear; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .fade {\\n      transition: none; } }\\n  .fade:not(.show) {\\n    opacity: 0; }\\n\\n.collapse:not(.show) {\\n  display: none; }\\n\\n.collapsing {\\n  position: relative;\\n  height: 0;\\n  overflow: hidden;\\n  transition: height 0.35s ease; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .collapsing {\\n      transition: none; } }\\n\\n.dropup,\\n.dropright,\\n.dropdown,\\n.dropleft {\\n  position: relative; }\\n\\n.dropdown-toggle {\\n  white-space: nowrap; }\\n  .dropdown-toggle::after {\\n    display: inline-block;\\n    margin-left: 0.255em;\\n    vertical-align: 0.255em;\\n    content: \\\"\\\";\\n    border-top: 0.3em solid;\\n    border-right: 0.3em solid transparent;\\n    border-bottom: 0;\\n    border-left: 0.3em solid transparent; }\\n  .dropdown-toggle:empty::after {\\n    margin-left: 0; }\\n\\n.dropdown-menu {\\n  position: absolute;\\n  top: 100%;\\n  left: 0;\\n  z-index: 1000;\\n  display: none;\\n  float: left;\\n  min-width: 10rem;\\n  padding: 0.5rem 0;\\n  margin: 0.125rem 0 0;\\n  font-size: 1rem;\\n  color: #212529;\\n  text-align: left;\\n  list-style: none;\\n  background-color: #fff;\\n  background-clip: padding-box;\\n  border: 1px solid rgba(0, 0, 0, 0.15);\\n  border-radius: 0.25rem; }\\n\\n.dropdown-menu-left {\\n  right: auto;\\n  left: 0; }\\n\\n.dropdown-menu-right {\\n  right: 0;\\n  left: auto; }\\n\\n@media (min-width: 576px) {\\n  .dropdown-menu-sm-left {\\n    right: auto;\\n    left: 0; }\\n  .dropdown-menu-sm-right {\\n    right: 0;\\n    left: auto; } }\\n\\n@media (min-width: 768px) {\\n  .dropdown-menu-md-left {\\n    right: auto;\\n    left: 0; }\\n  .dropdown-menu-md-right {\\n    right: 0;\\n    left: auto; } }\\n\\n@media (min-width: 992px) {\\n  .dropdown-menu-lg-left {\\n    right: auto;\\n    left: 0; }\\n  .dropdown-menu-lg-right {\\n    right: 0;\\n    left: auto; } }\\n\\n@media (min-width: 1200px) {\\n  .dropdown-menu-xl-left {\\n    right: auto;\\n    left: 0; }\\n  .dropdown-menu-xl-right {\\n    right: 0;\\n    left: auto; } }\\n\\n.dropup .dropdown-menu {\\n  top: auto;\\n  bottom: 100%;\\n  margin-top: 0;\\n  margin-bottom: 0.125rem; }\\n\\n.dropup .dropdown-toggle::after {\\n  display: inline-block;\\n  margin-left: 0.255em;\\n  vertical-align: 0.255em;\\n  content: \\\"\\\";\\n  border-top: 0;\\n  border-right: 0.3em solid transparent;\\n  border-bottom: 0.3em solid;\\n  border-left: 0.3em solid transparent; }\\n\\n.dropup .dropdown-toggle:empty::after {\\n  margin-left: 0; }\\n\\n.dropright .dropdown-menu {\\n  top: 0;\\n  right: auto;\\n  left: 100%;\\n  margin-top: 0;\\n  margin-left: 0.125rem; }\\n\\n.dropright .dropdown-toggle::after {\\n  display: inline-block;\\n  margin-left: 0.255em;\\n  vertical-align: 0.255em;\\n  content: \\\"\\\";\\n  border-top: 0.3em solid transparent;\\n  border-right: 0;\\n  border-bottom: 0.3em solid transparent;\\n  border-left: 0.3em solid; }\\n\\n.dropright .dropdown-toggle:empty::after {\\n  margin-left: 0; }\\n\\n.dropright .dropdown-toggle::after {\\n  vertical-align: 0; }\\n\\n.dropleft .dropdown-menu {\\n  top: 0;\\n  right: 100%;\\n  left: auto;\\n  margin-top: 0;\\n  margin-right: 0.125rem; }\\n\\n.dropleft .dropdown-toggle::after {\\n  display: inline-block;\\n  margin-left: 0.255em;\\n  vertical-align: 0.255em;\\n  content: \\\"\\\"; }\\n\\n.dropleft .dropdown-toggle::after {\\n  display: none; }\\n\\n.dropleft .dropdown-toggle::before {\\n  display: inline-block;\\n  margin-right: 0.255em;\\n  vertical-align: 0.255em;\\n  content: \\\"\\\";\\n  border-top: 0.3em solid transparent;\\n  border-right: 0.3em solid;\\n  border-bottom: 0.3em solid transparent; }\\n\\n.dropleft .dropdown-toggle:empty::after {\\n  margin-left: 0; }\\n\\n.dropleft .dropdown-toggle::before {\\n  vertical-align: 0; }\\n\\n.dropdown-menu[x-placement^=\\\"top\\\"], .dropdown-menu[x-placement^=\\\"right\\\"], .dropdown-menu[x-placement^=\\\"bottom\\\"], .dropdown-menu[x-placement^=\\\"left\\\"] {\\n  right: auto;\\n  bottom: auto; }\\n\\n.dropdown-divider {\\n  height: 0;\\n  margin: 0.5rem 0;\\n  overflow: hidden;\\n  border-top: 1px solid #e9ecef; }\\n\\n.dropdown-item {\\n  display: block;\\n  width: 100%;\\n  padding: 0.25rem 1.5rem;\\n  clear: both;\\n  font-weight: 400;\\n  color: #212529;\\n  text-align: inherit;\\n  white-space: nowrap;\\n  background-color: transparent;\\n  border: 0; }\\n  .dropdown-item:hover, .dropdown-item:focus {\\n    color: #16181b;\\n    text-decoration: none;\\n    background-color: #f8f9fa; }\\n  .dropdown-item.active, .dropdown-item:active {\\n    color: #fff;\\n    text-decoration: none;\\n    background-color: #a23422; }\\n  .dropdown-item.disabled, .dropdown-item:disabled {\\n    color: #6c757d;\\n    pointer-events: none;\\n    background-color: transparent; }\\n\\n.dropdown-menu.show {\\n  display: block; }\\n\\n.dropdown-header {\\n  display: block;\\n  padding: 0.5rem 1.5rem;\\n  margin-bottom: 0;\\n  font-size: 0.875rem;\\n  color: #6c757d;\\n  white-space: nowrap; }\\n\\n.dropdown-item-text {\\n  display: block;\\n  padding: 0.25rem 1.5rem;\\n  color: #212529; }\\n\\n.btn-group,\\n.btn-group-vertical {\\n  position: relative;\\n  display: inline-flex;\\n  vertical-align: middle; }\\n  .btn-group > .btn,\\n  .btn-group-vertical > .btn {\\n    position: relative;\\n    flex: 1 1 auto; }\\n    .btn-group > .btn:hover,\\n    .btn-group-vertical > .btn:hover {\\n      z-index: 1; }\\n    .btn-group > .btn:focus, .btn-group > .btn:active, .btn-group > .btn.active,\\n    .btn-group-vertical > .btn:focus,\\n    .btn-group-vertical > .btn:active,\\n    .btn-group-vertical > .btn.active {\\n      z-index: 1; }\\n\\n.btn-toolbar {\\n  display: flex;\\n  flex-wrap: wrap;\\n  justify-content: flex-start; }\\n  .btn-toolbar .input-group {\\n    width: auto; }\\n\\n.btn-group > .btn:not(:first-child),\\n.btn-group > .btn-group:not(:first-child) {\\n  margin-left: -1px; }\\n\\n.btn-group > .btn:not(:last-child):not(.dropdown-toggle),\\n.btn-group > .btn-group:not(:last-child) > .btn {\\n  border-top-right-radius: 0;\\n  border-bottom-right-radius: 0; }\\n\\n.btn-group > .btn:not(:first-child),\\n.btn-group > .btn-group:not(:first-child) > .btn {\\n  border-top-left-radius: 0;\\n  border-bottom-left-radius: 0; }\\n\\n.dropdown-toggle-split {\\n  padding-right: 0.5625rem;\\n  padding-left: 0.5625rem; }\\n  .dropdown-toggle-split::after,\\n  .dropup .dropdown-toggle-split::after,\\n  .dropright .dropdown-toggle-split::after {\\n    margin-left: 0; }\\n  .dropleft .dropdown-toggle-split::before {\\n    margin-right: 0; }\\n\\n.btn-sm + .dropdown-toggle-split, .btn-group-sm > .btn + .dropdown-toggle-split {\\n  padding-right: 0.375rem;\\n  padding-left: 0.375rem; }\\n\\n.btn-lg + .dropdown-toggle-split, .btn-group-lg > .btn + .dropdown-toggle-split {\\n  padding-right: 0.75rem;\\n  padding-left: 0.75rem; }\\n\\n.btn-group-vertical {\\n  flex-direction: column;\\n  align-items: flex-start;\\n  justify-content: center; }\\n  .btn-group-vertical > .btn,\\n  .btn-group-vertical > .btn-group {\\n    width: 100%; }\\n  .btn-group-vertical > .btn:not(:first-child),\\n  .btn-group-vertical > .btn-group:not(:first-child) {\\n    margin-top: -1px; }\\n  .btn-group-vertical > .btn:not(:last-child):not(.dropdown-toggle),\\n  .btn-group-vertical > .btn-group:not(:last-child) > .btn {\\n    border-bottom-right-radius: 0;\\n    border-bottom-left-radius: 0; }\\n  .btn-group-vertical > .btn:not(:first-child),\\n  .btn-group-vertical > .btn-group:not(:first-child) > .btn {\\n    border-top-left-radius: 0;\\n    border-top-right-radius: 0; }\\n\\n.btn-group-toggle > .btn,\\n.btn-group-toggle > .btn-group > .btn {\\n  margin-bottom: 0; }\\n  .btn-group-toggle > .btn input[type=\\\"radio\\\"],\\n  .btn-group-toggle > .btn input[type=\\\"checkbox\\\"],\\n  .btn-group-toggle > .btn-group > .btn input[type=\\\"radio\\\"],\\n  .btn-group-toggle > .btn-group > .btn input[type=\\\"checkbox\\\"] {\\n    position: absolute;\\n    clip: rect(0, 0, 0, 0);\\n    pointer-events: none; }\\n\\n.input-group {\\n  position: relative;\\n  display: flex;\\n  flex-wrap: wrap;\\n  align-items: stretch;\\n  width: 100%; }\\n  .input-group > .form-control,\\n  .input-group > .form-control-plaintext,\\n  .input-group > .custom-select,\\n  .input-group > .custom-file {\\n    position: relative;\\n    flex: 1 1 auto;\\n    width: 1%;\\n    min-width: 0;\\n    margin-bottom: 0; }\\n    .input-group > .form-control + .form-control,\\n    .input-group > .form-control + .custom-select,\\n    .input-group > .form-control + .custom-file,\\n    .input-group > .form-control-plaintext + .form-control,\\n    .input-group > .form-control-plaintext + .custom-select,\\n    .input-group > .form-control-plaintext + .custom-file,\\n    .input-group > .custom-select + .form-control,\\n    .input-group > .custom-select + .custom-select,\\n    .input-group > .custom-select + .custom-file,\\n    .input-group > .custom-file + .form-control,\\n    .input-group > .custom-file + .custom-select,\\n    .input-group > .custom-file + .custom-file {\\n      margin-left: -1px; }\\n  .input-group > .form-control:focus,\\n  .input-group > .custom-select:focus,\\n  .input-group > .custom-file .custom-file-input:focus ~ .custom-file-label {\\n    z-index: 3; }\\n  .input-group > .custom-file .custom-file-input:focus {\\n    z-index: 4; }\\n  .input-group > .form-control:not(:last-child),\\n  .input-group > .custom-select:not(:last-child) {\\n    border-top-right-radius: 0;\\n    border-bottom-right-radius: 0; }\\n  .input-group > .form-control:not(:first-child),\\n  .input-group > .custom-select:not(:first-child) {\\n    border-top-left-radius: 0;\\n    border-bottom-left-radius: 0; }\\n  .input-group > .custom-file {\\n    display: flex;\\n    align-items: center; }\\n    .input-group > .custom-file:not(:last-child) .custom-file-label,\\n    .input-group > .custom-file:not(:last-child) .custom-file-label::after {\\n      border-top-right-radius: 0;\\n      border-bottom-right-radius: 0; }\\n    .input-group > .custom-file:not(:first-child) .custom-file-label {\\n      border-top-left-radius: 0;\\n      border-bottom-left-radius: 0; }\\n\\n.input-group-prepend,\\n.input-group-append {\\n  display: flex; }\\n  .input-group-prepend .btn,\\n  .input-group-append .btn {\\n    position: relative;\\n    z-index: 2; }\\n    .input-group-prepend .btn:focus,\\n    .input-group-append .btn:focus {\\n      z-index: 3; }\\n  .input-group-prepend .btn + .btn,\\n  .input-group-prepend .btn + .input-group-text,\\n  .input-group-prepend .input-group-text + .input-group-text,\\n  .input-group-prepend .input-group-text + .btn,\\n  .input-group-append .btn + .btn,\\n  .input-group-append .btn + .input-group-text,\\n  .input-group-append .input-group-text + .input-group-text,\\n  .input-group-append .input-group-text + .btn {\\n    margin-left: -1px; }\\n\\n.input-group-prepend {\\n  margin-right: -1px; }\\n\\n.input-group-append {\\n  margin-left: -1px; }\\n\\n.input-group-text {\\n  display: flex;\\n  align-items: center;\\n  padding: 0.375rem 0.75rem;\\n  margin-bottom: 0;\\n  font-size: 1rem;\\n  font-weight: 400;\\n  line-height: 1.5;\\n  color: #495057;\\n  text-align: center;\\n  white-space: nowrap;\\n  background-color: #e9ecef;\\n  border: 1px solid #ced4da;\\n  border-radius: 0.25rem; }\\n  .input-group-text input[type=\\\"radio\\\"],\\n  .input-group-text input[type=\\\"checkbox\\\"] {\\n    margin-top: 0; }\\n\\n.input-group-lg > .form-control:not(textarea),\\n.input-group-lg > .custom-select {\\n  height: calc(1.5em + 1rem + 2px); }\\n\\n.input-group-lg > .form-control,\\n.input-group-lg > .custom-select,\\n.input-group-lg > .input-group-prepend > .input-group-text,\\n.input-group-lg > .input-group-append > .input-group-text,\\n.input-group-lg > .input-group-prepend > .btn,\\n.input-group-lg > .input-group-append > .btn {\\n  padding: 0.5rem 1rem;\\n  font-size: 1.25rem;\\n  line-height: 1.5;\\n  border-radius: 0.3rem; }\\n\\n.input-group-sm > .form-control:not(textarea),\\n.input-group-sm > .custom-select {\\n  height: calc(1.5em + 0.5rem + 2px); }\\n\\n.input-group-sm > .form-control,\\n.input-group-sm > .custom-select,\\n.input-group-sm > .input-group-prepend > .input-group-text,\\n.input-group-sm > .input-group-append > .input-group-text,\\n.input-group-sm > .input-group-prepend > .btn,\\n.input-group-sm > .input-group-append > .btn {\\n  padding: 0.25rem 0.5rem;\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  border-radius: 0.2rem; }\\n\\n.input-group-lg > .custom-select,\\n.input-group-sm > .custom-select {\\n  padding-right: 1.75rem; }\\n\\n.input-group > .input-group-prepend > .btn,\\n.input-group > .input-group-prepend > .input-group-text,\\n.input-group > .input-group-append:not(:last-child) > .btn,\\n.input-group > .input-group-append:not(:last-child) > .input-group-text,\\n.input-group > .input-group-append:last-child > .btn:not(:last-child):not(.dropdown-toggle),\\n.input-group > .input-group-append:last-child > .input-group-text:not(:last-child) {\\n  border-top-right-radius: 0;\\n  border-bottom-right-radius: 0; }\\n\\n.input-group > .input-group-append > .btn,\\n.input-group > .input-group-append > .input-group-text,\\n.input-group > .input-group-prepend:not(:first-child) > .btn,\\n.input-group > .input-group-prepend:not(:first-child) > .input-group-text,\\n.input-group > .input-group-prepend:first-child > .btn:not(:first-child),\\n.input-group > .input-group-prepend:first-child > .input-group-text:not(:first-child) {\\n  border-top-left-radius: 0;\\n  border-bottom-left-radius: 0; }\\n\\n.custom-control {\\n  position: relative;\\n  display: block;\\n  min-height: 1.5rem;\\n  padding-left: 1.5rem; }\\n\\n.custom-control-inline {\\n  display: inline-flex;\\n  margin-right: 1rem; }\\n\\n.custom-control-input {\\n  position: absolute;\\n  left: 0;\\n  z-index: -1;\\n  width: 1rem;\\n  height: 1.25rem;\\n  opacity: 0; }\\n  .custom-control-input:checked ~ .custom-control-label::before {\\n    color: #fff;\\n    border-color: #a23422;\\n    background-color: #a23422; }\\n  .custom-control-input:focus ~ .custom-control-label::before {\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .custom-control-input:focus:not(:checked) ~ .custom-control-label::before {\\n    border-color: #df7665; }\\n  .custom-control-input:not(:disabled):active ~ .custom-control-label::before {\\n    color: #fff;\\n    background-color: #e79b8f;\\n    border-color: #e79b8f; }\\n  .custom-control-input[disabled] ~ .custom-control-label, .custom-control-input:disabled ~ .custom-control-label {\\n    color: #6c757d; }\\n    .custom-control-input[disabled] ~ .custom-control-label::before, .custom-control-input:disabled ~ .custom-control-label::before {\\n      background-color: #e9ecef; }\\n\\n.custom-control-label {\\n  position: relative;\\n  margin-bottom: 0;\\n  vertical-align: top; }\\n  .custom-control-label::before {\\n    position: absolute;\\n    top: 0.25rem;\\n    left: -1.5rem;\\n    display: block;\\n    width: 1rem;\\n    height: 1rem;\\n    pointer-events: none;\\n    content: \\\"\\\";\\n    background-color: #fff;\\n    border: #adb5bd solid 1px; }\\n  .custom-control-label::after {\\n    position: absolute;\\n    top: 0.25rem;\\n    left: -1.5rem;\\n    display: block;\\n    width: 1rem;\\n    height: 1rem;\\n    content: \\\"\\\";\\n    background: no-repeat 50% / 50% 50%; }\\n\\n.custom-checkbox .custom-control-label::before {\\n  border-radius: 0.25rem; }\\n\\n.custom-checkbox .custom-control-input:checked ~ .custom-control-label::after {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='8' height='8' viewBox='0 0 8 8'%3e%3cpath fill='%23fff' d='M6.564.75l-3.59 3.612-1.538-1.55L0 4.26l2.974 2.99L8 2.193z'/%3e%3c/svg%3e\\\"); }\\n\\n.custom-checkbox .custom-control-input:indeterminate ~ .custom-control-label::before {\\n  border-color: #a23422;\\n  background-color: #a23422; }\\n\\n.custom-checkbox .custom-control-input:indeterminate ~ .custom-control-label::after {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='4' viewBox='0 0 4 4'%3e%3cpath stroke='%23fff' d='M0 2h4'/%3e%3c/svg%3e\\\"); }\\n\\n.custom-checkbox .custom-control-input:disabled:checked ~ .custom-control-label::before {\\n  background-color: rgba(162, 52, 34, 0.5); }\\n\\n.custom-checkbox .custom-control-input:disabled:indeterminate ~ .custom-control-label::before {\\n  background-color: rgba(162, 52, 34, 0.5); }\\n\\n.custom-radio .custom-control-label::before {\\n  border-radius: 50%; }\\n\\n.custom-radio .custom-control-input:checked ~ .custom-control-label::after {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' viewBox='-4 -4 8 8'%3e%3ccircle r='3' fill='%23fff'/%3e%3c/svg%3e\\\"); }\\n\\n.custom-radio .custom-control-input:disabled:checked ~ .custom-control-label::before {\\n  background-color: rgba(162, 52, 34, 0.5); }\\n\\n.custom-switch {\\n  padding-left: 2.25rem; }\\n  .custom-switch .custom-control-label::before {\\n    left: -2.25rem;\\n    width: 1.75rem;\\n    pointer-events: all;\\n    border-radius: 0.5rem; }\\n  .custom-switch .custom-control-label::after {\\n    top: calc(0.25rem + 2px);\\n    left: calc(-2.25rem + 2px);\\n    width: calc(1rem - 4px);\\n    height: calc(1rem - 4px);\\n    background-color: #adb5bd;\\n    border-radius: 0.5rem;\\n    transition: transform 0.15s ease-in-out, background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out; }\\n    @media (prefers-reduced-motion: reduce) {\\n      .custom-switch .custom-control-label::after {\\n        transition: none; } }\\n  .custom-switch .custom-control-input:checked ~ .custom-control-label::after {\\n    background-color: #fff;\\n    transform: translateX(0.75rem); }\\n  .custom-switch .custom-control-input:disabled:checked ~ .custom-control-label::before {\\n    background-color: rgba(162, 52, 34, 0.5); }\\n\\n.custom-select {\\n  display: inline-block;\\n  width: 100%;\\n  height: calc(1.5em + 0.75rem + 2px);\\n  padding: 0.375rem 1.75rem 0.375rem 0.75rem;\\n  font-size: 1rem;\\n  font-weight: 400;\\n  line-height: 1.5;\\n  color: #495057;\\n  vertical-align: middle;\\n  background: #fff url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5' viewBox='0 0 4 5'%3e%3cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3e%3c/svg%3e\\\") no-repeat right 0.75rem center/8px 10px;\\n  border: 1px solid #ced4da;\\n  border-radius: 0.25rem;\\n  -webkit-appearance: none;\\n     -moz-appearance: none;\\n          appearance: none; }\\n  .custom-select:focus {\\n    border-color: #df7665;\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n    .custom-select:focus::-ms-value {\\n      color: #495057;\\n      background-color: #fff; }\\n  .custom-select[multiple], .custom-select[size]:not([size=\\\"1\\\"]) {\\n    height: auto;\\n    padding-right: 0.75rem;\\n    background-image: none; }\\n  .custom-select:disabled {\\n    color: #6c757d;\\n    background-color: #e9ecef; }\\n  .custom-select::-ms-expand {\\n    display: none; }\\n  .custom-select:-moz-focusring {\\n    color: transparent;\\n    text-shadow: 0 0 0 #495057; }\\n\\n.custom-select-sm {\\n  height: calc(1.5em + 0.5rem + 2px);\\n  padding-top: 0.25rem;\\n  padding-bottom: 0.25rem;\\n  padding-left: 0.5rem;\\n  font-size: 0.875rem; }\\n\\n.custom-select-lg {\\n  height: calc(1.5em + 1rem + 2px);\\n  padding-top: 0.5rem;\\n  padding-bottom: 0.5rem;\\n  padding-left: 1rem;\\n  font-size: 1.25rem; }\\n\\n.custom-file {\\n  position: relative;\\n  display: inline-block;\\n  width: 100%;\\n  height: calc(1.5em + 0.75rem + 2px);\\n  margin-bottom: 0; }\\n\\n.custom-file-input {\\n  position: relative;\\n  z-index: 2;\\n  width: 100%;\\n  height: calc(1.5em + 0.75rem + 2px);\\n  margin: 0;\\n  opacity: 0; }\\n  .custom-file-input:focus ~ .custom-file-label {\\n    border-color: #df7665;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .custom-file-input[disabled] ~ .custom-file-label,\\n  .custom-file-input:disabled ~ .custom-file-label {\\n    background-color: #e9ecef; }\\n  .custom-file-input:lang(en) ~ .custom-file-label::after {\\n    content: \\\"Browse\\\"; }\\n  .custom-file-input ~ .custom-file-label[data-browse]::after {\\n    content: attr(data-browse); }\\n\\n.custom-file-label {\\n  position: absolute;\\n  top: 0;\\n  right: 0;\\n  left: 0;\\n  z-index: 1;\\n  height: calc(1.5em + 0.75rem + 2px);\\n  padding: 0.375rem 0.75rem;\\n  font-weight: 400;\\n  line-height: 1.5;\\n  color: #495057;\\n  background-color: #fff;\\n  border: 1px solid #ced4da;\\n  border-radius: 0.25rem; }\\n  .custom-file-label::after {\\n    position: absolute;\\n    top: 0;\\n    right: 0;\\n    bottom: 0;\\n    z-index: 3;\\n    display: block;\\n    height: calc(1.5em + 0.75rem);\\n    padding: 0.375rem 0.75rem;\\n    line-height: 1.5;\\n    color: #495057;\\n    content: \\\"Browse\\\";\\n    background-color: #e9ecef;\\n    border-left: inherit;\\n    border-radius: 0 0.25rem 0.25rem 0; }\\n\\n.custom-range {\\n  width: 100%;\\n  height: 1.4rem;\\n  padding: 0;\\n  background-color: transparent;\\n  -webkit-appearance: none;\\n     -moz-appearance: none;\\n          appearance: none; }\\n  .custom-range:focus {\\n    outline: none; }\\n    .custom-range:focus::-webkit-slider-thumb {\\n      box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n    .custom-range:focus::-moz-range-thumb {\\n      box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n    .custom-range:focus::-ms-thumb {\\n      box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .custom-range::-moz-focus-outer {\\n    border: 0; }\\n  .custom-range::-webkit-slider-thumb {\\n    width: 1rem;\\n    height: 1rem;\\n    margin-top: -0.25rem;\\n    background-color: #a23422;\\n    border: 0;\\n    border-radius: 1rem;\\n    -webkit-transition: background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\\n    transition: background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\\n    -webkit-appearance: none;\\n            appearance: none; }\\n    @media (prefers-reduced-motion: reduce) {\\n      .custom-range::-webkit-slider-thumb {\\n        -webkit-transition: none;\\n        transition: none; } }\\n    .custom-range::-webkit-slider-thumb:active {\\n      background-color: #e79b8f; }\\n  .custom-range::-webkit-slider-runnable-track {\\n    width: 100%;\\n    height: 0.5rem;\\n    color: transparent;\\n    cursor: pointer;\\n    background-color: #dee2e6;\\n    border-color: transparent;\\n    border-radius: 1rem; }\\n  .custom-range::-moz-range-thumb {\\n    width: 1rem;\\n    height: 1rem;\\n    background-color: #a23422;\\n    border: 0;\\n    border-radius: 1rem;\\n    -moz-transition: background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\\n    transition: background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\\n    -moz-appearance: none;\\n         appearance: none; }\\n    @media (prefers-reduced-motion: reduce) {\\n      .custom-range::-moz-range-thumb {\\n        -moz-transition: none;\\n        transition: none; } }\\n    .custom-range::-moz-range-thumb:active {\\n      background-color: #e79b8f; }\\n  .custom-range::-moz-range-track {\\n    width: 100%;\\n    height: 0.5rem;\\n    color: transparent;\\n    cursor: pointer;\\n    background-color: #dee2e6;\\n    border-color: transparent;\\n    border-radius: 1rem; }\\n  .custom-range::-ms-thumb {\\n    width: 1rem;\\n    height: 1rem;\\n    margin-top: 0;\\n    margin-right: 0.2rem;\\n    margin-left: 0.2rem;\\n    background-color: #a23422;\\n    border: 0;\\n    border-radius: 1rem;\\n    -ms-transition: background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\\n    transition: background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out;\\n    appearance: none; }\\n    @media (prefers-reduced-motion: reduce) {\\n      .custom-range::-ms-thumb {\\n        -ms-transition: none;\\n        transition: none; } }\\n    .custom-range::-ms-thumb:active {\\n      background-color: #e79b8f; }\\n  .custom-range::-ms-track {\\n    width: 100%;\\n    height: 0.5rem;\\n    color: transparent;\\n    cursor: pointer;\\n    background-color: transparent;\\n    border-color: transparent;\\n    border-width: 0.5rem; }\\n  .custom-range::-ms-fill-lower {\\n    background-color: #dee2e6;\\n    border-radius: 1rem; }\\n  .custom-range::-ms-fill-upper {\\n    margin-right: 15px;\\n    background-color: #dee2e6;\\n    border-radius: 1rem; }\\n  .custom-range:disabled::-webkit-slider-thumb {\\n    background-color: #adb5bd; }\\n  .custom-range:disabled::-webkit-slider-runnable-track {\\n    cursor: default; }\\n  .custom-range:disabled::-moz-range-thumb {\\n    background-color: #adb5bd; }\\n  .custom-range:disabled::-moz-range-track {\\n    cursor: default; }\\n  .custom-range:disabled::-ms-thumb {\\n    background-color: #adb5bd; }\\n\\n.custom-control-label::before,\\n.custom-file-label,\\n.custom-select {\\n  transition: background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .custom-control-label::before,\\n    .custom-file-label,\\n    .custom-select {\\n      transition: none; } }\\n\\n.nav {\\n  display: flex;\\n  flex-wrap: wrap;\\n  padding-left: 0;\\n  margin-bottom: 0;\\n  list-style: none; }\\n\\n.nav-link {\\n  display: block;\\n  padding: 0.5rem 1rem; }\\n  .nav-link:hover, .nav-link:focus {\\n    text-decoration: none; }\\n  .nav-link.disabled {\\n    color: #6c757d;\\n    pointer-events: none;\\n    cursor: default; }\\n\\n.nav-tabs {\\n  border-bottom: 1px solid #dee2e6; }\\n  .nav-tabs .nav-item {\\n    margin-bottom: -1px; }\\n  .nav-tabs .nav-link {\\n    border: 1px solid transparent;\\n    border-top-left-radius: 0.25rem;\\n    border-top-right-radius: 0.25rem; }\\n    .nav-tabs .nav-link:hover, .nav-tabs .nav-link:focus {\\n      border-color: #e9ecef #e9ecef #dee2e6; }\\n    .nav-tabs .nav-link.disabled {\\n      color: #6c757d;\\n      background-color: transparent;\\n      border-color: transparent; }\\n  .nav-tabs .nav-link.active,\\n  .nav-tabs .nav-item.show .nav-link {\\n    color: #495057;\\n    background-color: #fff;\\n    border-color: #dee2e6 #dee2e6 #fff; }\\n  .nav-tabs .dropdown-menu {\\n    margin-top: -1px;\\n    border-top-left-radius: 0;\\n    border-top-right-radius: 0; }\\n\\n.nav-pills .nav-link {\\n  border-radius: 0.25rem; }\\n\\n.nav-pills .nav-link.active,\\n.nav-pills .show > .nav-link {\\n  color: #fff;\\n  background-color: #a23422; }\\n\\n.nav-fill .nav-item {\\n  flex: 1 1 auto;\\n  text-align: center; }\\n\\n.nav-justified .nav-item {\\n  flex-basis: 0;\\n  flex-grow: 1;\\n  text-align: center; }\\n\\n.tab-content > .tab-pane {\\n  display: none; }\\n\\n.tab-content > .active {\\n  display: block; }\\n\\n.navbar {\\n  position: relative;\\n  display: flex;\\n  flex-wrap: wrap;\\n  align-items: center;\\n  justify-content: space-between;\\n  padding: 0.5rem 1rem; }\\n  .navbar .container,\\n  .navbar .container-fluid, .navbar .container-sm, .navbar .container-md, .navbar .container-lg, .navbar .container-xl {\\n    display: flex;\\n    flex-wrap: wrap;\\n    align-items: center;\\n    justify-content: space-between; }\\n\\n.navbar-brand {\\n  display: inline-block;\\n  padding-top: 0.3125rem;\\n  padding-bottom: 0.3125rem;\\n  margin-right: 1rem;\\n  font-size: 1.25rem;\\n  line-height: inherit;\\n  white-space: nowrap; }\\n  .navbar-brand:hover, .navbar-brand:focus {\\n    text-decoration: none; }\\n\\n.navbar-nav {\\n  display: flex;\\n  flex-direction: column;\\n  padding-left: 0;\\n  margin-bottom: 0;\\n  list-style: none; }\\n  .navbar-nav .nav-link {\\n    padding-right: 0;\\n    padding-left: 0; }\\n  .navbar-nav .dropdown-menu {\\n    position: static;\\n    float: none; }\\n\\n.navbar-text {\\n  display: inline-block;\\n  padding-top: 0.5rem;\\n  padding-bottom: 0.5rem; }\\n\\n.navbar-collapse {\\n  flex-basis: 100%;\\n  flex-grow: 1;\\n  align-items: center; }\\n\\n.navbar-toggler {\\n  padding: 0.25rem 0.75rem;\\n  font-size: 1.25rem;\\n  line-height: 1;\\n  background-color: transparent;\\n  border: 1px solid transparent;\\n  border-radius: 0.25rem; }\\n  .navbar-toggler:hover, .navbar-toggler:focus {\\n    text-decoration: none; }\\n\\n.navbar-toggler-icon {\\n  display: inline-block;\\n  width: 1.5em;\\n  height: 1.5em;\\n  vertical-align: middle;\\n  content: \\\"\\\";\\n  background: no-repeat center center;\\n  background-size: 100% 100%; }\\n\\n@media (max-width: 575.98px) {\\n  .navbar-expand-sm > .container,\\n  .navbar-expand-sm > .container-fluid, .navbar-expand-sm > .container-sm, .navbar-expand-sm > .container-md, .navbar-expand-sm > .container-lg, .navbar-expand-sm > .container-xl {\\n    padding-right: 0;\\n    padding-left: 0; } }\\n\\n@media (min-width: 576px) {\\n  .navbar-expand-sm {\\n    flex-flow: row nowrap;\\n    justify-content: flex-start; }\\n    .navbar-expand-sm .navbar-nav {\\n      flex-direction: row; }\\n      .navbar-expand-sm .navbar-nav .dropdown-menu {\\n        position: absolute; }\\n      .navbar-expand-sm .navbar-nav .nav-link {\\n        padding-right: 0.5rem;\\n        padding-left: 0.5rem; }\\n    .navbar-expand-sm > .container,\\n    .navbar-expand-sm > .container-fluid, .navbar-expand-sm > .container-sm, .navbar-expand-sm > .container-md, .navbar-expand-sm > .container-lg, .navbar-expand-sm > .container-xl {\\n      flex-wrap: nowrap; }\\n    .navbar-expand-sm .navbar-collapse {\\n      display: flex !important;\\n      flex-basis: auto; }\\n    .navbar-expand-sm .navbar-toggler {\\n      display: none; } }\\n\\n@media (max-width: 767.98px) {\\n  .navbar-expand-md > .container,\\n  .navbar-expand-md > .container-fluid, .navbar-expand-md > .container-sm, .navbar-expand-md > .container-md, .navbar-expand-md > .container-lg, .navbar-expand-md > .container-xl {\\n    padding-right: 0;\\n    padding-left: 0; } }\\n\\n@media (min-width: 768px) {\\n  .navbar-expand-md {\\n    flex-flow: row nowrap;\\n    justify-content: flex-start; }\\n    .navbar-expand-md .navbar-nav {\\n      flex-direction: row; }\\n      .navbar-expand-md .navbar-nav .dropdown-menu {\\n        position: absolute; }\\n      .navbar-expand-md .navbar-nav .nav-link {\\n        padding-right: 0.5rem;\\n        padding-left: 0.5rem; }\\n    .navbar-expand-md > .container,\\n    .navbar-expand-md > .container-fluid, .navbar-expand-md > .container-sm, .navbar-expand-md > .container-md, .navbar-expand-md > .container-lg, .navbar-expand-md > .container-xl {\\n      flex-wrap: nowrap; }\\n    .navbar-expand-md .navbar-collapse {\\n      display: flex !important;\\n      flex-basis: auto; }\\n    .navbar-expand-md .navbar-toggler {\\n      display: none; } }\\n\\n@media (max-width: 991.98px) {\\n  .navbar-expand-lg > .container,\\n  .navbar-expand-lg > .container-fluid, .navbar-expand-lg > .container-sm, .navbar-expand-lg > .container-md, .navbar-expand-lg > .container-lg, .navbar-expand-lg > .container-xl {\\n    padding-right: 0;\\n    padding-left: 0; } }\\n\\n@media (min-width: 992px) {\\n  .navbar-expand-lg {\\n    flex-flow: row nowrap;\\n    justify-content: flex-start; }\\n    .navbar-expand-lg .navbar-nav {\\n      flex-direction: row; }\\n      .navbar-expand-lg .navbar-nav .dropdown-menu {\\n        position: absolute; }\\n      .navbar-expand-lg .navbar-nav .nav-link {\\n        padding-right: 0.5rem;\\n        padding-left: 0.5rem; }\\n    .navbar-expand-lg > .container,\\n    .navbar-expand-lg > .container-fluid, .navbar-expand-lg > .container-sm, .navbar-expand-lg > .container-md, .navbar-expand-lg > .container-lg, .navbar-expand-lg > .container-xl {\\n      flex-wrap: nowrap; }\\n    .navbar-expand-lg .navbar-collapse {\\n      display: flex !important;\\n      flex-basis: auto; }\\n    .navbar-expand-lg .navbar-toggler {\\n      display: none; } }\\n\\n@media (max-width: 1199.98px) {\\n  .navbar-expand-xl > .container,\\n  .navbar-expand-xl > .container-fluid, .navbar-expand-xl > .container-sm, .navbar-expand-xl > .container-md, .navbar-expand-xl > .container-lg, .navbar-expand-xl > .container-xl {\\n    padding-right: 0;\\n    padding-left: 0; } }\\n\\n@media (min-width: 1200px) {\\n  .navbar-expand-xl {\\n    flex-flow: row nowrap;\\n    justify-content: flex-start; }\\n    .navbar-expand-xl .navbar-nav {\\n      flex-direction: row; }\\n      .navbar-expand-xl .navbar-nav .dropdown-menu {\\n        position: absolute; }\\n      .navbar-expand-xl .navbar-nav .nav-link {\\n        padding-right: 0.5rem;\\n        padding-left: 0.5rem; }\\n    .navbar-expand-xl > .container,\\n    .navbar-expand-xl > .container-fluid, .navbar-expand-xl > .container-sm, .navbar-expand-xl > .container-md, .navbar-expand-xl > .container-lg, .navbar-expand-xl > .container-xl {\\n      flex-wrap: nowrap; }\\n    .navbar-expand-xl .navbar-collapse {\\n      display: flex !important;\\n      flex-basis: auto; }\\n    .navbar-expand-xl .navbar-toggler {\\n      display: none; } }\\n\\n.navbar-expand {\\n  flex-flow: row nowrap;\\n  justify-content: flex-start; }\\n  .navbar-expand > .container,\\n  .navbar-expand > .container-fluid, .navbar-expand > .container-sm, .navbar-expand > .container-md, .navbar-expand > .container-lg, .navbar-expand > .container-xl {\\n    padding-right: 0;\\n    padding-left: 0; }\\n  .navbar-expand .navbar-nav {\\n    flex-direction: row; }\\n    .navbar-expand .navbar-nav .dropdown-menu {\\n      position: absolute; }\\n    .navbar-expand .navbar-nav .nav-link {\\n      padding-right: 0.5rem;\\n      padding-left: 0.5rem; }\\n  .navbar-expand > .container,\\n  .navbar-expand > .container-fluid, .navbar-expand > .container-sm, .navbar-expand > .container-md, .navbar-expand > .container-lg, .navbar-expand > .container-xl {\\n    flex-wrap: nowrap; }\\n  .navbar-expand .navbar-collapse {\\n    display: flex !important;\\n    flex-basis: auto; }\\n  .navbar-expand .navbar-toggler {\\n    display: none; }\\n\\n.navbar-light .navbar-brand {\\n  color: rgba(0, 0, 0, 0.9); }\\n  .navbar-light .navbar-brand:hover, .navbar-light .navbar-brand:focus {\\n    color: rgba(0, 0, 0, 0.9); }\\n\\n.navbar-light .navbar-nav .nav-link {\\n  color: rgba(0, 0, 0, 0.5); }\\n  .navbar-light .navbar-nav .nav-link:hover, .navbar-light .navbar-nav .nav-link:focus {\\n    color: rgba(0, 0, 0, 0.7); }\\n  .navbar-light .navbar-nav .nav-link.disabled {\\n    color: rgba(0, 0, 0, 0.3); }\\n\\n.navbar-light .navbar-nav .show > .nav-link,\\n.navbar-light .navbar-nav .active > .nav-link,\\n.navbar-light .navbar-nav .nav-link.show,\\n.navbar-light .navbar-nav .nav-link.active {\\n  color: rgba(0, 0, 0, 0.9); }\\n\\n.navbar-light .navbar-toggler {\\n  color: rgba(0, 0, 0, 0.5);\\n  border-color: rgba(0, 0, 0, 0.1); }\\n\\n.navbar-light .navbar-toggler-icon {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='30' height='30' viewBox='0 0 30 30'%3e%3cpath stroke='rgba%280, 0, 0, 0.5%29' stroke-linecap='round' stroke-miterlimit='10' stroke-width='2' d='M4 7h22M4 15h22M4 23h22'/%3e%3c/svg%3e\\\"); }\\n\\n.navbar-light .navbar-text {\\n  color: rgba(0, 0, 0, 0.5); }\\n  .navbar-light .navbar-text a {\\n    color: rgba(0, 0, 0, 0.9); }\\n    .navbar-light .navbar-text a:hover, .navbar-light .navbar-text a:focus {\\n      color: rgba(0, 0, 0, 0.9); }\\n\\n.navbar-dark .navbar-brand {\\n  color: #fff; }\\n  .navbar-dark .navbar-brand:hover, .navbar-dark .navbar-brand:focus {\\n    color: #fff; }\\n\\n.navbar-dark .navbar-nav .nav-link {\\n  color: rgba(255, 255, 255, 0.5); }\\n  .navbar-dark .navbar-nav .nav-link:hover, .navbar-dark .navbar-nav .nav-link:focus {\\n    color: rgba(255, 255, 255, 0.75); }\\n  .navbar-dark .navbar-nav .nav-link.disabled {\\n    color: rgba(255, 255, 255, 0.25); }\\n\\n.navbar-dark .navbar-nav .show > .nav-link,\\n.navbar-dark .navbar-nav .active > .nav-link,\\n.navbar-dark .navbar-nav .nav-link.show,\\n.navbar-dark .navbar-nav .nav-link.active {\\n  color: #fff; }\\n\\n.navbar-dark .navbar-toggler {\\n  color: rgba(255, 255, 255, 0.5);\\n  border-color: rgba(255, 255, 255, 0.1); }\\n\\n.navbar-dark .navbar-toggler-icon {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='30' height='30' viewBox='0 0 30 30'%3e%3cpath stroke='rgba%28255, 255, 255, 0.5%29' stroke-linecap='round' stroke-miterlimit='10' stroke-width='2' d='M4 7h22M4 15h22M4 23h22'/%3e%3c/svg%3e\\\"); }\\n\\n.navbar-dark .navbar-text {\\n  color: rgba(255, 255, 255, 0.5); }\\n  .navbar-dark .navbar-text a {\\n    color: #fff; }\\n    .navbar-dark .navbar-text a:hover, .navbar-dark .navbar-text a:focus {\\n      color: #fff; }\\n\\n.card {\\n  position: relative;\\n  display: flex;\\n  flex-direction: column;\\n  min-width: 0;\\n  word-wrap: break-word;\\n  background-color: #fff;\\n  background-clip: border-box;\\n  border: 1px solid rgba(0, 0, 0, 0.125);\\n  border-radius: 0.25rem; }\\n  .card > hr {\\n    margin-right: 0;\\n    margin-left: 0; }\\n  .card > .list-group {\\n    border-top: inherit;\\n    border-bottom: inherit; }\\n    .card > .list-group:first-child {\\n      border-top-width: 0;\\n      border-top-left-radius: calc(0.25rem - 1px);\\n      border-top-right-radius: calc(0.25rem - 1px); }\\n    .card > .list-group:last-child {\\n      border-bottom-width: 0;\\n      border-bottom-right-radius: calc(0.25rem - 1px);\\n      border-bottom-left-radius: calc(0.25rem - 1px); }\\n\\n.card-body {\\n  flex: 1 1 auto;\\n  min-height: 1px;\\n  padding: 1.25rem; }\\n\\n.card-title {\\n  margin-bottom: 0.75rem; }\\n\\n.card-subtitle {\\n  margin-top: -0.375rem;\\n  margin-bottom: 0; }\\n\\n.card-text:last-child {\\n  margin-bottom: 0; }\\n\\n.card-link:hover {\\n  text-decoration: none; }\\n\\n.card-link + .card-link {\\n  margin-left: 1.25rem; }\\n\\n.card-header {\\n  padding: 0.75rem 1.25rem;\\n  margin-bottom: 0;\\n  background-color: rgba(0, 0, 0, 0.03);\\n  border-bottom: 1px solid rgba(0, 0, 0, 0.125); }\\n  .card-header:first-child {\\n    border-radius: calc(0.25rem - 1px) calc(0.25rem - 1px) 0 0; }\\n  .card-header + .list-group .list-group-item:first-child {\\n    border-top: 0; }\\n\\n.card-footer {\\n  padding: 0.75rem 1.25rem;\\n  background-color: rgba(0, 0, 0, 0.03);\\n  border-top: 1px solid rgba(0, 0, 0, 0.125); }\\n  .card-footer:last-child {\\n    border-radius: 0 0 calc(0.25rem - 1px) calc(0.25rem - 1px); }\\n\\n.card-header-tabs {\\n  margin-right: -0.625rem;\\n  margin-bottom: -0.75rem;\\n  margin-left: -0.625rem;\\n  border-bottom: 0; }\\n\\n.card-header-pills {\\n  margin-right: -0.625rem;\\n  margin-left: -0.625rem; }\\n\\n.card-img-overlay {\\n  position: absolute;\\n  top: 0;\\n  right: 0;\\n  bottom: 0;\\n  left: 0;\\n  padding: 1.25rem; }\\n\\n.card-img,\\n.card-img-top,\\n.card-img-bottom {\\n  flex-shrink: 0;\\n  width: 100%; }\\n\\n.card-img,\\n.card-img-top {\\n  border-top-left-radius: calc(0.25rem - 1px);\\n  border-top-right-radius: calc(0.25rem - 1px); }\\n\\n.card-img,\\n.card-img-bottom {\\n  border-bottom-right-radius: calc(0.25rem - 1px);\\n  border-bottom-left-radius: calc(0.25rem - 1px); }\\n\\n.card-deck .card {\\n  margin-bottom: 15px; }\\n\\n@media (min-width: 576px) {\\n  .card-deck {\\n    display: flex;\\n    flex-flow: row wrap;\\n    margin-right: -15px;\\n    margin-left: -15px; }\\n    .card-deck .card {\\n      flex: 1 0 0%;\\n      margin-right: 15px;\\n      margin-bottom: 0;\\n      margin-left: 15px; } }\\n\\n.card-group > .card {\\n  margin-bottom: 15px; }\\n\\n@media (min-width: 576px) {\\n  .card-group {\\n    display: flex;\\n    flex-flow: row wrap; }\\n    .card-group > .card {\\n      flex: 1 0 0%;\\n      margin-bottom: 0; }\\n      .card-group > .card + .card {\\n        margin-left: 0;\\n        border-left: 0; }\\n      .card-group > .card:not(:last-child) {\\n        border-top-right-radius: 0;\\n        border-bottom-right-radius: 0; }\\n        .card-group > .card:not(:last-child) .card-img-top,\\n        .card-group > .card:not(:last-child) .card-header {\\n          border-top-right-radius: 0; }\\n        .card-group > .card:not(:last-child) .card-img-bottom,\\n        .card-group > .card:not(:last-child) .card-footer {\\n          border-bottom-right-radius: 0; }\\n      .card-group > .card:not(:first-child) {\\n        border-top-left-radius: 0;\\n        border-bottom-left-radius: 0; }\\n        .card-group > .card:not(:first-child) .card-img-top,\\n        .card-group > .card:not(:first-child) .card-header {\\n          border-top-left-radius: 0; }\\n        .card-group > .card:not(:first-child) .card-img-bottom,\\n        .card-group > .card:not(:first-child) .card-footer {\\n          border-bottom-left-radius: 0; } }\\n\\n.card-columns .card {\\n  margin-bottom: 0.75rem; }\\n\\n@media (min-width: 576px) {\\n  .card-columns {\\n    -moz-column-count: 3;\\n         column-count: 3;\\n    -moz-column-gap: 1.25rem;\\n         column-gap: 1.25rem;\\n    orphans: 1;\\n    widows: 1; }\\n    .card-columns .card {\\n      display: inline-block;\\n      width: 100%; } }\\n\\n.accordion > .card {\\n  overflow: hidden; }\\n  .accordion > .card:not(:last-of-type) {\\n    border-bottom: 0;\\n    border-bottom-right-radius: 0;\\n    border-bottom-left-radius: 0; }\\n  .accordion > .card:not(:first-of-type) {\\n    border-top-left-radius: 0;\\n    border-top-right-radius: 0; }\\n  .accordion > .card > .card-header {\\n    border-radius: 0;\\n    margin-bottom: -1px; }\\n\\n.breadcrumb {\\n  display: flex;\\n  flex-wrap: wrap;\\n  padding: 0.75rem 1rem;\\n  margin-bottom: 1rem;\\n  list-style: none;\\n  background-color: #e9ecef;\\n  border-radius: 0.25rem; }\\n\\n.breadcrumb-item {\\n  display: flex; }\\n  .breadcrumb-item + .breadcrumb-item {\\n    padding-left: 0.5rem; }\\n    .breadcrumb-item + .breadcrumb-item::before {\\n      display: inline-block;\\n      padding-right: 0.5rem;\\n      color: #6c757d;\\n      content: \\\"/\\\"; }\\n  .breadcrumb-item + .breadcrumb-item:hover::before {\\n    text-decoration: underline; }\\n  .breadcrumb-item + .breadcrumb-item:hover::before {\\n    text-decoration: none; }\\n  .breadcrumb-item.active {\\n    color: #6c757d; }\\n\\n.pagination {\\n  display: flex;\\n  padding-left: 0;\\n  list-style: none;\\n  border-radius: 0.25rem; }\\n\\n.page-link {\\n  position: relative;\\n  display: block;\\n  padding: 0.5rem 0.75rem;\\n  margin-left: -1px;\\n  line-height: 1.25;\\n  color: #a23422;\\n  background-color: #fff;\\n  border: 1px solid #dee2e6; }\\n  .page-link:hover {\\n    z-index: 2;\\n    color: #632015;\\n    text-decoration: none;\\n    background-color: #e9ecef;\\n    border-color: #dee2e6; }\\n  .page-link:focus {\\n    z-index: 3;\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n\\n.page-item:first-child .page-link {\\n  margin-left: 0;\\n  border-top-left-radius: 0.25rem;\\n  border-bottom-left-radius: 0.25rem; }\\n\\n.page-item:last-child .page-link {\\n  border-top-right-radius: 0.25rem;\\n  border-bottom-right-radius: 0.25rem; }\\n\\n.page-item.active .page-link {\\n  z-index: 3;\\n  color: #fff;\\n  background-color: #a23422;\\n  border-color: #a23422; }\\n\\n.page-item.disabled .page-link {\\n  color: #6c757d;\\n  pointer-events: none;\\n  cursor: auto;\\n  background-color: #fff;\\n  border-color: #dee2e6; }\\n\\n.pagination-lg .page-link {\\n  padding: 0.75rem 1.5rem;\\n  font-size: 1.25rem;\\n  line-height: 1.5; }\\n\\n.pagination-lg .page-item:first-child .page-link {\\n  border-top-left-radius: 0.3rem;\\n  border-bottom-left-radius: 0.3rem; }\\n\\n.pagination-lg .page-item:last-child .page-link {\\n  border-top-right-radius: 0.3rem;\\n  border-bottom-right-radius: 0.3rem; }\\n\\n.pagination-sm .page-link {\\n  padding: 0.25rem 0.5rem;\\n  font-size: 0.875rem;\\n  line-height: 1.5; }\\n\\n.pagination-sm .page-item:first-child .page-link {\\n  border-top-left-radius: 0.2rem;\\n  border-bottom-left-radius: 0.2rem; }\\n\\n.pagination-sm .page-item:last-child .page-link {\\n  border-top-right-radius: 0.2rem;\\n  border-bottom-right-radius: 0.2rem; }\\n\\n.badge {\\n  display: inline-block;\\n  padding: 0.25em 0.4em;\\n  font-size: 75%;\\n  font-weight: 700;\\n  line-height: 1;\\n  text-align: center;\\n  white-space: nowrap;\\n  vertical-align: baseline;\\n  border-radius: 0.25rem;\\n  transition: color 0.15s ease-in-out, background-color 0.15s ease-in-out, border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .badge {\\n      transition: none; } }\\n  a.badge:hover, a.badge:focus {\\n    text-decoration: none; }\\n  .badge:empty {\\n    display: none; }\\n\\n.btn .badge {\\n  position: relative;\\n  top: -1px; }\\n\\n.badge-pill {\\n  padding-right: 0.6em;\\n  padding-left: 0.6em;\\n  border-radius: 10rem; }\\n\\n.badge-primary {\\n  color: #fff;\\n  background-color: #a23422; }\\n  a.badge-primary:hover, a.badge-primary:focus {\\n    color: #fff;\\n    background-color: #782619; }\\n  a.badge-primary:focus, a.badge-primary.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.5); }\\n\\n.badge-secondary {\\n  color: #fff;\\n  background-color: #6c757d; }\\n  a.badge-secondary:hover, a.badge-secondary:focus {\\n    color: #fff;\\n    background-color: #545b62; }\\n  a.badge-secondary:focus, a.badge-secondary.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(108, 117, 125, 0.5); }\\n\\n.badge-success {\\n  color: #fff;\\n  background-color: #28a745; }\\n  a.badge-success:hover, a.badge-success:focus {\\n    color: #fff;\\n    background-color: #1e7e34; }\\n  a.badge-success:focus, a.badge-success.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.5); }\\n\\n.badge-info {\\n  color: #fff;\\n  background-color: #17a2b8; }\\n  a.badge-info:hover, a.badge-info:focus {\\n    color: #fff;\\n    background-color: #117a8b; }\\n  a.badge-info:focus, a.badge-info.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(23, 162, 184, 0.5); }\\n\\n.badge-warning {\\n  color: #212529;\\n  background-color: #ffc107; }\\n  a.badge-warning:hover, a.badge-warning:focus {\\n    color: #212529;\\n    background-color: #d39e00; }\\n  a.badge-warning:focus, a.badge-warning.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(255, 193, 7, 0.5); }\\n\\n.badge-danger {\\n  color: #fff;\\n  background-color: #dc3545; }\\n  a.badge-danger:hover, a.badge-danger:focus {\\n    color: #fff;\\n    background-color: #bd2130; }\\n  a.badge-danger:focus, a.badge-danger.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.5); }\\n\\n.badge-light {\\n  color: #212529;\\n  background-color: #f8f9fa; }\\n  a.badge-light:hover, a.badge-light:focus {\\n    color: #212529;\\n    background-color: #dae0e5; }\\n  a.badge-light:focus, a.badge-light.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(248, 249, 250, 0.5); }\\n\\n.badge-dark {\\n  color: #fff;\\n  background-color: #343a40; }\\n  a.badge-dark:hover, a.badge-dark:focus {\\n    color: #fff;\\n    background-color: #1d2124; }\\n  a.badge-dark:focus, a.badge-dark.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(52, 58, 64, 0.5); }\\n\\n.badge-primary-light-dark {\\n  color: #fff;\\n  background-color: #b33926; }\\n  a.badge-primary-light-dark:hover, a.badge-primary-light-dark:focus {\\n    color: #fff;\\n    background-color: #892c1d; }\\n  a.badge-primary-light-dark:focus, a.badge-primary-light-dark.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(179, 57, 38, 0.5); }\\n\\n.badge-primary-dark {\\n  color: #fff;\\n  background-color: #912f1e; }\\n  a.badge-primary-dark:hover, a.badge-primary-dark:focus {\\n    color: #fff;\\n    background-color: #672116; }\\n  a.badge-primary-dark:focus, a.badge-primary-dark.focus {\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(145, 47, 30, 0.5); }\\n\\n.jumbotron {\\n  padding: 2rem 1rem;\\n  margin-bottom: 2rem;\\n  background-color: #e9ecef;\\n  border-radius: 0.3rem; }\\n  @media (min-width: 576px) {\\n    .jumbotron {\\n      padding: 4rem 2rem; } }\\n\\n.jumbotron-fluid {\\n  padding-right: 0;\\n  padding-left: 0;\\n  border-radius: 0; }\\n\\n.alert {\\n  position: relative;\\n  padding: 0.75rem 1.25rem;\\n  margin-bottom: 1rem;\\n  border: 1px solid transparent;\\n  border-radius: 0.25rem; }\\n\\n.alert-heading {\\n  color: inherit; }\\n\\n.alert-link {\\n  font-weight: 700; }\\n\\n.alert-dismissible {\\n  padding-right: 4rem; }\\n  .alert-dismissible .close {\\n    position: absolute;\\n    top: 0;\\n    right: 0;\\n    padding: 0.75rem 1.25rem;\\n    color: inherit; }\\n\\n.alert-primary {\\n  color: #541b12;\\n  background-color: #ecd6d3;\\n  border-color: #e5c6c1; }\\n  .alert-primary hr {\\n    border-top-color: #ddb5af; }\\n  .alert-primary .alert-link {\\n    color: #2a0e09; }\\n\\n.alert-secondary {\\n  color: #383d41;\\n  background-color: #e2e3e5;\\n  border-color: #d6d8db; }\\n  .alert-secondary hr {\\n    border-top-color: #c8cbcf; }\\n  .alert-secondary .alert-link {\\n    color: #202326; }\\n\\n.alert-success {\\n  color: #155724;\\n  background-color: #d4edda;\\n  border-color: #c3e6cb; }\\n  .alert-success hr {\\n    border-top-color: #b1dfbb; }\\n  .alert-success .alert-link {\\n    color: #0b2e13; }\\n\\n.alert-info {\\n  color: #0c5460;\\n  background-color: #d1ecf1;\\n  border-color: #bee5eb; }\\n  .alert-info hr {\\n    border-top-color: #abdde5; }\\n  .alert-info .alert-link {\\n    color: #062c33; }\\n\\n.alert-warning {\\n  color: #856404;\\n  background-color: #fff3cd;\\n  border-color: #ffeeba; }\\n  .alert-warning hr {\\n    border-top-color: #ffe8a1; }\\n  .alert-warning .alert-link {\\n    color: #533f03; }\\n\\n.alert-danger {\\n  color: #721c24;\\n  background-color: #f8d7da;\\n  border-color: #f5c6cb; }\\n  .alert-danger hr {\\n    border-top-color: #f1b0b7; }\\n  .alert-danger .alert-link {\\n    color: #491217; }\\n\\n.alert-light {\\n  color: #818182;\\n  background-color: #fefefe;\\n  border-color: #fdfdfe; }\\n  .alert-light hr {\\n    border-top-color: #ececf6; }\\n  .alert-light .alert-link {\\n    color: #686868; }\\n\\n.alert-dark {\\n  color: #1b1e21;\\n  background-color: #d6d8d9;\\n  border-color: #c6c8ca; }\\n  .alert-dark hr {\\n    border-top-color: #b9bbbe; }\\n  .alert-dark .alert-link {\\n    color: #040505; }\\n\\n.alert-primary-light-dark {\\n  color: #5d1e14;\\n  background-color: #f0d7d4;\\n  border-color: #eac8c2; }\\n  .alert-primary-light-dark hr {\\n    border-top-color: #e3b7af; }\\n  .alert-primary-light-dark .alert-link {\\n    color: #33100b; }\\n\\n.alert-primary-dark {\\n  color: #4b1810;\\n  background-color: #e9d5d2;\\n  border-color: #e0c5c0; }\\n  .alert-primary-dark hr {\\n    border-top-color: #d8b5af; }\\n  .alert-primary-dark .alert-link {\\n    color: #210b07; }\\n\\n@-webkit-keyframes progress-bar-stripes {\\n  from {\\n    background-position: 1rem 0; }\\n  to {\\n    background-position: 0 0; } }\\n\\n@keyframes progress-bar-stripes {\\n  from {\\n    background-position: 1rem 0; }\\n  to {\\n    background-position: 0 0; } }\\n\\n.progress {\\n  display: flex;\\n  height: 1rem;\\n  overflow: hidden;\\n  line-height: 0;\\n  font-size: 0.75rem;\\n  background-color: #e9ecef;\\n  border-radius: 0.25rem; }\\n\\n.progress-bar {\\n  display: flex;\\n  flex-direction: column;\\n  justify-content: center;\\n  overflow: hidden;\\n  color: #fff;\\n  text-align: center;\\n  white-space: nowrap;\\n  background-color: #a23422;\\n  transition: width 0.6s ease; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .progress-bar {\\n      transition: none; } }\\n\\n.progress-bar-striped {\\n  background-image: linear-gradient(45deg, rgba(255, 255, 255, 0.15) 25%, transparent 25%, transparent 50%, rgba(255, 255, 255, 0.15) 50%, rgba(255, 255, 255, 0.15) 75%, transparent 75%, transparent);\\n  background-size: 1rem 1rem; }\\n\\n.progress-bar-animated {\\n  -webkit-animation: progress-bar-stripes 1s linear infinite;\\n          animation: progress-bar-stripes 1s linear infinite; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .progress-bar-animated {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.media {\\n  display: flex;\\n  align-items: flex-start; }\\n\\n.media-body {\\n  flex: 1; }\\n\\n.list-group {\\n  display: flex;\\n  flex-direction: column;\\n  padding-left: 0;\\n  margin-bottom: 0;\\n  border-radius: 0.25rem; }\\n\\n.list-group-item-action {\\n  width: 100%;\\n  color: #495057;\\n  text-align: inherit; }\\n  .list-group-item-action:hover, .list-group-item-action:focus {\\n    z-index: 1;\\n    color: #495057;\\n    text-decoration: none;\\n    background-color: #f8f9fa; }\\n  .list-group-item-action:active {\\n    color: #212529;\\n    background-color: #e9ecef; }\\n\\n.list-group-item {\\n  position: relative;\\n  display: block;\\n  padding: 0.75rem 1.25rem;\\n  background-color: #fff;\\n  border: 1px solid rgba(0, 0, 0, 0.125); }\\n  .list-group-item:first-child {\\n    border-top-left-radius: inherit;\\n    border-top-right-radius: inherit; }\\n  .list-group-item:last-child {\\n    border-bottom-right-radius: inherit;\\n    border-bottom-left-radius: inherit; }\\n  .list-group-item.disabled, .list-group-item:disabled {\\n    color: #6c757d;\\n    pointer-events: none;\\n    background-color: #fff; }\\n  .list-group-item.active {\\n    z-index: 2;\\n    color: #fff;\\n    background-color: #a23422;\\n    border-color: #a23422; }\\n  .list-group-item + .list-group-item {\\n    border-top-width: 0; }\\n    .list-group-item + .list-group-item.active {\\n      margin-top: -1px;\\n      border-top-width: 1px; }\\n\\n.list-group-horizontal {\\n  flex-direction: row; }\\n  .list-group-horizontal > .list-group-item:first-child {\\n    border-bottom-left-radius: 0.25rem;\\n    border-top-right-radius: 0; }\\n  .list-group-horizontal > .list-group-item:last-child {\\n    border-top-right-radius: 0.25rem;\\n    border-bottom-left-radius: 0; }\\n  .list-group-horizontal > .list-group-item.active {\\n    margin-top: 0; }\\n  .list-group-horizontal > .list-group-item + .list-group-item {\\n    border-top-width: 1px;\\n    border-left-width: 0; }\\n    .list-group-horizontal > .list-group-item + .list-group-item.active {\\n      margin-left: -1px;\\n      border-left-width: 1px; }\\n\\n@media (min-width: 576px) {\\n  .list-group-horizontal-sm {\\n    flex-direction: row; }\\n    .list-group-horizontal-sm > .list-group-item:first-child {\\n      border-bottom-left-radius: 0.25rem;\\n      border-top-right-radius: 0; }\\n    .list-group-horizontal-sm > .list-group-item:last-child {\\n      border-top-right-radius: 0.25rem;\\n      border-bottom-left-radius: 0; }\\n    .list-group-horizontal-sm > .list-group-item.active {\\n      margin-top: 0; }\\n    .list-group-horizontal-sm > .list-group-item + .list-group-item {\\n      border-top-width: 1px;\\n      border-left-width: 0; }\\n      .list-group-horizontal-sm > .list-group-item + .list-group-item.active {\\n        margin-left: -1px;\\n        border-left-width: 1px; } }\\n\\n@media (min-width: 768px) {\\n  .list-group-horizontal-md {\\n    flex-direction: row; }\\n    .list-group-horizontal-md > .list-group-item:first-child {\\n      border-bottom-left-radius: 0.25rem;\\n      border-top-right-radius: 0; }\\n    .list-group-horizontal-md > .list-group-item:last-child {\\n      border-top-right-radius: 0.25rem;\\n      border-bottom-left-radius: 0; }\\n    .list-group-horizontal-md > .list-group-item.active {\\n      margin-top: 0; }\\n    .list-group-horizontal-md > .list-group-item + .list-group-item {\\n      border-top-width: 1px;\\n      border-left-width: 0; }\\n      .list-group-horizontal-md > .list-group-item + .list-group-item.active {\\n        margin-left: -1px;\\n        border-left-width: 1px; } }\\n\\n@media (min-width: 992px) {\\n  .list-group-horizontal-lg {\\n    flex-direction: row; }\\n    .list-group-horizontal-lg > .list-group-item:first-child {\\n      border-bottom-left-radius: 0.25rem;\\n      border-top-right-radius: 0; }\\n    .list-group-horizontal-lg > .list-group-item:last-child {\\n      border-top-right-radius: 0.25rem;\\n      border-bottom-left-radius: 0; }\\n    .list-group-horizontal-lg > .list-group-item.active {\\n      margin-top: 0; }\\n    .list-group-horizontal-lg > .list-group-item + .list-group-item {\\n      border-top-width: 1px;\\n      border-left-width: 0; }\\n      .list-group-horizontal-lg > .list-group-item + .list-group-item.active {\\n        margin-left: -1px;\\n        border-left-width: 1px; } }\\n\\n@media (min-width: 1200px) {\\n  .list-group-horizontal-xl {\\n    flex-direction: row; }\\n    .list-group-horizontal-xl > .list-group-item:first-child {\\n      border-bottom-left-radius: 0.25rem;\\n      border-top-right-radius: 0; }\\n    .list-group-horizontal-xl > .list-group-item:last-child {\\n      border-top-right-radius: 0.25rem;\\n      border-bottom-left-radius: 0; }\\n    .list-group-horizontal-xl > .list-group-item.active {\\n      margin-top: 0; }\\n    .list-group-horizontal-xl > .list-group-item + .list-group-item {\\n      border-top-width: 1px;\\n      border-left-width: 0; }\\n      .list-group-horizontal-xl > .list-group-item + .list-group-item.active {\\n        margin-left: -1px;\\n        border-left-width: 1px; } }\\n\\n.list-group-flush {\\n  border-radius: 0; }\\n  .list-group-flush > .list-group-item {\\n    border-width: 0 0 1px; }\\n    .list-group-flush > .list-group-item:last-child {\\n      border-bottom-width: 0; }\\n\\n.list-group-item-primary {\\n  color: #541b12;\\n  background-color: #e5c6c1; }\\n  .list-group-item-primary.list-group-item-action:hover, .list-group-item-primary.list-group-item-action:focus {\\n    color: #541b12;\\n    background-color: #ddb5af; }\\n  .list-group-item-primary.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #541b12;\\n    border-color: #541b12; }\\n\\n.list-group-item-secondary {\\n  color: #383d41;\\n  background-color: #d6d8db; }\\n  .list-group-item-secondary.list-group-item-action:hover, .list-group-item-secondary.list-group-item-action:focus {\\n    color: #383d41;\\n    background-color: #c8cbcf; }\\n  .list-group-item-secondary.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #383d41;\\n    border-color: #383d41; }\\n\\n.list-group-item-success {\\n  color: #155724;\\n  background-color: #c3e6cb; }\\n  .list-group-item-success.list-group-item-action:hover, .list-group-item-success.list-group-item-action:focus {\\n    color: #155724;\\n    background-color: #b1dfbb; }\\n  .list-group-item-success.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #155724;\\n    border-color: #155724; }\\n\\n.list-group-item-info {\\n  color: #0c5460;\\n  background-color: #bee5eb; }\\n  .list-group-item-info.list-group-item-action:hover, .list-group-item-info.list-group-item-action:focus {\\n    color: #0c5460;\\n    background-color: #abdde5; }\\n  .list-group-item-info.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #0c5460;\\n    border-color: #0c5460; }\\n\\n.list-group-item-warning {\\n  color: #856404;\\n  background-color: #ffeeba; }\\n  .list-group-item-warning.list-group-item-action:hover, .list-group-item-warning.list-group-item-action:focus {\\n    color: #856404;\\n    background-color: #ffe8a1; }\\n  .list-group-item-warning.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #856404;\\n    border-color: #856404; }\\n\\n.list-group-item-danger {\\n  color: #721c24;\\n  background-color: #f5c6cb; }\\n  .list-group-item-danger.list-group-item-action:hover, .list-group-item-danger.list-group-item-action:focus {\\n    color: #721c24;\\n    background-color: #f1b0b7; }\\n  .list-group-item-danger.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #721c24;\\n    border-color: #721c24; }\\n\\n.list-group-item-light {\\n  color: #818182;\\n  background-color: #fdfdfe; }\\n  .list-group-item-light.list-group-item-action:hover, .list-group-item-light.list-group-item-action:focus {\\n    color: #818182;\\n    background-color: #ececf6; }\\n  .list-group-item-light.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #818182;\\n    border-color: #818182; }\\n\\n.list-group-item-dark {\\n  color: #1b1e21;\\n  background-color: #c6c8ca; }\\n  .list-group-item-dark.list-group-item-action:hover, .list-group-item-dark.list-group-item-action:focus {\\n    color: #1b1e21;\\n    background-color: #b9bbbe; }\\n  .list-group-item-dark.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #1b1e21;\\n    border-color: #1b1e21; }\\n\\n.list-group-item-primary-light-dark {\\n  color: #5d1e14;\\n  background-color: #eac8c2; }\\n  .list-group-item-primary-light-dark.list-group-item-action:hover, .list-group-item-primary-light-dark.list-group-item-action:focus {\\n    color: #5d1e14;\\n    background-color: #e3b7af; }\\n  .list-group-item-primary-light-dark.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #5d1e14;\\n    border-color: #5d1e14; }\\n\\n.list-group-item-primary-dark {\\n  color: #4b1810;\\n  background-color: #e0c5c0; }\\n  .list-group-item-primary-dark.list-group-item-action:hover, .list-group-item-primary-dark.list-group-item-action:focus {\\n    color: #4b1810;\\n    background-color: #d8b5af; }\\n  .list-group-item-primary-dark.list-group-item-action.active {\\n    color: #fff;\\n    background-color: #4b1810;\\n    border-color: #4b1810; }\\n\\n.close {\\n  float: right;\\n  font-size: 1.5rem;\\n  font-weight: 700;\\n  line-height: 1;\\n  color: #000;\\n  text-shadow: 0 1px 0 #fff;\\n  opacity: .5; }\\n  .close:hover {\\n    color: #000;\\n    text-decoration: none; }\\n  .close:not(:disabled):not(.disabled):hover, .close:not(:disabled):not(.disabled):focus {\\n    opacity: .75; }\\n\\nbutton.close {\\n  padding: 0;\\n  background-color: transparent;\\n  border: 0; }\\n\\na.close.disabled {\\n  pointer-events: none; }\\n\\n.toast {\\n  max-width: 350px;\\n  overflow: hidden;\\n  font-size: 0.875rem;\\n  background-color: rgba(255, 255, 255, 0.85);\\n  background-clip: padding-box;\\n  border: 1px solid rgba(0, 0, 0, 0.1);\\n  box-shadow: 0 0.25rem 0.75rem rgba(0, 0, 0, 0.1);\\n  -webkit-backdrop-filter: blur(10px);\\n          backdrop-filter: blur(10px);\\n  opacity: 0;\\n  border-radius: 0.25rem; }\\n  .toast:not(:last-child) {\\n    margin-bottom: 0.75rem; }\\n  .toast.showing {\\n    opacity: 1; }\\n  .toast.show {\\n    display: block;\\n    opacity: 1; }\\n  .toast.hide {\\n    display: none; }\\n\\n.toast-header {\\n  display: flex;\\n  align-items: center;\\n  padding: 0.25rem 0.75rem;\\n  color: #6c757d;\\n  background-color: rgba(255, 255, 255, 0.85);\\n  background-clip: padding-box;\\n  border-bottom: 1px solid rgba(0, 0, 0, 0.05); }\\n\\n.toast-body {\\n  padding: 0.75rem; }\\n\\n.modal-open {\\n  overflow: hidden; }\\n  .modal-open .modal {\\n    overflow-x: hidden;\\n    overflow-y: auto; }\\n\\n.modal {\\n  position: fixed;\\n  top: 0;\\n  left: 0;\\n  z-index: 1050;\\n  display: none;\\n  width: 100%;\\n  height: 100%;\\n  overflow: hidden;\\n  outline: 0; }\\n\\n.modal-dialog {\\n  position: relative;\\n  width: auto;\\n  margin: 0.5rem;\\n  pointer-events: none; }\\n  .modal.fade .modal-dialog {\\n    transition: transform 0.3s ease-out;\\n    transform: translate(0, -50px); }\\n    @media (prefers-reduced-motion: reduce) {\\n      .modal.fade .modal-dialog {\\n        transition: none; } }\\n  .modal.show .modal-dialog {\\n    transform: none; }\\n  .modal.modal-static .modal-dialog {\\n    transform: scale(1.02); }\\n\\n.modal-dialog-scrollable {\\n  display: flex;\\n  max-height: calc(100% - 1rem); }\\n  .modal-dialog-scrollable .modal-content {\\n    max-height: calc(100vh - 1rem);\\n    overflow: hidden; }\\n  .modal-dialog-scrollable .modal-header,\\n  .modal-dialog-scrollable .modal-footer {\\n    flex-shrink: 0; }\\n  .modal-dialog-scrollable .modal-body {\\n    overflow-y: auto; }\\n\\n.modal-dialog-centered {\\n  display: flex;\\n  align-items: center;\\n  min-height: calc(100% - 1rem); }\\n  .modal-dialog-centered::before {\\n    display: block;\\n    height: calc(100vh - 1rem);\\n    height: -webkit-min-content;\\n    height: -moz-min-content;\\n    height: min-content;\\n    content: \\\"\\\"; }\\n  .modal-dialog-centered.modal-dialog-scrollable {\\n    flex-direction: column;\\n    justify-content: center;\\n    height: 100%; }\\n    .modal-dialog-centered.modal-dialog-scrollable .modal-content {\\n      max-height: none; }\\n    .modal-dialog-centered.modal-dialog-scrollable::before {\\n      content: none; }\\n\\n.modal-content {\\n  position: relative;\\n  display: flex;\\n  flex-direction: column;\\n  width: 100%;\\n  pointer-events: auto;\\n  background-color: #fff;\\n  background-clip: padding-box;\\n  border: 1px solid rgba(0, 0, 0, 0.2);\\n  border-radius: 0.3rem;\\n  outline: 0; }\\n\\n.modal-backdrop {\\n  position: fixed;\\n  top: 0;\\n  left: 0;\\n  z-index: 1040;\\n  width: 100vw;\\n  height: 100vh;\\n  background-color: #000; }\\n  .modal-backdrop.fade {\\n    opacity: 0; }\\n  .modal-backdrop.show {\\n    opacity: 0.5; }\\n\\n.modal-header {\\n  display: flex;\\n  align-items: flex-start;\\n  justify-content: space-between;\\n  padding: 1rem 1rem;\\n  border-bottom: 1px solid #dee2e6;\\n  border-top-left-radius: calc(0.3rem - 1px);\\n  border-top-right-radius: calc(0.3rem - 1px); }\\n  .modal-header .close {\\n    padding: 1rem 1rem;\\n    margin: -1rem -1rem -1rem auto; }\\n\\n.modal-title {\\n  margin-bottom: 0;\\n  line-height: 1.5; }\\n\\n.modal-body {\\n  position: relative;\\n  flex: 1 1 auto;\\n  padding: 1rem; }\\n\\n.modal-footer {\\n  display: flex;\\n  flex-wrap: wrap;\\n  align-items: center;\\n  justify-content: flex-end;\\n  padding: 0.75rem;\\n  border-top: 1px solid #dee2e6;\\n  border-bottom-right-radius: calc(0.3rem - 1px);\\n  border-bottom-left-radius: calc(0.3rem - 1px); }\\n  .modal-footer > * {\\n    margin: 0.25rem; }\\n\\n.modal-scrollbar-measure {\\n  position: absolute;\\n  top: -9999px;\\n  width: 50px;\\n  height: 50px;\\n  overflow: scroll; }\\n\\n@media (min-width: 576px) {\\n  .modal-dialog {\\n    max-width: 500px;\\n    margin: 1.75rem auto; }\\n  .modal-dialog-scrollable {\\n    max-height: calc(100% - 3.5rem); }\\n    .modal-dialog-scrollable .modal-content {\\n      max-height: calc(100vh - 3.5rem); }\\n  .modal-dialog-centered {\\n    min-height: calc(100% - 3.5rem); }\\n    .modal-dialog-centered::before {\\n      height: calc(100vh - 3.5rem);\\n      height: -webkit-min-content;\\n      height: -moz-min-content;\\n      height: min-content; }\\n  .modal-sm {\\n    max-width: 300px; } }\\n\\n@media (min-width: 992px) {\\n  .modal-lg,\\n  .modal-xl {\\n    max-width: 800px; } }\\n\\n@media (min-width: 1200px) {\\n  .modal-xl {\\n    max-width: 1140px; } }\\n\\n.tooltip {\\n  position: absolute;\\n  z-index: 1070;\\n  display: block;\\n  margin: 0;\\n  font-family: -apple-system, BlinkMacSystemFont, \\\"Segoe UI\\\", Roboto, \\\"Helvetica Neue\\\", Arial, \\\"Noto Sans\\\", sans-serif, \\\"Apple Color Emoji\\\", \\\"Segoe UI Emoji\\\", \\\"Segoe UI Symbol\\\", \\\"Noto Color Emoji\\\";\\n  font-style: normal;\\n  font-weight: 400;\\n  line-height: 1.5;\\n  text-align: left;\\n  text-align: start;\\n  text-decoration: none;\\n  text-shadow: none;\\n  text-transform: none;\\n  letter-spacing: normal;\\n  word-break: normal;\\n  word-spacing: normal;\\n  white-space: normal;\\n  line-break: auto;\\n  font-size: 0.875rem;\\n  word-wrap: break-word;\\n  opacity: 0; }\\n  .tooltip.show {\\n    opacity: 0.9; }\\n  .tooltip .arrow {\\n    position: absolute;\\n    display: block;\\n    width: 0.8rem;\\n    height: 0.4rem; }\\n    .tooltip .arrow::before {\\n      position: absolute;\\n      content: \\\"\\\";\\n      border-color: transparent;\\n      border-style: solid; }\\n\\n.bs-tooltip-top, .bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"], .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] {\\n  padding: 0.4rem 0; }\\n  .bs-tooltip-top .arrow, .bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow {\\n    bottom: 0; }\\n    .bs-tooltip-top .arrow::before, .bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n      top: 0;\\n      border-width: 0.4rem 0.4rem 0;\\n      border-top-color: #000; }\\n\\n.bs-tooltip-right, .bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"], .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] {\\n  padding: 0 0.4rem; }\\n  .bs-tooltip-right .arrow, .bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow {\\n    left: 0;\\n    width: 0.4rem;\\n    height: 0.8rem; }\\n    .bs-tooltip-right .arrow::before, .bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n      right: 0;\\n      border-width: 0.4rem 0.4rem 0.4rem 0;\\n      border-right-color: #000; }\\n\\n.bs-tooltip-bottom, .bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"], .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] {\\n  padding: 0.4rem 0; }\\n  .bs-tooltip-bottom .arrow, .bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow {\\n    top: 0; }\\n    .bs-tooltip-bottom .arrow::before, .bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n      bottom: 0;\\n      border-width: 0 0.4rem 0.4rem;\\n      border-bottom-color: #000; }\\n\\n.bs-tooltip-left, .bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"], .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] {\\n  padding: 0 0.4rem; }\\n  .bs-tooltip-left .arrow, .bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow {\\n    right: 0;\\n    width: 0.4rem;\\n    height: 0.8rem; }\\n    .bs-tooltip-left .arrow::before, .bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n      left: 0;\\n      border-width: 0.4rem 0 0.4rem 0.4rem;\\n      border-left-color: #000; }\\n\\n.tooltip-inner {\\n  max-width: 200px;\\n  padding: 0.25rem 0.5rem;\\n  color: #fff;\\n  text-align: center;\\n  background-color: #000;\\n  border-radius: 0.25rem; }\\n\\n.popover {\\n  position: absolute;\\n  top: 0;\\n  left: 0;\\n  z-index: 1060;\\n  display: block;\\n  max-width: 276px;\\n  font-family: -apple-system, BlinkMacSystemFont, \\\"Segoe UI\\\", Roboto, \\\"Helvetica Neue\\\", Arial, \\\"Noto Sans\\\", sans-serif, \\\"Apple Color Emoji\\\", \\\"Segoe UI Emoji\\\", \\\"Segoe UI Symbol\\\", \\\"Noto Color Emoji\\\";\\n  font-style: normal;\\n  font-weight: 400;\\n  line-height: 1.5;\\n  text-align: left;\\n  text-align: start;\\n  text-decoration: none;\\n  text-shadow: none;\\n  text-transform: none;\\n  letter-spacing: normal;\\n  word-break: normal;\\n  word-spacing: normal;\\n  white-space: normal;\\n  line-break: auto;\\n  font-size: 0.875rem;\\n  word-wrap: break-word;\\n  background-color: #fff;\\n  background-clip: padding-box;\\n  border: 1px solid rgba(0, 0, 0, 0.2);\\n  border-radius: 0.3rem; }\\n  .popover .arrow {\\n    position: absolute;\\n    display: block;\\n    width: 1rem;\\n    height: 0.5rem;\\n    margin: 0 0.3rem; }\\n    .popover .arrow::before, .popover .arrow::after {\\n      position: absolute;\\n      display: block;\\n      content: \\\"\\\";\\n      border-color: transparent;\\n      border-style: solid; }\\n\\n.bs-popover-top, .bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-primary.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-secondary.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-success.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-info.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-warning.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-danger.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-light.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-dark.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"top\\\"], .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"top\\\"] {\\n  margin-bottom: 0.5rem; }\\n  .bs-popover-top > .arrow, .bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow {\\n    bottom: calc(-0.5rem - 1px); }\\n    .bs-popover-top > .arrow::before, .bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n      bottom: 0;\\n      border-width: 0.5rem 0.5rem 0;\\n      border-top-color: rgba(0, 0, 0, 0.25); }\\n    .bs-popover-top > .arrow::after, .bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n      bottom: 1px;\\n      border-width: 0.5rem 0.5rem 0;\\n      border-top-color: #fff; }\\n\\n.bs-popover-right, .bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-primary.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-secondary.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-success.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-info.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-warning.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-danger.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-light.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-dark.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"right\\\"], .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"right\\\"] {\\n  margin-left: 0.5rem; }\\n  .bs-popover-right > .arrow, .bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow {\\n    left: calc(-0.5rem - 1px);\\n    width: 0.5rem;\\n    height: 1rem;\\n    margin: 0.3rem 0; }\\n    .bs-popover-right > .arrow::before, .bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n      left: 0;\\n      border-width: 0.5rem 0.5rem 0.5rem 0;\\n      border-right-color: rgba(0, 0, 0, 0.25); }\\n    .bs-popover-right > .arrow::after, .bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n      left: 1px;\\n      border-width: 0.5rem 0.5rem 0.5rem 0;\\n      border-right-color: #fff; }\\n\\n.bs-popover-bottom, .bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-primary.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-secondary.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-success.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-info.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-warning.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-danger.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-light.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"], .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] {\\n  margin-top: 0.5rem; }\\n  .bs-popover-bottom > .arrow, .bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow {\\n    top: calc(-0.5rem - 1px); }\\n    .bs-popover-bottom > .arrow::before, .bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n      top: 0;\\n      border-width: 0 0.5rem 0.5rem 0.5rem;\\n      border-bottom-color: rgba(0, 0, 0, 0.25); }\\n    .bs-popover-bottom > .arrow::after, .bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n      top: 1px;\\n      border-width: 0 0.5rem 0.5rem 0.5rem;\\n      border-bottom-color: #fff; }\\n  .bs-popover-bottom .popover-header::before, .bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n    position: absolute;\\n    top: 0;\\n    left: 50%;\\n    display: block;\\n    width: 1rem;\\n    margin-left: -0.5rem;\\n    content: \\\"\\\";\\n    border-bottom: 1px solid #f7f7f7; }\\n\\n.bs-popover-left, .bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-primary.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-secondary.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-success.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-info.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-warning.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-danger.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-light.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-dark.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"left\\\"], .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"left\\\"] {\\n  margin-right: 0.5rem; }\\n  .bs-popover-left > .arrow, .bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow {\\n    right: calc(-0.5rem - 1px);\\n    width: 0.5rem;\\n    height: 1rem;\\n    margin: 0.3rem 0; }\\n    .bs-popover-left > .arrow::before, .bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n      right: 0;\\n      border-width: 0.5rem 0 0.5rem 0.5rem;\\n      border-left-color: rgba(0, 0, 0, 0.25); }\\n    .bs-popover-left > .arrow::after, .bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n      right: 1px;\\n      border-width: 0.5rem 0 0.5rem 0.5rem;\\n      border-left-color: #fff; }\\n\\n.popover-header {\\n  padding: 0.5rem 0.75rem;\\n  margin-bottom: 0;\\n  font-size: 1rem;\\n  background-color: #f7f7f7;\\n  border-bottom: 1px solid #ebebeb;\\n  border-top-left-radius: calc(0.3rem - 1px);\\n  border-top-right-radius: calc(0.3rem - 1px); }\\n  .popover-header:empty {\\n    display: none; }\\n\\n.popover-body {\\n  padding: 0.5rem 0.75rem;\\n  color: #212529; }\\n\\n.carousel {\\n  position: relative; }\\n\\n.carousel.pointer-event {\\n  touch-action: pan-y; }\\n\\n.carousel-inner {\\n  position: relative;\\n  width: 100%;\\n  overflow: hidden; }\\n  .carousel-inner::after {\\n    display: block;\\n    clear: both;\\n    content: \\\"\\\"; }\\n\\n.carousel-item {\\n  position: relative;\\n  display: none;\\n  float: left;\\n  width: 100%;\\n  margin-right: -100%;\\n  -webkit-backface-visibility: hidden;\\n          backface-visibility: hidden;\\n  transition: transform 0.6s ease-in-out; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .carousel-item {\\n      transition: none; } }\\n\\n.carousel-item.active,\\n.carousel-item-next,\\n.carousel-item-prev {\\n  display: block; }\\n\\n.carousel-item-next:not(.carousel-item-left),\\n.active.carousel-item-right {\\n  transform: translateX(100%); }\\n\\n.carousel-item-prev:not(.carousel-item-right),\\n.active.carousel-item-left {\\n  transform: translateX(-100%); }\\n\\n.carousel-fade .carousel-item {\\n  opacity: 0;\\n  transition-property: opacity;\\n  transform: none; }\\n\\n.carousel-fade .carousel-item.active,\\n.carousel-fade .carousel-item-next.carousel-item-left,\\n.carousel-fade .carousel-item-prev.carousel-item-right {\\n  z-index: 1;\\n  opacity: 1; }\\n\\n.carousel-fade .active.carousel-item-left,\\n.carousel-fade .active.carousel-item-right {\\n  z-index: 0;\\n  opacity: 0;\\n  transition: opacity 0s 0.6s; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .carousel-fade .active.carousel-item-left,\\n    .carousel-fade .active.carousel-item-right {\\n      transition: none; } }\\n\\n.carousel-control-prev,\\n.carousel-control-next {\\n  position: absolute;\\n  top: 0;\\n  bottom: 0;\\n  z-index: 1;\\n  display: flex;\\n  align-items: center;\\n  justify-content: center;\\n  width: 15%;\\n  color: #fff;\\n  text-align: center;\\n  opacity: 0.5;\\n  transition: opacity 0.15s ease; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .carousel-control-prev,\\n    .carousel-control-next {\\n      transition: none; } }\\n  .carousel-control-prev:hover, .carousel-control-prev:focus,\\n  .carousel-control-next:hover,\\n  .carousel-control-next:focus {\\n    color: #fff;\\n    text-decoration: none;\\n    outline: 0;\\n    opacity: 0.9; }\\n\\n.carousel-control-prev {\\n  left: 0; }\\n\\n.carousel-control-next {\\n  right: 0; }\\n\\n.carousel-control-prev-icon,\\n.carousel-control-next-icon {\\n  display: inline-block;\\n  width: 20px;\\n  height: 20px;\\n  background: no-repeat 50% / 100% 100%; }\\n\\n.carousel-control-prev-icon {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' fill='%23fff' width='8' height='8' viewBox='0 0 8 8'%3e%3cpath d='M5.25 0l-4 4 4 4 1.5-1.5L4.25 4l2.5-2.5L5.25 0z'/%3e%3c/svg%3e\\\"); }\\n\\n.carousel-control-next-icon {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' fill='%23fff' width='8' height='8' viewBox='0 0 8 8'%3e%3cpath d='M2.75 0l-1.5 1.5L3.75 4l-2.5 2.5L2.75 8l4-4-4-4z'/%3e%3c/svg%3e\\\"); }\\n\\n.carousel-indicators {\\n  position: absolute;\\n  right: 0;\\n  bottom: 0;\\n  left: 0;\\n  z-index: 15;\\n  display: flex;\\n  justify-content: center;\\n  padding-left: 0;\\n  margin-right: 15%;\\n  margin-left: 15%;\\n  list-style: none; }\\n  .carousel-indicators li {\\n    box-sizing: content-box;\\n    flex: 0 1 auto;\\n    width: 30px;\\n    height: 3px;\\n    margin-right: 3px;\\n    margin-left: 3px;\\n    text-indent: -999px;\\n    cursor: pointer;\\n    background-color: #fff;\\n    background-clip: padding-box;\\n    border-top: 10px solid transparent;\\n    border-bottom: 10px solid transparent;\\n    opacity: .5;\\n    transition: opacity 0.6s ease; }\\n    @media (prefers-reduced-motion: reduce) {\\n      .carousel-indicators li {\\n        transition: none; } }\\n  .carousel-indicators .active {\\n    opacity: 1; }\\n\\n.carousel-caption {\\n  position: absolute;\\n  right: 15%;\\n  bottom: 20px;\\n  left: 15%;\\n  z-index: 10;\\n  padding-top: 20px;\\n  padding-bottom: 20px;\\n  color: #fff;\\n  text-align: center; }\\n\\n@-webkit-keyframes spinner-border {\\n  to {\\n    transform: rotate(360deg); } }\\n\\n@keyframes spinner-border {\\n  to {\\n    transform: rotate(360deg); } }\\n\\n.spinner-border {\\n  display: inline-block;\\n  width: 2rem;\\n  height: 2rem;\\n  vertical-align: text-bottom;\\n  border: 0.25em solid currentColor;\\n  border-right-color: transparent;\\n  border-radius: 50%;\\n  -webkit-animation: spinner-border .75s linear infinite;\\n          animation: spinner-border .75s linear infinite; }\\n\\n.spinner-border-sm {\\n  width: 1rem;\\n  height: 1rem;\\n  border-width: 0.2em; }\\n\\n@-webkit-keyframes spinner-grow {\\n  0% {\\n    transform: scale(0); }\\n  50% {\\n    opacity: 1;\\n    transform: none; } }\\n\\n@keyframes spinner-grow {\\n  0% {\\n    transform: scale(0); }\\n  50% {\\n    opacity: 1;\\n    transform: none; } }\\n\\n.spinner-grow {\\n  display: inline-block;\\n  width: 2rem;\\n  height: 2rem;\\n  vertical-align: text-bottom;\\n  background-color: currentColor;\\n  border-radius: 50%;\\n  opacity: 0;\\n  -webkit-animation: spinner-grow .75s linear infinite;\\n          animation: spinner-grow .75s linear infinite; }\\n\\n.spinner-grow-sm {\\n  width: 1rem;\\n  height: 1rem; }\\n\\n.align-baseline {\\n  vertical-align: baseline !important; }\\n\\n.align-top {\\n  vertical-align: top !important; }\\n\\n.align-middle {\\n  vertical-align: middle !important; }\\n\\n.align-bottom {\\n  vertical-align: bottom !important; }\\n\\n.align-text-bottom {\\n  vertical-align: text-bottom !important; }\\n\\n.align-text-top {\\n  vertical-align: text-top !important; }\\n\\n.bg-primary {\\n  background-color: #a23422 !important; }\\n\\na.bg-primary:hover, a.bg-primary:focus,\\nbutton.bg-primary:hover,\\nbutton.bg-primary:focus {\\n  background-color: #782619 !important; }\\n\\n.bg-secondary {\\n  background-color: #6c757d !important; }\\n\\na.bg-secondary:hover, a.bg-secondary:focus,\\nbutton.bg-secondary:hover,\\nbutton.bg-secondary:focus {\\n  background-color: #545b62 !important; }\\n\\n.bg-success {\\n  background-color: #28a745 !important; }\\n\\na.bg-success:hover, a.bg-success:focus,\\nbutton.bg-success:hover,\\nbutton.bg-success:focus {\\n  background-color: #1e7e34 !important; }\\n\\n.bg-info {\\n  background-color: #17a2b8 !important; }\\n\\na.bg-info:hover, a.bg-info:focus,\\nbutton.bg-info:hover,\\nbutton.bg-info:focus {\\n  background-color: #117a8b !important; }\\n\\n.bg-warning {\\n  background-color: #ffc107 !important; }\\n\\na.bg-warning:hover, a.bg-warning:focus,\\nbutton.bg-warning:hover,\\nbutton.bg-warning:focus {\\n  background-color: #d39e00 !important; }\\n\\n.bg-danger {\\n  background-color: #dc3545 !important; }\\n\\na.bg-danger:hover, a.bg-danger:focus,\\nbutton.bg-danger:hover,\\nbutton.bg-danger:focus {\\n  background-color: #bd2130 !important; }\\n\\n.bg-light {\\n  background-color: #f8f9fa !important; }\\n\\na.bg-light:hover, a.bg-light:focus,\\nbutton.bg-light:hover,\\nbutton.bg-light:focus {\\n  background-color: #dae0e5 !important; }\\n\\n.bg-dark {\\n  background-color: #343a40 !important; }\\n\\na.bg-dark:hover, a.bg-dark:focus,\\nbutton.bg-dark:hover,\\nbutton.bg-dark:focus {\\n  background-color: #1d2124 !important; }\\n\\n.bg-primary-light-dark {\\n  background-color: #b33926 !important; }\\n\\na.bg-primary-light-dark:hover, a.bg-primary-light-dark:focus,\\nbutton.bg-primary-light-dark:hover,\\nbutton.bg-primary-light-dark:focus {\\n  background-color: #892c1d !important; }\\n\\n.bg-primary-dark {\\n  background-color: #912f1e !important; }\\n\\na.bg-primary-dark:hover, a.bg-primary-dark:focus,\\nbutton.bg-primary-dark:hover,\\nbutton.bg-primary-dark:focus {\\n  background-color: #672116 !important; }\\n\\n.bg-white {\\n  background-color: #fff !important; }\\n\\n.bg-transparent {\\n  background-color: transparent !important; }\\n\\n.border {\\n  border: 1px solid #dee2e6 !important; }\\n\\n.border-top {\\n  border-top: 1px solid #dee2e6 !important; }\\n\\n.border-right {\\n  border-right: 1px solid #dee2e6 !important; }\\n\\n.border-bottom {\\n  border-bottom: 1px solid #dee2e6 !important; }\\n\\n.border-left {\\n  border-left: 1px solid #dee2e6 !important; }\\n\\n.border-0 {\\n  border: 0 !important; }\\n\\n.border-top-0 {\\n  border-top: 0 !important; }\\n\\n.border-right-0 {\\n  border-right: 0 !important; }\\n\\n.border-bottom-0 {\\n  border-bottom: 0 !important; }\\n\\n.border-left-0 {\\n  border-left: 0 !important; }\\n\\n.border-primary {\\n  border-color: #a23422 !important; }\\n\\n.border-secondary {\\n  border-color: #6c757d !important; }\\n\\n.border-success {\\n  border-color: #28a745 !important; }\\n\\n.border-info {\\n  border-color: #17a2b8 !important; }\\n\\n.border-warning {\\n  border-color: #ffc107 !important; }\\n\\n.border-danger {\\n  border-color: #dc3545 !important; }\\n\\n.border-light {\\n  border-color: #f8f9fa !important; }\\n\\n.border-dark {\\n  border-color: #343a40 !important; }\\n\\n.border-primary-light-dark {\\n  border-color: #b33926 !important; }\\n\\n.border-primary-dark {\\n  border-color: #912f1e !important; }\\n\\n.border-white {\\n  border-color: #fff !important; }\\n\\n.rounded-sm {\\n  border-radius: 0.2rem !important; }\\n\\n.rounded {\\n  border-radius: 0.25rem !important; }\\n\\n.rounded-top {\\n  border-top-left-radius: 0.25rem !important;\\n  border-top-right-radius: 0.25rem !important; }\\n\\n.rounded-right {\\n  border-top-right-radius: 0.25rem !important;\\n  border-bottom-right-radius: 0.25rem !important; }\\n\\n.rounded-bottom {\\n  border-bottom-right-radius: 0.25rem !important;\\n  border-bottom-left-radius: 0.25rem !important; }\\n\\n.rounded-left {\\n  border-top-left-radius: 0.25rem !important;\\n  border-bottom-left-radius: 0.25rem !important; }\\n\\n.rounded-lg {\\n  border-radius: 0.3rem !important; }\\n\\n.rounded-circle {\\n  border-radius: 50% !important; }\\n\\n.rounded-pill {\\n  border-radius: 50rem !important; }\\n\\n.rounded-0 {\\n  border-radius: 0 !important; }\\n\\n.clearfix::after {\\n  display: block;\\n  clear: both;\\n  content: \\\"\\\"; }\\n\\n.d-none {\\n  display: none !important; }\\n\\n.d-inline {\\n  display: inline !important; }\\n\\n.d-inline-block {\\n  display: inline-block !important; }\\n\\n.d-block {\\n  display: block !important; }\\n\\n.d-table {\\n  display: table !important; }\\n\\n.d-table-row {\\n  display: table-row !important; }\\n\\n.d-table-cell {\\n  display: table-cell !important; }\\n\\n.d-flex {\\n  display: flex !important; }\\n\\n.d-inline-flex {\\n  display: inline-flex !important; }\\n\\n@media (min-width: 576px) {\\n  .d-sm-none {\\n    display: none !important; }\\n  .d-sm-inline {\\n    display: inline !important; }\\n  .d-sm-inline-block {\\n    display: inline-block !important; }\\n  .d-sm-block {\\n    display: block !important; }\\n  .d-sm-table {\\n    display: table !important; }\\n  .d-sm-table-row {\\n    display: table-row !important; }\\n  .d-sm-table-cell {\\n    display: table-cell !important; }\\n  .d-sm-flex {\\n    display: flex !important; }\\n  .d-sm-inline-flex {\\n    display: inline-flex !important; } }\\n\\n@media (min-width: 768px) {\\n  .d-md-none {\\n    display: none !important; }\\n  .d-md-inline {\\n    display: inline !important; }\\n  .d-md-inline-block {\\n    display: inline-block !important; }\\n  .d-md-block {\\n    display: block !important; }\\n  .d-md-table {\\n    display: table !important; }\\n  .d-md-table-row {\\n    display: table-row !important; }\\n  .d-md-table-cell {\\n    display: table-cell !important; }\\n  .d-md-flex {\\n    display: flex !important; }\\n  .d-md-inline-flex {\\n    display: inline-flex !important; } }\\n\\n@media (min-width: 992px) {\\n  .d-lg-none {\\n    display: none !important; }\\n  .d-lg-inline {\\n    display: inline !important; }\\n  .d-lg-inline-block {\\n    display: inline-block !important; }\\n  .d-lg-block {\\n    display: block !important; }\\n  .d-lg-table {\\n    display: table !important; }\\n  .d-lg-table-row {\\n    display: table-row !important; }\\n  .d-lg-table-cell {\\n    display: table-cell !important; }\\n  .d-lg-flex {\\n    display: flex !important; }\\n  .d-lg-inline-flex {\\n    display: inline-flex !important; } }\\n\\n@media (min-width: 1200px) {\\n  .d-xl-none {\\n    display: none !important; }\\n  .d-xl-inline {\\n    display: inline !important; }\\n  .d-xl-inline-block {\\n    display: inline-block !important; }\\n  .d-xl-block {\\n    display: block !important; }\\n  .d-xl-table {\\n    display: table !important; }\\n  .d-xl-table-row {\\n    display: table-row !important; }\\n  .d-xl-table-cell {\\n    display: table-cell !important; }\\n  .d-xl-flex {\\n    display: flex !important; }\\n  .d-xl-inline-flex {\\n    display: inline-flex !important; } }\\n\\n@media print {\\n  .d-print-none {\\n    display: none !important; }\\n  .d-print-inline {\\n    display: inline !important; }\\n  .d-print-inline-block {\\n    display: inline-block !important; }\\n  .d-print-block {\\n    display: block !important; }\\n  .d-print-table {\\n    display: table !important; }\\n  .d-print-table-row {\\n    display: table-row !important; }\\n  .d-print-table-cell {\\n    display: table-cell !important; }\\n  .d-print-flex {\\n    display: flex !important; }\\n  .d-print-inline-flex {\\n    display: inline-flex !important; } }\\n\\n.embed-responsive {\\n  position: relative;\\n  display: block;\\n  width: 100%;\\n  padding: 0;\\n  overflow: hidden; }\\n  .embed-responsive::before {\\n    display: block;\\n    content: \\\"\\\"; }\\n  .embed-responsive .embed-responsive-item,\\n  .embed-responsive iframe,\\n  .embed-responsive embed,\\n  .embed-responsive object,\\n  .embed-responsive video {\\n    position: absolute;\\n    top: 0;\\n    bottom: 0;\\n    left: 0;\\n    width: 100%;\\n    height: 100%;\\n    border: 0; }\\n\\n.embed-responsive-21by9::before {\\n  padding-top: 42.85714%; }\\n\\n.embed-responsive-16by9::before {\\n  padding-top: 56.25%; }\\n\\n.embed-responsive-4by3::before {\\n  padding-top: 75%; }\\n\\n.embed-responsive-1by1::before {\\n  padding-top: 100%; }\\n\\n.flex-row {\\n  flex-direction: row !important; }\\n\\n.flex-column {\\n  flex-direction: column !important; }\\n\\n.flex-row-reverse {\\n  flex-direction: row-reverse !important; }\\n\\n.flex-column-reverse {\\n  flex-direction: column-reverse !important; }\\n\\n.flex-wrap {\\n  flex-wrap: wrap !important; }\\n\\n.flex-nowrap {\\n  flex-wrap: nowrap !important; }\\n\\n.flex-wrap-reverse {\\n  flex-wrap: wrap-reverse !important; }\\n\\n.flex-fill {\\n  flex: 1 1 auto !important; }\\n\\n.flex-grow-0 {\\n  flex-grow: 0 !important; }\\n\\n.flex-grow-1 {\\n  flex-grow: 1 !important; }\\n\\n.flex-shrink-0 {\\n  flex-shrink: 0 !important; }\\n\\n.flex-shrink-1 {\\n  flex-shrink: 1 !important; }\\n\\n.justify-content-start {\\n  justify-content: flex-start !important; }\\n\\n.justify-content-end {\\n  justify-content: flex-end !important; }\\n\\n.justify-content-center {\\n  justify-content: center !important; }\\n\\n.justify-content-between {\\n  justify-content: space-between !important; }\\n\\n.justify-content-around {\\n  justify-content: space-around !important; }\\n\\n.align-items-start {\\n  align-items: flex-start !important; }\\n\\n.align-items-end {\\n  align-items: flex-end !important; }\\n\\n.align-items-center {\\n  align-items: center !important; }\\n\\n.align-items-baseline {\\n  align-items: baseline !important; }\\n\\n.align-items-stretch {\\n  align-items: stretch !important; }\\n\\n.align-content-start {\\n  align-content: flex-start !important; }\\n\\n.align-content-end {\\n  align-content: flex-end !important; }\\n\\n.align-content-center {\\n  align-content: center !important; }\\n\\n.align-content-between {\\n  align-content: space-between !important; }\\n\\n.align-content-around {\\n  align-content: space-around !important; }\\n\\n.align-content-stretch {\\n  align-content: stretch !important; }\\n\\n.align-self-auto {\\n  align-self: auto !important; }\\n\\n.align-self-start {\\n  align-self: flex-start !important; }\\n\\n.align-self-end {\\n  align-self: flex-end !important; }\\n\\n.align-self-center {\\n  align-self: center !important; }\\n\\n.align-self-baseline {\\n  align-self: baseline !important; }\\n\\n.align-self-stretch {\\n  align-self: stretch !important; }\\n\\n@media (min-width: 576px) {\\n  .flex-sm-row {\\n    flex-direction: row !important; }\\n  .flex-sm-column {\\n    flex-direction: column !important; }\\n  .flex-sm-row-reverse {\\n    flex-direction: row-reverse !important; }\\n  .flex-sm-column-reverse {\\n    flex-direction: column-reverse !important; }\\n  .flex-sm-wrap {\\n    flex-wrap: wrap !important; }\\n  .flex-sm-nowrap {\\n    flex-wrap: nowrap !important; }\\n  .flex-sm-wrap-reverse {\\n    flex-wrap: wrap-reverse !important; }\\n  .flex-sm-fill {\\n    flex: 1 1 auto !important; }\\n  .flex-sm-grow-0 {\\n    flex-grow: 0 !important; }\\n  .flex-sm-grow-1 {\\n    flex-grow: 1 !important; }\\n  .flex-sm-shrink-0 {\\n    flex-shrink: 0 !important; }\\n  .flex-sm-shrink-1 {\\n    flex-shrink: 1 !important; }\\n  .justify-content-sm-start {\\n    justify-content: flex-start !important; }\\n  .justify-content-sm-end {\\n    justify-content: flex-end !important; }\\n  .justify-content-sm-center {\\n    justify-content: center !important; }\\n  .justify-content-sm-between {\\n    justify-content: space-between !important; }\\n  .justify-content-sm-around {\\n    justify-content: space-around !important; }\\n  .align-items-sm-start {\\n    align-items: flex-start !important; }\\n  .align-items-sm-end {\\n    align-items: flex-end !important; }\\n  .align-items-sm-center {\\n    align-items: center !important; }\\n  .align-items-sm-baseline {\\n    align-items: baseline !important; }\\n  .align-items-sm-stretch {\\n    align-items: stretch !important; }\\n  .align-content-sm-start {\\n    align-content: flex-start !important; }\\n  .align-content-sm-end {\\n    align-content: flex-end !important; }\\n  .align-content-sm-center {\\n    align-content: center !important; }\\n  .align-content-sm-between {\\n    align-content: space-between !important; }\\n  .align-content-sm-around {\\n    align-content: space-around !important; }\\n  .align-content-sm-stretch {\\n    align-content: stretch !important; }\\n  .align-self-sm-auto {\\n    align-self: auto !important; }\\n  .align-self-sm-start {\\n    align-self: flex-start !important; }\\n  .align-self-sm-end {\\n    align-self: flex-end !important; }\\n  .align-self-sm-center {\\n    align-self: center !important; }\\n  .align-self-sm-baseline {\\n    align-self: baseline !important; }\\n  .align-self-sm-stretch {\\n    align-self: stretch !important; } }\\n\\n@media (min-width: 768px) {\\n  .flex-md-row {\\n    flex-direction: row !important; }\\n  .flex-md-column {\\n    flex-direction: column !important; }\\n  .flex-md-row-reverse {\\n    flex-direction: row-reverse !important; }\\n  .flex-md-column-reverse {\\n    flex-direction: column-reverse !important; }\\n  .flex-md-wrap {\\n    flex-wrap: wrap !important; }\\n  .flex-md-nowrap {\\n    flex-wrap: nowrap !important; }\\n  .flex-md-wrap-reverse {\\n    flex-wrap: wrap-reverse !important; }\\n  .flex-md-fill {\\n    flex: 1 1 auto !important; }\\n  .flex-md-grow-0 {\\n    flex-grow: 0 !important; }\\n  .flex-md-grow-1 {\\n    flex-grow: 1 !important; }\\n  .flex-md-shrink-0 {\\n    flex-shrink: 0 !important; }\\n  .flex-md-shrink-1 {\\n    flex-shrink: 1 !important; }\\n  .justify-content-md-start {\\n    justify-content: flex-start !important; }\\n  .justify-content-md-end {\\n    justify-content: flex-end !important; }\\n  .justify-content-md-center {\\n    justify-content: center !important; }\\n  .justify-content-md-between {\\n    justify-content: space-between !important; }\\n  .justify-content-md-around {\\n    justify-content: space-around !important; }\\n  .align-items-md-start {\\n    align-items: flex-start !important; }\\n  .align-items-md-end {\\n    align-items: flex-end !important; }\\n  .align-items-md-center {\\n    align-items: center !important; }\\n  .align-items-md-baseline {\\n    align-items: baseline !important; }\\n  .align-items-md-stretch {\\n    align-items: stretch !important; }\\n  .align-content-md-start {\\n    align-content: flex-start !important; }\\n  .align-content-md-end {\\n    align-content: flex-end !important; }\\n  .align-content-md-center {\\n    align-content: center !important; }\\n  .align-content-md-between {\\n    align-content: space-between !important; }\\n  .align-content-md-around {\\n    align-content: space-around !important; }\\n  .align-content-md-stretch {\\n    align-content: stretch !important; }\\n  .align-self-md-auto {\\n    align-self: auto !important; }\\n  .align-self-md-start {\\n    align-self: flex-start !important; }\\n  .align-self-md-end {\\n    align-self: flex-end !important; }\\n  .align-self-md-center {\\n    align-self: center !important; }\\n  .align-self-md-baseline {\\n    align-self: baseline !important; }\\n  .align-self-md-stretch {\\n    align-self: stretch !important; } }\\n\\n@media (min-width: 992px) {\\n  .flex-lg-row {\\n    flex-direction: row !important; }\\n  .flex-lg-column {\\n    flex-direction: column !important; }\\n  .flex-lg-row-reverse {\\n    flex-direction: row-reverse !important; }\\n  .flex-lg-column-reverse {\\n    flex-direction: column-reverse !important; }\\n  .flex-lg-wrap {\\n    flex-wrap: wrap !important; }\\n  .flex-lg-nowrap {\\n    flex-wrap: nowrap !important; }\\n  .flex-lg-wrap-reverse {\\n    flex-wrap: wrap-reverse !important; }\\n  .flex-lg-fill {\\n    flex: 1 1 auto !important; }\\n  .flex-lg-grow-0 {\\n    flex-grow: 0 !important; }\\n  .flex-lg-grow-1 {\\n    flex-grow: 1 !important; }\\n  .flex-lg-shrink-0 {\\n    flex-shrink: 0 !important; }\\n  .flex-lg-shrink-1 {\\n    flex-shrink: 1 !important; }\\n  .justify-content-lg-start {\\n    justify-content: flex-start !important; }\\n  .justify-content-lg-end {\\n    justify-content: flex-end !important; }\\n  .justify-content-lg-center {\\n    justify-content: center !important; }\\n  .justify-content-lg-between {\\n    justify-content: space-between !important; }\\n  .justify-content-lg-around {\\n    justify-content: space-around !important; }\\n  .align-items-lg-start {\\n    align-items: flex-start !important; }\\n  .align-items-lg-end {\\n    align-items: flex-end !important; }\\n  .align-items-lg-center {\\n    align-items: center !important; }\\n  .align-items-lg-baseline {\\n    align-items: baseline !important; }\\n  .align-items-lg-stretch {\\n    align-items: stretch !important; }\\n  .align-content-lg-start {\\n    align-content: flex-start !important; }\\n  .align-content-lg-end {\\n    align-content: flex-end !important; }\\n  .align-content-lg-center {\\n    align-content: center !important; }\\n  .align-content-lg-between {\\n    align-content: space-between !important; }\\n  .align-content-lg-around {\\n    align-content: space-around !important; }\\n  .align-content-lg-stretch {\\n    align-content: stretch !important; }\\n  .align-self-lg-auto {\\n    align-self: auto !important; }\\n  .align-self-lg-start {\\n    align-self: flex-start !important; }\\n  .align-self-lg-end {\\n    align-self: flex-end !important; }\\n  .align-self-lg-center {\\n    align-self: center !important; }\\n  .align-self-lg-baseline {\\n    align-self: baseline !important; }\\n  .align-self-lg-stretch {\\n    align-self: stretch !important; } }\\n\\n@media (min-width: 1200px) {\\n  .flex-xl-row {\\n    flex-direction: row !important; }\\n  .flex-xl-column {\\n    flex-direction: column !important; }\\n  .flex-xl-row-reverse {\\n    flex-direction: row-reverse !important; }\\n  .flex-xl-column-reverse {\\n    flex-direction: column-reverse !important; }\\n  .flex-xl-wrap {\\n    flex-wrap: wrap !important; }\\n  .flex-xl-nowrap {\\n    flex-wrap: nowrap !important; }\\n  .flex-xl-wrap-reverse {\\n    flex-wrap: wrap-reverse !important; }\\n  .flex-xl-fill {\\n    flex: 1 1 auto !important; }\\n  .flex-xl-grow-0 {\\n    flex-grow: 0 !important; }\\n  .flex-xl-grow-1 {\\n    flex-grow: 1 !important; }\\n  .flex-xl-shrink-0 {\\n    flex-shrink: 0 !important; }\\n  .flex-xl-shrink-1 {\\n    flex-shrink: 1 !important; }\\n  .justify-content-xl-start {\\n    justify-content: flex-start !important; }\\n  .justify-content-xl-end {\\n    justify-content: flex-end !important; }\\n  .justify-content-xl-center {\\n    justify-content: center !important; }\\n  .justify-content-xl-between {\\n    justify-content: space-between !important; }\\n  .justify-content-xl-around {\\n    justify-content: space-around !important; }\\n  .align-items-xl-start {\\n    align-items: flex-start !important; }\\n  .align-items-xl-end {\\n    align-items: flex-end !important; }\\n  .align-items-xl-center {\\n    align-items: center !important; }\\n  .align-items-xl-baseline {\\n    align-items: baseline !important; }\\n  .align-items-xl-stretch {\\n    align-items: stretch !important; }\\n  .align-content-xl-start {\\n    align-content: flex-start !important; }\\n  .align-content-xl-end {\\n    align-content: flex-end !important; }\\n  .align-content-xl-center {\\n    align-content: center !important; }\\n  .align-content-xl-between {\\n    align-content: space-between !important; }\\n  .align-content-xl-around {\\n    align-content: space-around !important; }\\n  .align-content-xl-stretch {\\n    align-content: stretch !important; }\\n  .align-self-xl-auto {\\n    align-self: auto !important; }\\n  .align-self-xl-start {\\n    align-self: flex-start !important; }\\n  .align-self-xl-end {\\n    align-self: flex-end !important; }\\n  .align-self-xl-center {\\n    align-self: center !important; }\\n  .align-self-xl-baseline {\\n    align-self: baseline !important; }\\n  .align-self-xl-stretch {\\n    align-self: stretch !important; } }\\n\\n.float-left {\\n  float: left !important; }\\n\\n.float-right {\\n  float: right !important; }\\n\\n.float-none {\\n  float: none !important; }\\n\\n@media (min-width: 576px) {\\n  .float-sm-left {\\n    float: left !important; }\\n  .float-sm-right {\\n    float: right !important; }\\n  .float-sm-none {\\n    float: none !important; } }\\n\\n@media (min-width: 768px) {\\n  .float-md-left {\\n    float: left !important; }\\n  .float-md-right {\\n    float: right !important; }\\n  .float-md-none {\\n    float: none !important; } }\\n\\n@media (min-width: 992px) {\\n  .float-lg-left {\\n    float: left !important; }\\n  .float-lg-right {\\n    float: right !important; }\\n  .float-lg-none {\\n    float: none !important; } }\\n\\n@media (min-width: 1200px) {\\n  .float-xl-left {\\n    float: left !important; }\\n  .float-xl-right {\\n    float: right !important; }\\n  .float-xl-none {\\n    float: none !important; } }\\n\\n.user-select-all {\\n  -webkit-user-select: all !important;\\n     -moz-user-select: all !important;\\n      -ms-user-select: all !important;\\n          user-select: all !important; }\\n\\n.user-select-auto {\\n  -webkit-user-select: auto !important;\\n     -moz-user-select: auto !important;\\n      -ms-user-select: auto !important;\\n          user-select: auto !important; }\\n\\n.user-select-none {\\n  -webkit-user-select: none !important;\\n     -moz-user-select: none !important;\\n      -ms-user-select: none !important;\\n          user-select: none !important; }\\n\\n.overflow-auto {\\n  overflow: auto !important; }\\n\\n.overflow-hidden {\\n  overflow: hidden !important; }\\n\\n.position-static {\\n  position: static !important; }\\n\\n.position-relative {\\n  position: relative !important; }\\n\\n.position-absolute {\\n  position: absolute !important; }\\n\\n.position-fixed {\\n  position: fixed !important; }\\n\\n.position-sticky {\\n  position: -webkit-sticky !important;\\n  position: sticky !important; }\\n\\n.fixed-top {\\n  position: fixed;\\n  top: 0;\\n  right: 0;\\n  left: 0;\\n  z-index: 1030; }\\n\\n.fixed-bottom {\\n  position: fixed;\\n  right: 0;\\n  bottom: 0;\\n  left: 0;\\n  z-index: 1030; }\\n\\n@supports ((position: -webkit-sticky) or (position: sticky)) {\\n  .sticky-top {\\n    position: -webkit-sticky;\\n    position: sticky;\\n    top: 0;\\n    z-index: 1020; } }\\n\\n.sr-only {\\n  position: absolute;\\n  width: 1px;\\n  height: 1px;\\n  padding: 0;\\n  margin: -1px;\\n  overflow: hidden;\\n  clip: rect(0, 0, 0, 0);\\n  white-space: nowrap;\\n  border: 0; }\\n\\n.sr-only-focusable:active, .sr-only-focusable:focus {\\n  position: static;\\n  width: auto;\\n  height: auto;\\n  overflow: visible;\\n  clip: auto;\\n  white-space: normal; }\\n\\n.shadow-sm {\\n  box-shadow: 0 0.125rem 0.25rem rgba(0, 0, 0, 0.075) !important; }\\n\\n.shadow {\\n  box-shadow: 0 0.5rem 1rem rgba(0, 0, 0, 0.15) !important; }\\n\\n.shadow-lg {\\n  box-shadow: 0 1rem 3rem rgba(0, 0, 0, 0.175) !important; }\\n\\n.shadow-none {\\n  box-shadow: none !important; }\\n\\n.w-25 {\\n  width: 25% !important; }\\n\\n.w-50 {\\n  width: 50% !important; }\\n\\n.w-75 {\\n  width: 75% !important; }\\n\\n.w-100 {\\n  width: 100% !important; }\\n\\n.w-auto {\\n  width: auto !important; }\\n\\n.h-25 {\\n  height: 25% !important; }\\n\\n.h-50 {\\n  height: 50% !important; }\\n\\n.h-75 {\\n  height: 75% !important; }\\n\\n.h-100 {\\n  height: 100% !important; }\\n\\n.h-auto {\\n  height: auto !important; }\\n\\n.mw-100 {\\n  max-width: 100% !important; }\\n\\n.mh-100 {\\n  max-height: 100% !important; }\\n\\n.min-vw-100 {\\n  min-width: 100vw !important; }\\n\\n.min-vh-100 {\\n  min-height: 100vh !important; }\\n\\n.vw-100 {\\n  width: 100vw !important; }\\n\\n.vh-100 {\\n  height: 100vh !important; }\\n\\n.m-0 {\\n  margin: 0 !important; }\\n\\n.mt-0,\\n.my-0 {\\n  margin-top: 0 !important; }\\n\\n.mr-0,\\n.mx-0 {\\n  margin-right: 0 !important; }\\n\\n.mb-0,\\n.my-0 {\\n  margin-bottom: 0 !important; }\\n\\n.ml-0,\\n.mx-0 {\\n  margin-left: 0 !important; }\\n\\n.m-1 {\\n  margin: 0.25rem !important; }\\n\\n.mt-1,\\n.my-1 {\\n  margin-top: 0.25rem !important; }\\n\\n.mr-1,\\n.mx-1 {\\n  margin-right: 0.25rem !important; }\\n\\n.mb-1,\\n.my-1 {\\n  margin-bottom: 0.25rem !important; }\\n\\n.ml-1,\\n.mx-1 {\\n  margin-left: 0.25rem !important; }\\n\\n.m-2 {\\n  margin: 0.5rem !important; }\\n\\n.mt-2,\\n.my-2 {\\n  margin-top: 0.5rem !important; }\\n\\n.mr-2,\\n.mx-2 {\\n  margin-right: 0.5rem !important; }\\n\\n.mb-2,\\n.my-2 {\\n  margin-bottom: 0.5rem !important; }\\n\\n.ml-2,\\n.mx-2 {\\n  margin-left: 0.5rem !important; }\\n\\n.m-3 {\\n  margin: 1rem !important; }\\n\\n.mt-3,\\n.my-3 {\\n  margin-top: 1rem !important; }\\n\\n.mr-3,\\n.mx-3 {\\n  margin-right: 1rem !important; }\\n\\n.mb-3,\\n.my-3 {\\n  margin-bottom: 1rem !important; }\\n\\n.ml-3,\\n.mx-3 {\\n  margin-left: 1rem !important; }\\n\\n.m-4 {\\n  margin: 1.5rem !important; }\\n\\n.mt-4,\\n.my-4 {\\n  margin-top: 1.5rem !important; }\\n\\n.mr-4,\\n.mx-4 {\\n  margin-right: 1.5rem !important; }\\n\\n.mb-4,\\n.my-4 {\\n  margin-bottom: 1.5rem !important; }\\n\\n.ml-4,\\n.mx-4 {\\n  margin-left: 1.5rem !important; }\\n\\n.m-5 {\\n  margin: 3rem !important; }\\n\\n.mt-5,\\n.my-5 {\\n  margin-top: 3rem !important; }\\n\\n.mr-5,\\n.mx-5 {\\n  margin-right: 3rem !important; }\\n\\n.mb-5,\\n.my-5 {\\n  margin-bottom: 3rem !important; }\\n\\n.ml-5,\\n.mx-5 {\\n  margin-left: 3rem !important; }\\n\\n.p-0 {\\n  padding: 0 !important; }\\n\\n.pt-0,\\n.py-0 {\\n  padding-top: 0 !important; }\\n\\n.pr-0,\\n.px-0 {\\n  padding-right: 0 !important; }\\n\\n.pb-0,\\n.py-0 {\\n  padding-bottom: 0 !important; }\\n\\n.pl-0,\\n.px-0 {\\n  padding-left: 0 !important; }\\n\\n.p-1 {\\n  padding: 0.25rem !important; }\\n\\n.pt-1,\\n.py-1 {\\n  padding-top: 0.25rem !important; }\\n\\n.pr-1,\\n.px-1 {\\n  padding-right: 0.25rem !important; }\\n\\n.pb-1,\\n.py-1 {\\n  padding-bottom: 0.25rem !important; }\\n\\n.pl-1,\\n.px-1 {\\n  padding-left: 0.25rem !important; }\\n\\n.p-2 {\\n  padding: 0.5rem !important; }\\n\\n.pt-2,\\n.py-2 {\\n  padding-top: 0.5rem !important; }\\n\\n.pr-2,\\n.px-2 {\\n  padding-right: 0.5rem !important; }\\n\\n.pb-2,\\n.py-2 {\\n  padding-bottom: 0.5rem !important; }\\n\\n.pl-2,\\n.px-2 {\\n  padding-left: 0.5rem !important; }\\n\\n.p-3 {\\n  padding: 1rem !important; }\\n\\n.pt-3,\\n.py-3 {\\n  padding-top: 1rem !important; }\\n\\n.pr-3,\\n.px-3 {\\n  padding-right: 1rem !important; }\\n\\n.pb-3,\\n.py-3 {\\n  padding-bottom: 1rem !important; }\\n\\n.pl-3,\\n.px-3 {\\n  padding-left: 1rem !important; }\\n\\n.p-4 {\\n  padding: 1.5rem !important; }\\n\\n.pt-4,\\n.py-4 {\\n  padding-top: 1.5rem !important; }\\n\\n.pr-4,\\n.px-4 {\\n  padding-right: 1.5rem !important; }\\n\\n.pb-4,\\n.py-4 {\\n  padding-bottom: 1.5rem !important; }\\n\\n.pl-4,\\n.px-4 {\\n  padding-left: 1.5rem !important; }\\n\\n.p-5 {\\n  padding: 3rem !important; }\\n\\n.pt-5,\\n.py-5 {\\n  padding-top: 3rem !important; }\\n\\n.pr-5,\\n.px-5 {\\n  padding-right: 3rem !important; }\\n\\n.pb-5,\\n.py-5 {\\n  padding-bottom: 3rem !important; }\\n\\n.pl-5,\\n.px-5 {\\n  padding-left: 3rem !important; }\\n\\n.m-n1 {\\n  margin: -0.25rem !important; }\\n\\n.mt-n1,\\n.my-n1 {\\n  margin-top: -0.25rem !important; }\\n\\n.mr-n1,\\n.mx-n1 {\\n  margin-right: -0.25rem !important; }\\n\\n.mb-n1,\\n.my-n1 {\\n  margin-bottom: -0.25rem !important; }\\n\\n.ml-n1,\\n.mx-n1 {\\n  margin-left: -0.25rem !important; }\\n\\n.m-n2 {\\n  margin: -0.5rem !important; }\\n\\n.mt-n2,\\n.my-n2 {\\n  margin-top: -0.5rem !important; }\\n\\n.mr-n2,\\n.mx-n2 {\\n  margin-right: -0.5rem !important; }\\n\\n.mb-n2,\\n.my-n2 {\\n  margin-bottom: -0.5rem !important; }\\n\\n.ml-n2,\\n.mx-n2 {\\n  margin-left: -0.5rem !important; }\\n\\n.m-n3 {\\n  margin: -1rem !important; }\\n\\n.mt-n3,\\n.my-n3 {\\n  margin-top: -1rem !important; }\\n\\n.mr-n3,\\n.mx-n3 {\\n  margin-right: -1rem !important; }\\n\\n.mb-n3,\\n.my-n3 {\\n  margin-bottom: -1rem !important; }\\n\\n.ml-n3,\\n.mx-n3 {\\n  margin-left: -1rem !important; }\\n\\n.m-n4 {\\n  margin: -1.5rem !important; }\\n\\n.mt-n4,\\n.my-n4 {\\n  margin-top: -1.5rem !important; }\\n\\n.mr-n4,\\n.mx-n4 {\\n  margin-right: -1.5rem !important; }\\n\\n.mb-n4,\\n.my-n4 {\\n  margin-bottom: -1.5rem !important; }\\n\\n.ml-n4,\\n.mx-n4 {\\n  margin-left: -1.5rem !important; }\\n\\n.m-n5 {\\n  margin: -3rem !important; }\\n\\n.mt-n5,\\n.my-n5 {\\n  margin-top: -3rem !important; }\\n\\n.mr-n5,\\n.mx-n5 {\\n  margin-right: -3rem !important; }\\n\\n.mb-n5,\\n.my-n5 {\\n  margin-bottom: -3rem !important; }\\n\\n.ml-n5,\\n.mx-n5 {\\n  margin-left: -3rem !important; }\\n\\n.m-auto {\\n  margin: auto !important; }\\n\\n.mt-auto,\\n.my-auto {\\n  margin-top: auto !important; }\\n\\n.mr-auto,\\n.mx-auto {\\n  margin-right: auto !important; }\\n\\n.mb-auto,\\n.my-auto {\\n  margin-bottom: auto !important; }\\n\\n.ml-auto,\\n.mx-auto {\\n  margin-left: auto !important; }\\n\\n@media (min-width: 576px) {\\n  .m-sm-0 {\\n    margin: 0 !important; }\\n  .mt-sm-0,\\n  .my-sm-0 {\\n    margin-top: 0 !important; }\\n  .mr-sm-0,\\n  .mx-sm-0 {\\n    margin-right: 0 !important; }\\n  .mb-sm-0,\\n  .my-sm-0 {\\n    margin-bottom: 0 !important; }\\n  .ml-sm-0,\\n  .mx-sm-0 {\\n    margin-left: 0 !important; }\\n  .m-sm-1 {\\n    margin: 0.25rem !important; }\\n  .mt-sm-1,\\n  .my-sm-1 {\\n    margin-top: 0.25rem !important; }\\n  .mr-sm-1,\\n  .mx-sm-1 {\\n    margin-right: 0.25rem !important; }\\n  .mb-sm-1,\\n  .my-sm-1 {\\n    margin-bottom: 0.25rem !important; }\\n  .ml-sm-1,\\n  .mx-sm-1 {\\n    margin-left: 0.25rem !important; }\\n  .m-sm-2 {\\n    margin: 0.5rem !important; }\\n  .mt-sm-2,\\n  .my-sm-2 {\\n    margin-top: 0.5rem !important; }\\n  .mr-sm-2,\\n  .mx-sm-2 {\\n    margin-right: 0.5rem !important; }\\n  .mb-sm-2,\\n  .my-sm-2 {\\n    margin-bottom: 0.5rem !important; }\\n  .ml-sm-2,\\n  .mx-sm-2 {\\n    margin-left: 0.5rem !important; }\\n  .m-sm-3 {\\n    margin: 1rem !important; }\\n  .mt-sm-3,\\n  .my-sm-3 {\\n    margin-top: 1rem !important; }\\n  .mr-sm-3,\\n  .mx-sm-3 {\\n    margin-right: 1rem !important; }\\n  .mb-sm-3,\\n  .my-sm-3 {\\n    margin-bottom: 1rem !important; }\\n  .ml-sm-3,\\n  .mx-sm-3 {\\n    margin-left: 1rem !important; }\\n  .m-sm-4 {\\n    margin: 1.5rem !important; }\\n  .mt-sm-4,\\n  .my-sm-4 {\\n    margin-top: 1.5rem !important; }\\n  .mr-sm-4,\\n  .mx-sm-4 {\\n    margin-right: 1.5rem !important; }\\n  .mb-sm-4,\\n  .my-sm-4 {\\n    margin-bottom: 1.5rem !important; }\\n  .ml-sm-4,\\n  .mx-sm-4 {\\n    margin-left: 1.5rem !important; }\\n  .m-sm-5 {\\n    margin: 3rem !important; }\\n  .mt-sm-5,\\n  .my-sm-5 {\\n    margin-top: 3rem !important; }\\n  .mr-sm-5,\\n  .mx-sm-5 {\\n    margin-right: 3rem !important; }\\n  .mb-sm-5,\\n  .my-sm-5 {\\n    margin-bottom: 3rem !important; }\\n  .ml-sm-5,\\n  .mx-sm-5 {\\n    margin-left: 3rem !important; }\\n  .p-sm-0 {\\n    padding: 0 !important; }\\n  .pt-sm-0,\\n  .py-sm-0 {\\n    padding-top: 0 !important; }\\n  .pr-sm-0,\\n  .px-sm-0 {\\n    padding-right: 0 !important; }\\n  .pb-sm-0,\\n  .py-sm-0 {\\n    padding-bottom: 0 !important; }\\n  .pl-sm-0,\\n  .px-sm-0 {\\n    padding-left: 0 !important; }\\n  .p-sm-1 {\\n    padding: 0.25rem !important; }\\n  .pt-sm-1,\\n  .py-sm-1 {\\n    padding-top: 0.25rem !important; }\\n  .pr-sm-1,\\n  .px-sm-1 {\\n    padding-right: 0.25rem !important; }\\n  .pb-sm-1,\\n  .py-sm-1 {\\n    padding-bottom: 0.25rem !important; }\\n  .pl-sm-1,\\n  .px-sm-1 {\\n    padding-left: 0.25rem !important; }\\n  .p-sm-2 {\\n    padding: 0.5rem !important; }\\n  .pt-sm-2,\\n  .py-sm-2 {\\n    padding-top: 0.5rem !important; }\\n  .pr-sm-2,\\n  .px-sm-2 {\\n    padding-right: 0.5rem !important; }\\n  .pb-sm-2,\\n  .py-sm-2 {\\n    padding-bottom: 0.5rem !important; }\\n  .pl-sm-2,\\n  .px-sm-2 {\\n    padding-left: 0.5rem !important; }\\n  .p-sm-3 {\\n    padding: 1rem !important; }\\n  .pt-sm-3,\\n  .py-sm-3 {\\n    padding-top: 1rem !important; }\\n  .pr-sm-3,\\n  .px-sm-3 {\\n    padding-right: 1rem !important; }\\n  .pb-sm-3,\\n  .py-sm-3 {\\n    padding-bottom: 1rem !important; }\\n  .pl-sm-3,\\n  .px-sm-3 {\\n    padding-left: 1rem !important; }\\n  .p-sm-4 {\\n    padding: 1.5rem !important; }\\n  .pt-sm-4,\\n  .py-sm-4 {\\n    padding-top: 1.5rem !important; }\\n  .pr-sm-4,\\n  .px-sm-4 {\\n    padding-right: 1.5rem !important; }\\n  .pb-sm-4,\\n  .py-sm-4 {\\n    padding-bottom: 1.5rem !important; }\\n  .pl-sm-4,\\n  .px-sm-4 {\\n    padding-left: 1.5rem !important; }\\n  .p-sm-5 {\\n    padding: 3rem !important; }\\n  .pt-sm-5,\\n  .py-sm-5 {\\n    padding-top: 3rem !important; }\\n  .pr-sm-5,\\n  .px-sm-5 {\\n    padding-right: 3rem !important; }\\n  .pb-sm-5,\\n  .py-sm-5 {\\n    padding-bottom: 3rem !important; }\\n  .pl-sm-5,\\n  .px-sm-5 {\\n    padding-left: 3rem !important; }\\n  .m-sm-n1 {\\n    margin: -0.25rem !important; }\\n  .mt-sm-n1,\\n  .my-sm-n1 {\\n    margin-top: -0.25rem !important; }\\n  .mr-sm-n1,\\n  .mx-sm-n1 {\\n    margin-right: -0.25rem !important; }\\n  .mb-sm-n1,\\n  .my-sm-n1 {\\n    margin-bottom: -0.25rem !important; }\\n  .ml-sm-n1,\\n  .mx-sm-n1 {\\n    margin-left: -0.25rem !important; }\\n  .m-sm-n2 {\\n    margin: -0.5rem !important; }\\n  .mt-sm-n2,\\n  .my-sm-n2 {\\n    margin-top: -0.5rem !important; }\\n  .mr-sm-n2,\\n  .mx-sm-n2 {\\n    margin-right: -0.5rem !important; }\\n  .mb-sm-n2,\\n  .my-sm-n2 {\\n    margin-bottom: -0.5rem !important; }\\n  .ml-sm-n2,\\n  .mx-sm-n2 {\\n    margin-left: -0.5rem !important; }\\n  .m-sm-n3 {\\n    margin: -1rem !important; }\\n  .mt-sm-n3,\\n  .my-sm-n3 {\\n    margin-top: -1rem !important; }\\n  .mr-sm-n3,\\n  .mx-sm-n3 {\\n    margin-right: -1rem !important; }\\n  .mb-sm-n3,\\n  .my-sm-n3 {\\n    margin-bottom: -1rem !important; }\\n  .ml-sm-n3,\\n  .mx-sm-n3 {\\n    margin-left: -1rem !important; }\\n  .m-sm-n4 {\\n    margin: -1.5rem !important; }\\n  .mt-sm-n4,\\n  .my-sm-n4 {\\n    margin-top: -1.5rem !important; }\\n  .mr-sm-n4,\\n  .mx-sm-n4 {\\n    margin-right: -1.5rem !important; }\\n  .mb-sm-n4,\\n  .my-sm-n4 {\\n    margin-bottom: -1.5rem !important; }\\n  .ml-sm-n4,\\n  .mx-sm-n4 {\\n    margin-left: -1.5rem !important; }\\n  .m-sm-n5 {\\n    margin: -3rem !important; }\\n  .mt-sm-n5,\\n  .my-sm-n5 {\\n    margin-top: -3rem !important; }\\n  .mr-sm-n5,\\n  .mx-sm-n5 {\\n    margin-right: -3rem !important; }\\n  .mb-sm-n5,\\n  .my-sm-n5 {\\n    margin-bottom: -3rem !important; }\\n  .ml-sm-n5,\\n  .mx-sm-n5 {\\n    margin-left: -3rem !important; }\\n  .m-sm-auto {\\n    margin: auto !important; }\\n  .mt-sm-auto,\\n  .my-sm-auto {\\n    margin-top: auto !important; }\\n  .mr-sm-auto,\\n  .mx-sm-auto {\\n    margin-right: auto !important; }\\n  .mb-sm-auto,\\n  .my-sm-auto {\\n    margin-bottom: auto !important; }\\n  .ml-sm-auto,\\n  .mx-sm-auto {\\n    margin-left: auto !important; } }\\n\\n@media (min-width: 768px) {\\n  .m-md-0 {\\n    margin: 0 !important; }\\n  .mt-md-0,\\n  .my-md-0 {\\n    margin-top: 0 !important; }\\n  .mr-md-0,\\n  .mx-md-0 {\\n    margin-right: 0 !important; }\\n  .mb-md-0,\\n  .my-md-0 {\\n    margin-bottom: 0 !important; }\\n  .ml-md-0,\\n  .mx-md-0 {\\n    margin-left: 0 !important; }\\n  .m-md-1 {\\n    margin: 0.25rem !important; }\\n  .mt-md-1,\\n  .my-md-1 {\\n    margin-top: 0.25rem !important; }\\n  .mr-md-1,\\n  .mx-md-1 {\\n    margin-right: 0.25rem !important; }\\n  .mb-md-1,\\n  .my-md-1 {\\n    margin-bottom: 0.25rem !important; }\\n  .ml-md-1,\\n  .mx-md-1 {\\n    margin-left: 0.25rem !important; }\\n  .m-md-2 {\\n    margin: 0.5rem !important; }\\n  .mt-md-2,\\n  .my-md-2 {\\n    margin-top: 0.5rem !important; }\\n  .mr-md-2,\\n  .mx-md-2 {\\n    margin-right: 0.5rem !important; }\\n  .mb-md-2,\\n  .my-md-2 {\\n    margin-bottom: 0.5rem !important; }\\n  .ml-md-2,\\n  .mx-md-2 {\\n    margin-left: 0.5rem !important; }\\n  .m-md-3 {\\n    margin: 1rem !important; }\\n  .mt-md-3,\\n  .my-md-3 {\\n    margin-top: 1rem !important; }\\n  .mr-md-3,\\n  .mx-md-3 {\\n    margin-right: 1rem !important; }\\n  .mb-md-3,\\n  .my-md-3 {\\n    margin-bottom: 1rem !important; }\\n  .ml-md-3,\\n  .mx-md-3 {\\n    margin-left: 1rem !important; }\\n  .m-md-4 {\\n    margin: 1.5rem !important; }\\n  .mt-md-4,\\n  .my-md-4 {\\n    margin-top: 1.5rem !important; }\\n  .mr-md-4,\\n  .mx-md-4 {\\n    margin-right: 1.5rem !important; }\\n  .mb-md-4,\\n  .my-md-4 {\\n    margin-bottom: 1.5rem !important; }\\n  .ml-md-4,\\n  .mx-md-4 {\\n    margin-left: 1.5rem !important; }\\n  .m-md-5 {\\n    margin: 3rem !important; }\\n  .mt-md-5,\\n  .my-md-5 {\\n    margin-top: 3rem !important; }\\n  .mr-md-5,\\n  .mx-md-5 {\\n    margin-right: 3rem !important; }\\n  .mb-md-5,\\n  .my-md-5 {\\n    margin-bottom: 3rem !important; }\\n  .ml-md-5,\\n  .mx-md-5 {\\n    margin-left: 3rem !important; }\\n  .p-md-0 {\\n    padding: 0 !important; }\\n  .pt-md-0,\\n  .py-md-0 {\\n    padding-top: 0 !important; }\\n  .pr-md-0,\\n  .px-md-0 {\\n    padding-right: 0 !important; }\\n  .pb-md-0,\\n  .py-md-0 {\\n    padding-bottom: 0 !important; }\\n  .pl-md-0,\\n  .px-md-0 {\\n    padding-left: 0 !important; }\\n  .p-md-1 {\\n    padding: 0.25rem !important; }\\n  .pt-md-1,\\n  .py-md-1 {\\n    padding-top: 0.25rem !important; }\\n  .pr-md-1,\\n  .px-md-1 {\\n    padding-right: 0.25rem !important; }\\n  .pb-md-1,\\n  .py-md-1 {\\n    padding-bottom: 0.25rem !important; }\\n  .pl-md-1,\\n  .px-md-1 {\\n    padding-left: 0.25rem !important; }\\n  .p-md-2 {\\n    padding: 0.5rem !important; }\\n  .pt-md-2,\\n  .py-md-2 {\\n    padding-top: 0.5rem !important; }\\n  .pr-md-2,\\n  .px-md-2 {\\n    padding-right: 0.5rem !important; }\\n  .pb-md-2,\\n  .py-md-2 {\\n    padding-bottom: 0.5rem !important; }\\n  .pl-md-2,\\n  .px-md-2 {\\n    padding-left: 0.5rem !important; }\\n  .p-md-3 {\\n    padding: 1rem !important; }\\n  .pt-md-3,\\n  .py-md-3 {\\n    padding-top: 1rem !important; }\\n  .pr-md-3,\\n  .px-md-3 {\\n    padding-right: 1rem !important; }\\n  .pb-md-3,\\n  .py-md-3 {\\n    padding-bottom: 1rem !important; }\\n  .pl-md-3,\\n  .px-md-3 {\\n    padding-left: 1rem !important; }\\n  .p-md-4 {\\n    padding: 1.5rem !important; }\\n  .pt-md-4,\\n  .py-md-4 {\\n    padding-top: 1.5rem !important; }\\n  .pr-md-4,\\n  .px-md-4 {\\n    padding-right: 1.5rem !important; }\\n  .pb-md-4,\\n  .py-md-4 {\\n    padding-bottom: 1.5rem !important; }\\n  .pl-md-4,\\n  .px-md-4 {\\n    padding-left: 1.5rem !important; }\\n  .p-md-5 {\\n    padding: 3rem !important; }\\n  .pt-md-5,\\n  .py-md-5 {\\n    padding-top: 3rem !important; }\\n  .pr-md-5,\\n  .px-md-5 {\\n    padding-right: 3rem !important; }\\n  .pb-md-5,\\n  .py-md-5 {\\n    padding-bottom: 3rem !important; }\\n  .pl-md-5,\\n  .px-md-5 {\\n    padding-left: 3rem !important; }\\n  .m-md-n1 {\\n    margin: -0.25rem !important; }\\n  .mt-md-n1,\\n  .my-md-n1 {\\n    margin-top: -0.25rem !important; }\\n  .mr-md-n1,\\n  .mx-md-n1 {\\n    margin-right: -0.25rem !important; }\\n  .mb-md-n1,\\n  .my-md-n1 {\\n    margin-bottom: -0.25rem !important; }\\n  .ml-md-n1,\\n  .mx-md-n1 {\\n    margin-left: -0.25rem !important; }\\n  .m-md-n2 {\\n    margin: -0.5rem !important; }\\n  .mt-md-n2,\\n  .my-md-n2 {\\n    margin-top: -0.5rem !important; }\\n  .mr-md-n2,\\n  .mx-md-n2 {\\n    margin-right: -0.5rem !important; }\\n  .mb-md-n2,\\n  .my-md-n2 {\\n    margin-bottom: -0.5rem !important; }\\n  .ml-md-n2,\\n  .mx-md-n2 {\\n    margin-left: -0.5rem !important; }\\n  .m-md-n3 {\\n    margin: -1rem !important; }\\n  .mt-md-n3,\\n  .my-md-n3 {\\n    margin-top: -1rem !important; }\\n  .mr-md-n3,\\n  .mx-md-n3 {\\n    margin-right: -1rem !important; }\\n  .mb-md-n3,\\n  .my-md-n3 {\\n    margin-bottom: -1rem !important; }\\n  .ml-md-n3,\\n  .mx-md-n3 {\\n    margin-left: -1rem !important; }\\n  .m-md-n4 {\\n    margin: -1.5rem !important; }\\n  .mt-md-n4,\\n  .my-md-n4 {\\n    margin-top: -1.5rem !important; }\\n  .mr-md-n4,\\n  .mx-md-n4 {\\n    margin-right: -1.5rem !important; }\\n  .mb-md-n4,\\n  .my-md-n4 {\\n    margin-bottom: -1.5rem !important; }\\n  .ml-md-n4,\\n  .mx-md-n4 {\\n    margin-left: -1.5rem !important; }\\n  .m-md-n5 {\\n    margin: -3rem !important; }\\n  .mt-md-n5,\\n  .my-md-n5 {\\n    margin-top: -3rem !important; }\\n  .mr-md-n5,\\n  .mx-md-n5 {\\n    margin-right: -3rem !important; }\\n  .mb-md-n5,\\n  .my-md-n5 {\\n    margin-bottom: -3rem !important; }\\n  .ml-md-n5,\\n  .mx-md-n5 {\\n    margin-left: -3rem !important; }\\n  .m-md-auto {\\n    margin: auto !important; }\\n  .mt-md-auto,\\n  .my-md-auto {\\n    margin-top: auto !important; }\\n  .mr-md-auto,\\n  .mx-md-auto {\\n    margin-right: auto !important; }\\n  .mb-md-auto,\\n  .my-md-auto {\\n    margin-bottom: auto !important; }\\n  .ml-md-auto,\\n  .mx-md-auto {\\n    margin-left: auto !important; } }\\n\\n@media (min-width: 992px) {\\n  .m-lg-0 {\\n    margin: 0 !important; }\\n  .mt-lg-0,\\n  .my-lg-0 {\\n    margin-top: 0 !important; }\\n  .mr-lg-0,\\n  .mx-lg-0 {\\n    margin-right: 0 !important; }\\n  .mb-lg-0,\\n  .my-lg-0 {\\n    margin-bottom: 0 !important; }\\n  .ml-lg-0,\\n  .mx-lg-0 {\\n    margin-left: 0 !important; }\\n  .m-lg-1 {\\n    margin: 0.25rem !important; }\\n  .mt-lg-1,\\n  .my-lg-1 {\\n    margin-top: 0.25rem !important; }\\n  .mr-lg-1,\\n  .mx-lg-1 {\\n    margin-right: 0.25rem !important; }\\n  .mb-lg-1,\\n  .my-lg-1 {\\n    margin-bottom: 0.25rem !important; }\\n  .ml-lg-1,\\n  .mx-lg-1 {\\n    margin-left: 0.25rem !important; }\\n  .m-lg-2 {\\n    margin: 0.5rem !important; }\\n  .mt-lg-2,\\n  .my-lg-2 {\\n    margin-top: 0.5rem !important; }\\n  .mr-lg-2,\\n  .mx-lg-2 {\\n    margin-right: 0.5rem !important; }\\n  .mb-lg-2,\\n  .my-lg-2 {\\n    margin-bottom: 0.5rem !important; }\\n  .ml-lg-2,\\n  .mx-lg-2 {\\n    margin-left: 0.5rem !important; }\\n  .m-lg-3 {\\n    margin: 1rem !important; }\\n  .mt-lg-3,\\n  .my-lg-3 {\\n    margin-top: 1rem !important; }\\n  .mr-lg-3,\\n  .mx-lg-3 {\\n    margin-right: 1rem !important; }\\n  .mb-lg-3,\\n  .my-lg-3 {\\n    margin-bottom: 1rem !important; }\\n  .ml-lg-3,\\n  .mx-lg-3 {\\n    margin-left: 1rem !important; }\\n  .m-lg-4 {\\n    margin: 1.5rem !important; }\\n  .mt-lg-4,\\n  .my-lg-4 {\\n    margin-top: 1.5rem !important; }\\n  .mr-lg-4,\\n  .mx-lg-4 {\\n    margin-right: 1.5rem !important; }\\n  .mb-lg-4,\\n  .my-lg-4 {\\n    margin-bottom: 1.5rem !important; }\\n  .ml-lg-4,\\n  .mx-lg-4 {\\n    margin-left: 1.5rem !important; }\\n  .m-lg-5 {\\n    margin: 3rem !important; }\\n  .mt-lg-5,\\n  .my-lg-5 {\\n    margin-top: 3rem !important; }\\n  .mr-lg-5,\\n  .mx-lg-5 {\\n    margin-right: 3rem !important; }\\n  .mb-lg-5,\\n  .my-lg-5 {\\n    margin-bottom: 3rem !important; }\\n  .ml-lg-5,\\n  .mx-lg-5 {\\n    margin-left: 3rem !important; }\\n  .p-lg-0 {\\n    padding: 0 !important; }\\n  .pt-lg-0,\\n  .py-lg-0 {\\n    padding-top: 0 !important; }\\n  .pr-lg-0,\\n  .px-lg-0 {\\n    padding-right: 0 !important; }\\n  .pb-lg-0,\\n  .py-lg-0 {\\n    padding-bottom: 0 !important; }\\n  .pl-lg-0,\\n  .px-lg-0 {\\n    padding-left: 0 !important; }\\n  .p-lg-1 {\\n    padding: 0.25rem !important; }\\n  .pt-lg-1,\\n  .py-lg-1 {\\n    padding-top: 0.25rem !important; }\\n  .pr-lg-1,\\n  .px-lg-1 {\\n    padding-right: 0.25rem !important; }\\n  .pb-lg-1,\\n  .py-lg-1 {\\n    padding-bottom: 0.25rem !important; }\\n  .pl-lg-1,\\n  .px-lg-1 {\\n    padding-left: 0.25rem !important; }\\n  .p-lg-2 {\\n    padding: 0.5rem !important; }\\n  .pt-lg-2,\\n  .py-lg-2 {\\n    padding-top: 0.5rem !important; }\\n  .pr-lg-2,\\n  .px-lg-2 {\\n    padding-right: 0.5rem !important; }\\n  .pb-lg-2,\\n  .py-lg-2 {\\n    padding-bottom: 0.5rem !important; }\\n  .pl-lg-2,\\n  .px-lg-2 {\\n    padding-left: 0.5rem !important; }\\n  .p-lg-3 {\\n    padding: 1rem !important; }\\n  .pt-lg-3,\\n  .py-lg-3 {\\n    padding-top: 1rem !important; }\\n  .pr-lg-3,\\n  .px-lg-3 {\\n    padding-right: 1rem !important; }\\n  .pb-lg-3,\\n  .py-lg-3 {\\n    padding-bottom: 1rem !important; }\\n  .pl-lg-3,\\n  .px-lg-3 {\\n    padding-left: 1rem !important; }\\n  .p-lg-4 {\\n    padding: 1.5rem !important; }\\n  .pt-lg-4,\\n  .py-lg-4 {\\n    padding-top: 1.5rem !important; }\\n  .pr-lg-4,\\n  .px-lg-4 {\\n    padding-right: 1.5rem !important; }\\n  .pb-lg-4,\\n  .py-lg-4 {\\n    padding-bottom: 1.5rem !important; }\\n  .pl-lg-4,\\n  .px-lg-4 {\\n    padding-left: 1.5rem !important; }\\n  .p-lg-5 {\\n    padding: 3rem !important; }\\n  .pt-lg-5,\\n  .py-lg-5 {\\n    padding-top: 3rem !important; }\\n  .pr-lg-5,\\n  .px-lg-5 {\\n    padding-right: 3rem !important; }\\n  .pb-lg-5,\\n  .py-lg-5 {\\n    padding-bottom: 3rem !important; }\\n  .pl-lg-5,\\n  .px-lg-5 {\\n    padding-left: 3rem !important; }\\n  .m-lg-n1 {\\n    margin: -0.25rem !important; }\\n  .mt-lg-n1,\\n  .my-lg-n1 {\\n    margin-top: -0.25rem !important; }\\n  .mr-lg-n1,\\n  .mx-lg-n1 {\\n    margin-right: -0.25rem !important; }\\n  .mb-lg-n1,\\n  .my-lg-n1 {\\n    margin-bottom: -0.25rem !important; }\\n  .ml-lg-n1,\\n  .mx-lg-n1 {\\n    margin-left: -0.25rem !important; }\\n  .m-lg-n2 {\\n    margin: -0.5rem !important; }\\n  .mt-lg-n2,\\n  .my-lg-n2 {\\n    margin-top: -0.5rem !important; }\\n  .mr-lg-n2,\\n  .mx-lg-n2 {\\n    margin-right: -0.5rem !important; }\\n  .mb-lg-n2,\\n  .my-lg-n2 {\\n    margin-bottom: -0.5rem !important; }\\n  .ml-lg-n2,\\n  .mx-lg-n2 {\\n    margin-left: -0.5rem !important; }\\n  .m-lg-n3 {\\n    margin: -1rem !important; }\\n  .mt-lg-n3,\\n  .my-lg-n3 {\\n    margin-top: -1rem !important; }\\n  .mr-lg-n3,\\n  .mx-lg-n3 {\\n    margin-right: -1rem !important; }\\n  .mb-lg-n3,\\n  .my-lg-n3 {\\n    margin-bottom: -1rem !important; }\\n  .ml-lg-n3,\\n  .mx-lg-n3 {\\n    margin-left: -1rem !important; }\\n  .m-lg-n4 {\\n    margin: -1.5rem !important; }\\n  .mt-lg-n4,\\n  .my-lg-n4 {\\n    margin-top: -1.5rem !important; }\\n  .mr-lg-n4,\\n  .mx-lg-n4 {\\n    margin-right: -1.5rem !important; }\\n  .mb-lg-n4,\\n  .my-lg-n4 {\\n    margin-bottom: -1.5rem !important; }\\n  .ml-lg-n4,\\n  .mx-lg-n4 {\\n    margin-left: -1.5rem !important; }\\n  .m-lg-n5 {\\n    margin: -3rem !important; }\\n  .mt-lg-n5,\\n  .my-lg-n5 {\\n    margin-top: -3rem !important; }\\n  .mr-lg-n5,\\n  .mx-lg-n5 {\\n    margin-right: -3rem !important; }\\n  .mb-lg-n5,\\n  .my-lg-n5 {\\n    margin-bottom: -3rem !important; }\\n  .ml-lg-n5,\\n  .mx-lg-n5 {\\n    margin-left: -3rem !important; }\\n  .m-lg-auto {\\n    margin: auto !important; }\\n  .mt-lg-auto,\\n  .my-lg-auto {\\n    margin-top: auto !important; }\\n  .mr-lg-auto,\\n  .mx-lg-auto {\\n    margin-right: auto !important; }\\n  .mb-lg-auto,\\n  .my-lg-auto {\\n    margin-bottom: auto !important; }\\n  .ml-lg-auto,\\n  .mx-lg-auto {\\n    margin-left: auto !important; } }\\n\\n@media (min-width: 1200px) {\\n  .m-xl-0 {\\n    margin: 0 !important; }\\n  .mt-xl-0,\\n  .my-xl-0 {\\n    margin-top: 0 !important; }\\n  .mr-xl-0,\\n  .mx-xl-0 {\\n    margin-right: 0 !important; }\\n  .mb-xl-0,\\n  .my-xl-0 {\\n    margin-bottom: 0 !important; }\\n  .ml-xl-0,\\n  .mx-xl-0 {\\n    margin-left: 0 !important; }\\n  .m-xl-1 {\\n    margin: 0.25rem !important; }\\n  .mt-xl-1,\\n  .my-xl-1 {\\n    margin-top: 0.25rem !important; }\\n  .mr-xl-1,\\n  .mx-xl-1 {\\n    margin-right: 0.25rem !important; }\\n  .mb-xl-1,\\n  .my-xl-1 {\\n    margin-bottom: 0.25rem !important; }\\n  .ml-xl-1,\\n  .mx-xl-1 {\\n    margin-left: 0.25rem !important; }\\n  .m-xl-2 {\\n    margin: 0.5rem !important; }\\n  .mt-xl-2,\\n  .my-xl-2 {\\n    margin-top: 0.5rem !important; }\\n  .mr-xl-2,\\n  .mx-xl-2 {\\n    margin-right: 0.5rem !important; }\\n  .mb-xl-2,\\n  .my-xl-2 {\\n    margin-bottom: 0.5rem !important; }\\n  .ml-xl-2,\\n  .mx-xl-2 {\\n    margin-left: 0.5rem !important; }\\n  .m-xl-3 {\\n    margin: 1rem !important; }\\n  .mt-xl-3,\\n  .my-xl-3 {\\n    margin-top: 1rem !important; }\\n  .mr-xl-3,\\n  .mx-xl-3 {\\n    margin-right: 1rem !important; }\\n  .mb-xl-3,\\n  .my-xl-3 {\\n    margin-bottom: 1rem !important; }\\n  .ml-xl-3,\\n  .mx-xl-3 {\\n    margin-left: 1rem !important; }\\n  .m-xl-4 {\\n    margin: 1.5rem !important; }\\n  .mt-xl-4,\\n  .my-xl-4 {\\n    margin-top: 1.5rem !important; }\\n  .mr-xl-4,\\n  .mx-xl-4 {\\n    margin-right: 1.5rem !important; }\\n  .mb-xl-4,\\n  .my-xl-4 {\\n    margin-bottom: 1.5rem !important; }\\n  .ml-xl-4,\\n  .mx-xl-4 {\\n    margin-left: 1.5rem !important; }\\n  .m-xl-5 {\\n    margin: 3rem !important; }\\n  .mt-xl-5,\\n  .my-xl-5 {\\n    margin-top: 3rem !important; }\\n  .mr-xl-5,\\n  .mx-xl-5 {\\n    margin-right: 3rem !important; }\\n  .mb-xl-5,\\n  .my-xl-5 {\\n    margin-bottom: 3rem !important; }\\n  .ml-xl-5,\\n  .mx-xl-5 {\\n    margin-left: 3rem !important; }\\n  .p-xl-0 {\\n    padding: 0 !important; }\\n  .pt-xl-0,\\n  .py-xl-0 {\\n    padding-top: 0 !important; }\\n  .pr-xl-0,\\n  .px-xl-0 {\\n    padding-right: 0 !important; }\\n  .pb-xl-0,\\n  .py-xl-0 {\\n    padding-bottom: 0 !important; }\\n  .pl-xl-0,\\n  .px-xl-0 {\\n    padding-left: 0 !important; }\\n  .p-xl-1 {\\n    padding: 0.25rem !important; }\\n  .pt-xl-1,\\n  .py-xl-1 {\\n    padding-top: 0.25rem !important; }\\n  .pr-xl-1,\\n  .px-xl-1 {\\n    padding-right: 0.25rem !important; }\\n  .pb-xl-1,\\n  .py-xl-1 {\\n    padding-bottom: 0.25rem !important; }\\n  .pl-xl-1,\\n  .px-xl-1 {\\n    padding-left: 0.25rem !important; }\\n  .p-xl-2 {\\n    padding: 0.5rem !important; }\\n  .pt-xl-2,\\n  .py-xl-2 {\\n    padding-top: 0.5rem !important; }\\n  .pr-xl-2,\\n  .px-xl-2 {\\n    padding-right: 0.5rem !important; }\\n  .pb-xl-2,\\n  .py-xl-2 {\\n    padding-bottom: 0.5rem !important; }\\n  .pl-xl-2,\\n  .px-xl-2 {\\n    padding-left: 0.5rem !important; }\\n  .p-xl-3 {\\n    padding: 1rem !important; }\\n  .pt-xl-3,\\n  .py-xl-3 {\\n    padding-top: 1rem !important; }\\n  .pr-xl-3,\\n  .px-xl-3 {\\n    padding-right: 1rem !important; }\\n  .pb-xl-3,\\n  .py-xl-3 {\\n    padding-bottom: 1rem !important; }\\n  .pl-xl-3,\\n  .px-xl-3 {\\n    padding-left: 1rem !important; }\\n  .p-xl-4 {\\n    padding: 1.5rem !important; }\\n  .pt-xl-4,\\n  .py-xl-4 {\\n    padding-top: 1.5rem !important; }\\n  .pr-xl-4,\\n  .px-xl-4 {\\n    padding-right: 1.5rem !important; }\\n  .pb-xl-4,\\n  .py-xl-4 {\\n    padding-bottom: 1.5rem !important; }\\n  .pl-xl-4,\\n  .px-xl-4 {\\n    padding-left: 1.5rem !important; }\\n  .p-xl-5 {\\n    padding: 3rem !important; }\\n  .pt-xl-5,\\n  .py-xl-5 {\\n    padding-top: 3rem !important; }\\n  .pr-xl-5,\\n  .px-xl-5 {\\n    padding-right: 3rem !important; }\\n  .pb-xl-5,\\n  .py-xl-5 {\\n    padding-bottom: 3rem !important; }\\n  .pl-xl-5,\\n  .px-xl-5 {\\n    padding-left: 3rem !important; }\\n  .m-xl-n1 {\\n    margin: -0.25rem !important; }\\n  .mt-xl-n1,\\n  .my-xl-n1 {\\n    margin-top: -0.25rem !important; }\\n  .mr-xl-n1,\\n  .mx-xl-n1 {\\n    margin-right: -0.25rem !important; }\\n  .mb-xl-n1,\\n  .my-xl-n1 {\\n    margin-bottom: -0.25rem !important; }\\n  .ml-xl-n1,\\n  .mx-xl-n1 {\\n    margin-left: -0.25rem !important; }\\n  .m-xl-n2 {\\n    margin: -0.5rem !important; }\\n  .mt-xl-n2,\\n  .my-xl-n2 {\\n    margin-top: -0.5rem !important; }\\n  .mr-xl-n2,\\n  .mx-xl-n2 {\\n    margin-right: -0.5rem !important; }\\n  .mb-xl-n2,\\n  .my-xl-n2 {\\n    margin-bottom: -0.5rem !important; }\\n  .ml-xl-n2,\\n  .mx-xl-n2 {\\n    margin-left: -0.5rem !important; }\\n  .m-xl-n3 {\\n    margin: -1rem !important; }\\n  .mt-xl-n3,\\n  .my-xl-n3 {\\n    margin-top: -1rem !important; }\\n  .mr-xl-n3,\\n  .mx-xl-n3 {\\n    margin-right: -1rem !important; }\\n  .mb-xl-n3,\\n  .my-xl-n3 {\\n    margin-bottom: -1rem !important; }\\n  .ml-xl-n3,\\n  .mx-xl-n3 {\\n    margin-left: -1rem !important; }\\n  .m-xl-n4 {\\n    margin: -1.5rem !important; }\\n  .mt-xl-n4,\\n  .my-xl-n4 {\\n    margin-top: -1.5rem !important; }\\n  .mr-xl-n4,\\n  .mx-xl-n4 {\\n    margin-right: -1.5rem !important; }\\n  .mb-xl-n4,\\n  .my-xl-n4 {\\n    margin-bottom: -1.5rem !important; }\\n  .ml-xl-n4,\\n  .mx-xl-n4 {\\n    margin-left: -1.5rem !important; }\\n  .m-xl-n5 {\\n    margin: -3rem !important; }\\n  .mt-xl-n5,\\n  .my-xl-n5 {\\n    margin-top: -3rem !important; }\\n  .mr-xl-n5,\\n  .mx-xl-n5 {\\n    margin-right: -3rem !important; }\\n  .mb-xl-n5,\\n  .my-xl-n5 {\\n    margin-bottom: -3rem !important; }\\n  .ml-xl-n5,\\n  .mx-xl-n5 {\\n    margin-left: -3rem !important; }\\n  .m-xl-auto {\\n    margin: auto !important; }\\n  .mt-xl-auto,\\n  .my-xl-auto {\\n    margin-top: auto !important; }\\n  .mr-xl-auto,\\n  .mx-xl-auto {\\n    margin-right: auto !important; }\\n  .mb-xl-auto,\\n  .my-xl-auto {\\n    margin-bottom: auto !important; }\\n  .ml-xl-auto,\\n  .mx-xl-auto {\\n    margin-left: auto !important; } }\\n\\n.stretched-link::after {\\n  position: absolute;\\n  top: 0;\\n  right: 0;\\n  bottom: 0;\\n  left: 0;\\n  z-index: 1;\\n  pointer-events: auto;\\n  content: \\\"\\\";\\n  background-color: rgba(0, 0, 0, 0); }\\n\\n.text-monospace {\\n  font-family: SFMono-Regular, Menlo, Monaco, Consolas, \\\"Liberation Mono\\\", \\\"Courier New\\\", monospace !important; }\\n\\n.text-justify {\\n  text-align: justify !important; }\\n\\n.text-wrap {\\n  white-space: normal !important; }\\n\\n.text-nowrap {\\n  white-space: nowrap !important; }\\n\\n.text-truncate {\\n  overflow: hidden;\\n  text-overflow: ellipsis;\\n  white-space: nowrap; }\\n\\n.text-left {\\n  text-align: left !important; }\\n\\n.text-right {\\n  text-align: right !important; }\\n\\n.text-center {\\n  text-align: center !important; }\\n\\n@media (min-width: 576px) {\\n  .text-sm-left {\\n    text-align: left !important; }\\n  .text-sm-right {\\n    text-align: right !important; }\\n  .text-sm-center {\\n    text-align: center !important; } }\\n\\n@media (min-width: 768px) {\\n  .text-md-left {\\n    text-align: left !important; }\\n  .text-md-right {\\n    text-align: right !important; }\\n  .text-md-center {\\n    text-align: center !important; } }\\n\\n@media (min-width: 992px) {\\n  .text-lg-left {\\n    text-align: left !important; }\\n  .text-lg-right {\\n    text-align: right !important; }\\n  .text-lg-center {\\n    text-align: center !important; } }\\n\\n@media (min-width: 1200px) {\\n  .text-xl-left {\\n    text-align: left !important; }\\n  .text-xl-right {\\n    text-align: right !important; }\\n  .text-xl-center {\\n    text-align: center !important; } }\\n\\n.text-lowercase {\\n  text-transform: lowercase !important; }\\n\\n.text-uppercase {\\n  text-transform: uppercase !important; }\\n\\n.text-capitalize {\\n  text-transform: capitalize !important; }\\n\\n.font-weight-light {\\n  font-weight: 300 !important; }\\n\\n.font-weight-lighter {\\n  font-weight: lighter !important; }\\n\\n.font-weight-normal {\\n  font-weight: 400 !important; }\\n\\n.font-weight-bold {\\n  font-weight: 700 !important; }\\n\\n.font-weight-bolder {\\n  font-weight: bolder !important; }\\n\\n.font-italic {\\n  font-style: italic !important; }\\n\\n.text-white {\\n  color: #fff !important; }\\n\\n.text-primary {\\n  color: #a23422 !important; }\\n\\na.text-primary:hover, a.text-primary:focus {\\n  color: #632015 !important; }\\n\\n.text-secondary {\\n  color: #6c757d !important; }\\n\\na.text-secondary:hover, a.text-secondary:focus {\\n  color: #494f54 !important; }\\n\\n.text-success {\\n  color: #28a745 !important; }\\n\\na.text-success:hover, a.text-success:focus {\\n  color: #19692c !important; }\\n\\n.text-info {\\n  color: #17a2b8 !important; }\\n\\na.text-info:hover, a.text-info:focus {\\n  color: #0f6674 !important; }\\n\\n.text-warning {\\n  color: #ffc107 !important; }\\n\\na.text-warning:hover, a.text-warning:focus {\\n  color: #ba8b00 !important; }\\n\\n.text-danger {\\n  color: #dc3545 !important; }\\n\\na.text-danger:hover, a.text-danger:focus {\\n  color: #a71d2a !important; }\\n\\n.text-light {\\n  color: #f8f9fa !important; }\\n\\na.text-light:hover, a.text-light:focus {\\n  color: #cbd3da !important; }\\n\\n.text-dark {\\n  color: #343a40 !important; }\\n\\na.text-dark:hover, a.text-dark:focus {\\n  color: #121416 !important; }\\n\\n.text-primary-light-dark {\\n  color: #b33926 !important; }\\n\\na.text-primary-light-dark:hover, a.text-primary-light-dark:focus {\\n  color: #742518 !important; }\\n\\n.text-primary-dark {\\n  color: #912f1e !important; }\\n\\na.text-primary-dark:hover, a.text-primary-dark:focus {\\n  color: #521a11 !important; }\\n\\n.text-body {\\n  color: #212529 !important; }\\n\\n.text-muted {\\n  color: #6c757d !important; }\\n\\n.text-black-50 {\\n  color: rgba(0, 0, 0, 0.5) !important; }\\n\\n.text-white-50 {\\n  color: rgba(255, 255, 255, 0.5) !important; }\\n\\n.text-hide {\\n  font: 0/0 a;\\n  color: transparent;\\n  text-shadow: none;\\n  background-color: transparent;\\n  border: 0; }\\n\\n.text-decoration-none {\\n  text-decoration: none !important; }\\n\\n.text-break {\\n  word-wrap: break-word !important; }\\n\\n.text-reset {\\n  color: inherit !important; }\\n\\n.visible {\\n  visibility: visible !important; }\\n\\n.invisible {\\n  visibility: hidden !important; }\\n\\n@media print {\\n  *,\\n  *::before,\\n  *::after {\\n    text-shadow: none !important;\\n    box-shadow: none !important; }\\n  a:not(.btn) {\\n    text-decoration: underline; }\\n  abbr[title]::after {\\n    content: \\\" (\\\" attr(title) \\\")\\\"; }\\n  pre {\\n    white-space: pre-wrap !important; }\\n  pre,\\n  blockquote {\\n    border: 1px solid #adb5bd;\\n    page-break-inside: avoid; }\\n  thead {\\n    display: table-header-group; }\\n  tr,\\n  img {\\n    page-break-inside: avoid; }\\n  p,\\n  h2,\\n  h3 {\\n    orphans: 3;\\n    widows: 3; }\\n  h2,\\n  h3 {\\n    page-break-after: avoid; }\\n  @page {\\n    size: a3; }\\n  body {\\n    min-width: 992px !important; }\\n  .container {\\n    min-width: 992px !important; }\\n  .navbar {\\n    display: none; }\\n  .badge {\\n    border: 1px solid #000; }\\n  .table {\\n    border-collapse: collapse !important; }\\n    .table td,\\n    .table th {\\n      background-color: #fff !important; }\\n  .table-bordered th,\\n  .table-bordered td {\\n    border: 1px solid #dee2e6 !important; }\\n  .table-dark {\\n    color: inherit; }\\n    .table-dark th,\\n    .table-dark td,\\n    .table-dark thead th,\\n    .table-dark tbody + tbody {\\n      border-color: #dee2e6; }\\n  .table .thead-dark th {\\n    color: inherit;\\n    border-color: #dee2e6; } }\\n\\n.bv-no-focus-ring:focus {\\n  outline: none; }\\n\\n@media (max-width: 575.98px) {\\n  .bv-d-xs-down-none {\\n    display: none !important; } }\\n\\n@media (max-width: 767.98px) {\\n  .bv-d-sm-down-none {\\n    display: none !important; } }\\n\\n@media (max-width: 991.98px) {\\n  .bv-d-md-down-none {\\n    display: none !important; } }\\n\\n@media (max-width: 1199.98px) {\\n  .bv-d-lg-down-none {\\n    display: none !important; } }\\n\\n.bv-d-xl-down-none {\\n  display: none !important; }\\n\\n.form-control.focus {\\n  color: #495057;\\n  background-color: #fff;\\n  border-color: #df7665;\\n  outline: 0;\\n  box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .form-control.focus.is-valid {\\n    border-color: #28a745;\\n    box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.25); }\\n  .form-control.focus.is-invalid {\\n    border-color: #dc3545;\\n    box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.25); }\\n\\n.b-form-btn-label-control.form-control {\\n  background-image: none;\\n  padding: 0; }\\n  .input-group .b-form-btn-label-control.form-control {\\n    padding: 0; }\\n  [dir=\\\"rtl\\\"] .b-form-btn-label-control.form-control, .b-form-btn-label-control.form-control[dir=\\\"rtl\\\"] {\\n    flex-direction: row-reverse; }\\n    [dir=\\\"rtl\\\"] .b-form-btn-label-control.form-control > label, .b-form-btn-label-control.form-control[dir=\\\"rtl\\\"] > label {\\n      text-align: right; }\\n  .b-form-btn-label-control.form-control > .btn {\\n    line-height: 1;\\n    font-size: inherit;\\n    box-shadow: none !important;\\n    border: 0; }\\n    .b-form-btn-label-control.form-control > .btn:disabled {\\n      pointer-events: none; }\\n  .b-form-btn-label-control.form-control.is-valid > .btn {\\n    color: #28a745; }\\n  .b-form-btn-label-control.form-control.is-invalid > .btn {\\n    color: #dc3545; }\\n  .b-form-btn-label-control.form-control > .dropdown-menu {\\n    padding: 0.5rem; }\\n  .b-form-btn-label-control.form-control > label {\\n    outline: 0;\\n    padding-left: 0.25rem;\\n    margin: 0;\\n    border: 0;\\n    font-size: inherit;\\n    cursor: pointer;\\n    min-height: calc(calc(1.5em + 0.75rem + 2px) - 2px); }\\n    .b-form-btn-label-control.form-control > label.form-control-sm {\\n      min-height: calc(calc(1.5em + 0.5rem + 2px) - 2px); }\\n    .b-form-btn-label-control.form-control > label.form-control-lg {\\n      min-height: calc(calc(1.5em + 1rem + 2px) - 2px); }\\n    .input-group.input-group-sm .b-form-btn-label-control.form-control > label {\\n      min-height: calc(calc(1.5em + 0.5rem + 2px) - 2px);\\n      padding-top: 0.25rem;\\n      padding-bottom: 0.25rem; }\\n    .input-group.input-group-lg .b-form-btn-label-control.form-control > label {\\n      min-height: calc(calc(1.5em + 1rem + 2px) - 2px);\\n      padding-top: 0.5rem;\\n      padding-bottom: 0.5rem; }\\n  .b-form-btn-label-control.form-control[aria-disabled=\\\"true\\\"], .b-form-btn-label-control.form-control[aria-readonly=\\\"true\\\"] {\\n    background-color: #e9ecef;\\n    opacity: 1; }\\n  .b-form-btn-label-control.form-control[aria-disabled=\\\"true\\\"] {\\n    pointer-events: none; }\\n    .b-form-btn-label-control.form-control[aria-disabled=\\\"true\\\"] > label {\\n      cursor: default; }\\n\\n.b-form-btn-label-control.btn-group > .dropdown-menu {\\n  padding: 0.5rem; }\\n\\n.b-avatar {\\n  display: inline-flex;\\n  align-items: center;\\n  justify-content: center;\\n  vertical-align: middle;\\n  font-size: inherit;\\n  font-weight: 400;\\n  line-height: 1;\\n  max-width: 100%;\\n  max-height: auto;\\n  text-align: center;\\n  overflow: visible;\\n  position: relative;\\n  transition: color 0.15s ease-in-out, background-color 0.15s ease-in-out,\\r box-shadow 0.15s ease-in-out; }\\n  .b-avatar:focus {\\n    outline: 0; }\\n  .b-avatar.btn, .b-avatar[href] {\\n    padding: 0;\\n    border: 0; }\\n    .b-avatar.btn .b-avatar-img img, .b-avatar[href] .b-avatar-img img {\\n      transition: transform 0.15s ease-in-out; }\\n    .b-avatar.btn:not(:disabled):not(.disabled), .b-avatar[href]:not(:disabled):not(.disabled) {\\n      cursor: pointer; }\\n      .b-avatar.btn:not(:disabled):not(.disabled):hover .b-avatar-img img, .b-avatar[href]:not(:disabled):not(.disabled):hover .b-avatar-img img {\\n        transform: scale(1.15); }\\n  .b-avatar.disabled, .b-avatar:disabled, .b-avatar[disabled] {\\n    opacity: 0.65;\\n    pointer-events: none; }\\n  .b-avatar .b-avatar-custom,\\n  .b-avatar .b-avatar-text,\\n  .b-avatar .b-avatar-img {\\n    border-radius: inherit;\\n    width: 100%;\\n    height: 100%;\\n    overflow: hidden;\\n    display: flex;\\n    justify-content: center;\\n    align-items: center; }\\n  .b-avatar .b-avatar-text {\\n    text-transform: uppercase;\\n    white-space: nowrap; }\\n  .b-avatar[href] {\\n    text-decoration: none; }\\n  .b-avatar > .b-icon {\\n    width: 60%;\\n    height: auto;\\n    max-width: 100%; }\\n  .b-avatar .b-avatar-img img {\\n    width: 100%;\\n    height: 100%;\\n    max-height: auto;\\n    border-radius: inherit; }\\n  .b-avatar .b-avatar-badge {\\n    position: absolute;\\n    min-height: 1.5em;\\n    min-width: 1.5em;\\n    padding: 0.25em;\\n    line-height: 1;\\n    border-radius: 10em;\\n    font-size: 70%;\\n    font-weight: 700;\\n    z-index: 5; }\\n\\n.b-avatar-group .b-avatar-group-inner {\\n  display: flex;\\n  flex-wrap: wrap; }\\n\\n.b-avatar-group .b-avatar {\\n  border: 1px solid #dee2e6; }\\n\\n.b-avatar-group a.b-avatar:hover:not(.disabled):not(disabled),\\n.b-avatar-group .btn.b-avatar:hover:not(.disabled):not(disabled) {\\n  z-index: 3; }\\n\\n.b-calendar {\\n  display: inline-flex; }\\n  .b-calendar .b-calendar-inner {\\n    min-width: 250px; }\\n  .b-calendar .b-calendar-header,\\n  .b-calendar .b-calendar-nav {\\n    margin-bottom: 0.25rem; }\\n  .b-calendar .b-calendar-nav .btn {\\n    padding: 0.25rem; }\\n  .b-calendar output {\\n    padding: 0.25rem;\\n    font-size: 80%; }\\n    .b-calendar output.readonly {\\n      background-color: #e9ecef;\\n      opacity: 1; }\\n  .b-calendar .b-calendar-footer {\\n    margin-top: 0.5rem; }\\n  .b-calendar .b-calendar-grid {\\n    padding: 0;\\n    margin: 0;\\n    overflow: hidden; }\\n    .b-calendar .b-calendar-grid .row {\\n      flex-wrap: nowrap; }\\n  .b-calendar .b-calendar-grid-caption {\\n    padding: 0.25rem; }\\n  .b-calendar .b-calendar-grid-body .col[data-date] .btn {\\n    width: 32px;\\n    height: 32px;\\n    font-size: 14px;\\n    line-height: 1;\\n    margin: 3px auto;\\n    padding: 9px 0; }\\n  .b-calendar .btn:disabled, .b-calendar .btn.disabled, .b-calendar .btn[aria-disabled=\\\"true\\\"] {\\n    cursor: default;\\n    pointer-events: none; }\\n\\n.card-img-left {\\n  border-top-left-radius: calc(0.25rem - 1px);\\n  border-bottom-left-radius: calc(0.25rem - 1px); }\\n\\n.card-img-right {\\n  border-top-right-radius: calc(0.25rem - 1px);\\n  border-bottom-right-radius: calc(0.25rem - 1px); }\\n\\n.dropdown:not(.dropleft) .dropdown-toggle.dropdown-toggle-no-caret::after {\\n  display: none !important; }\\n\\n.dropdown.dropleft .dropdown-toggle.dropdown-toggle-no-caret::before {\\n  display: none !important; }\\n\\n.dropdown .dropdown-menu:focus {\\n  outline: none; }\\n\\n.b-dropdown-form {\\n  display: inline-block;\\n  padding: 0.25rem 1.5rem;\\n  width: 100%;\\n  clear: both;\\n  font-weight: 400; }\\n  .b-dropdown-form:focus {\\n    outline: 1px dotted !important;\\n    outline: 5px auto -webkit-focus-ring-color !important; }\\n  .b-dropdown-form.disabled, .b-dropdown-form:disabled {\\n    outline: 0 !important;\\n    color: #6c757d;\\n    pointer-events: none; }\\n\\n.b-dropdown-text {\\n  display: inline-block;\\n  padding: 0.25rem 1.5rem;\\n  margin-bottom: 0;\\n  width: 100%;\\n  clear: both;\\n  font-weight: lighter; }\\n\\n.custom-checkbox.b-custom-control-lg,\\n.input-group-lg .custom-checkbox {\\n  font-size: 1.25rem;\\n  line-height: 1.5;\\n  padding-left: 1.875rem; }\\n  .custom-checkbox.b-custom-control-lg .custom-control-label::before,\\n  .input-group-lg .custom-checkbox .custom-control-label::before {\\n    top: 0.3125rem;\\n    left: -1.875rem;\\n    width: 1.25rem;\\n    height: 1.25rem;\\n    border-radius: 0.3rem; }\\n  .custom-checkbox.b-custom-control-lg .custom-control-label::after,\\n  .input-group-lg .custom-checkbox .custom-control-label::after {\\n    top: 0.3125rem;\\n    left: -1.875rem;\\n    width: 1.25rem;\\n    height: 1.25rem;\\n    background-size: 50% 50%; }\\n\\n.custom-checkbox.b-custom-control-sm,\\n.input-group-sm .custom-checkbox {\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  padding-left: 1.3125rem; }\\n  .custom-checkbox.b-custom-control-sm .custom-control-label::before,\\n  .input-group-sm .custom-checkbox .custom-control-label::before {\\n    top: 0.21875rem;\\n    left: -1.3125rem;\\n    width: 0.875rem;\\n    height: 0.875rem;\\n    border-radius: 0.2rem; }\\n  .custom-checkbox.b-custom-control-sm .custom-control-label::after,\\n  .input-group-sm .custom-checkbox .custom-control-label::after {\\n    top: 0.21875rem;\\n    left: -1.3125rem;\\n    width: 0.875rem;\\n    height: 0.875rem;\\n    background-size: 50% 50%; }\\n\\n.custom-switch.b-custom-control-lg,\\n.input-group-lg .custom-switch {\\n  padding-left: 2.8125rem; }\\n  .custom-switch.b-custom-control-lg .custom-control-label,\\n  .input-group-lg .custom-switch .custom-control-label {\\n    font-size: 1.25rem;\\n    line-height: 1.5; }\\n    .custom-switch.b-custom-control-lg .custom-control-label::before,\\n    .input-group-lg .custom-switch .custom-control-label::before {\\n      top: 0.3125rem;\\n      height: 1.25rem;\\n      left: -2.8125rem;\\n      width: 2.1875rem;\\n      border-radius: 0.625rem; }\\n    .custom-switch.b-custom-control-lg .custom-control-label::after,\\n    .input-group-lg .custom-switch .custom-control-label::after {\\n      top: calc( 0.3125rem + 2px);\\n      left: calc( -2.8125rem + 2px);\\n      width: calc( 1.25rem - 4px);\\n      height: calc( 1.25rem - 4px);\\n      border-radius: 0.625rem;\\n      background-size: 50% 50%; }\\n  .custom-switch.b-custom-control-lg .custom-control-input:checked ~ .custom-control-label::after,\\n  .input-group-lg .custom-switch .custom-control-input:checked ~ .custom-control-label::after {\\n    transform: translateX(0.9375rem); }\\n\\n.custom-switch.b-custom-control-sm,\\n.input-group-sm .custom-switch {\\n  padding-left: 1.96875rem; }\\n  .custom-switch.b-custom-control-sm .custom-control-label,\\n  .input-group-sm .custom-switch .custom-control-label {\\n    font-size: 0.875rem;\\n    line-height: 1.5; }\\n    .custom-switch.b-custom-control-sm .custom-control-label::before,\\n    .input-group-sm .custom-switch .custom-control-label::before {\\n      top: 0.21875rem;\\n      left: -1.96875rem;\\n      width: 1.53125rem;\\n      height: 0.875rem;\\n      border-radius: 0.4375rem; }\\n    .custom-switch.b-custom-control-sm .custom-control-label::after,\\n    .input-group-sm .custom-switch .custom-control-label::after {\\n      top: calc( 0.21875rem + 2px);\\n      left: calc( -1.96875rem + 2px);\\n      width: calc( 0.875rem - 4px);\\n      height: calc( 0.875rem - 4px);\\n      border-radius: 0.4375rem;\\n      background-size: 50% 50%; }\\n  .custom-switch.b-custom-control-sm .custom-control-input:checked ~ .custom-control-label::after,\\n  .input-group-sm .custom-switch .custom-control-input:checked ~ .custom-control-label::after {\\n    transform: translateX(0.65625rem); }\\n\\n.input-group > .input-group-prepend > .btn-group > .btn,\\n.input-group > .input-group-append:not(:last-child) > .btn-group > .btn,\\n.input-group > .input-group-append:last-child > .btn-group:not(:last-child):not(.dropdown-toggle) > .btn {\\n  border-top-right-radius: 0;\\n  border-bottom-right-radius: 0; }\\n\\n.input-group > .input-group-append > .btn-group > .btn,\\n.input-group > .input-group-prepend:not(:first-child) > .btn-group > .btn,\\n.input-group > .input-group-prepend:first-child > .btn-group:not(:first-child) > .btn {\\n  border-top-left-radius: 0;\\n  border-bottom-left-radius: 0; }\\n\\n.b-custom-control-lg.custom-file,\\n.b-custom-control-lg .custom-file-input,\\n.b-custom-control-lg .custom-file-label,\\n.input-group-lg.custom-file,\\n.input-group-lg .custom-file-input,\\n.input-group-lg .custom-file-label {\\n  font-size: 1.25rem;\\n  height: calc(1.5em + 1rem + 2px); }\\n\\n.b-custom-control-lg .custom-file-label,\\n.b-custom-control-lg .custom-file-label:after,\\n.input-group-lg .custom-file-label,\\n.input-group-lg .custom-file-label:after {\\n  padding: 0.5rem 1rem;\\n  line-height: 1.5; }\\n\\n.b-custom-control-lg .custom-file-label,\\n.input-group-lg .custom-file-label {\\n  border-radius: 0.3rem; }\\n  .b-custom-control-lg .custom-file-label::after,\\n  .input-group-lg .custom-file-label::after {\\n    font-size: inherit;\\n    height: calc( 1.5em + 1rem);\\n    border-radius: 0 0.3rem 0.3rem 0; }\\n\\n.b-custom-control-sm.custom-file,\\n.b-custom-control-sm .custom-file-input,\\n.b-custom-control-sm .custom-file-label,\\n.input-group-sm.custom-file,\\n.input-group-sm .custom-file-input,\\n.input-group-sm .custom-file-label {\\n  font-size: 0.875rem;\\n  height: calc(1.5em + 0.5rem + 2px); }\\n\\n.b-custom-control-sm .custom-file-label,\\n.b-custom-control-sm .custom-file-label:after,\\n.input-group-sm .custom-file-label,\\n.input-group-sm .custom-file-label:after {\\n  padding: 0.25rem 0.5rem;\\n  line-height: 1.5; }\\n\\n.b-custom-control-sm .custom-file-label,\\n.input-group-sm .custom-file-label {\\n  border-radius: 0.2rem; }\\n  .b-custom-control-sm .custom-file-label::after,\\n  .input-group-sm .custom-file-label::after {\\n    font-size: inherit;\\n    height: calc( 1.5em + 0.5rem);\\n    border-radius: 0 0.2rem 0.2rem 0; }\\n\\n.was-validated .form-control:invalid,\\n.was-validated .form-control:valid, .form-control.is-invalid, .form-control.is-valid {\\n  background-position: right calc(0.375em + 0.1875rem) center; }\\n\\ninput[type=\\\"color\\\"].form-control {\\n  height: calc(1.5em + 0.75rem + 2px);\\n  padding: 0.125rem 0.25rem; }\\n\\ninput[type=\\\"color\\\"].form-control.form-control-sm,\\n.input-group-sm input[type=\\\"color\\\"].form-control {\\n  height: calc(1.5em + 0.5rem + 2px);\\n  padding: 0.125rem 0.25rem; }\\n\\ninput[type=\\\"color\\\"].form-control.form-control-lg,\\n.input-group-lg input[type=\\\"color\\\"].form-control {\\n  height: calc(1.5em + 1rem + 2px);\\n  padding: 0.125rem 0.25rem; }\\n\\ninput[type=\\\"color\\\"].form-control:disabled {\\n  background-color: #adb5bd;\\n  opacity: 0.65; }\\n\\n.input-group > .custom-range {\\n  position: relative;\\n  flex: 1 1 auto;\\n  width: 1%;\\n  margin-bottom: 0; }\\n  .input-group > .custom-range + .form-control,\\n  .input-group > .custom-range + .form-control-plaintext,\\n  .input-group > .custom-range + .custom-select,\\n  .input-group > .custom-range + .custom-range,\\n  .input-group > .custom-range + .custom-file {\\n    margin-left: -1px; }\\n\\n.input-group > .form-control + .custom-range,\\n.input-group > .form-control-plaintext + .custom-range,\\n.input-group > .custom-select + .custom-range,\\n.input-group > .custom-range + .custom-range,\\n.input-group > .custom-file + .custom-range {\\n  margin-left: -1px; }\\n\\n.input-group > .custom-range:focus {\\n  z-index: 3; }\\n\\n.input-group > .custom-range:not(:last-child) {\\n  border-top-right-radius: 0;\\n  border-bottom-right-radius: 0; }\\n\\n.input-group > .custom-range:not(:first-child) {\\n  border-top-left-radius: 0;\\n  border-bottom-left-radius: 0; }\\n\\n.input-group > .custom-range {\\n  height: calc(1.5em + 0.75rem + 2px);\\n  padding: 0 0.75rem;\\n  background-color: #fff;\\n  background-clip: padding-box;\\n  border: 1px solid #ced4da;\\n  height: calc(1.5em + 0.75rem + 2px);\\n  border-radius: 0.25rem;\\n  transition: border-color 0.15s ease-in-out, box-shadow 0.15s ease-in-out; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .input-group > .custom-range {\\n      transition: none; } }\\n  .input-group > .custom-range:focus {\\n    color: #495057;\\n    background-color: #fff;\\n    border-color: #df7665;\\n    outline: 0;\\n    box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .input-group > .custom-range:disabled, .input-group > .custom-range[readonly] {\\n    background-color: #e9ecef; }\\n\\n.input-group-lg > .custom-range {\\n  height: calc(1.5em + 1rem + 2px);\\n  padding: 0 1rem;\\n  border-radius: 0.3rem; }\\n\\n.input-group-sm > .custom-range {\\n  height: calc(1.5em + 0.5rem + 2px);\\n  padding: 0 0.5rem;\\n  border-radius: 0.2rem; }\\n\\n.was-validated .input-group .custom-range:valid, .input-group .custom-range.is-valid {\\n  border-color: #28a745; }\\n  .was-validated .input-group .custom-range:valid:focus, .input-group .custom-range.is-valid:focus {\\n    border-color: #28a745;\\n    box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.25); }\\n\\n.was-validated .custom-range:valid:focus::-webkit-slider-thumb, .custom-range.is-valid:focus::-webkit-slider-thumb {\\n  box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem #9be7ac; }\\n\\n.was-validated .custom-range:valid:focus::-moz-range-thumb, .custom-range.is-valid:focus::-moz-range-thumb {\\n  box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem #9be7ac; }\\n\\n.was-validated .custom-range:valid:focus::-ms-thumb, .custom-range.is-valid:focus::-ms-thumb {\\n  box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem #9be7ac; }\\n\\n.was-validated .custom-range:valid::-webkit-slider-thumb, .custom-range.is-valid::-webkit-slider-thumb {\\n  background-color: #28a745;\\n  background-image: none; }\\n  .was-validated .custom-range:valid::-webkit-slider-thumb:active, .custom-range.is-valid::-webkit-slider-thumb:active {\\n    background-color: #9be7ac;\\n    background-image: none; }\\n\\n.was-validated .custom-range:valid::-webkit-slider-runnable-track, .custom-range.is-valid::-webkit-slider-runnable-track {\\n  background-color: rgba(40, 167, 69, 0.35); }\\n\\n.was-validated .custom-range:valid::-moz-range-thumb, .custom-range.is-valid::-moz-range-thumb {\\n  background-color: #28a745;\\n  background-image: none; }\\n  .was-validated .custom-range:valid::-moz-range-thumb:active, .custom-range.is-valid::-moz-range-thumb:active {\\n    background-color: #9be7ac;\\n    background-image: none; }\\n\\n.was-validated .custom-range:valid::-moz-range-track, .custom-range.is-valid::-moz-range-track {\\n  background: rgba(40, 167, 69, 0.35); }\\n\\n.was-validated .custom-range:valid ~ .valid-feedback,\\n.was-validated .custom-range:valid ~ .valid-tooltip, .custom-range.is-valid ~ .valid-feedback,\\n.custom-range.is-valid ~ .valid-tooltip {\\n  display: block; }\\n\\n.was-validated .custom-range:valid::-ms-thumb, .custom-range.is-valid::-ms-thumb {\\n  background-color: #28a745;\\n  background-image: none; }\\n  .was-validated .custom-range:valid::-ms-thumb:active, .custom-range.is-valid::-ms-thumb:active {\\n    background-color: #9be7ac;\\n    background-image: none; }\\n\\n.was-validated .custom-range:valid::-ms-track-lower, .custom-range.is-valid::-ms-track-lower {\\n  background: rgba(40, 167, 69, 0.35); }\\n\\n.was-validated .custom-range:valid::-ms-track-upper, .custom-range.is-valid::-ms-track-upper {\\n  background: rgba(40, 167, 69, 0.35); }\\n\\n.was-validated .input-group .custom-range:invalid, .input-group .custom-range.is-invalid {\\n  border-color: #dc3545; }\\n  .was-validated .input-group .custom-range:invalid:focus, .input-group .custom-range.is-invalid:focus {\\n    border-color: #dc3545;\\n    box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.25); }\\n\\n.was-validated .custom-range:invalid:focus::-webkit-slider-thumb, .custom-range.is-invalid:focus::-webkit-slider-thumb {\\n  box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem #f6cdd1; }\\n\\n.was-validated .custom-range:invalid:focus::-moz-range-thumb, .custom-range.is-invalid:focus::-moz-range-thumb {\\n  box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem #f6cdd1; }\\n\\n.was-validated .custom-range:invalid:focus::-ms-thumb, .custom-range.is-invalid:focus::-ms-thumb {\\n  box-shadow: 0 0 0 1px #fff, 0 0 0 0.2rem #f6cdd1; }\\n\\n.was-validated .custom-range:invalid::-webkit-slider-thumb, .custom-range.is-invalid::-webkit-slider-thumb {\\n  background-color: #dc3545;\\n  background-image: none; }\\n  .was-validated .custom-range:invalid::-webkit-slider-thumb:active, .custom-range.is-invalid::-webkit-slider-thumb:active {\\n    background-color: #f6cdd1;\\n    background-image: none; }\\n\\n.was-validated .custom-range:invalid::-webkit-slider-runnable-track, .custom-range.is-invalid::-webkit-slider-runnable-track {\\n  background-color: rgba(220, 53, 69, 0.35); }\\n\\n.was-validated .custom-range:invalid::-moz-range-thumb, .custom-range.is-invalid::-moz-range-thumb {\\n  background-color: #dc3545;\\n  background-image: none; }\\n  .was-validated .custom-range:invalid::-moz-range-thumb:active, .custom-range.is-invalid::-moz-range-thumb:active {\\n    background-color: #f6cdd1;\\n    background-image: none; }\\n\\n.was-validated .custom-range:invalid::-moz-range-track, .custom-range.is-invalid::-moz-range-track {\\n  background: rgba(220, 53, 69, 0.35); }\\n\\n.was-validated .custom-range:invalid ~ .invalid-feedback,\\n.was-validated .custom-range:invalid ~ .invalid-tooltip, .custom-range.is-invalid ~ .invalid-feedback,\\n.custom-range.is-invalid ~ .invalid-tooltip {\\n  display: block; }\\n\\n.was-validated .custom-range:invalid::-ms-thumb, .custom-range.is-invalid::-ms-thumb {\\n  background-color: #dc3545;\\n  background-image: none; }\\n  .was-validated .custom-range:invalid::-ms-thumb:active, .custom-range.is-invalid::-ms-thumb:active {\\n    background-color: #f6cdd1;\\n    background-image: none; }\\n\\n.was-validated .custom-range:invalid::-ms-track-lower, .custom-range.is-invalid::-ms-track-lower {\\n  background: rgba(220, 53, 69, 0.35); }\\n\\n.was-validated .custom-range:invalid::-ms-track-upper, .custom-range.is-invalid::-ms-track-upper {\\n  background: rgba(220, 53, 69, 0.35); }\\n\\n.custom-radio.b-custom-control-lg,\\n.input-group-lg .custom-radio {\\n  font-size: 1.25rem;\\n  line-height: 1.5;\\n  padding-left: 1.875rem; }\\n  .custom-radio.b-custom-control-lg .custom-control-label::before,\\n  .input-group-lg .custom-radio .custom-control-label::before {\\n    top: 0.3125rem;\\n    left: -1.875rem;\\n    width: 1.25rem;\\n    height: 1.25rem;\\n    border-radius: 50%; }\\n  .custom-radio.b-custom-control-lg .custom-control-label::after,\\n  .input-group-lg .custom-radio .custom-control-label::after {\\n    top: 0.3125rem;\\n    left: -1.875rem;\\n    width: 1.25rem;\\n    height: 1.25rem;\\n    background: no-repeat 50% / 50% 50%; }\\n\\n.custom-radio.b-custom-control-sm,\\n.input-group-sm .custom-radio {\\n  font-size: 0.875rem;\\n  line-height: 1.5;\\n  padding-left: 1.3125rem; }\\n  .custom-radio.b-custom-control-sm .custom-control-label::before,\\n  .input-group-sm .custom-radio .custom-control-label::before {\\n    top: 0.21875rem;\\n    left: -1.3125rem;\\n    width: 0.875rem;\\n    height: 0.875rem;\\n    border-radius: 50%; }\\n  .custom-radio.b-custom-control-sm .custom-control-label::after,\\n  .input-group-sm .custom-radio .custom-control-label::after {\\n    top: 0.21875rem;\\n    left: -1.3125rem;\\n    width: 0.875rem;\\n    height: 0.875rem;\\n    background: no-repeat 50% / 50% 50%; }\\n\\n.b-rating {\\n  text-align: center; }\\n  .b-rating.d-inline-flex {\\n    width: auto; }\\n  .b-rating .b-rating-star,\\n  .b-rating .b-rating-value {\\n    padding: 0 0.25em; }\\n  .b-rating .b-rating-value {\\n    min-width: 2.5em; }\\n  .b-rating .b-rating-star {\\n    display: inline-flex;\\n    justify-content: center;\\n    outline: 0; }\\n    .b-rating .b-rating-star .b-rating-icon {\\n      display: inline-flex;\\n      transition: all 0.15s ease-in-out; }\\n  .b-rating.disabled, .b-rating:disabled {\\n    background-color: #e9ecef;\\n    color: #6c757d; }\\n  .b-rating:not(.disabled):not(.readonly) .b-rating-star {\\n    cursor: pointer; }\\n  .b-rating:not(.disabled):not(.readonly):focus:not(:hover) .b-rating-star.focused .b-rating-icon,\\n  .b-rating:not(.disabled):not(.readonly) .b-rating-star:hover .b-rating-icon {\\n    transform: scale(1.5); }\\n  .b-rating[dir=\\\"rtl\\\"] .b-rating-star-half {\\n    transform: scale(-1, 1); }\\n\\n.b-form-spinbutton {\\n  text-align: center;\\n  overflow: hidden;\\n  background-image: none;\\n  padding: 0; }\\n  [dir=\\\"rtl\\\"] .b-form-spinbutton:not(.flex-column), .b-form-spinbutton[dir=\\\"rtl\\\"]:not(.flex-column) {\\n    flex-direction: row-reverse; }\\n  .b-form-spinbutton output {\\n    font-size: inherit;\\n    outline: 0;\\n    border: 0;\\n    background-color: transparent;\\n    width: auto;\\n    margin: 0;\\n    padding: 0 0.25rem; }\\n    .b-form-spinbutton output > div,\\n    .b-form-spinbutton output > bdi {\\n      display: block;\\n      min-width: 2.25em;\\n      height: 1.5em; }\\n  .b-form-spinbutton.flex-column {\\n    height: auto;\\n    width: auto; }\\n    .b-form-spinbutton.flex-column output {\\n      margin: 0 0.25rem;\\n      padding: 0.25rem 0; }\\n  .b-form-spinbutton:not(.d-inline-flex):not(.flex-column) {\\n    output-width: 100%; }\\n  .b-form-spinbutton.d-inline-flex:not(.flex-column) {\\n    width: auto; }\\n  .b-form-spinbutton .btn {\\n    line-height: 1;\\n    box-shadow: none !important; }\\n    .b-form-spinbutton .btn:disabled {\\n      pointer-events: none; }\\n    .b-form-spinbutton .btn:hover:not(:disabled) > div > .b-icon {\\n      transform: scale(1.25); }\\n  .b-form-spinbutton.disabled, .b-form-spinbutton.readonly {\\n    background-color: #e9ecef; }\\n  .b-form-spinbutton.disabled {\\n    pointer-events: none; }\\n\\n.b-form-tags.focus {\\n  color: #495057;\\n  background-color: #fff;\\n  border-color: #df7665;\\n  outline: 0;\\n  box-shadow: 0 0 0 0.2rem rgba(162, 52, 34, 0.25); }\\n  .b-form-tags.focus.is-valid {\\n    border-color: #28a745;\\n    box-shadow: 0 0 0 0.2rem rgba(40, 167, 69, 0.25); }\\n  .b-form-tags.focus.is-invalid {\\n    border-color: #dc3545;\\n    box-shadow: 0 0 0 0.2rem rgba(220, 53, 69, 0.25); }\\n\\n.b-form-tags.disabled {\\n  background-color: #e9ecef; }\\n\\n.b-form-tag {\\n  font-size: 75%;\\n  font-weight: normal;\\n  line-height: 1.5; }\\n  .b-form-tag.disabled {\\n    opacity: 0.75; }\\n  .b-form-tag > button.b-form-tag-remove {\\n    color: inherit;\\n    font-size: 125%;\\n    line-height: 1;\\n    float: none; }\\n\\n.form-control-sm .b-form-tag {\\n  line-height: 1.5; }\\n\\n.form-control-lg .b-form-tag {\\n  line-height: 1.5; }\\n\\n.modal-backdrop {\\n  opacity: 0.5; }\\n\\n.b-pagination-pills .page-item .page-link {\\n  border-radius: 50rem !important;\\n  margin-left: 0.25rem;\\n  line-height: 1; }\\n\\n.b-pagination-pills .page-item:first-child .page-link {\\n  margin-left: 0; }\\n\\n.popover.b-popover {\\n  display: block;\\n  opacity: 1;\\n  outline: 0; }\\n  .popover.b-popover.fade:not(.show) {\\n    opacity: 0; }\\n  .popover.b-popover.show {\\n    opacity: 1; }\\n\\n.b-popover-primary.popover {\\n  background-color: #ecd6d3;\\n  border-color: #e5c6c1; }\\n\\n.b-popover-primary.bs-popover-top > .arrow::before, .b-popover-primary.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #e5c6c1; }\\n\\n.b-popover-primary.bs-popover-top > .arrow::after, .b-popover-primary.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #ecd6d3; }\\n\\n.b-popover-primary.bs-popover-right > .arrow::before, .b-popover-primary.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #e5c6c1; }\\n\\n.b-popover-primary.bs-popover-right > .arrow::after, .b-popover-primary.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #ecd6d3; }\\n\\n.b-popover-primary.bs-popover-bottom > .arrow::before, .b-popover-primary.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #e5c6c1; }\\n\\n.b-popover-primary.bs-popover-bottom > .arrow::after, .b-popover-primary.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #e7ccc8; }\\n\\n.b-popover-primary.bs-popover-bottom .popover-header::before, .b-popover-primary.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #e7ccc8; }\\n\\n.b-popover-primary.bs-popover-left > .arrow::before, .b-popover-primary.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #e5c6c1; }\\n\\n.b-popover-primary.bs-popover-left > .arrow::after, .b-popover-primary.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #ecd6d3; }\\n\\n.b-popover-primary .popover-header {\\n  color: #212529;\\n  background-color: #e7ccc8;\\n  border-bottom-color: #e0bbb7; }\\n\\n.b-popover-primary .popover-body {\\n  color: #541b12; }\\n\\n.b-popover-secondary.popover {\\n  background-color: #e2e3e5;\\n  border-color: #d6d8db; }\\n\\n.b-popover-secondary.bs-popover-top > .arrow::before, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #d6d8db; }\\n\\n.b-popover-secondary.bs-popover-top > .arrow::after, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #e2e3e5; }\\n\\n.b-popover-secondary.bs-popover-right > .arrow::before, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #d6d8db; }\\n\\n.b-popover-secondary.bs-popover-right > .arrow::after, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #e2e3e5; }\\n\\n.b-popover-secondary.bs-popover-bottom > .arrow::before, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #d6d8db; }\\n\\n.b-popover-secondary.bs-popover-bottom > .arrow::after, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #dadbde; }\\n\\n.b-popover-secondary.bs-popover-bottom .popover-header::before, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #dadbde; }\\n\\n.b-popover-secondary.bs-popover-left > .arrow::before, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #d6d8db; }\\n\\n.b-popover-secondary.bs-popover-left > .arrow::after, .b-popover-secondary.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #e2e3e5; }\\n\\n.b-popover-secondary .popover-header {\\n  color: #212529;\\n  background-color: #dadbde;\\n  border-bottom-color: #ccced2; }\\n\\n.b-popover-secondary .popover-body {\\n  color: #383d41; }\\n\\n.b-popover-success.popover {\\n  background-color: #d4edda;\\n  border-color: #c3e6cb; }\\n\\n.b-popover-success.bs-popover-top > .arrow::before, .b-popover-success.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #c3e6cb; }\\n\\n.b-popover-success.bs-popover-top > .arrow::after, .b-popover-success.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #d4edda; }\\n\\n.b-popover-success.bs-popover-right > .arrow::before, .b-popover-success.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #c3e6cb; }\\n\\n.b-popover-success.bs-popover-right > .arrow::after, .b-popover-success.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #d4edda; }\\n\\n.b-popover-success.bs-popover-bottom > .arrow::before, .b-popover-success.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #c3e6cb; }\\n\\n.b-popover-success.bs-popover-bottom > .arrow::after, .b-popover-success.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #c9e8d1; }\\n\\n.b-popover-success.bs-popover-bottom .popover-header::before, .b-popover-success.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #c9e8d1; }\\n\\n.b-popover-success.bs-popover-left > .arrow::before, .b-popover-success.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #c3e6cb; }\\n\\n.b-popover-success.bs-popover-left > .arrow::after, .b-popover-success.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #d4edda; }\\n\\n.b-popover-success .popover-header {\\n  color: #212529;\\n  background-color: #c9e8d1;\\n  border-bottom-color: #b7e1c1; }\\n\\n.b-popover-success .popover-body {\\n  color: #155724; }\\n\\n.b-popover-info.popover {\\n  background-color: #d1ecf1;\\n  border-color: #bee5eb; }\\n\\n.b-popover-info.bs-popover-top > .arrow::before, .b-popover-info.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #bee5eb; }\\n\\n.b-popover-info.bs-popover-top > .arrow::after, .b-popover-info.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #d1ecf1; }\\n\\n.b-popover-info.bs-popover-right > .arrow::before, .b-popover-info.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #bee5eb; }\\n\\n.b-popover-info.bs-popover-right > .arrow::after, .b-popover-info.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #d1ecf1; }\\n\\n.b-popover-info.bs-popover-bottom > .arrow::before, .b-popover-info.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #bee5eb; }\\n\\n.b-popover-info.bs-popover-bottom > .arrow::after, .b-popover-info.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #c5e7ed; }\\n\\n.b-popover-info.bs-popover-bottom .popover-header::before, .b-popover-info.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #c5e7ed; }\\n\\n.b-popover-info.bs-popover-left > .arrow::before, .b-popover-info.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #bee5eb; }\\n\\n.b-popover-info.bs-popover-left > .arrow::after, .b-popover-info.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #d1ecf1; }\\n\\n.b-popover-info .popover-header {\\n  color: #212529;\\n  background-color: #c5e7ed;\\n  border-bottom-color: #b2dfe7; }\\n\\n.b-popover-info .popover-body {\\n  color: #0c5460; }\\n\\n.b-popover-warning.popover {\\n  background-color: #fff3cd;\\n  border-color: #ffeeba; }\\n\\n.b-popover-warning.bs-popover-top > .arrow::before, .b-popover-warning.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #ffeeba; }\\n\\n.b-popover-warning.bs-popover-top > .arrow::after, .b-popover-warning.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #fff3cd; }\\n\\n.b-popover-warning.bs-popover-right > .arrow::before, .b-popover-warning.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #ffeeba; }\\n\\n.b-popover-warning.bs-popover-right > .arrow::after, .b-popover-warning.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #fff3cd; }\\n\\n.b-popover-warning.bs-popover-bottom > .arrow::before, .b-popover-warning.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #ffeeba; }\\n\\n.b-popover-warning.bs-popover-bottom > .arrow::after, .b-popover-warning.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #ffefbe; }\\n\\n.b-popover-warning.bs-popover-bottom .popover-header::before, .b-popover-warning.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #ffefbe; }\\n\\n.b-popover-warning.bs-popover-left > .arrow::before, .b-popover-warning.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #ffeeba; }\\n\\n.b-popover-warning.bs-popover-left > .arrow::after, .b-popover-warning.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #fff3cd; }\\n\\n.b-popover-warning .popover-header {\\n  color: #212529;\\n  background-color: #ffefbe;\\n  border-bottom-color: #ffe9a4; }\\n\\n.b-popover-warning .popover-body {\\n  color: #856404; }\\n\\n.b-popover-danger.popover {\\n  background-color: #f8d7da;\\n  border-color: #f5c6cb; }\\n\\n.b-popover-danger.bs-popover-top > .arrow::before, .b-popover-danger.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #f5c6cb; }\\n\\n.b-popover-danger.bs-popover-top > .arrow::after, .b-popover-danger.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #f8d7da; }\\n\\n.b-popover-danger.bs-popover-right > .arrow::before, .b-popover-danger.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #f5c6cb; }\\n\\n.b-popover-danger.bs-popover-right > .arrow::after, .b-popover-danger.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #f8d7da; }\\n\\n.b-popover-danger.bs-popover-bottom > .arrow::before, .b-popover-danger.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #f5c6cb; }\\n\\n.b-popover-danger.bs-popover-bottom > .arrow::after, .b-popover-danger.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #f6cace; }\\n\\n.b-popover-danger.bs-popover-bottom .popover-header::before, .b-popover-danger.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #f6cace; }\\n\\n.b-popover-danger.bs-popover-left > .arrow::before, .b-popover-danger.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #f5c6cb; }\\n\\n.b-popover-danger.bs-popover-left > .arrow::after, .b-popover-danger.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #f8d7da; }\\n\\n.b-popover-danger .popover-header {\\n  color: #212529;\\n  background-color: #f6cace;\\n  border-bottom-color: #f2b4ba; }\\n\\n.b-popover-danger .popover-body {\\n  color: #721c24; }\\n\\n.b-popover-light.popover {\\n  background-color: #fefefe;\\n  border-color: #fdfdfe; }\\n\\n.b-popover-light.bs-popover-top > .arrow::before, .b-popover-light.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #fdfdfe; }\\n\\n.b-popover-light.bs-popover-top > .arrow::after, .b-popover-light.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #fefefe; }\\n\\n.b-popover-light.bs-popover-right > .arrow::before, .b-popover-light.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #fdfdfe; }\\n\\n.b-popover-light.bs-popover-right > .arrow::after, .b-popover-light.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #fefefe; }\\n\\n.b-popover-light.bs-popover-bottom > .arrow::before, .b-popover-light.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #fdfdfe; }\\n\\n.b-popover-light.bs-popover-bottom > .arrow::after, .b-popover-light.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #f6f6f6; }\\n\\n.b-popover-light.bs-popover-bottom .popover-header::before, .b-popover-light.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #f6f6f6; }\\n\\n.b-popover-light.bs-popover-left > .arrow::before, .b-popover-light.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #fdfdfe; }\\n\\n.b-popover-light.bs-popover-left > .arrow::after, .b-popover-light.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #fefefe; }\\n\\n.b-popover-light .popover-header {\\n  color: #212529;\\n  background-color: #f6f6f6;\\n  border-bottom-color: #eaeaea; }\\n\\n.b-popover-light .popover-body {\\n  color: #818182; }\\n\\n.b-popover-dark.popover {\\n  background-color: #d6d8d9;\\n  border-color: #c6c8ca; }\\n\\n.b-popover-dark.bs-popover-top > .arrow::before, .b-popover-dark.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #c6c8ca; }\\n\\n.b-popover-dark.bs-popover-top > .arrow::after, .b-popover-dark.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #d6d8d9; }\\n\\n.b-popover-dark.bs-popover-right > .arrow::before, .b-popover-dark.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #c6c8ca; }\\n\\n.b-popover-dark.bs-popover-right > .arrow::after, .b-popover-dark.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #d6d8d9; }\\n\\n.b-popover-dark.bs-popover-bottom > .arrow::before, .b-popover-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #c6c8ca; }\\n\\n.b-popover-dark.bs-popover-bottom > .arrow::after, .b-popover-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #ced0d2; }\\n\\n.b-popover-dark.bs-popover-bottom .popover-header::before, .b-popover-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #ced0d2; }\\n\\n.b-popover-dark.bs-popover-left > .arrow::before, .b-popover-dark.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #c6c8ca; }\\n\\n.b-popover-dark.bs-popover-left > .arrow::after, .b-popover-dark.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #d6d8d9; }\\n\\n.b-popover-dark .popover-header {\\n  color: #212529;\\n  background-color: #ced0d2;\\n  border-bottom-color: #c1c4c5; }\\n\\n.b-popover-dark .popover-body {\\n  color: #1b1e21; }\\n\\n.b-popover-primary-light-dark.popover {\\n  background-color: #f0d7d4;\\n  border-color: #eac8c2; }\\n\\n.b-popover-primary-light-dark.bs-popover-top > .arrow::before, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #eac8c2; }\\n\\n.b-popover-primary-light-dark.bs-popover-top > .arrow::after, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #f0d7d4; }\\n\\n.b-popover-primary-light-dark.bs-popover-right > .arrow::before, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #eac8c2; }\\n\\n.b-popover-primary-light-dark.bs-popover-right > .arrow::after, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #f0d7d4; }\\n\\n.b-popover-primary-light-dark.bs-popover-bottom > .arrow::before, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #eac8c2; }\\n\\n.b-popover-primary-light-dark.bs-popover-bottom > .arrow::after, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #ecccc9; }\\n\\n.b-popover-primary-light-dark.bs-popover-bottom .popover-header::before, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #ecccc9; }\\n\\n.b-popover-primary-light-dark.bs-popover-left > .arrow::before, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #eac8c2; }\\n\\n.b-popover-primary-light-dark.bs-popover-left > .arrow::after, .b-popover-primary-light-dark.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #f0d7d4; }\\n\\n.b-popover-primary-light-dark .popover-header {\\n  color: #212529;\\n  background-color: #ecccc9;\\n  border-bottom-color: #e5bbb6; }\\n\\n.b-popover-primary-light-dark .popover-body {\\n  color: #5d1e14; }\\n\\n.b-popover-primary-dark.popover {\\n  background-color: #e9d5d2;\\n  border-color: #e0c5c0; }\\n\\n.b-popover-primary-dark.bs-popover-top > .arrow::before, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::before {\\n  border-top-color: #e0c5c0; }\\n\\n.b-popover-primary-dark.bs-popover-top > .arrow::after, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"top\\\"] > .arrow::after {\\n  border-top-color: #e9d5d2; }\\n\\n.b-popover-primary-dark.bs-popover-right > .arrow::before, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::before {\\n  border-right-color: #e0c5c0; }\\n\\n.b-popover-primary-dark.bs-popover-right > .arrow::after, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"right\\\"] > .arrow::after {\\n  border-right-color: #e9d5d2; }\\n\\n.b-popover-primary-dark.bs-popover-bottom > .arrow::before, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::before {\\n  border-bottom-color: #e0c5c0; }\\n\\n.b-popover-primary-dark.bs-popover-bottom > .arrow::after, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] > .arrow::after {\\n  border-bottom-color: #e4cbc8; }\\n\\n.b-popover-primary-dark.bs-popover-bottom .popover-header::before, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"bottom\\\"] .popover-header::before {\\n  border-bottom-color: #e4cbc8; }\\n\\n.b-popover-primary-dark.bs-popover-left > .arrow::before, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::before {\\n  border-left-color: #e0c5c0; }\\n\\n.b-popover-primary-dark.bs-popover-left > .arrow::after, .b-popover-primary-dark.bs-popover-auto[x-placement^=\\\"left\\\"] > .arrow::after {\\n  border-left-color: #e9d5d2; }\\n\\n.b-popover-primary-dark .popover-header {\\n  color: #212529;\\n  background-color: #e4cbc8;\\n  border-bottom-color: #dcbbb7; }\\n\\n.b-popover-primary-dark .popover-body {\\n  color: #4b1810; }\\n\\n.b-sidebar-outer {\\n  position: fixed !important;\\n  top: 0;\\n  left: 0;\\n  right: 0;\\n  height: 0;\\n  overflow: visible;\\n  z-index: calc(1030 + 5); }\\n\\n.b-sidebar-backdrop {\\n  position: fixed !important;\\n  top: 0;\\n  left: 0;\\n  z-index: -1;\\n  width: 100vw;\\n  height: 100vh;\\n  opacity: 0.6; }\\n\\n.b-sidebar {\\n  display: flex;\\n  flex-direction: column;\\n  position: fixed !important;\\n  top: 0;\\n  height: 100vh;\\n  width: 320px;\\n  max-width: 100% !important;\\n  height: 100vh !important;\\n  margin: 0 !important;\\n  outline: 0;\\n  transform: translateX(0); }\\n  .b-sidebar.slide {\\n    transition: transform 0.3s ease-in-out; }\\n    @media (prefers-reduced-motion: reduce) {\\n      .b-sidebar.slide {\\n        transition: none; } }\\n  .b-sidebar:not(.b-sidebar-right) {\\n    left: 0;\\n    right: auto; }\\n    .b-sidebar:not(.b-sidebar-right).slide:not(.show) {\\n      transform: translateX(-100%); }\\n    .b-sidebar:not(.b-sidebar-right) > .b-sidebar-header .close {\\n      margin-left: auto; }\\n  .b-sidebar.b-sidebar-right {\\n    left: auto;\\n    right: 0; }\\n    .b-sidebar.b-sidebar-right.slide:not(.show) {\\n      transform: translateX(100%); }\\n    .b-sidebar.b-sidebar-right > .b-sidebar-header .close {\\n      margin-right: auto; }\\n  .b-sidebar > .b-sidebar-header {\\n    font-size: 1.5rem;\\n    padding: 0.5rem 1rem;\\n    display: flex;\\n    flex-direction: row;\\n    flex-grow: 0;\\n    align-items: center; }\\n    [dir=\\\"rtl\\\"] .b-sidebar > .b-sidebar-header {\\n      flex-direction: row-reverse; }\\n    .b-sidebar > .b-sidebar-header .close {\\n      float: none;\\n      font-size: 1.5rem; }\\n  .b-sidebar > .b-sidebar-body {\\n    flex-grow: 1;\\n    height: 100%;\\n    overflow-y: auto; }\\n  .b-sidebar > .b-sidebar-footer {\\n    flex-grow: 0; }\\n\\n.table.b-table.b-table-fixed {\\n  table-layout: fixed; }\\n\\n.table.b-table.b-table-no-border-collapse {\\n  border-collapse: separate;\\n  border-spacing: 0; }\\n\\n.table.b-table[aria-busy=\\\"true\\\"] {\\n  opacity: 0.55; }\\n\\n.table.b-table > tbody > tr.b-table-details > td {\\n  border-top: none !important; }\\n\\n.table.b-table > caption {\\n  caption-side: bottom; }\\n\\n.table.b-table.b-table-caption-top > caption {\\n  caption-side: top !important; }\\n\\n.table.b-table > tbody > .table-active,\\n.table.b-table > tbody > .table-active > th,\\n.table.b-table > tbody > .table-active > td {\\n  background-color: rgba(0, 0, 0, 0.075); }\\n\\n.table.b-table.table-hover > tbody > tr.table-active:hover td,\\n.table.b-table.table-hover > tbody > tr.table-active:hover th {\\n  color: #212529;\\n  background-image: linear-gradient(rgba(0, 0, 0, 0.075), rgba(0, 0, 0, 0.075));\\n  background-repeat: no-repeat; }\\n\\n.table.b-table > tbody > .bg-active,\\n.table.b-table > tbody > .bg-active > th,\\n.table.b-table > tbody > .bg-active > td {\\n  background-color: rgba(255, 255, 255, 0.075) !important; }\\n\\n.table.b-table.table-hover.table-dark > tbody > tr.bg-active:hover td,\\n.table.b-table.table-hover.table-dark > tbody > tr.bg-active:hover th {\\n  color: #fff;\\n  background-image: linear-gradient(rgba(255, 255, 255, 0.075), rgba(255, 255, 255, 0.075));\\n  background-repeat: no-repeat; }\\n\\n.b-table-sticky-header,\\n.table-responsive,\\n[class*=\\\"table-responsive-\\\"] {\\n  margin-bottom: 1rem; }\\n  .b-table-sticky-header > .table,\\n  .table-responsive > .table,\\n  [class*=\\\"table-responsive-\\\"] > .table {\\n    margin-bottom: 0; }\\n\\n.b-table-sticky-header {\\n  overflow-y: auto;\\n  max-height: 300px; }\\n\\n@media print {\\n  .b-table-sticky-header {\\n    overflow-y: visible !important;\\n    max-height: none !important; } }\\n\\n@supports ((position: -webkit-sticky) or (position: sticky)) {\\n  .b-table-sticky-header > .table.b-table > thead > tr > th {\\n    position: -webkit-sticky;\\n    position: sticky;\\n    top: 0;\\n    z-index: 2; }\\n  .b-table-sticky-header > .table.b-table > thead > tr > .b-table-sticky-column,\\n  .b-table-sticky-header > .table.b-table > tbody > tr > .b-table-sticky-column,\\n  .b-table-sticky-header > .table.b-table > tfoot > tr > .b-table-sticky-column,\\n  .table-responsive > .table.b-table > thead > tr > .b-table-sticky-column,\\n  .table-responsive > .table.b-table > tbody > tr > .b-table-sticky-column,\\n  .table-responsive > .table.b-table > tfoot > tr > .b-table-sticky-column,\\n  [class*=\\\"table-responsive-\\\"] > .table.b-table > thead > tr > .b-table-sticky-column,\\n  [class*=\\\"table-responsive-\\\"] > .table.b-table > tbody > tr > .b-table-sticky-column,\\n  [class*=\\\"table-responsive-\\\"] > .table.b-table > tfoot > tr > .b-table-sticky-column {\\n    position: -webkit-sticky;\\n    position: sticky;\\n    left: 0; }\\n  .b-table-sticky-header > .table.b-table > thead > tr > .b-table-sticky-column,\\n  .table-responsive > .table.b-table > thead > tr > .b-table-sticky-column,\\n  [class*=\\\"table-responsive-\\\"] > .table.b-table > thead > tr > .b-table-sticky-column {\\n    z-index: 5; }\\n  .b-table-sticky-header > .table.b-table > tbody > tr > .b-table-sticky-column,\\n  .b-table-sticky-header > .table.b-table > tfoot > tr > .b-table-sticky-column,\\n  .table-responsive > .table.b-table > tbody > tr > .b-table-sticky-column,\\n  .table-responsive > .table.b-table > tfoot > tr > .b-table-sticky-column,\\n  [class*=\\\"table-responsive-\\\"] > .table.b-table > tbody > tr > .b-table-sticky-column,\\n  [class*=\\\"table-responsive-\\\"] > .table.b-table > tfoot > tr > .b-table-sticky-column {\\n    z-index: 2; }\\n  .table.b-table > thead > tr > .table-b-table-default,\\n  .table.b-table > tbody > tr > .table-b-table-default,\\n  .table.b-table > tfoot > tr > .table-b-table-default {\\n    color: #212529;\\n    background-color: #fff; }\\n  .table.b-table.table-dark > thead > tr > .bg-b-table-default,\\n  .table.b-table.table-dark > tbody > tr > .bg-b-table-default,\\n  .table.b-table.table-dark > tfoot > tr > .bg-b-table-default {\\n    color: #fff;\\n    background-color: #343a40; }\\n  .table.b-table.table-striped > tbody > tr:nth-of-type(odd) > .table-b-table-default {\\n    background-image: linear-gradient(rgba(0, 0, 0, 0.05), rgba(0, 0, 0, 0.05));\\n    background-repeat: no-repeat; }\\n  .table.b-table.table-striped.table-dark > tbody > tr:nth-of-type(odd) > .bg-b-table-default {\\n    background-image: linear-gradient(rgba(255, 255, 255, 0.05), rgba(255, 255, 255, 0.05));\\n    background-repeat: no-repeat; }\\n  .table.b-table.table-hover > tbody > tr:hover > .table-b-table-default {\\n    color: #212529;\\n    background-image: linear-gradient(rgba(0, 0, 0, 0.075), rgba(0, 0, 0, 0.075));\\n    background-repeat: no-repeat; }\\n  .table.b-table.table-hover.table-dark > tbody > tr:hover > .bg-b-table-default {\\n    color: #fff;\\n    background-image: linear-gradient(rgba(255, 255, 255, 0.075), rgba(255, 255, 255, 0.075));\\n    background-repeat: no-repeat; } }\\n\\n.table.b-table > thead > tr > [aria-sort],\\n.table.b-table > tfoot > tr > [aria-sort] {\\n  cursor: pointer;\\n  background-image: none;\\n  background-repeat: no-repeat;\\n  background-size: 0.65em 1em; }\\n  .table.b-table > thead > tr > [aria-sort]:not(.b-table-sort-icon-left),\\n  .table.b-table > tfoot > tr > [aria-sort]:not(.b-table-sort-icon-left) {\\n    background-position: right calc(0.75rem / 2) center;\\n    padding-right: calc(0.75rem + 0.65em); }\\n  .table.b-table > thead > tr > [aria-sort].b-table-sort-icon-left,\\n  .table.b-table > tfoot > tr > [aria-sort].b-table-sort-icon-left {\\n    background-position: left calc(0.75rem / 2) center;\\n    padding-left: calc(0.75rem + 0.65em); }\\n\\n.table.b-table > thead > tr > [aria-sort=\\\"none\\\"],\\n.table.b-table > tfoot > tr > [aria-sort=\\\"none\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='black' opacity='.3' d='M51 1l25 23 24 22H1l25-22zM51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table > thead > tr > [aria-sort=\\\"ascending\\\"],\\n.table.b-table > tfoot > tr > [aria-sort=\\\"ascending\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='black' d='M51 1l25 23 24 22H1l25-22z'/%3e%3cpath fill='black' opacity='.3' d='M51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table > thead > tr > [aria-sort=\\\"descending\\\"],\\n.table.b-table > tfoot > tr > [aria-sort=\\\"descending\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='black' opacity='.3' d='M51 1l25 23 24 22H1l25-22z'/%3e%3cpath fill='black' d='M51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table.table-dark > thead > tr > [aria-sort=\\\"none\\\"],\\n.table.b-table.table-dark > tfoot > tr > [aria-sort=\\\"none\\\"],\\n.table.b-table > .thead-dark > tr > [aria-sort=\\\"none\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='white' opacity='.3' d='M51 1l25 23 24 22H1l25-22zM51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table.table-dark > thead > tr > [aria-sort=\\\"ascending\\\"],\\n.table.b-table.table-dark > tfoot > tr > [aria-sort=\\\"ascending\\\"],\\n.table.b-table > .thead-dark > tr > [aria-sort=\\\"ascending\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='white' d='M51 1l25 23 24 22H1l25-22z'/%3e%3cpath fill='white' opacity='.3' d='M51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table.table-dark > thead > tr > [aria-sort=\\\"descending\\\"],\\n.table.b-table.table-dark > tfoot > tr > [aria-sort=\\\"descending\\\"],\\n.table.b-table > .thead-dark > tr > [aria-sort=\\\"descending\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='white' opacity='.3' d='M51 1l25 23 24 22H1l25-22z'/%3e%3cpath fill='white' d='M51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table > thead > tr > .table-dark[aria-sort=\\\"none\\\"],\\n.table.b-table > tfoot > tr > .table-dark[aria-sort=\\\"none\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='white' opacity='.3' d='M51 1l25 23 24 22H1l25-22zM51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table > thead > tr > .table-dark[aria-sort=\\\"ascending\\\"],\\n.table.b-table > tfoot > tr > .table-dark[aria-sort=\\\"ascending\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='white' d='M51 1l25 23 24 22H1l25-22z'/%3e%3cpath fill='white' opacity='.3' d='M51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table > thead > tr > .table-dark[aria-sort=\\\"descending\\\"],\\n.table.b-table > tfoot > tr > .table-dark[aria-sort=\\\"descending\\\"] {\\n  background-image: url(\\\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' width='101' height='101' view-box='0 0 101 101' preserveAspectRatio='none'%3e%3cpath fill='white' opacity='.3' d='M51 1l25 23 24 22H1l25-22z'/%3e%3cpath fill='white' d='M51 101l25-23 24-22H1l25 22z'/%3e%3c/svg%3e\\\"); }\\n\\n.table.b-table.table-sm > thead > tr > [aria-sort]:not(.b-table-sort-icon-left),\\n.table.b-table.table-sm > tfoot > tr > [aria-sort]:not(.b-table-sort-icon-left) {\\n  background-position: right calc(0.3rem / 2) center;\\n  padding-right: calc(0.3rem + 0.65em); }\\n\\n.table.b-table.table-sm > thead > tr > [aria-sort].b-table-sort-icon-left,\\n.table.b-table.table-sm > tfoot > tr > [aria-sort].b-table-sort-icon-left {\\n  background-position: left calc(0.3rem / 2) center;\\n  padding-left: calc(0.3rem + 0.65em); }\\n\\n.table.b-table.b-table-selectable:not(.b-table-selectable-no-click) > tbody > tr {\\n  cursor: pointer; }\\n\\n.table.b-table.b-table-selectable:not(.b-table-selectable-no-click).b-table-selecting.b-table-select-range > tbody > tr {\\n  -webkit-user-select: none;\\n     -moz-user-select: none;\\n      -ms-user-select: none;\\n          user-select: none; }\\n\\n@media (max-width: 575.98px) {\\n  .table.b-table.b-table-stacked-sm {\\n    display: block;\\n    width: 100%; }\\n    .table.b-table.b-table-stacked-sm > caption,\\n    .table.b-table.b-table-stacked-sm > tbody,\\n    .table.b-table.b-table-stacked-sm > tbody > tr,\\n    .table.b-table.b-table-stacked-sm > tbody > tr > td,\\n    .table.b-table.b-table-stacked-sm > tbody > tr > th {\\n      display: block; }\\n    .table.b-table.b-table-stacked-sm > thead,\\n    .table.b-table.b-table-stacked-sm > tfoot {\\n      display: none; }\\n      .table.b-table.b-table-stacked-sm > thead > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-sm > thead > tr.b-table-bottom-row,\\n      .table.b-table.b-table-stacked-sm > tfoot > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-sm > tfoot > tr.b-table-bottom-row {\\n        display: none; }\\n    .table.b-table.b-table-stacked-sm > caption {\\n      caption-side: top !important; }\\n    .table.b-table.b-table-stacked-sm > tbody > tr > [data-label]::before {\\n      content: attr(data-label);\\n      width: 40%;\\n      float: left;\\n      text-align: right;\\n      overflow-wrap: break-word;\\n      font-weight: bold;\\n      font-style: normal;\\n      padding: 0 calc(1rem / 2) 0 0;\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-sm > tbody > tr > [data-label]::after {\\n      display: block;\\n      clear: both;\\n      content: \\\"\\\"; }\\n    .table.b-table.b-table-stacked-sm > tbody > tr > [data-label] > div {\\n      display: inline-block;\\n      width: calc(100% - 40%);\\n      padding: 0 0 0 calc(1rem / 2);\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-sm > tbody > tr.top-row, .table.b-table.b-table-stacked-sm > tbody > tr.bottom-row {\\n      display: none; }\\n    .table.b-table.b-table-stacked-sm > tbody > tr > :first-child {\\n      border-top-width: 3px; }\\n    .table.b-table.b-table-stacked-sm > tbody > tr > [rowspan] + td,\\n    .table.b-table.b-table-stacked-sm > tbody > tr > [rowspan] + th {\\n      border-top-width: 3px; } }\\n\\n@media (max-width: 767.98px) {\\n  .table.b-table.b-table-stacked-md {\\n    display: block;\\n    width: 100%; }\\n    .table.b-table.b-table-stacked-md > caption,\\n    .table.b-table.b-table-stacked-md > tbody,\\n    .table.b-table.b-table-stacked-md > tbody > tr,\\n    .table.b-table.b-table-stacked-md > tbody > tr > td,\\n    .table.b-table.b-table-stacked-md > tbody > tr > th {\\n      display: block; }\\n    .table.b-table.b-table-stacked-md > thead,\\n    .table.b-table.b-table-stacked-md > tfoot {\\n      display: none; }\\n      .table.b-table.b-table-stacked-md > thead > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-md > thead > tr.b-table-bottom-row,\\n      .table.b-table.b-table-stacked-md > tfoot > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-md > tfoot > tr.b-table-bottom-row {\\n        display: none; }\\n    .table.b-table.b-table-stacked-md > caption {\\n      caption-side: top !important; }\\n    .table.b-table.b-table-stacked-md > tbody > tr > [data-label]::before {\\n      content: attr(data-label);\\n      width: 40%;\\n      float: left;\\n      text-align: right;\\n      overflow-wrap: break-word;\\n      font-weight: bold;\\n      font-style: normal;\\n      padding: 0 calc(1rem / 2) 0 0;\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-md > tbody > tr > [data-label]::after {\\n      display: block;\\n      clear: both;\\n      content: \\\"\\\"; }\\n    .table.b-table.b-table-stacked-md > tbody > tr > [data-label] > div {\\n      display: inline-block;\\n      width: calc(100% - 40%);\\n      padding: 0 0 0 calc(1rem / 2);\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-md > tbody > tr.top-row, .table.b-table.b-table-stacked-md > tbody > tr.bottom-row {\\n      display: none; }\\n    .table.b-table.b-table-stacked-md > tbody > tr > :first-child {\\n      border-top-width: 3px; }\\n    .table.b-table.b-table-stacked-md > tbody > tr > [rowspan] + td,\\n    .table.b-table.b-table-stacked-md > tbody > tr > [rowspan] + th {\\n      border-top-width: 3px; } }\\n\\n@media (max-width: 991.98px) {\\n  .table.b-table.b-table-stacked-lg {\\n    display: block;\\n    width: 100%; }\\n    .table.b-table.b-table-stacked-lg > caption,\\n    .table.b-table.b-table-stacked-lg > tbody,\\n    .table.b-table.b-table-stacked-lg > tbody > tr,\\n    .table.b-table.b-table-stacked-lg > tbody > tr > td,\\n    .table.b-table.b-table-stacked-lg > tbody > tr > th {\\n      display: block; }\\n    .table.b-table.b-table-stacked-lg > thead,\\n    .table.b-table.b-table-stacked-lg > tfoot {\\n      display: none; }\\n      .table.b-table.b-table-stacked-lg > thead > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-lg > thead > tr.b-table-bottom-row,\\n      .table.b-table.b-table-stacked-lg > tfoot > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-lg > tfoot > tr.b-table-bottom-row {\\n        display: none; }\\n    .table.b-table.b-table-stacked-lg > caption {\\n      caption-side: top !important; }\\n    .table.b-table.b-table-stacked-lg > tbody > tr > [data-label]::before {\\n      content: attr(data-label);\\n      width: 40%;\\n      float: left;\\n      text-align: right;\\n      overflow-wrap: break-word;\\n      font-weight: bold;\\n      font-style: normal;\\n      padding: 0 calc(1rem / 2) 0 0;\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-lg > tbody > tr > [data-label]::after {\\n      display: block;\\n      clear: both;\\n      content: \\\"\\\"; }\\n    .table.b-table.b-table-stacked-lg > tbody > tr > [data-label] > div {\\n      display: inline-block;\\n      width: calc(100% - 40%);\\n      padding: 0 0 0 calc(1rem / 2);\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-lg > tbody > tr.top-row, .table.b-table.b-table-stacked-lg > tbody > tr.bottom-row {\\n      display: none; }\\n    .table.b-table.b-table-stacked-lg > tbody > tr > :first-child {\\n      border-top-width: 3px; }\\n    .table.b-table.b-table-stacked-lg > tbody > tr > [rowspan] + td,\\n    .table.b-table.b-table-stacked-lg > tbody > tr > [rowspan] + th {\\n      border-top-width: 3px; } }\\n\\n@media (max-width: 1199.98px) {\\n  .table.b-table.b-table-stacked-xl {\\n    display: block;\\n    width: 100%; }\\n    .table.b-table.b-table-stacked-xl > caption,\\n    .table.b-table.b-table-stacked-xl > tbody,\\n    .table.b-table.b-table-stacked-xl > tbody > tr,\\n    .table.b-table.b-table-stacked-xl > tbody > tr > td,\\n    .table.b-table.b-table-stacked-xl > tbody > tr > th {\\n      display: block; }\\n    .table.b-table.b-table-stacked-xl > thead,\\n    .table.b-table.b-table-stacked-xl > tfoot {\\n      display: none; }\\n      .table.b-table.b-table-stacked-xl > thead > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-xl > thead > tr.b-table-bottom-row,\\n      .table.b-table.b-table-stacked-xl > tfoot > tr.b-table-top-row,\\n      .table.b-table.b-table-stacked-xl > tfoot > tr.b-table-bottom-row {\\n        display: none; }\\n    .table.b-table.b-table-stacked-xl > caption {\\n      caption-side: top !important; }\\n    .table.b-table.b-table-stacked-xl > tbody > tr > [data-label]::before {\\n      content: attr(data-label);\\n      width: 40%;\\n      float: left;\\n      text-align: right;\\n      overflow-wrap: break-word;\\n      font-weight: bold;\\n      font-style: normal;\\n      padding: 0 calc(1rem / 2) 0 0;\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-xl > tbody > tr > [data-label]::after {\\n      display: block;\\n      clear: both;\\n      content: \\\"\\\"; }\\n    .table.b-table.b-table-stacked-xl > tbody > tr > [data-label] > div {\\n      display: inline-block;\\n      width: calc(100% - 40%);\\n      padding: 0 0 0 calc(1rem / 2);\\n      margin: 0; }\\n    .table.b-table.b-table-stacked-xl > tbody > tr.top-row, .table.b-table.b-table-stacked-xl > tbody > tr.bottom-row {\\n      display: none; }\\n    .table.b-table.b-table-stacked-xl > tbody > tr > :first-child {\\n      border-top-width: 3px; }\\n    .table.b-table.b-table-stacked-xl > tbody > tr > [rowspan] + td,\\n    .table.b-table.b-table-stacked-xl > tbody > tr > [rowspan] + th {\\n      border-top-width: 3px; } }\\n\\n.table.b-table.b-table-stacked {\\n  display: block;\\n  width: 100%; }\\n  .table.b-table.b-table-stacked > caption,\\n  .table.b-table.b-table-stacked > tbody,\\n  .table.b-table.b-table-stacked > tbody > tr,\\n  .table.b-table.b-table-stacked > tbody > tr > td,\\n  .table.b-table.b-table-stacked > tbody > tr > th {\\n    display: block; }\\n  .table.b-table.b-table-stacked > thead,\\n  .table.b-table.b-table-stacked > tfoot {\\n    display: none; }\\n    .table.b-table.b-table-stacked > thead > tr.b-table-top-row,\\n    .table.b-table.b-table-stacked > thead > tr.b-table-bottom-row,\\n    .table.b-table.b-table-stacked > tfoot > tr.b-table-top-row,\\n    .table.b-table.b-table-stacked > tfoot > tr.b-table-bottom-row {\\n      display: none; }\\n  .table.b-table.b-table-stacked > caption {\\n    caption-side: top !important; }\\n  .table.b-table.b-table-stacked > tbody > tr > [data-label]::before {\\n    content: attr(data-label);\\n    width: 40%;\\n    float: left;\\n    text-align: right;\\n    overflow-wrap: break-word;\\n    font-weight: bold;\\n    font-style: normal;\\n    padding: 0 calc(1rem / 2) 0 0;\\n    margin: 0; }\\n  .table.b-table.b-table-stacked > tbody > tr > [data-label]::after {\\n    display: block;\\n    clear: both;\\n    content: \\\"\\\"; }\\n  .table.b-table.b-table-stacked > tbody > tr > [data-label] > div {\\n    display: inline-block;\\n    width: calc(100% - 40%);\\n    padding: 0 0 0 calc(1rem / 2);\\n    margin: 0; }\\n  .table.b-table.b-table-stacked > tbody > tr.top-row, .table.b-table.b-table-stacked > tbody > tr.bottom-row {\\n    display: none; }\\n  .table.b-table.b-table-stacked > tbody > tr > :first-child {\\n    border-top-width: 3px; }\\n  .table.b-table.b-table-stacked > tbody > tr > [rowspan] + td,\\n  .table.b-table.b-table-stacked > tbody > tr > [rowspan] + th {\\n    border-top-width: 3px; }\\n\\n.b-time {\\n  min-width: 150px; }\\n  .b-time[aria-disabled=\\\"true\\\"] output,\\n  .b-time[aria-readonly=\\\"true\\\"] output,\\n  .b-time output.disabled {\\n    background-color: #e9ecef;\\n    opacity: 1; }\\n  .b-time[aria-disabled=\\\"true\\\"] output {\\n    pointer-events: none; }\\n  [dir=\\\"rtl\\\"] .b-time > .d-flex:not(.flex-column) {\\n    flex-direction: row-reverse; }\\n  .b-time .b-time-header {\\n    margin-bottom: 0.5rem; }\\n    .b-time .b-time-header output {\\n      padding: 0.25rem;\\n      font-size: 80%; }\\n  .b-time .b-time-footer {\\n    margin-top: 0.5rem; }\\n  .b-time .b-time-ampm {\\n    margin-left: 0.5rem; }\\n\\n.b-toast {\\n  display: block;\\n  position: relative;\\n  max-width: 350px;\\n  -webkit-backface-visibility: hidden;\\n          backface-visibility: hidden;\\n  background-clip: padding-box;\\n  z-index: 1;\\n  border-radius: 0.25rem; }\\n  .b-toast .toast {\\n    background-color: rgba(255, 255, 255, 0.85); }\\n  .b-toast:not(:last-child) {\\n    margin-bottom: 0.75rem; }\\n  .b-toast.b-toast-solid .toast {\\n    background-color: white; }\\n  .b-toast .toast {\\n    opacity: 1; }\\n    .b-toast .toast.fade:not(.show) {\\n      opacity: 0; }\\n    .b-toast .toast .toast-body {\\n      display: block; }\\n\\n.b-toast-primary .toast {\\n  background-color: rgba(244, 231, 229, 0.85);\\n  border-color: rgba(229, 198, 193, 0.85);\\n  color: #541b12; }\\n  .b-toast-primary .toast .toast-header {\\n    color: #541b12;\\n    background-color: rgba(236, 214, 211, 0.85);\\n    border-bottom-color: rgba(229, 198, 193, 0.85); }\\n\\n.b-toast-primary.b-toast-solid .toast {\\n  background-color: #f4e7e5; }\\n\\n.b-toast-secondary .toast {\\n  background-color: rgba(239, 240, 241, 0.85);\\n  border-color: rgba(214, 216, 219, 0.85);\\n  color: #383d41; }\\n  .b-toast-secondary .toast .toast-header {\\n    color: #383d41;\\n    background-color: rgba(226, 227, 229, 0.85);\\n    border-bottom-color: rgba(214, 216, 219, 0.85); }\\n\\n.b-toast-secondary.b-toast-solid .toast {\\n  background-color: #eff0f1; }\\n\\n.b-toast-success .toast {\\n  background-color: rgba(230, 245, 233, 0.85);\\n  border-color: rgba(195, 230, 203, 0.85);\\n  color: #155724; }\\n  .b-toast-success .toast .toast-header {\\n    color: #155724;\\n    background-color: rgba(212, 237, 218, 0.85);\\n    border-bottom-color: rgba(195, 230, 203, 0.85); }\\n\\n.b-toast-success.b-toast-solid .toast {\\n  background-color: #e6f5e9; }\\n\\n.b-toast-info .toast {\\n  background-color: rgba(229, 244, 247, 0.85);\\n  border-color: rgba(190, 229, 235, 0.85);\\n  color: #0c5460; }\\n  .b-toast-info .toast .toast-header {\\n    color: #0c5460;\\n    background-color: rgba(209, 236, 241, 0.85);\\n    border-bottom-color: rgba(190, 229, 235, 0.85); }\\n\\n.b-toast-info.b-toast-solid .toast {\\n  background-color: #e5f4f7; }\\n\\n.b-toast-warning .toast {\\n  background-color: rgba(255, 249, 231, 0.85);\\n  border-color: rgba(255, 238, 186, 0.85);\\n  color: #856404; }\\n  .b-toast-warning .toast .toast-header {\\n    color: #856404;\\n    background-color: rgba(255, 243, 205, 0.85);\\n    border-bottom-color: rgba(255, 238, 186, 0.85); }\\n\\n.b-toast-warning.b-toast-solid .toast {\\n  background-color: #fff9e7; }\\n\\n.b-toast-danger .toast {\\n  background-color: rgba(252, 237, 238, 0.85);\\n  border-color: rgba(245, 198, 203, 0.85);\\n  color: #721c24; }\\n  .b-toast-danger .toast .toast-header {\\n    color: #721c24;\\n    background-color: rgba(248, 215, 218, 0.85);\\n    border-bottom-color: rgba(245, 198, 203, 0.85); }\\n\\n.b-toast-danger.b-toast-solid .toast {\\n  background-color: #fcedee; }\\n\\n.b-toast-light .toast {\\n  background-color: rgba(255, 255, 255, 0.85);\\n  border-color: rgba(253, 253, 254, 0.85);\\n  color: #818182; }\\n  .b-toast-light .toast .toast-header {\\n    color: #818182;\\n    background-color: rgba(254, 254, 254, 0.85);\\n    border-bottom-color: rgba(253, 253, 254, 0.85); }\\n\\n.b-toast-light.b-toast-solid .toast {\\n  background-color: white; }\\n\\n.b-toast-dark .toast {\\n  background-color: rgba(227, 229, 229, 0.85);\\n  border-color: rgba(198, 200, 202, 0.85);\\n  color: #1b1e21; }\\n  .b-toast-dark .toast .toast-header {\\n    color: #1b1e21;\\n    background-color: rgba(214, 216, 217, 0.85);\\n    border-bottom-color: rgba(198, 200, 202, 0.85); }\\n\\n.b-toast-dark.b-toast-solid .toast {\\n  background-color: #e3e5e5; }\\n\\n.b-toast-primary-light-dark .toast {\\n  background-color: rgba(247, 233, 231, 0.85);\\n  border-color: rgba(234, 200, 194, 0.85);\\n  color: #5d1e14; }\\n  .b-toast-primary-light-dark .toast .toast-header {\\n    color: #5d1e14;\\n    background-color: rgba(240, 215, 212, 0.85);\\n    border-bottom-color: rgba(234, 200, 194, 0.85); }\\n\\n.b-toast-primary-light-dark.b-toast-solid .toast {\\n  background-color: #f7e9e7; }\\n\\n.b-toast-primary-dark .toast {\\n  background-color: rgba(241, 229, 227, 0.85);\\n  border-color: rgba(224, 197, 192, 0.85);\\n  color: #4b1810; }\\n  .b-toast-primary-dark .toast .toast-header {\\n    color: #4b1810;\\n    background-color: rgba(233, 213, 210, 0.85);\\n    border-bottom-color: rgba(224, 197, 192, 0.85); }\\n\\n.b-toast-primary-dark.b-toast-solid .toast {\\n  background-color: #f1e5e3; }\\n\\n.b-toaster {\\n  z-index: 1100; }\\n  .b-toaster .b-toaster-slot {\\n    position: relative;\\n    display: block; }\\n    .b-toaster .b-toaster-slot:empty {\\n      display: none !important; }\\n\\n.b-toaster.b-toaster-top-right, .b-toaster.b-toaster-top-left, .b-toaster.b-toaster-top-center, .b-toaster.b-toaster-top-full, .b-toaster.b-toaster-bottom-right, .b-toaster.b-toaster-bottom-left, .b-toaster.b-toaster-bottom-center, .b-toaster.b-toaster-bottom-full {\\n  position: fixed;\\n  left: 0.5rem;\\n  right: 0.5rem;\\n  margin: 0;\\n  padding: 0;\\n  height: 0;\\n  overflow: visible; }\\n  .b-toaster.b-toaster-top-right .b-toaster-slot, .b-toaster.b-toaster-top-left .b-toaster-slot, .b-toaster.b-toaster-top-center .b-toaster-slot, .b-toaster.b-toaster-top-full .b-toaster-slot, .b-toaster.b-toaster-bottom-right .b-toaster-slot, .b-toaster.b-toaster-bottom-left .b-toaster-slot, .b-toaster.b-toaster-bottom-center .b-toaster-slot, .b-toaster.b-toaster-bottom-full .b-toaster-slot {\\n    position: absolute;\\n    max-width: 350px;\\n    width: 100%;\\n    /* IE 11 fix */\\n    left: 0;\\n    right: 0;\\n    padding: 0;\\n    margin: 0; }\\n\\n.b-toaster.b-toaster-top-full .b-toaster-slot, .b-toaster.b-toaster-bottom-full .b-toaster-slot {\\n  width: 100%;\\n  max-width: 100%; }\\n  .b-toaster.b-toaster-top-full .b-toaster-slot .b-toast,\\n  .b-toaster.b-toaster-top-full .b-toaster-slot .toast, .b-toaster.b-toaster-bottom-full .b-toaster-slot .b-toast,\\n  .b-toaster.b-toaster-bottom-full .b-toaster-slot .toast {\\n    width: 100%;\\n    max-width: 100%; }\\n\\n.b-toaster.b-toaster-top-right, .b-toaster.b-toaster-top-left, .b-toaster.b-toaster-top-center, .b-toaster.b-toaster-top-full {\\n  top: 0; }\\n  .b-toaster.b-toaster-top-right .b-toaster-slot, .b-toaster.b-toaster-top-left .b-toaster-slot, .b-toaster.b-toaster-top-center .b-toaster-slot, .b-toaster.b-toaster-top-full .b-toaster-slot {\\n    top: 0.5rem; }\\n\\n.b-toaster.b-toaster-bottom-right, .b-toaster.b-toaster-bottom-left, .b-toaster.b-toaster-bottom-center, .b-toaster.b-toaster-bottom-full {\\n  bottom: 0; }\\n  .b-toaster.b-toaster-bottom-right .b-toaster-slot, .b-toaster.b-toaster-bottom-left .b-toaster-slot, .b-toaster.b-toaster-bottom-center .b-toaster-slot, .b-toaster.b-toaster-bottom-full .b-toaster-slot {\\n    bottom: 0.5rem; }\\n\\n.b-toaster.b-toaster-top-right .b-toaster-slot, .b-toaster.b-toaster-bottom-right .b-toaster-slot, .b-toaster.b-toaster-top-center .b-toaster-slot, .b-toaster.b-toaster-bottom-center .b-toaster-slot {\\n  margin-left: auto; }\\n\\n.b-toaster.b-toaster-top-left .b-toaster-slot, .b-toaster.b-toaster-bottom-left .b-toaster-slot, .b-toaster.b-toaster-top-center .b-toaster-slot, .b-toaster.b-toaster-bottom-center .b-toaster-slot {\\n  margin-right: auto; }\\n\\n.b-toaster.b-toaster-top-right .b-toast.b-toaster-enter-active, .b-toaster.b-toaster-top-right .b-toast.b-toaster-leave-active, .b-toaster.b-toaster-top-right .b-toast.b-toaster-move, .b-toaster.b-toaster-top-left .b-toast.b-toaster-enter-active, .b-toaster.b-toaster-top-left .b-toast.b-toaster-leave-active, .b-toaster.b-toaster-top-left .b-toast.b-toaster-move, .b-toaster.b-toaster-bottom-right .b-toast.b-toaster-enter-active, .b-toaster.b-toaster-bottom-right .b-toast.b-toaster-leave-active, .b-toaster.b-toaster-bottom-right .b-toast.b-toaster-move, .b-toaster.b-toaster-bottom-left .b-toast.b-toaster-enter-active, .b-toaster.b-toaster-bottom-left .b-toast.b-toaster-leave-active, .b-toaster.b-toaster-bottom-left .b-toast.b-toaster-move {\\n  transition: transform 0.175s; }\\n\\n.b-toaster.b-toaster-top-right .b-toast.b-toaster-enter-to .toast.fade, .b-toaster.b-toaster-top-right .b-toast.b-toaster-enter-active .toast.fade, .b-toaster.b-toaster-top-left .b-toast.b-toaster-enter-to .toast.fade, .b-toaster.b-toaster-top-left .b-toast.b-toaster-enter-active .toast.fade, .b-toaster.b-toaster-bottom-right .b-toast.b-toaster-enter-to .toast.fade, .b-toaster.b-toaster-bottom-right .b-toast.b-toaster-enter-active .toast.fade, .b-toaster.b-toaster-bottom-left .b-toast.b-toaster-enter-to .toast.fade, .b-toaster.b-toaster-bottom-left .b-toast.b-toaster-enter-active .toast.fade {\\n  transition-delay: 0.175s; }\\n\\n.b-toaster.b-toaster-top-right .b-toast.b-toaster-leave-active, .b-toaster.b-toaster-top-left .b-toast.b-toaster-leave-active, .b-toaster.b-toaster-bottom-right .b-toast.b-toaster-leave-active, .b-toaster.b-toaster-bottom-left .b-toast.b-toaster-leave-active {\\n  position: absolute;\\n  transition-delay: 0.175s; }\\n  .b-toaster.b-toaster-top-right .b-toast.b-toaster-leave-active .toast.fade, .b-toaster.b-toaster-top-left .b-toast.b-toaster-leave-active .toast.fade, .b-toaster.b-toaster-bottom-right .b-toast.b-toaster-leave-active .toast.fade, .b-toaster.b-toaster-bottom-left .b-toast.b-toaster-leave-active .toast.fade {\\n    transition-delay: 0s; }\\n\\n.tooltip.b-tooltip {\\n  display: block;\\n  opacity: 0.9;\\n  outline: 0; }\\n  .tooltip.b-tooltip.fade:not(.show) {\\n    opacity: 0; }\\n  .tooltip.b-tooltip.show {\\n    opacity: 0.9; }\\n  .tooltip.b-tooltip.noninteractive {\\n    pointer-events: none; }\\n  .tooltip.b-tooltip .arrow {\\n    margin: 0 0.25rem; }\\n  .tooltip.b-tooltip.bs-tooltip-right .arrow, .tooltip.b-tooltip.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow, .tooltip.b-tooltip.bs-tooltip-left .arrow, .tooltip.b-tooltip.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow {\\n    margin: 0.25rem 0; }\\n\\n.tooltip.b-tooltip-primary.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #a23422; }\\n\\n.tooltip.b-tooltip-primary.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #a23422; }\\n\\n.tooltip.b-tooltip-primary.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #a23422; }\\n\\n.tooltip.b-tooltip-primary.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-primary.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #a23422; }\\n\\n.tooltip.b-tooltip-primary .tooltip-inner {\\n  color: #fff;\\n  background-color: #a23422; }\\n\\n.tooltip.b-tooltip-secondary.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #6c757d; }\\n\\n.tooltip.b-tooltip-secondary.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #6c757d; }\\n\\n.tooltip.b-tooltip-secondary.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #6c757d; }\\n\\n.tooltip.b-tooltip-secondary.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-secondary.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #6c757d; }\\n\\n.tooltip.b-tooltip-secondary .tooltip-inner {\\n  color: #fff;\\n  background-color: #6c757d; }\\n\\n.tooltip.b-tooltip-success.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #28a745; }\\n\\n.tooltip.b-tooltip-success.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #28a745; }\\n\\n.tooltip.b-tooltip-success.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #28a745; }\\n\\n.tooltip.b-tooltip-success.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-success.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #28a745; }\\n\\n.tooltip.b-tooltip-success .tooltip-inner {\\n  color: #fff;\\n  background-color: #28a745; }\\n\\n.tooltip.b-tooltip-info.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #17a2b8; }\\n\\n.tooltip.b-tooltip-info.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #17a2b8; }\\n\\n.tooltip.b-tooltip-info.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #17a2b8; }\\n\\n.tooltip.b-tooltip-info.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-info.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #17a2b8; }\\n\\n.tooltip.b-tooltip-info .tooltip-inner {\\n  color: #fff;\\n  background-color: #17a2b8; }\\n\\n.tooltip.b-tooltip-warning.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #ffc107; }\\n\\n.tooltip.b-tooltip-warning.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #ffc107; }\\n\\n.tooltip.b-tooltip-warning.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #ffc107; }\\n\\n.tooltip.b-tooltip-warning.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-warning.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #ffc107; }\\n\\n.tooltip.b-tooltip-warning .tooltip-inner {\\n  color: #212529;\\n  background-color: #ffc107; }\\n\\n.tooltip.b-tooltip-danger.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #dc3545; }\\n\\n.tooltip.b-tooltip-danger.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #dc3545; }\\n\\n.tooltip.b-tooltip-danger.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #dc3545; }\\n\\n.tooltip.b-tooltip-danger.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-danger.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #dc3545; }\\n\\n.tooltip.b-tooltip-danger .tooltip-inner {\\n  color: #fff;\\n  background-color: #dc3545; }\\n\\n.tooltip.b-tooltip-light.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #f8f9fa; }\\n\\n.tooltip.b-tooltip-light.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #f8f9fa; }\\n\\n.tooltip.b-tooltip-light.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #f8f9fa; }\\n\\n.tooltip.b-tooltip-light.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-light.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #f8f9fa; }\\n\\n.tooltip.b-tooltip-light .tooltip-inner {\\n  color: #212529;\\n  background-color: #f8f9fa; }\\n\\n.tooltip.b-tooltip-dark.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #343a40; }\\n\\n.tooltip.b-tooltip-dark.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #343a40; }\\n\\n.tooltip.b-tooltip-dark.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #343a40; }\\n\\n.tooltip.b-tooltip-dark.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #343a40; }\\n\\n.tooltip.b-tooltip-dark .tooltip-inner {\\n  color: #fff;\\n  background-color: #343a40; }\\n\\n.tooltip.b-tooltip-primary-light-dark.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #b33926; }\\n\\n.tooltip.b-tooltip-primary-light-dark.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #b33926; }\\n\\n.tooltip.b-tooltip-primary-light-dark.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #b33926; }\\n\\n.tooltip.b-tooltip-primary-light-dark.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-primary-light-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #b33926; }\\n\\n.tooltip.b-tooltip-primary-light-dark .tooltip-inner {\\n  color: #fff;\\n  background-color: #b33926; }\\n\\n.tooltip.b-tooltip-primary-dark.bs-tooltip-top .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"top\\\"] .arrow::before {\\n  border-top-color: #912f1e; }\\n\\n.tooltip.b-tooltip-primary-dark.bs-tooltip-right .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"right\\\"] .arrow::before {\\n  border-right-color: #912f1e; }\\n\\n.tooltip.b-tooltip-primary-dark.bs-tooltip-bottom .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"bottom\\\"] .arrow::before {\\n  border-bottom-color: #912f1e; }\\n\\n.tooltip.b-tooltip-primary-dark.bs-tooltip-left .arrow::before, .tooltip.b-tooltip-primary-dark.bs-tooltip-auto[x-placement^=\\\"left\\\"] .arrow::before {\\n  border-left-color: #912f1e; }\\n\\n.tooltip.b-tooltip-primary-dark .tooltip-inner {\\n  color: #fff;\\n  background-color: #912f1e; }\\n\\n.b-icon.bi {\\n  display: inline-block;\\n  overflow: visible;\\n  vertical-align: -0.15em; }\\n\\n.b-icon.b-icon-animation-cylon,\\n.b-icon.b-iconstack .b-icon-animation-cylon > g {\\n  transform-origin: center;\\n  -webkit-animation: 0.75s infinite ease-in-out alternate b-icon-animation-cylon;\\n          animation: 0.75s infinite ease-in-out alternate b-icon-animation-cylon; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-cylon,\\n    .b-icon.b-iconstack .b-icon-animation-cylon > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.b-icon.b-icon-animation-cylon-vertical,\\n.b-icon.b-iconstack .b-icon-animation-cylon-vertical > g {\\n  transform-origin: center;\\n  -webkit-animation: 0.75s infinite ease-in-out alternate b-icon-animation-cylon-vertical;\\n          animation: 0.75s infinite ease-in-out alternate b-icon-animation-cylon-vertical; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-cylon-vertical,\\n    .b-icon.b-iconstack .b-icon-animation-cylon-vertical > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.b-icon.b-icon-animation-fade,\\n.b-icon.b-iconstack .b-icon-animation-fade > g {\\n  transform-origin: center;\\n  -webkit-animation: 0.75s infinite ease-in-out alternate b-icon-animation-fade;\\n          animation: 0.75s infinite ease-in-out alternate b-icon-animation-fade; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-fade,\\n    .b-icon.b-iconstack .b-icon-animation-fade > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.b-icon.b-icon-animation-spin,\\n.b-icon.b-iconstack .b-icon-animation-spin > g {\\n  transform-origin: center;\\n  -webkit-animation: 2s infinite linear normal b-icon-animation-spin;\\n          animation: 2s infinite linear normal b-icon-animation-spin; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-spin,\\n    .b-icon.b-iconstack .b-icon-animation-spin > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.b-icon.b-icon-animation-spin-reverse,\\n.b-icon.b-iconstack .b-icon-animation-spin-reverse > g {\\n  transform-origin: center;\\n  animation: 2s infinite linear reverse b-icon-animation-spin; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-spin-reverse,\\n    .b-icon.b-iconstack .b-icon-animation-spin-reverse > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.b-icon.b-icon-animation-spin-pulse,\\n.b-icon.b-iconstack .b-icon-animation-spin-pulse > g {\\n  transform-origin: center;\\n  -webkit-animation: 1s infinite steps(8) normal b-icon-animation-spin;\\n          animation: 1s infinite steps(8) normal b-icon-animation-spin; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-spin-pulse,\\n    .b-icon.b-iconstack .b-icon-animation-spin-pulse > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.b-icon.b-icon-animation-spin-reverse-pulse,\\n.b-icon.b-iconstack .b-icon-animation-spin-reverse-pulse > g {\\n  transform-origin: center;\\n  animation: 1s infinite steps(8) reverse b-icon-animation-spin; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-spin-reverse-pulse,\\n    .b-icon.b-iconstack .b-icon-animation-spin-reverse-pulse > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n.b-icon.b-icon-animation-throb,\\n.b-icon.b-iconstack .b-icon-animation-throb > g {\\n  transform-origin: center;\\n  -webkit-animation: 0.75s infinite ease-in-out alternate b-icon-animation-throb;\\n          animation: 0.75s infinite ease-in-out alternate b-icon-animation-throb; }\\n  @media (prefers-reduced-motion: reduce) {\\n    .b-icon.b-icon-animation-throb,\\n    .b-icon.b-iconstack .b-icon-animation-throb > g {\\n      -webkit-animation: none;\\n              animation: none; } }\\n\\n@-webkit-keyframes b-icon-animation-cylon {\\n  0% {\\n    transform: translateX(-25%); }\\n  100% {\\n    transform: translateX(25%); } }\\n\\n@keyframes b-icon-animation-cylon {\\n  0% {\\n    transform: translateX(-25%); }\\n  100% {\\n    transform: translateX(25%); } }\\n\\n@-webkit-keyframes b-icon-animation-cylon-vertical {\\n  0% {\\n    transform: translateY(25%); }\\n  100% {\\n    transform: translateY(-25%); } }\\n\\n@keyframes b-icon-animation-cylon-vertical {\\n  0% {\\n    transform: translateY(25%); }\\n  100% {\\n    transform: translateY(-25%); } }\\n\\n@-webkit-keyframes b-icon-animation-fade {\\n  0% {\\n    opacity: 0.1; }\\n  100% {\\n    opacity: 1; } }\\n\\n@keyframes b-icon-animation-fade {\\n  0% {\\n    opacity: 0.1; }\\n  100% {\\n    opacity: 1; } }\\n\\n@-webkit-keyframes b-icon-animation-spin {\\n  0% {\\n    transform: rotate(0deg); }\\n  100% {\\n    transform: rotate(359deg); } }\\n\\n@keyframes b-icon-animation-spin {\\n  0% {\\n    transform: rotate(0deg); }\\n  100% {\\n    transform: rotate(359deg); } }\\n\\n@-webkit-keyframes b-icon-animation-throb {\\n  0% {\\n    opacity: 0.5;\\n    transform: scale(0.5); }\\n  100% {\\n    opacity: 1;\\n    transform: scale(1); } }\\n\\n@keyframes b-icon-animation-throb {\\n  0% {\\n    opacity: 0.5;\\n    transform: scale(0.5); }\\n  100% {\\n    opacity: 1;\\n    transform: scale(1); } }\\n\\n.btn .b-icon.bi,\\n.nav-link .b-icon.bi,\\n.dropdown-toggle .b-icon.bi,\\n.dropdown-item .b-icon.bi,\\n.input-group-text .b-icon.bi {\\n  font-size: 125%;\\n  vertical-align: text-bottom; }\\n\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/scss/custom.scss?./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-3-1!./node_modules/postcss-loader/src??ref--9-oneOf-3-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-3-3");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss&":
/*!***********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss& ***!
  \***********************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \".vue-json-query-builder {\\n  font-size: 12px;\\n  -webkit-user-select: none;\\n     -moz-user-select: none;\\n      -ms-user-select: none;\\n          user-select: none;\\n}\\n.vue-json-query-builder * {\\n    font-size: 12px !important;\\n}\\n.vue-json-query-builder .vue-json-query-builder-header {\\n    cursor: pointer;\\n}\\n.modal {\\n  font-size: 12px;\\n}\\n.modal * {\\n    font-size: 12px !important;\\n}\\n\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss&":
/*!***************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss& ***!
  \***************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// Imports\nvar ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../node_modules/css-loader/dist/runtime/api.js */ \"./node_modules/css-loader/dist/runtime/api.js\");\nexports = ___CSS_LOADER_API_IMPORT___(false);\n// Module\nexports.push([module.i, \".vue-query-rule .vs__clear {\\n  display: none;\\n}\\n\", \"\"]);\n// Exports\nmodule.exports = exports;\n\n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss&":
/*!*************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/vue-style-loader??ref--9-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss& ***!
  \*************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!../../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../../node_modules/postcss-loader/src??ref--9-oneOf-1-2!../../node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-json-query-builder.vue?vue&type=style&index=0&lang=scss& */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss&\");\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"8bdfd074\", content, true, {\"sourceMap\":false,\"shadowMode\":false});\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?./node_modules/vue-style-loader??ref--9-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss&":
/*!*****************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/vue-style-loader??ref--9-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss& ***!
  \*****************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!../../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../../node_modules/postcss-loader/src??ref--9-oneOf-1-2!../../node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-query-rule.vue?vue&type=style&index=0&lang=scss& */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss&\");\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"f394a8b4\", content, true, {\"sourceMap\":false,\"shadowMode\":false});\n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?./node_modules/vue-style-loader??ref--9-oneOf-1-0!./node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src??ref--9-oneOf-1-2!./node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/vue-styleguidist/lib/loaders/docs-loader.js!./node_modules/vue-cli-plugin-styleguidist/empty-object-loader.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs":
/*!***************************************************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ./node_modules/vue-styleguidist/lib/loaders/docs-loader.js!./node_modules/vue-cli-plugin-styleguidist/empty-object-loader.js!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs ***!
  \***************************************************************************************************************************************************************************************************************************************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony default export */ __webpack_exports__[\"default\"] = (function (Component) {\n\t\tComponent.options.__docs = \"module.exports = {}\"\n\t  });\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?./node_modules/vue-styleguidist/lib/loaders/docs-loader.js!./node_modules/vue-cli-plugin-styleguidist/empty-object-loader.js!./node_modules/cache-loader/dist/cjs.js??ref--1-0!./node_modules/vue-loader/lib??vue-loader-options");

/***/ }),

/***/ "./node_modules/vue-styleguidist/lib/loaders/examples-loader.js?customLangs=vue|js|jsx!./src/components/vue-json-query-builder.vue":
/*!*****************************************************************************************************************************************!*\
  !*** ./node_modules/vue-styleguidist/lib/loaders/examples-loader.js?customLangs=vue|js|jsx!./src/components/vue-json-query-builder.vue ***!
  \*****************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("\nif (false) {}\nvar requireMap = {\n    'vue': __webpack_require__(/*! vue */ \"./node_modules/vue/dist/vue.esm.js\"),\n    '@/scss/custom.scss': __webpack_require__(/*! @/scss/custom.scss */ \"./src/scss/custom.scss\"),\n    'bootstrap-vue': __webpack_require__(/*! bootstrap-vue */ \"./node_modules/bootstrap-vue/esm/index.js\"),\n    'vue-select': __webpack_require__(/*! vue-select */ \"./node_modules/vue-select/dist/vue-select.js\"),\n    'vue-select/src/scss/vue-select.scss': __webpack_require__(/*! vue-select/src/scss/vue-select.scss */ \"./node_modules/vue-select/src/scss/vue-select.scss\")\n};\nvar requireInRuntimeBase = __webpack_require__(/*! ./node_modules/vue-styleguidist/lib/loaders/utils/client/requireInRuntime */ \"./node_modules/vue-styleguidist/lib/loaders/utils/client/requireInRuntime.js\");\nvar requireInRuntime = requireInRuntimeBase.bind(null, requireMap);\nvar evalInContextBase = __webpack_require__(/*! ./node_modules/vue-styleguidist/lib/loaders/utils/client/evalInContext */ \"./node_modules/vue-styleguidist/lib/loaders/utils/client/evalInContext.js\");\nvar evalInContext = evalInContextBase.bind(null, \n\t\"\", \n\tnull, null)\nmodule.exports = [\n    {\n        'type': 'markdown',\n        'content': '## Examples\\n\\nStandard setup:'\n    },\n    {\n        'type': 'code',\n        'content': '  <template>\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" />\\n  </template>\\n\\n  <script>\\n    import Vue from \\'vue\\';\\n    import \\'@/scss/custom.scss\\';\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    export default {\\n      data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'owner\\',\\n              operator: \\'!=\\',\\n              value: 0\\n            }, {\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }, {\\n            id: \\'owner\\',\\n            name: \\'Owner\\',\\n            type: \\'select\\',\\n            options: [{\\n              id: 0,\\n              name: \\'Charles Smith\\'\\n            }, {\\n              id: 1,\\n              name: \\'Emmy Carlton\\'\\n            }, {\\n              id: 2,\\n              name: \\'Jim Bowmann\\'\\n            }, {\\n              id: 4,\\n              name: \\'Karla Entwisle\\'\\n            }, {\\n              id: 5,\\n              name: \\'Omar Warren\\'\\n            }, {\\n              id: 6,\\n              name: \\'Samantha Lowenstein\\'\\n            }, {\\n              id: 7,\\n              name: \\'Zachary Appleton\\'\\n            }]\\n          }, {\\n            id: \\'phone\\',\\n            name: \\'Phone\\',\\n            type: \\'phone\\'\\n          }, {\\n            id: \\'email\\',\\n            name: \\'Email\\',\\n            type: \\'email\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n      }\\n    }\\n  </script>',\n        'settings': {},\n        'evalInContext': evalInContext.bind(null, requireInRuntime.bind(null, null)),\n        'compiled': {\n            'script': '\\n    var vue$0 = require(\\'vue\\');\\nvar Vue = vue$0.default || vue$0;\\n    require(\\'@/scss/custom.scss\\');\\n    var bootstrap_vue$45 = require(\\'bootstrap-vue\\');\\nvar BootstrapVue = bootstrap_vue$45.BootstrapVue;\\nvar IconsPlugin = bootstrap_vue$45.IconsPlugin;\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    \\n;return {\\n  template: \"\\\\n    <VueJSONQueryBuilder v-bind:query=\\\\\"query\\\\\" v-bind:options=\\\\\"queryOptions\\\\\" />\\\\n  \",\\n  \\n      data: function data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'owner\\',\\n              operator: \\'!=\\',\\n              value: 0\\n            }, {\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }, {\\n            id: \\'owner\\',\\n            name: \\'Owner\\',\\n            type: \\'select\\',\\n            options: [{\\n              id: 0,\\n              name: \\'Charles Smith\\'\\n            }, {\\n              id: 1,\\n              name: \\'Emmy Carlton\\'\\n            }, {\\n              id: 2,\\n              name: \\'Jim Bowmann\\'\\n            }, {\\n              id: 4,\\n              name: \\'Karla Entwisle\\'\\n            }, {\\n              id: 5,\\n              name: \\'Omar Warren\\'\\n            }, {\\n              id: 6,\\n              name: \\'Samantha Lowenstein\\'\\n            }, {\\n              id: 7,\\n              name: \\'Zachary Appleton\\'\\n            }]\\n          }, {\\n            id: \\'phone\\',\\n            name: \\'Phone\\',\\n            type: \\'phone\\'\\n          }, {\\n            id: \\'email\\',\\n            name: \\'Email\\',\\n            type: \\'email\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n      }\\n    }\\n\\n  ',\n            'style': void 0\n        }\n    },\n    {\n        'type': 'markdown',\n        'content': 'Emit current query to parent'\n    },\n    {\n        'type': 'code',\n        'content': '  <template>\\n    <div>\\n      <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-model=\"currentQuery\" />\\n      <strong class=\"mt-3 mb-1 d-block\">Emitted Query:</strong>\\n      <b-card>\\n        <pre><code>{{ JSON.stringify(currentQuery, null, 4) }}</code></pre>\\n      </b-card>\\n    </div>\\n  </template>\\n\\n  <script>\\n    import Vue from \\'vue\\';\\n    import \\'@/scss/custom.scss\\';\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    export default {\\n      data() {\\n        return {\\n          currentQuery: {},\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n      }\\n    }\\n  </script>',\n        'settings': {},\n        'evalInContext': evalInContext.bind(null, requireInRuntime.bind(null, null)),\n        'compiled': {\n            'script': '\\n    var vue$0 = require(\\'vue\\');\\nvar Vue = vue$0.default || vue$0;\\n    require(\\'@/scss/custom.scss\\');\\n    var bootstrap_vue$45 = require(\\'bootstrap-vue\\');\\nvar BootstrapVue = bootstrap_vue$45.BootstrapVue;\\nvar IconsPlugin = bootstrap_vue$45.IconsPlugin;\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    \\n;return {\\n  template: \"\\\\n    <div>\\\\n      <VueJSONQueryBuilder v-bind:query=\\\\\"query\\\\\" v-bind:options=\\\\\"queryOptions\\\\\" v-model=\\\\\"currentQuery\\\\\" />\\\\n      <strong class=\\\\\"mt-3 mb-1 d-block\\\\\">Emitted Query:</strong>\\\\n      <b-card>\\\\n        <pre><code>{{ JSON.stringify(currentQuery, null, 4) }}</code></pre>\\\\n      </b-card>\\\\n    </div>\\\\n  \",\\n  \\n      data: function data() {\\n        return {\\n          currentQuery: {},\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n      }\\n    }\\n\\n  ',\n            'style': void 0\n        }\n    },\n    {\n        'type': 'markdown',\n        'content': 'Add button to execute query'\n    },\n    {\n        'type': 'code',\n        'content': '  <template>\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-bind:run-query=\"viewQuery\" />\\n  </template>\\n\\n  <script>\\n    import Vue from \\'vue\\';\\n    import \\'@/scss/custom.scss\\';\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    export default {\\n      data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n        viewQuery: function(query) {\\n          alert(JSON.stringify(query));\\n        }\\n      }\\n    }\\n  </script>',\n        'settings': {},\n        'evalInContext': evalInContext.bind(null, requireInRuntime.bind(null, null)),\n        'compiled': {\n            'script': '\\n    var vue$0 = require(\\'vue\\');\\nvar Vue = vue$0.default || vue$0;\\n    require(\\'@/scss/custom.scss\\');\\n    var bootstrap_vue$45 = require(\\'bootstrap-vue\\');\\nvar BootstrapVue = bootstrap_vue$45.BootstrapVue;\\nvar IconsPlugin = bootstrap_vue$45.IconsPlugin;\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    \\n;return {\\n  template: \"\\\\n    <VueJSONQueryBuilder v-bind:query=\\\\\"query\\\\\" v-bind:options=\\\\\"queryOptions\\\\\" v-bind:run-query=\\\\\"viewQuery\\\\\" />\\\\n  \",\\n  \\n      data: function data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n        viewQuery: function(query) {\\n          alert(JSON.stringify(query));\\n        }\\n      }\\n    }\\n\\n  ',\n            'style': void 0\n        }\n    },\n    {\n        'type': 'markdown',\n        'content': 'Add button to execute async query'\n    },\n    {\n        'type': 'code',\n        'content': '  <template>\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-bind:run-query=\"viewQuery\" />\\n  </template>\\n\\n  <script>\\n    import Vue from \\'vue\\';\\n    import \\'@/scss/custom.scss\\';\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    export default {\\n      data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n        viewQuery: function(query) {\\n          return new Promise(function(resolve){\\n            setTimeout(function(){\\n              alert(JSON.stringify(query));\\n              resolve();\\n            }, 1000);\\n          });\\n        }\\n      }\\n    }\\n  </script>',\n        'settings': {},\n        'evalInContext': evalInContext.bind(null, requireInRuntime.bind(null, null)),\n        'compiled': {\n            'script': '\\n    var vue$0 = require(\\'vue\\');\\nvar Vue = vue$0.default || vue$0;\\n    require(\\'@/scss/custom.scss\\');\\n    var bootstrap_vue$45 = require(\\'bootstrap-vue\\');\\nvar BootstrapVue = bootstrap_vue$45.BootstrapVue;\\nvar IconsPlugin = bootstrap_vue$45.IconsPlugin;\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    \\n;return {\\n  template: \"\\\\n    <VueJSONQueryBuilder v-bind:query=\\\\\"query\\\\\" v-bind:options=\\\\\"queryOptions\\\\\" v-bind:run-query=\\\\\"viewQuery\\\\\" />\\\\n  \",\\n  \\n      data: function data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      },\\n      methods: {\\n        viewQuery: function(query) {\\n          return new Promise(function(resolve){\\n            setTimeout(function(){\\n              alert(JSON.stringify(query));\\n              resolve();\\n            }, 1000);\\n          });\\n        }\\n      }\\n    }\\n\\n  ',\n            'style': void 0\n        }\n    },\n    {\n        'type': 'markdown',\n        'content': 'Collapse query builder on load'\n    },\n    {\n        'type': 'code',\n        'content': '  <template>\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-bind:visible=\"false\" />\\n  </template>\\n\\n  <script>\\n    import Vue from \\'vue\\';\\n    import \\'@/scss/custom.scss\\';\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    export default {\\n      data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      }\\n    }\\n  </script>',\n        'settings': {},\n        'evalInContext': evalInContext.bind(null, requireInRuntime.bind(null, null)),\n        'compiled': {\n            'script': '\\n    var vue$0 = require(\\'vue\\');\\nvar Vue = vue$0.default || vue$0;\\n    require(\\'@/scss/custom.scss\\');\\n    var bootstrap_vue$45 = require(\\'bootstrap-vue\\');\\nvar BootstrapVue = bootstrap_vue$45.BootstrapVue;\\nvar IconsPlugin = bootstrap_vue$45.IconsPlugin;\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n\\n    \\n;return {\\n  template: \"\\\\n    <VueJSONQueryBuilder v-bind:query=\\\\\"query\\\\\" v-bind:options=\\\\\"queryOptions\\\\\" v-bind:visible=\\\\\"false\\\\\" />\\\\n  \",\\n  \\n      data: function data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'price\\',\\n              operator: \\'<=\\',\\n              value: \\'80000\\'\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }]\\n        }\\n      }\\n    }\\n\\n  ',\n            'style': void 0\n        }\n    },\n    {\n        'type': 'markdown',\n        'content': 'Replace rule ID selector, rule operator selector, or value inputs by type by using slots'\n    },\n    {\n        'type': 'code',\n        'content': '  <template>\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\">\\n      <template v-slot:ruleID=\"{rule, options}\">\\n        <v-select\\n          size=\"sm\"\\n          :options=\"options\"\\n          :reduce=\"item => item.id\"\\n          label=\"name\"\\n          autocomplete=\"new-password\"\\n          v-model=\"rule.id\"\\n        />\\n      </template>\\n      <template v-slot:ruleOperator=\"{rule, options}\">\\n        <v-select\\n          size=\"sm\"\\n          :options=\"options\"\\n          :reduce=\"item => item.id\"\\n          label=\"name\"\\n          autocomplete=\"new-password\"\\n          v-model=\"rule.operator\"\\n        />\\n      </template>\\n      <template v-slot:select=\"{rule, options, multiple}\">\\n        <v-select\\n          size=\"sm\"\\n          :options=\"options\"\\n          :reduce=\"item => item.id\"\\n          label=\"name\"\\n          autocomplete=\"new-password\"\\n          v-model=\"rule.value\"\\n          :multiple=\"multiple\"\\n        />\\n      </template>\\n    </VueJSONQueryBuilder>\\n  </template>\\n\\n  <script>\\n    import Vue from \\'vue\\';\\n    import \\'@/scss/custom.scss\\';\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n        \\n    import vSelect from \\'vue-select\\';\\n    Vue.component(\\'v-select\\', vSelect);\\n    import \"vue-select/src/scss/vue-select.scss\";\\n\\n    export default {\\n      data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'owner\\',\\n              operator: \\'=\\',\\n              value: 0\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }, {\\n            id: \\'owner\\',\\n            name: \\'Owner\\',\\n            type: \\'select\\',\\n            options: [{\\n              id: 0,\\n              name: \\'Charles Smith\\'\\n            }, {\\n              id: 1,\\n              name: \\'Emmy Carlton\\'\\n            }, {\\n              id: 2,\\n              name: \\'Jim Bowmann\\'\\n            }, {\\n              id: 4,\\n              name: \\'Karla Entwisle\\'\\n            }, {\\n              id: 5,\\n              name: \\'Omar Warren\\'\\n            }, {\\n              id: 6,\\n              name: \\'Samantha Lowenstein\\'\\n            }, {\\n              id: 7,\\n              name: \\'Zachary Appleton\\'\\n            }]\\n          }, {\\n            id: \\'phone\\',\\n            name: \\'Phone\\',\\n            type: \\'phone\\'\\n          }, {\\n            id: \\'email\\',\\n            name: \\'Email\\',\\n            type: \\'email\\'\\n          }]\\n        }\\n      }\\n    }\\n  </script>',\n        'settings': {},\n        'evalInContext': evalInContext.bind(null, requireInRuntime.bind(null, null)),\n        'compiled': {\n            'script': '\\n    var vue$0 = require(\\'vue\\');\\nvar Vue = vue$0.default || vue$0;\\n    require(\\'@/scss/custom.scss\\');\\n    var bootstrap_vue$45 = require(\\'bootstrap-vue\\');\\nvar BootstrapVue = bootstrap_vue$45.BootstrapVue;\\nvar IconsPlugin = bootstrap_vue$45.IconsPlugin;\\n    Vue.use(BootstrapVue);\\n    Vue.use(IconsPlugin);\\n        \\n    var vue_select$139 = require(\\'vue-select\\');\\nvar vSelect = vue_select$139.default || vue_select$139;\\n    Vue.component(\\'v-select\\', vSelect);\\n    require(\\'vue-select/src/scss/vue-select.scss\\');\\n\\n    \\n;return {\\n  template: \"\\\\n    <VueJSONQueryBuilder v-bind:query=\\\\\"query\\\\\" v-bind:options=\\\\\"queryOptions\\\\\">\\\\n      <template v-slot:ruleID=\\\\\"{rule, options}\\\\\">\\\\n        <v-select\\\\n          size=\\\\\"sm\\\\\"\\\\n          :options=\\\\\"options\\\\\"\\\\n          :reduce=\\\\\"item => item.id\\\\\"\\\\n          label=\\\\\"name\\\\\"\\\\n          autocomplete=\\\\\"new-password\\\\\"\\\\n          v-model=\\\\\"rule.id\\\\\"\\\\n        />\\\\n      </template>\\\\n      <template v-slot:ruleOperator=\\\\\"{rule, options}\\\\\">\\\\n        <v-select\\\\n          size=\\\\\"sm\\\\\"\\\\n          :options=\\\\\"options\\\\\"\\\\n          :reduce=\\\\\"item => item.id\\\\\"\\\\n          label=\\\\\"name\\\\\"\\\\n          autocomplete=\\\\\"new-password\\\\\"\\\\n          v-model=\\\\\"rule.operator\\\\\"\\\\n        />\\\\n      </template>\\\\n      <template v-slot:select=\\\\\"{rule, options, multiple}\\\\\">\\\\n        <v-select\\\\n          size=\\\\\"sm\\\\\"\\\\n          :options=\\\\\"options\\\\\"\\\\n          :reduce=\\\\\"item => item.id\\\\\"\\\\n          label=\\\\\"name\\\\\"\\\\n          autocomplete=\\\\\"new-password\\\\\"\\\\n          v-model=\\\\\"rule.value\\\\\"\\\\n          :multiple=\\\\\"multiple\\\\\"\\\\n        />\\\\n      </template>\\\\n    </VueJSONQueryBuilder>\\\\n  \",\\n  \\n      data: function data() {\\n        return {\\n          query: {\\n            condition: \\'and\\',\\n            rules: [{\\n              id: \\'owner\\',\\n              operator: \\'=\\',\\n              value: 0\\n            }]\\n          },\\n          queryOptions: [{\\n            id: \\'price\\',\\n            name: \\'Price\\',\\n            type: \\'number\\'\\n          }, {\\n            id: \\'date\\',\\n            name: \\'Date\\',\\n            type: \\'date\\'\\n          }, {\\n            id: \\'time\\',\\n            name: \\'Time\\',\\n            type: \\'time\\'\\n          }, {\\n            id: \\'owner\\',\\n            name: \\'Owner\\',\\n            type: \\'select\\',\\n            options: [{\\n              id: 0,\\n              name: \\'Charles Smith\\'\\n            }, {\\n              id: 1,\\n              name: \\'Emmy Carlton\\'\\n            }, {\\n              id: 2,\\n              name: \\'Jim Bowmann\\'\\n            }, {\\n              id: 4,\\n              name: \\'Karla Entwisle\\'\\n            }, {\\n              id: 5,\\n              name: \\'Omar Warren\\'\\n            }, {\\n              id: 6,\\n              name: \\'Samantha Lowenstein\\'\\n            }, {\\n              id: 7,\\n              name: \\'Zachary Appleton\\'\\n            }]\\n          }, {\\n            id: \\'phone\\',\\n            name: \\'Phone\\',\\n            type: \\'phone\\'\\n          }, {\\n            id: \\'email\\',\\n            name: \\'Email\\',\\n            type: \\'email\\'\\n          }]\\n        }\\n      }\\n    }\\n\\n  ',\n            'style': void 0\n        }\n    }\n]\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?./node_modules/vue-styleguidist/lib/loaders/examples-loader.js?customLangs=vue%7Cjs%7Cjsx");

/***/ }),

/***/ "./node_modules/vue-styleguidist/lib/loaders/vuedoc-loader.js!./src/components/vue-json-query-builder.vue":
/*!****************************************************************************************************************!*\
  !*** ./node_modules/vue-styleguidist/lib/loaders/vuedoc-loader.js!./src/components/vue-json-query-builder.vue ***!
  \****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("\n\t\tif (false) {}\n\n\t\tmodule.exports = {\n    'displayName': 'Vue JSON Query Builder',\n    'description': 'VueJSONQueryBuilder is a Vue-based UI component that allows the user to generate queries in JSON format.',\n    'tags': {},\n    'exportName': 'default',\n    'docsBlocks': ['## Examples\\r\\n\\r\\nStandard setup:\\r\\n\\r\\n```vue\\r\\n  <template>\\r\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" />\\r\\n  </template>\\r\\n\\r\\n  <script>\\r\\n    import Vue from \\'vue\\';\\r\\n    import \\'@/scss/custom.scss\\';\\r\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\r\\n    Vue.use(BootstrapVue);\\r\\n    Vue.use(IconsPlugin);\\r\\n\\r\\n    export default {\\r\\n      data() {\\r\\n        return {\\r\\n          query: {\\r\\n            condition: \\'and\\',\\r\\n            rules: [{\\r\\n              id: \\'owner\\',\\r\\n              operator: \\'!=\\',\\r\\n              value: 0\\r\\n            }, {\\r\\n              id: \\'price\\',\\r\\n              operator: \\'<=\\',\\r\\n              value: \\'80000\\'\\r\\n            }]\\r\\n          },\\r\\n          queryOptions: [{\\r\\n            id: \\'price\\',\\r\\n            name: \\'Price\\',\\r\\n            type: \\'number\\'\\r\\n          }, {\\r\\n            id: \\'date\\',\\r\\n            name: \\'Date\\',\\r\\n            type: \\'date\\'\\r\\n          }, {\\r\\n            id: \\'time\\',\\r\\n            name: \\'Time\\',\\r\\n            type: \\'time\\'\\r\\n          }, {\\r\\n            id: \\'owner\\',\\r\\n            name: \\'Owner\\',\\r\\n            type: \\'select\\',\\r\\n            options: [{\\r\\n              id: 0,\\r\\n              name: \\'Charles Smith\\'\\r\\n            }, {\\r\\n              id: 1,\\r\\n              name: \\'Emmy Carlton\\'\\r\\n            }, {\\r\\n              id: 2,\\r\\n              name: \\'Jim Bowmann\\'\\r\\n            }, {\\r\\n              id: 4,\\r\\n              name: \\'Karla Entwisle\\'\\r\\n            }, {\\r\\n              id: 5,\\r\\n              name: \\'Omar Warren\\'\\r\\n            }, {\\r\\n              id: 6,\\r\\n              name: \\'Samantha Lowenstein\\'\\r\\n            }, {\\r\\n              id: 7,\\r\\n              name: \\'Zachary Appleton\\'\\r\\n            }]\\r\\n          }, {\\r\\n            id: \\'phone\\',\\r\\n            name: \\'Phone\\',\\r\\n            type: \\'phone\\'\\r\\n          }, {\\r\\n            id: \\'email\\',\\r\\n            name: \\'Email\\',\\r\\n            type: \\'email\\'\\r\\n          }]\\r\\n        }\\r\\n      },\\r\\n      methods: {\\r\\n      }\\r\\n    }\\r\\n  </script>\\r\\n```\\r\\n\\r\\nEmit current query to parent\\r\\n```vue\\r\\n  <template>\\r\\n    <div>\\r\\n      <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-model=\"currentQuery\" />\\r\\n      <strong class=\"mt-3 mb-1 d-block\">Emitted Query:</strong>\\r\\n      <b-card>\\r\\n        <pre><code>{{ JSON.stringify(currentQuery, null, 4) }}</code></pre>\\r\\n      </b-card>\\r\\n    </div>\\r\\n  </template>\\r\\n\\r\\n  <script>\\r\\n    import Vue from \\'vue\\';\\r\\n    import \\'@/scss/custom.scss\\';\\r\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\r\\n    Vue.use(BootstrapVue);\\r\\n    Vue.use(IconsPlugin);\\r\\n\\r\\n    export default {\\r\\n      data() {\\r\\n        return {\\r\\n          currentQuery: {},\\r\\n          query: {\\r\\n            condition: \\'and\\',\\r\\n            rules: [{\\r\\n              id: \\'price\\',\\r\\n              operator: \\'<=\\',\\r\\n              value: \\'80000\\'\\r\\n            }]\\r\\n          },\\r\\n          queryOptions: [{\\r\\n            id: \\'price\\',\\r\\n            name: \\'Price\\',\\r\\n            type: \\'number\\'\\r\\n          }, {\\r\\n            id: \\'date\\',\\r\\n            name: \\'Date\\',\\r\\n            type: \\'date\\'\\r\\n          }, {\\r\\n            id: \\'time\\',\\r\\n            name: \\'Time\\',\\r\\n            type: \\'time\\'\\r\\n          }]\\r\\n        }\\r\\n      },\\r\\n      methods: {\\r\\n      }\\r\\n    }\\r\\n  </script>\\r\\n```\\r\\n\\r\\nAdd button to execute query\\r\\n```vue\\r\\n  <template>\\r\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-bind:run-query=\"viewQuery\" />\\r\\n  </template>\\r\\n\\r\\n  <script>\\r\\n    import Vue from \\'vue\\';\\r\\n    import \\'@/scss/custom.scss\\';\\r\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\r\\n    Vue.use(BootstrapVue);\\r\\n    Vue.use(IconsPlugin);\\r\\n\\r\\n    export default {\\r\\n      data() {\\r\\n        return {\\r\\n          query: {\\r\\n            condition: \\'and\\',\\r\\n            rules: [{\\r\\n              id: \\'price\\',\\r\\n              operator: \\'<=\\',\\r\\n              value: \\'80000\\'\\r\\n            }]\\r\\n          },\\r\\n          queryOptions: [{\\r\\n            id: \\'price\\',\\r\\n            name: \\'Price\\',\\r\\n            type: \\'number\\'\\r\\n          }, {\\r\\n            id: \\'date\\',\\r\\n            name: \\'Date\\',\\r\\n            type: \\'date\\'\\r\\n          }, {\\r\\n            id: \\'time\\',\\r\\n            name: \\'Time\\',\\r\\n            type: \\'time\\'\\r\\n          }]\\r\\n        }\\r\\n      },\\r\\n      methods: {\\r\\n        viewQuery: function(query) {\\r\\n          alert(JSON.stringify(query));\\r\\n        }\\r\\n      }\\r\\n    }\\r\\n  </script>\\r\\n```\\r\\n\\r\\nAdd button to execute async query\\r\\n```vue\\r\\n  <template>\\r\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-bind:run-query=\"viewQuery\" />\\r\\n  </template>\\r\\n\\r\\n  <script>\\r\\n    import Vue from \\'vue\\';\\r\\n    import \\'@/scss/custom.scss\\';\\r\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\r\\n    Vue.use(BootstrapVue);\\r\\n    Vue.use(IconsPlugin);\\r\\n\\r\\n    export default {\\r\\n      data() {\\r\\n        return {\\r\\n          query: {\\r\\n            condition: \\'and\\',\\r\\n            rules: [{\\r\\n              id: \\'price\\',\\r\\n              operator: \\'<=\\',\\r\\n              value: \\'80000\\'\\r\\n            }]\\r\\n          },\\r\\n          queryOptions: [{\\r\\n            id: \\'price\\',\\r\\n            name: \\'Price\\',\\r\\n            type: \\'number\\'\\r\\n          }, {\\r\\n            id: \\'date\\',\\r\\n            name: \\'Date\\',\\r\\n            type: \\'date\\'\\r\\n          }, {\\r\\n            id: \\'time\\',\\r\\n            name: \\'Time\\',\\r\\n            type: \\'time\\'\\r\\n          }]\\r\\n        }\\r\\n      },\\r\\n      methods: {\\r\\n        viewQuery: function(query) {\\r\\n          return new Promise(function(resolve){\\r\\n            setTimeout(function(){\\r\\n              alert(JSON.stringify(query));\\r\\n              resolve();\\r\\n            }, 1000);\\r\\n          });\\r\\n        }\\r\\n      }\\r\\n    }\\r\\n  </script>\\r\\n```\\r\\n\\r\\nCollapse query builder on load\\r\\n```vue\\r\\n  <template>\\r\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\" v-bind:visible=\"false\" />\\r\\n  </template>\\r\\n\\r\\n  <script>\\r\\n    import Vue from \\'vue\\';\\r\\n    import \\'@/scss/custom.scss\\';\\r\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\r\\n    Vue.use(BootstrapVue);\\r\\n    Vue.use(IconsPlugin);\\r\\n\\r\\n    export default {\\r\\n      data() {\\r\\n        return {\\r\\n          query: {\\r\\n            condition: \\'and\\',\\r\\n            rules: [{\\r\\n              id: \\'price\\',\\r\\n              operator: \\'<=\\',\\r\\n              value: \\'80000\\'\\r\\n            }]\\r\\n          },\\r\\n          queryOptions: [{\\r\\n            id: \\'price\\',\\r\\n            name: \\'Price\\',\\r\\n            type: \\'number\\'\\r\\n          }, {\\r\\n            id: \\'date\\',\\r\\n            name: \\'Date\\',\\r\\n            type: \\'date\\'\\r\\n          }, {\\r\\n            id: \\'time\\',\\r\\n            name: \\'Time\\',\\r\\n            type: \\'time\\'\\r\\n          }]\\r\\n        }\\r\\n      }\\r\\n    }\\r\\n  </script>\\r\\n```\\r\\n\\r\\nReplace rule ID selector, rule operator selector, or value inputs by type by using slots\\r\\n```vue\\r\\n  <template>\\r\\n    <VueJSONQueryBuilder v-bind:query=\"query\" v-bind:options=\"queryOptions\">\\r\\n      <template v-slot:ruleID=\"{rule, options}\">\\r\\n        <v-select\\r\\n          size=\"sm\"\\r\\n          :options=\"options\"\\r\\n          :reduce=\"item => item.id\"\\r\\n          label=\"name\"\\r\\n          autocomplete=\"new-password\"\\r\\n          v-model=\"rule.id\"\\r\\n        />\\r\\n      </template>\\r\\n      <template v-slot:ruleOperator=\"{rule, options}\">\\r\\n        <v-select\\r\\n          size=\"sm\"\\r\\n          :options=\"options\"\\r\\n          :reduce=\"item => item.id\"\\r\\n          label=\"name\"\\r\\n          autocomplete=\"new-password\"\\r\\n          v-model=\"rule.operator\"\\r\\n        />\\r\\n      </template>\\r\\n      <template v-slot:select=\"{rule, options, multiple}\">\\r\\n        <v-select\\r\\n          size=\"sm\"\\r\\n          :options=\"options\"\\r\\n          :reduce=\"item => item.id\"\\r\\n          label=\"name\"\\r\\n          autocomplete=\"new-password\"\\r\\n          v-model=\"rule.value\"\\r\\n          :multiple=\"multiple\"\\r\\n        />\\r\\n      </template>\\r\\n    </VueJSONQueryBuilder>\\r\\n  </template>\\r\\n\\r\\n  <script>\\r\\n    import Vue from \\'vue\\';\\r\\n    import \\'@/scss/custom.scss\\';\\r\\n    import { BootstrapVue, IconsPlugin } from \\'bootstrap-vue\\';\\r\\n    Vue.use(BootstrapVue);\\r\\n    Vue.use(IconsPlugin);\\r\\n        \\r\\n    import vSelect from \\'vue-select\\';\\r\\n    Vue.component(\\'v-select\\', vSelect);\\r\\n    import \"vue-select/src/scss/vue-select.scss\";\\r\\n\\r\\n    export default {\\r\\n      data() {\\r\\n        return {\\r\\n          query: {\\r\\n            condition: \\'and\\',\\r\\n            rules: [{\\r\\n              id: \\'owner\\',\\r\\n              operator: \\'=\\',\\r\\n              value: 0\\r\\n            }]\\r\\n          },\\r\\n          queryOptions: [{\\r\\n            id: \\'price\\',\\r\\n            name: \\'Price\\',\\r\\n            type: \\'number\\'\\r\\n          }, {\\r\\n            id: \\'date\\',\\r\\n            name: \\'Date\\',\\r\\n            type: \\'date\\'\\r\\n          }, {\\r\\n            id: \\'time\\',\\r\\n            name: \\'Time\\',\\r\\n            type: \\'time\\'\\r\\n          }, {\\r\\n            id: \\'owner\\',\\r\\n            name: \\'Owner\\',\\r\\n            type: \\'select\\',\\r\\n            options: [{\\r\\n              id: 0,\\r\\n              name: \\'Charles Smith\\'\\r\\n            }, {\\r\\n              id: 1,\\r\\n              name: \\'Emmy Carlton\\'\\r\\n            }, {\\r\\n              id: 2,\\r\\n              name: \\'Jim Bowmann\\'\\r\\n            }, {\\r\\n              id: 4,\\r\\n              name: \\'Karla Entwisle\\'\\r\\n            }, {\\r\\n              id: 5,\\r\\n              name: \\'Omar Warren\\'\\r\\n            }, {\\r\\n              id: 6,\\r\\n              name: \\'Samantha Lowenstein\\'\\r\\n            }, {\\r\\n              id: 7,\\r\\n              name: \\'Zachary Appleton\\'\\r\\n            }]\\r\\n          }, {\\r\\n            id: \\'phone\\',\\r\\n            name: \\'Phone\\',\\r\\n            type: \\'phone\\'\\r\\n          }, {\\r\\n            id: \\'email\\',\\r\\n            name: \\'Email\\',\\r\\n            type: \\'email\\'\\r\\n          }]\\r\\n        }\\r\\n      }\\r\\n    }\\r\\n  </script>\\r\\n```'],\n    'props': [\n        {\n            'name': 'query',\n            'description': 'The initial query to load into VueJSONQueryBuilder on load.',\n            'type': { 'name': 'object' },\n            'required': true\n        },\n        {\n            'name': 'options',\n            'description': 'The options to define the parameters of each rule.',\n            'type': { 'name': 'array' }\n        },\n        {\n            'name': 'runQuery',\n            'description': 'The function to run upon click of \"Run Query\" button, returning current query.',\n            'type': { 'name': 'func|object' },\n            'required': false,\n            'defaultValue': {\n                'func': false,\n                'value': 'null'\n            }\n        },\n        {\n            'name': 'storage',\n            'description': 'The location in localStorage in which to store current query.',\n            'type': { 'name': 'string' },\n            'required': false,\n            'defaultValue': {\n                'func': false,\n                'value': '\\'\\''\n            }\n        },\n        {\n            'name': 'v-model',\n            'description': 'Returns current query to parent component.',\n            'tags': {\n                'model': [{\n                        'description': true,\n                        'title': 'model'\n                    }]\n            },\n            'type': { 'name': 'object' },\n            'required': false,\n            'defaultValue': {\n                'func': false,\n                'value': '{}'\n            }\n        },\n        {\n            'name': 'visible',\n            'description': 'Determines whether VueJSONQueryBuilder instance is collapsed or expanded upon load.',\n            'type': { 'name': 'boolean' },\n            'required': false,\n            'defaultValue': {\n                'func': false,\n                'value': 'true'\n            }\n        }\n    ],\n    'events': void 0,\n    'methods': void 0,\n    'slots': {\n        'ruleID': {\n            'name': 'ruleID',\n            'scoped': true,\n            'description': 'The user interface element to replace ruleID selector',\n            'bindings': [\n                {\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The options to be applied to this rule selector'\n                },\n                {\n                    'title': 'binding',\n                    'type': { 'name': 'array' },\n                    'name': 'options',\n                    'description': 'The list of options to apply to new ruleID selector. Each object in array must include `id` and `name` attributes'\n                }\n            ]\n        },\n        'ruleOperator': {\n            'name': 'ruleOperator',\n            'scoped': true,\n            'description': 'The user interface element to replace ruleOperator selector',\n            'bindings': [\n                {\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The options to be applied to this operator selector'\n                },\n                {\n                    'title': 'binding',\n                    'type': { 'name': 'array' },\n                    'name': 'options',\n                    'description': 'list of options to apply to new ruleOperator selector. Each object in array must include `id` and `name` attributes.'\n                }\n            ]\n        },\n        'number': {\n            'name': 'number',\n            'scoped': true,\n            'description': 'The user interface element to replace number input',\n            'bindings': [{\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The rule to be connected to this input'\n                }]\n        },\n        'date': {\n            'name': 'date',\n            'scoped': true,\n            'description': 'The user interface element to replace date input',\n            'bindings': [{\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The rule to be connected to this input'\n                }]\n        },\n        'time': {\n            'name': 'time',\n            'scoped': true,\n            'description': 'The user interface element to replace time input',\n            'bindings': [{\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The rule to be connected to this input'\n                }]\n        },\n        'select': {\n            'name': 'select',\n            'scoped': true,\n            'description': 'The user interface element to replace select',\n            'bindings': [\n                {\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The rule to be connected to this select'\n                },\n                {\n                    'title': 'binding',\n                    'type': { 'name': 'array' },\n                    'name': 'options',\n                    'description': 'list of options to apply to this select. Each object in array must include `id` and `name` attributes.'\n                },\n                {\n                    'title': 'binding',\n                    'type': { 'name': 'boolean' },\n                    'name': 'multiple',\n                    'description': 'Determines whether select allows for singular or multiple selections.'\n                }\n            ]\n        },\n        'phone': {\n            'name': 'phone',\n            'scoped': true,\n            'description': 'The user interface element to replace phone input',\n            'bindings': [{\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The rule to be connected to this input'\n                }]\n        },\n        'email': {\n            'name': 'email',\n            'scoped': true,\n            'description': 'The user interface element to replace email input',\n            'bindings': [{\n                    'title': 'binding',\n                    'type': { 'name': 'object' },\n                    'name': 'rule',\n                    'description': 'The rule to be connected to this input'\n                }]\n        }\n    },\n    'example': __webpack_require__(/*! !./node_modules/vue-styleguidist/lib/loaders/examples-loader.js?customLangs=vue|js|jsx!./src/components/vue-json-query-builder.vue */ \"./node_modules/vue-styleguidist/lib/loaders/examples-loader.js?customLangs=vue|js|jsx!./src/components/vue-json-query-builder.vue\"),\n    'examples': null\n}\n\t\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?./node_modules/vue-styleguidist/lib/loaders/vuedoc-loader.js");

/***/ }),

/***/ "./src/components/vue-json-query-builder.vue":
/*!***************************************************!*\
  !*** ./src/components/vue-json-query-builder.vue ***!
  \***************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _vue_json_query_builder_vue_vue_type_template_id_1e8f3424___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./vue-json-query-builder.vue?vue&type=template&id=1e8f3424& */ \"./src/components/vue-json-query-builder.vue?vue&type=template&id=1e8f3424&\");\n/* harmony import */ var _vue_json_query_builder_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./vue-json-query-builder.vue?vue&type=script&lang=js& */ \"./src/components/vue-json-query-builder.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport *//* harmony import */ var _vue_json_query_builder_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./vue-json-query-builder.vue?vue&type=style&index=0&lang=scss& */ \"./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss&\");\n/* harmony import */ var _node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../node_modules/vue-loader/lib/runtime/componentNormalizer.js */ \"./node_modules/vue-loader/lib/runtime/componentNormalizer.js\");\n/* harmony import */ var _vue_json_query_builder_vue_vue_type_custom_index_0_blockType_docs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs */ \"./src/components/vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs\");\n\n\n\n\n\n\n/* normalize component */\n\nvar component = Object(_node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"])(\n  _vue_json_query_builder_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__[\"default\"],\n  _vue_json_query_builder_vue_vue_type_template_id_1e8f3424___WEBPACK_IMPORTED_MODULE_0__[\"render\"],\n  _vue_json_query_builder_vue_vue_type_template_id_1e8f3424___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"],\n  false,\n  null,\n  null,\n  null\n  \n)\n\n/* custom blocks */\n\nif (typeof _vue_json_query_builder_vue_vue_type_custom_index_0_blockType_docs__WEBPACK_IMPORTED_MODULE_4__[\"default\"] === 'function') Object(_vue_json_query_builder_vue_vue_type_custom_index_0_blockType_docs__WEBPACK_IMPORTED_MODULE_4__[\"default\"])(component)\n\n/* harmony default export */ __webpack_exports__[\"default\"] = (component.exports);\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?");

/***/ }),

/***/ "./src/components/vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs":
/*!******************************************************************************************!*\
  !*** ./src/components/vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs ***!
  \******************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_vue_styleguidist_lib_loaders_docs_loader_js_node_modules_vue_cli_plugin_styleguidist_empty_object_loader_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_custom_index_0_blockType_docs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/vue-styleguidist/lib/loaders/docs-loader.js!../../node_modules/vue-cli-plugin-styleguidist/empty-object-loader.js!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs */ \"./node_modules/vue-styleguidist/lib/loaders/docs-loader.js!./node_modules/vue-cli-plugin-styleguidist/empty-object-loader.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=custom&index=0&blockType=docs\");\n/* empty/unused harmony star reexport */ /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_vue_styleguidist_lib_loaders_docs_loader_js_node_modules_vue_cli_plugin_styleguidist_empty_object_loader_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_custom_index_0_blockType_docs__WEBPACK_IMPORTED_MODULE_0__[\"default\"]); \n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?");

/***/ }),

/***/ "./src/components/vue-json-query-builder.vue?vue&type=script&lang=js&":
/*!****************************************************************************!*\
  !*** ./src/components/vue-json-query-builder.vue?vue&type=script&lang=js& ***!
  \****************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/cache-loader/dist/cjs.js??ref--13-0!../../node_modules/babel-loader/lib!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-json-query-builder.vue?vue&type=script&lang=js& */ \"./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport */ /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__[\"default\"]); \n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?");

/***/ }),

/***/ "./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss&":
/*!*************************************************************************************!*\
  !*** ./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss& ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/vue-style-loader??ref--9-oneOf-1-0!../../node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!../../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../../node_modules/postcss-loader/src??ref--9-oneOf-1-2!../../node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-json-query-builder.vue?vue&type=style&index=0&lang=scss& */ \"./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=style&index=0&lang=scss&\");\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__);\n/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));\n /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0___default.a); \n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?");

/***/ }),

/***/ "./src/components/vue-json-query-builder.vue?vue&type=template&id=1e8f3424&":
/*!**********************************************************************************!*\
  !*** ./src/components/vue-json-query-builder.vue?vue&type=template&id=1e8f3424& ***!
  \**********************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_template_id_1e8f3424___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"4798365a-vue-loader-template\"}!../../node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-json-query-builder.vue?vue&type=template&id=1e8f3424& */ \"./node_modules/cache-loader/dist/cjs.js?{\\\"cacheDirectory\\\":\\\"node_modules/.cache/vue-loader\\\",\\\"cacheIdentifier\\\":\\\"4798365a-vue-loader-template\\\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-json-query-builder.vue?vue&type=template&id=1e8f3424&\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_template_id_1e8f3424___WEBPACK_IMPORTED_MODULE_0__[\"render\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_json_query_builder_vue_vue_type_template_id_1e8f3424___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"]; });\n\n\n\n//# sourceURL=webpack:///./src/components/vue-json-query-builder.vue?");

/***/ }),

/***/ "./src/components/vue-query-group.vue":
/*!********************************************!*\
  !*** ./src/components/vue-query-group.vue ***!
  \********************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _vue_query_group_vue_vue_type_template_id_2c86c013___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./vue-query-group.vue?vue&type=template&id=2c86c013& */ \"./src/components/vue-query-group.vue?vue&type=template&id=2c86c013&\");\n/* harmony import */ var _vue_query_group_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./vue-query-group.vue?vue&type=script&lang=js& */ \"./src/components/vue-query-group.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport *//* harmony import */ var _node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../../node_modules/vue-loader/lib/runtime/componentNormalizer.js */ \"./node_modules/vue-loader/lib/runtime/componentNormalizer.js\");\n\n\n\n\n\n/* normalize component */\n\nvar component = Object(_node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_2__[\"default\"])(\n  _vue_query_group_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__[\"default\"],\n  _vue_query_group_vue_vue_type_template_id_2c86c013___WEBPACK_IMPORTED_MODULE_0__[\"render\"],\n  _vue_query_group_vue_vue_type_template_id_2c86c013___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"],\n  false,\n  null,\n  null,\n  null\n  \n)\n\n/* hot reload */\nif (false) { var api; }\ncomponent.options.__file = \"src/components/vue-query-group.vue\"\n/* harmony default export */ __webpack_exports__[\"default\"] = (component.exports);\n\n//# sourceURL=webpack:///./src/components/vue-query-group.vue?");

/***/ }),

/***/ "./src/components/vue-query-group.vue?vue&type=script&lang=js&":
/*!*********************************************************************!*\
  !*** ./src/components/vue-query-group.vue?vue&type=script&lang=js& ***!
  \*********************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_group_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/cache-loader/dist/cjs.js??ref--13-0!../../node_modules/babel-loader/lib!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-query-group.vue?vue&type=script&lang=js& */ \"./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-group.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport */ /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_group_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__[\"default\"]); \n\n//# sourceURL=webpack:///./src/components/vue-query-group.vue?");

/***/ }),

/***/ "./src/components/vue-query-group.vue?vue&type=template&id=2c86c013&":
/*!***************************************************************************!*\
  !*** ./src/components/vue-query-group.vue?vue&type=template&id=2c86c013& ***!
  \***************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_group_vue_vue_type_template_id_2c86c013___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"4798365a-vue-loader-template\"}!../../node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-query-group.vue?vue&type=template&id=2c86c013& */ \"./node_modules/cache-loader/dist/cjs.js?{\\\"cacheDirectory\\\":\\\"node_modules/.cache/vue-loader\\\",\\\"cacheIdentifier\\\":\\\"4798365a-vue-loader-template\\\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-group.vue?vue&type=template&id=2c86c013&\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_group_vue_vue_type_template_id_2c86c013___WEBPACK_IMPORTED_MODULE_0__[\"render\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_group_vue_vue_type_template_id_2c86c013___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"]; });\n\n\n\n//# sourceURL=webpack:///./src/components/vue-query-group.vue?");

/***/ }),

/***/ "./src/components/vue-query-rule.vue":
/*!*******************************************!*\
  !*** ./src/components/vue-query-rule.vue ***!
  \*******************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _vue_query_rule_vue_vue_type_template_id_002e3d98___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./vue-query-rule.vue?vue&type=template&id=002e3d98& */ \"./src/components/vue-query-rule.vue?vue&type=template&id=002e3d98&\");\n/* harmony import */ var _vue_query_rule_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./vue-query-rule.vue?vue&type=script&lang=js& */ \"./src/components/vue-query-rule.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport *//* harmony import */ var _vue_query_rule_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./vue-query-rule.vue?vue&type=style&index=0&lang=scss& */ \"./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss&\");\n/* harmony import */ var _node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../node_modules/vue-loader/lib/runtime/componentNormalizer.js */ \"./node_modules/vue-loader/lib/runtime/componentNormalizer.js\");\n\n\n\n\n\n\n/* normalize component */\n\nvar component = Object(_node_modules_vue_loader_lib_runtime_componentNormalizer_js__WEBPACK_IMPORTED_MODULE_3__[\"default\"])(\n  _vue_query_rule_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_1__[\"default\"],\n  _vue_query_rule_vue_vue_type_template_id_002e3d98___WEBPACK_IMPORTED_MODULE_0__[\"render\"],\n  _vue_query_rule_vue_vue_type_template_id_002e3d98___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"],\n  false,\n  null,\n  null,\n  null\n  \n)\n\n/* hot reload */\nif (false) { var api; }\ncomponent.options.__file = \"src/components/vue-query-rule.vue\"\n/* harmony default export */ __webpack_exports__[\"default\"] = (component.exports);\n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?");

/***/ }),

/***/ "./src/components/vue-query-rule.vue?vue&type=script&lang=js&":
/*!********************************************************************!*\
  !*** ./src/components/vue-query-rule.vue?vue&type=script&lang=js& ***!
  \********************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/cache-loader/dist/cjs.js??ref--13-0!../../node_modules/babel-loader/lib!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-query-rule.vue?vue&type=script&lang=js& */ \"./node_modules/cache-loader/dist/cjs.js?!./node_modules/babel-loader/lib/index.js!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=script&lang=js&\");\n/* empty/unused harmony star reexport */ /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_cache_loader_dist_cjs_js_ref_13_0_node_modules_babel_loader_lib_index_js_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_script_lang_js___WEBPACK_IMPORTED_MODULE_0__[\"default\"]); \n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?");

/***/ }),

/***/ "./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss&":
/*!*****************************************************************************!*\
  !*** ./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss& ***!
  \*****************************************************************************/
/*! no static exports found */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/vue-style-loader??ref--9-oneOf-1-0!../../node_modules/css-loader/dist/cjs.js??ref--9-oneOf-1-1!../../node_modules/vue-loader/lib/loaders/stylePostLoader.js!../../node_modules/postcss-loader/src??ref--9-oneOf-1-2!../../node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-1-3!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-query-rule.vue?vue&type=style&index=0&lang=scss& */ \"./node_modules/vue-style-loader/index.js?!./node_modules/css-loader/dist/cjs.js?!./node_modules/vue-loader/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=style&index=0&lang=scss&\");\n/* harmony import */ var _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__);\n/* harmony reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return _node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0__[key]; }) }(__WEBPACK_IMPORT_KEY__));\n /* harmony default export */ __webpack_exports__[\"default\"] = (_node_modules_vue_style_loader_index_js_ref_9_oneOf_1_0_node_modules_css_loader_dist_cjs_js_ref_9_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_9_oneOf_1_2_node_modules_sass_loader_dist_cjs_js_ref_9_oneOf_1_3_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_style_index_0_lang_scss___WEBPACK_IMPORTED_MODULE_0___default.a); \n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?");

/***/ }),

/***/ "./src/components/vue-query-rule.vue?vue&type=template&id=002e3d98&":
/*!**************************************************************************!*\
  !*** ./src/components/vue-query-rule.vue?vue&type=template&id=002e3d98& ***!
  \**************************************************************************/
/*! exports provided: render, staticRenderFns */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_template_id_002e3d98___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! -!../../node_modules/cache-loader/dist/cjs.js?{\"cacheDirectory\":\"node_modules/.cache/vue-loader\",\"cacheIdentifier\":\"4798365a-vue-loader-template\"}!../../node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!../../node_modules/cache-loader/dist/cjs.js??ref--1-0!../../node_modules/vue-loader/lib??vue-loader-options!./vue-query-rule.vue?vue&type=template&id=002e3d98& */ \"./node_modules/cache-loader/dist/cjs.js?{\\\"cacheDirectory\\\":\\\"node_modules/.cache/vue-loader\\\",\\\"cacheIdentifier\\\":\\\"4798365a-vue-loader-template\\\"}!./node_modules/vue-loader/lib/loaders/templateLoader.js?!./node_modules/cache-loader/dist/cjs.js?!./node_modules/vue-loader/lib/index.js?!./src/components/vue-query-rule.vue?vue&type=template&id=002e3d98&\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"render\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_template_id_002e3d98___WEBPACK_IMPORTED_MODULE_0__[\"render\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"staticRenderFns\", function() { return _node_modules_cache_loader_dist_cjs_js_cacheDirectory_node_modules_cache_vue_loader_cacheIdentifier_4798365a_vue_loader_template_node_modules_vue_loader_lib_loaders_templateLoader_js_vue_loader_options_node_modules_cache_loader_dist_cjs_js_ref_1_0_node_modules_vue_loader_lib_index_js_vue_loader_options_vue_query_rule_vue_vue_type_template_id_002e3d98___WEBPACK_IMPORTED_MODULE_0__[\"staticRenderFns\"]; });\n\n\n\n//# sourceURL=webpack:///./src/components/vue-query-rule.vue?");

/***/ }),

/***/ "./src/scss/custom.scss":
/*!******************************!*\
  !*** ./src/scss/custom.scss ***!
  \******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("// style-loader: Adds some css to the DOM by adding a <style> tag\n\n// load the styles\nvar content = __webpack_require__(/*! !../../node_modules/css-loader/dist/cjs.js??ref--9-oneOf-3-1!../../node_modules/postcss-loader/src??ref--9-oneOf-3-2!../../node_modules/sass-loader/dist/cjs.js??ref--9-oneOf-3-3!./custom.scss */ \"./node_modules/css-loader/dist/cjs.js?!./node_modules/postcss-loader/src/index.js?!./node_modules/sass-loader/dist/cjs.js?!./src/scss/custom.scss\");\nif(typeof content === 'string') content = [[module.i, content, '']];\nif(content.locals) module.exports = content.locals;\n// add the styles to the DOM\nvar add = __webpack_require__(/*! ../../node_modules/vue-style-loader/lib/addStylesClient.js */ \"./node_modules/vue-style-loader/lib/addStylesClient.js\").default\nvar update = add(\"1fd08542\", content, true, {\"sourceMap\":false,\"shadowMode\":false});\n\n//# sourceURL=webpack:///./src/scss/custom.scss?");

/***/ }),

/***/ 0:
/*!**************************************************************!*\
  !*** multi ./node_modules/vue-styleguidist/lib/client/index ***!
  \**************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__(/*! C:\\Users\\eedge\\Documents\\GitHub\\vue-query-builder\\node_modules\\vue-styleguidist\\lib\\client\\index */\"./node_modules/vue-styleguidist/lib/client/index.js\");\n\n\n//# sourceURL=webpack:///multi_./node_modules/vue-styleguidist/lib/client/index?");

/***/ })

/******/ });